
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | SYMB_REG of (
# 21 "lib/BPFParser.mly"
       (string)
# 15 "lib/BPFParser.ml"
  )
    | STRL
    | STAR
    | SIZE of (
# 25 "lib/BPFParser.mly"
       (BPFBase.signed * BPFBase.width)
# 22 "lib/BPFParser.ml"
  )
    | SEMI
    | RPAR
    | PROC of (
# 24 "lib/BPFParser.mly"
       (int)
# 29 "lib/BPFParser.ml"
  )
    | PLUS
    | PIPE
    | NUM of (
# 22 "lib/BPFParser.mly"
       (int)
# 36 "lib/BPFParser.ml"
  )
    | NAME of (
# 23 "lib/BPFParser.mly"
       (string)
# 41 "lib/BPFParser.ml"
  )
    | MINUS
    | LPAR
    | LOCK
    | LDAQ
    | IF
    | GOTO
    | EQUAL
    | EOF
    | COND of (
# 38 "lib/BPFParser.mly"
       (BPFBase.cond)
# 54 "lib/BPFParser.ml"
  )
    | COMMA
    | COLON
    | ARCH_REG of (
# 20 "lib/BPFParser.mly"
       (BPFBase.reg)
# 61 "lib/BPFParser.ml"
  )
    | AMOXCHGT of (
# 33 "lib/BPFParser.mly"
       (BPFBase.width)
# 66 "lib/BPFParser.ml"
  )
    | AMOF of (
# 32 "lib/BPFParser.mly"
       (BPFBase.op)
# 71 "lib/BPFParser.ml"
  )
    | AMOCMPXCHGT of (
# 34 "lib/BPFParser.mly"
       (BPFBase.width)
# 76 "lib/BPFParser.ml"
  )
    | ALU_OP of (
# 31 "lib/BPFParser.mly"
       (BPFBase.op)
# 81 "lib/BPFParser.ml"
  )
  
end

include MenhirBasics

# 1 "lib/BPFParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Copyright (c) 2024 Puranjay Mohan <puranjay@kernel.org>                  *)
(*                                                                          *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module A=BPFBase


# 106 "lib/BPFParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState002 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 002.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState004 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 004.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState008 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 008.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState016 : (('s, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 016.
        Stack shape : STRL SIZE.
        Start symbol: main. *)

  | MenhirState018 : ((('s, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 018.
        Stack shape : STRL SIZE reg.
        Start symbol: main. *)

  | MenhirState026 : (((('s, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 026.
        Stack shape : STRL SIZE reg k.
        Start symbol: main. *)

  | MenhirState034 : (('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 034.
        Stack shape : STAR SIZE.
        Start symbol: main. *)

  | MenhirState035 : ((('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 035.
        Stack shape : STAR SIZE reg.
        Start symbol: main. *)

  | MenhirState038 : (((('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 038.
        Stack shape : STAR SIZE reg k.
        Start symbol: main. *)

  | MenhirState042 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 042.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState049 : (('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 049.
        Stack shape : LOCK SIZE.
        Start symbol: main. *)

  | MenhirState050 : ((('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 050.
        Stack shape : LOCK SIZE reg.
        Start symbol: main. *)

  | MenhirState053 : (((('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k _menhir_cell0_ALU_OP, _menhir_box_main) _menhir_state
    (** State 053.
        Stack shape : LOCK SIZE reg k ALU_OP.
        Start symbol: main. *)

  | MenhirState055 : (('s, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_state
    (** State 055.
        Stack shape : IF.
        Start symbol: main. *)

  | MenhirState057 : ((('s, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND, _menhir_box_main) _menhir_state
    (** State 057.
        Stack shape : IF reg COND.
        Start symbol: main. *)

  | MenhirState067 : (('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 067.
        Stack shape : reg.
        Start symbol: main. *)

  | MenhirState073 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 073.
        Stack shape : reg STAR SIZE.
        Start symbol: main. *)

  | MenhirState074 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 074.
        Stack shape : reg STAR SIZE reg.
        Start symbol: main. *)

  | MenhirState083 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LDAQ _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 083.
        Stack shape : reg LDAQ SIZE.
        Start symbol: main. *)

  | MenhirState084 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LDAQ _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 084.
        Stack shape : reg LDAQ SIZE reg.
        Start symbol: main. *)

  | MenhirState089 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_state
    (** State 089.
        Stack shape : reg AMOXCHGT.
        Start symbol: main. *)

  | MenhirState090 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 090.
        Stack shape : reg AMOXCHGT reg.
        Start symbol: main. *)

  | MenhirState092 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 092.
        Stack shape : reg AMOXCHGT reg k.
        Start symbol: main. *)

  | MenhirState101 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 101.
        Stack shape : reg AMOF SIZE.
        Start symbol: main. *)

  | MenhirState102 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 102.
        Stack shape : reg AMOF SIZE reg.
        Start symbol: main. *)

  | MenhirState105 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 105.
        Stack shape : reg AMOF SIZE reg k.
        Start symbol: main. *)

  | MenhirState109 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_state
    (** State 109.
        Stack shape : reg AMOCMPXCHGT.
        Start symbol: main. *)

  | MenhirState110 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 110.
        Stack shape : reg AMOCMPXCHGT reg.
        Start symbol: main. *)

  | MenhirState112 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 112.
        Stack shape : reg AMOCMPXCHGT reg k.
        Start symbol: main. *)

  | MenhirState114 : (((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 114.
        Stack shape : reg AMOCMPXCHGT reg k reg.
        Start symbol: main. *)

  | MenhirState119 : (('s, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP, _menhir_box_main) _menhir_state
    (** State 119.
        Stack shape : reg ALU_OP.
        Start symbol: main. *)

  | MenhirState127 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 127.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState130 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 130.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (BPFBase.pseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (BPFBase.pseudo list)

and ('s, 'r) _menhir_cell1_k = 
  | MenhirCell1_k of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (A.reg_arg)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and 's _menhir_cell0_ALU_OP = 
  | MenhirCell0_ALU_OP of 's * (
# 31 "lib/BPFParser.mly"
       (BPFBase.op)
# 297 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOCMPXCHGT = 
  | MenhirCell1_AMOCMPXCHGT of 's * ('s, 'r) _menhir_state * (
# 34 "lib/BPFParser.mly"
       (BPFBase.width)
# 304 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOF = 
  | MenhirCell1_AMOF of 's * ('s, 'r) _menhir_state * (
# 32 "lib/BPFParser.mly"
       (BPFBase.op)
# 311 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOXCHGT = 
  | MenhirCell1_AMOXCHGT of 's * ('s, 'r) _menhir_state * (
# 33 "lib/BPFParser.mly"
       (BPFBase.width)
# 318 "lib/BPFParser.ml"
)

and 's _menhir_cell0_COND = 
  | MenhirCell0_COND of 's * (
# 38 "lib/BPFParser.mly"
       (BPFBase.cond)
# 325 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LDAQ = 
  | MenhirCell1_LDAQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOCK = 
  | MenhirCell1_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 23 "lib/BPFParser.mly"
       (string)
# 341 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 24 "lib/BPFParser.mly"
       (int)
# 348 "lib/BPFParser.ml"
)

and 's _menhir_cell0_SIZE = 
  | MenhirCell0_SIZE of 's * (
# 25 "lib/BPFParser.mly"
       (BPFBase.signed * BPFBase.width)
# 355 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_STAR = 
  | MenhirCell1_STAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STRL = 
  | MenhirCell1_STRL of 's * ('s, 'r) _menhir_state

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * BPFBase.pseudo list list) [@@unboxed]

let _menhir_action_01 =
  fun _1 _2 _3 ->
    (
# 88 "lib/BPFParser.mly"
  ( A.OP (_2,_1,_3) )
# 372 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_02 =
  fun _1 _2 _3 ->
    (
# 91 "lib/BPFParser.mly"
  ( A.OPI (_2,_1,_3) )
# 380 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_03 =
  fun _1 _10 _5 _9 ->
    (
# 95 "lib/BPFParser.mly"
  ( let s,w = _5 in
    A.LOAD (w,s,_1,_9,_10) )
# 389 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_04 =
  fun _1 _10 _11 _6 ->
    (
# 100 "lib/BPFParser.mly"
 ( let _,w = _6 in
   A.LDAQ (w,_1,_10,_11) )
# 398 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_05 =
  fun _11 _3 _7 _8 ->
    (
# 105 "lib/BPFParser.mly"
  ( let _,w = _3 in
    A.STORE (w,_7,_8,_11) )
# 407 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_06 =
  fun _11 _3 _7 _8 ->
    (
# 110 "lib/BPFParser.mly"
  ( let _,w = _3 in
    A.STOREI (w,_7,_8,_11) )
# 416 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_07 =
  fun _12 _4 _8 _9 ->
    (
# 115 "lib/BPFParser.mly"
  ( let _,w = _4 in
    A.STRL (w,_8,_9,_12) )
# 425 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_08 =
  fun _1 _3 ->
    (
# 120 "lib/BPFParser.mly"
  ( A.MOV(_1, _3))
# 433 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_09 =
  fun _1 _3 ->
    (
# 124 "lib/BPFParser.mly"
  ( A.MOVI(_1, _3))
# 441 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_10 =
  fun _10 _11 _14 _3 _6 ->
    (
# 128 "lib/BPFParser.mly"
  ( let op = _3 in
    let _,w = _6 in
   A.AMO(op, w, _10, _11, _14, A.SC, true) )
# 451 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_11 =
  fun _3 _5 _6 _8 ->
    (
# 134 "lib/BPFParser.mly"
  ( let sz = _3 in
   A.AMO(A.AMOXCHG, sz, _5, _6, _8, A.SC, true) )
# 460 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_12 =
  fun _10 _3 _5 _6 ->
    (
# 139 "lib/BPFParser.mly"
  ( let sz = _3 in
   A.AMO(A.AMOCMPXCHG, sz, _5, _6, _10, A.SC, true) )
# 469 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_13 =
  fun _11 _12 _4 _8 _9 ->
    (
# 144 "lib/BPFParser.mly"
  ( let _,w = _4 in
      let op = _11 in
    A.AMO(op, w, _8, _9, _12, A.X, false) )
# 479 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_14 =
  fun _2 ->
    (
# 150 "lib/BPFParser.mly"
  ( A.GOTO(_2) )
# 487 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_15 =
  fun _2 _3 _4 _6 ->
    (
# 154 "lib/BPFParser.mly"
  ( let c=_3 in
    A.JCOND(c, _2, _4, _6)  )
# 496 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_16 =
  fun _2 _3 _4 _6 ->
    (
# 157 "lib/BPFParser.mly"
  ( let c=_3 in
    A.JCONDI(c, _2, _4, _6)  )
# 505 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_17 =
  fun () ->
    (
# 70 "lib/BPFParser.mly"
             ( A.Nop )
# 513 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_18 =
  fun _1 _3 ->
    (
# 71 "lib/BPFParser.mly"
                          ( A.Label (_1,_3) )
# 521 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_19 =
  fun _1 ->
    (
# 72 "lib/BPFParser.mly"
             ( A.Instruction _1)
# 529 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_20 =
  fun _1 ->
    (
# 65 "lib/BPFParser.mly"
      ([_1])
# 537 "lib/BPFParser.ml"
     : (BPFBase.pseudo list))

let _menhir_action_21 =
  fun _1 _3 ->
    (
# 67 "lib/BPFParser.mly"
      (_1::_3)
# 545 "lib/BPFParser.ml"
     : (BPFBase.pseudo list))

let _menhir_action_22 =
  fun _1 ->
    (
# 60 "lib/BPFParser.mly"
    ([_1])
# 553 "lib/BPFParser.ml"
     : (BPFBase.pseudo list list))

let _menhir_action_23 =
  fun _1 _3 ->
    (
# 61 "lib/BPFParser.mly"
                                   (_1::_3)
# 561 "lib/BPFParser.ml"
     : (BPFBase.pseudo list list))

let _menhir_action_24 =
  fun _1 ->
    (
# 79 "lib/BPFParser.mly"
      ( _1 )
# 569 "lib/BPFParser.ml"
     : (int))

let _menhir_action_25 =
  fun _2 ->
    (
# 80 "lib/BPFParser.mly"
            ( -_2 )
# 577 "lib/BPFParser.ml"
     : (int))

let _menhir_action_26 =
  fun _2 ->
    (
# 81 "lib/BPFParser.mly"
           ( _2 )
# 585 "lib/BPFParser.ml"
     : (int))

let _menhir_action_27 =
  fun _2 _3 ->
    (
# 48 "lib/BPFParser.mly"
                                  ( _2,_3 )
# 593 "lib/BPFParser.ml"
     : (MiscParser.proc list * BPFBase.pseudo list list))

let _menhir_action_28 =
  fun ps ->
    (
# 56 "lib/BPFParser.mly"
  ( List.map (fun p -> p,None,MiscParser.Main) ps )
# 601 "lib/BPFParser.ml"
     : (MiscParser.proc list))

let _menhir_action_29 =
  fun _1 ->
    (
# 75 "lib/BPFParser.mly"
           ( A.Symbolic_reg _1 )
# 609 "lib/BPFParser.ml"
     : (A.reg_arg))

let _menhir_action_30 =
  fun _1 ->
    (
# 76 "lib/BPFParser.mly"
           ( _1 )
# 617 "lib/BPFParser.ml"
     : (A.reg_arg))

let _menhir_action_31 =
  fun () ->
    (
# 51 "lib/BPFParser.mly"
  ( () )
# 625 "lib/BPFParser.ml"
     : (unit))

let _menhir_action_32 =
  fun () ->
    (
# 52 "lib/BPFParser.mly"
       ( () )
# 633 "lib/BPFParser.ml"
     : (unit))

let _menhir_action_33 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 641 "lib/BPFParser.ml"
     : (int list))

let _menhir_action_34 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 649 "lib/BPFParser.ml"
     : (int list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ALU_OP _ ->
        "ALU_OP"
    | AMOCMPXCHGT _ ->
        "AMOCMPXCHGT"
    | AMOF _ ->
        "AMOF"
    | AMOXCHGT _ ->
        "AMOXCHGT"
    | ARCH_REG _ ->
        "ARCH_REG"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | COND _ ->
        "COND"
    | EOF ->
        "EOF"
    | EQUAL ->
        "EQUAL"
    | GOTO ->
        "GOTO"
    | IF ->
        "IF"
    | LDAQ ->
        "LDAQ"
    | LOCK ->
        "LOCK"
    | LPAR ->
        "LPAR"
    | MINUS ->
        "MINUS"
    | NAME _ ->
        "NAME"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PLUS ->
        "PLUS"
    | PROC _ ->
        "PROC"
    | RPAR ->
        "RPAR"
    | SEMI ->
        "SEMI"
    | SIZE _ ->
        "SIZE"
    | STAR ->
        "STAR"
    | STRL ->
        "STRL"
    | SYMB_REG _ ->
        "SYMB_REG"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_124 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_27 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState127 ->
          _menhir_run_128 _menhir_stack _v
      | MenhirState008 ->
          _menhir_run_124 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_128 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_23 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let rec _menhir_run_009 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_29 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState119 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState067 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState114 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState112 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState105 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState101 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState127 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState008 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState055 ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState053 ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState049 ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState034 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState016 ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_120 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_01 _1 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_19 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState008 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState127 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_129 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState130
          | STRL ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState130
          | STAR ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState130
          | NAME _v_1 ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState130
          | LOCK ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState130
          | IF ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState130
          | GOTO ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState130
          | ARCH_REG _v_2 ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState130
          | PIPE | SEMI ->
              let _v_3 = _menhir_action_17 () in
              _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState130 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_20 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STRL (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SIZE _v ->
                  let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | STAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | LPAR ->
                              let _menhir_s = MenhirState016 in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | SYMB_REG _v ->
                                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | ARCH_REG _v ->
                                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_017 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_30 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_029 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SIZE _v ->
              let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | STAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | RPAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | LPAR ->
                          let _menhir_s = MenhirState034 in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | SYMB_REG _v ->
                              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                          | ARCH_REG _v ->
                              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_041 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState042
          | STRL ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
          | STAR ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
          | NAME _v_1 ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState042
          | LOCK ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
          | IF ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
          | GOTO ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
          | ARCH_REG _v_2 ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState042
          | PIPE | SEMI ->
              let _v_3 = _menhir_action_17 () in
              _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SIZE _v ->
                  let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | STAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | LPAR ->
                              let _menhir_s = MenhirState049 in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | SYMB_REG _v ->
                                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | ARCH_REG _v ->
                                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_055 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState055 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_14 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_18 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState130 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState127 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState008 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_131 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_21 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_126 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState127
      | STRL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | STAR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | NAME _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState127
      | LOCK ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | IF ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | GOTO ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState127
      | ARCH_REG _v_2 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState127
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_3 = _menhir_action_17 () in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState127 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_22 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_08 _1 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_115 : type  ttv_stack. (((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_AMOCMPXCHGT (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_12 _10 _3 _5 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_113 : type  ttv_stack. (((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState114 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState110
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | _ ->
          _eRR ()
  
  and _menhir_run_019 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_26 _2 in
          _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_k : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState119 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState067 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState110 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState074 ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState057 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState050 ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState035 ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState018 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_121 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_02 _1 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_118 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_09 _1 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_111 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState112 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_103 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_s = MenhirState105 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState092 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LDAQ _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_reg (_menhir_stack, _, _10) = _menhir_stack in
              let MenhirCell0_SIZE (_menhir_stack, _6) = _menhir_stack in
              let MenhirCell1_LDAQ (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
              let _11 = _v in
              let _v = _menhir_action_04 _1 _10 _11 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_075 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _9) = _menhir_stack in
          let MenhirCell0_SIZE (_menhir_stack, _5) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_03 _1 _10 _5 _9 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | GOTO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell0_COND (_menhir_stack, _3) = _menhir_stack in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_16 _2 _3 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ALU_OP _v ->
              let _menhir_stack = MenhirCell0_ALU_OP (_menhir_stack, _v) in
              let _menhir_s = MenhirState053 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _7) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _11 = _v in
      let _v = _menhir_action_06 _11 _3 _7 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_036 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EQUAL ->
              let _menhir_s = MenhirState038 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PLUS ->
                  _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NUM _v ->
                  _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | MINUS ->
                  _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_021 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_24 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_022 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_25 _2 in
          _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_s = MenhirState026 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_106 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _11) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _10) = _menhir_stack in
          let MenhirCell0_SIZE (_menhir_stack, _6) = _menhir_stack in
          let MenhirCell1_AMOF (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _14 = _v in
          let _v = _menhir_action_10 _10 _11 _14 _3 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_102 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState102
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState102
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState102
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_AMOXCHGT (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _8 = _v in
          let _v = _menhir_action_11 _3 _5 _6 _8 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_090 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState090
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LDAQ _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState084
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState084
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState084
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState074
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState074
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState074
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          let _menhir_s = MenhirState067 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STAR ->
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SIZE _v ->
                      let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | STAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | RPAR ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | LPAR ->
                                  let _menhir_s = MenhirState073 in
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  (match (_tok : MenhirBasics.token) with
                                  | SYMB_REG _v ->
                                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                  | ARCH_REG _v ->
                                      _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                  | _ ->
                                      _eRR ())
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | PLUS ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LDAQ ->
              let _menhir_stack = MenhirCell1_LDAQ (_menhir_stack, _menhir_s) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | LPAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | SIZE _v ->
                          let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | STAR ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | RPAR ->
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  (match (_tok : MenhirBasics.token) with
                                  | LPAR ->
                                      let _menhir_s = MenhirState083 in
                                      let _tok = _menhir_lexer _menhir_lexbuf in
                                      (match (_tok : MenhirBasics.token) with
                                      | SYMB_REG _v ->
                                          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | ARCH_REG _v ->
                                          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | _ ->
                                          _eRR ())
                                  | _ ->
                                      _eRR ())
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | AMOXCHGT _v ->
              let _menhir_stack = MenhirCell1_AMOXCHGT (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _menhir_s = MenhirState089 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SYMB_REG _v ->
                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | ARCH_REG _v ->
                      _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | AMOF _v ->
              let _menhir_stack = MenhirCell1_AMOF (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | LPAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | SIZE _v ->
                          let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | STAR ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | RPAR ->
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  (match (_tok : MenhirBasics.token) with
                                  | LPAR ->
                                      let _menhir_s = MenhirState101 in
                                      let _tok = _menhir_lexer _menhir_lexbuf in
                                      (match (_tok : MenhirBasics.token) with
                                      | SYMB_REG _v ->
                                          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | ARCH_REG _v ->
                                          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | _ ->
                                          _eRR ())
                                  | _ ->
                                      _eRR ())
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | AMOCMPXCHGT _v ->
              let _menhir_stack = MenhirCell1_AMOCMPXCHGT (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _menhir_s = MenhirState109 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SYMB_REG _v ->
                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | ARCH_REG _v ->
                      _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ALU_OP _v_19 ->
          let _menhir_stack = MenhirCell0_ALU_OP (_menhir_stack, _v_19) in
          let _menhir_s = MenhirState119 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PLUS ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | GOTO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell0_COND (_menhir_stack, _3) = _menhir_stack in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_15 _2 _3 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_056 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COND _v_0 ->
          let _menhir_stack = MenhirCell0_COND (_menhir_stack, _v_0) in
          let _menhir_s = MenhirState057 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PLUS ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_054 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _11) = _menhir_stack in
      let MenhirCell1_k (_menhir_stack, _, _9) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _4) = _menhir_stack in
      let MenhirCell1_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
      let _12 = _v in
      let _v = _menhir_action_13 _11 _12 _4 _8 _9 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_050 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState050
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
      | _ ->
          _eRR ()
  
  and _menhir_run_039 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _7) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _11 = _v in
      let _v = _menhir_action_05 _11 _3 _7 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_035 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState035
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _9) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell0_SIZE (_menhir_stack, _4) = _menhir_stack in
          let MenhirCell1_STRL (_menhir_stack, _menhir_s) = _menhir_stack in
          let _12 = _v in
          let _v = _menhir_action_07 _12 _4 _8 _9 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_018 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_STRL _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState018
      | NUM _v_0 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState018
      | MINUS ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState018
      | _ ->
          _eRR ()
  
  let _menhir_run_006 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let ps = _v in
      let _v = _menhir_action_28 ps in
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState008
      | STRL ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | STAR ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | NAME _v_1 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState008
      | LOCK ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | IF ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | GOTO ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ARCH_REG _v_2 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState008
      | PIPE | SEMI ->
          let _v_3 = _menhir_action_17 () in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState008 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_PROC_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState002 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState004 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_005 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_34 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState004 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_33 x in
          _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState002
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_32 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ ->
          let _v = _menhir_action_31 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
