
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | SYMB_REG of (
# 33 "lib/RISCVParser.mly"
       (string)
# 15 "lib/RISCVParser.ml"
  )
    | STORE of (
# 49 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 20 "lib/RISCVParser.ml"
  )
    | SEMI
    | SC of (
# 51 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 26 "lib/RISCVParser.ml"
  )
    | RPAR
    | RET
    | PROC of (
# 36 "lib/RISCVParser.mly"
       (int)
# 33 "lib/RISCVParser.ml"
  )
    | PIPE
    | OPW of (
# 45 "lib/RISCVParser.mly"
       (RISCVBase.opw)
# 39 "lib/RISCVParser.ml"
  )
    | OPIW of (
# 42 "lib/RISCVParser.mly"
       (RISCVBase.opiw)
# 44 "lib/RISCVParser.ml"
  )
    | OPI of (
# 41 "lib/RISCVParser.mly"
       (RISCVBase.opi)
# 49 "lib/RISCVParser.ml"
  )
    | OP of (
# 44 "lib/RISCVParser.mly"
       (RISCVBase.op)
# 54 "lib/RISCVParser.ml"
  )
    | NUM of (
# 34 "lib/RISCVParser.mly"
       (int)
# 59 "lib/RISCVParser.ml"
  )
    | NOP
    | NAME of (
# 35 "lib/RISCVParser.mly"
       (string)
# 65 "lib/RISCVParser.ml"
  )
    | MV
    | META of (
# 54 "lib/RISCVParser.mly"
       (string)
# 71 "lib/RISCVParser.ml"
  )
    | LUI
    | LR of (
# 50 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 77 "lib/RISCVParser.ml"
  )
    | LPAR
    | LOAD of (
# 48 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.signed * RISCVBase.mo )
# 83 "lib/RISCVParser.ml"
  )
    | LI
    | LA
    | J
    | FENCETSO
    | FENCEI
    | FENCE
    | EXT of (
# 56 "lib/RISCVParser.mly"
       (RISCVBase.signed * RISCVBase.width)
# 94 "lib/RISCVParser.ml"
  )
    | EOF
    | COMMA
    | COLON
    | BCC of (
# 47 "lib/RISCVParser.mly"
       (RISCVBase.cond)
# 102 "lib/RISCVParser.ml"
  )
    | AUIPC
    | ARCH_REG of (
# 32 "lib/RISCVParser.mly"
       (RISCVBase.reg)
# 108 "lib/RISCVParser.ml"
  )
    | AMO of (
# 52 "lib/RISCVParser.mly"
       (RISCVBase.opamo * RISCVBase.width * RISCVBase.mo)
# 113 "lib/RISCVParser.ml"
  )
  
end

include MenhirBasics

# 1 "lib/RISCVParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2017-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module A=RISCVBase

(* We consider memory order and IO as the same*)
let tr_rw = function
  | "r" -> A.R
  | "ir" -> A.IR
  | "w" -> A.W
  | "ow" -> A.OW 
  | "rw"  -> A.RW
  | "iorw" -> A.IORW
  | _ -> raise Parsing.Parse_error

# 150 "lib/RISCVParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_instr_option_seq) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: instr_option_seq. *)

  | MenhirState001 : (('s, 'r) _menhir_cell1_STORE, 'r) _menhir_state
    (** State 001.
        Stack shape : STORE.
        Start symbol: <undetermined>. *)

  | MenhirState005 : ((('s, 'r) _menhir_cell1_STORE, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 005.
        Stack shape : STORE reg.
        Start symbol: <undetermined>. *)

  | MenhirState007 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_NUM, 'r) _menhir_state
    (** State 007.
        Stack shape : reg NUM.
        Start symbol: <undetermined>. *)

  | MenhirState010 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 010.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState014 : (('s, 'r) _menhir_cell1_SC, 'r) _menhir_state
    (** State 014.
        Stack shape : SC.
        Start symbol: <undetermined>. *)

  | MenhirState016 : ((('s, 'r) _menhir_cell1_SC, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 016.
        Stack shape : SC reg.
        Start symbol: <undetermined>. *)

  | MenhirState018 : (((('s, 'r) _menhir_cell1_SC, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 018.
        Stack shape : SC reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState020 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_NUM, 'r) _menhir_state
    (** State 020.
        Stack shape : reg NUM.
        Start symbol: <undetermined>. *)

  | MenhirState023 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 023.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState028 : (('s, 'r) _menhir_cell1_OPW, 'r) _menhir_state
    (** State 028.
        Stack shape : OPW.
        Start symbol: <undetermined>. *)

  | MenhirState030 : ((('s, 'r) _menhir_cell1_OPW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 030.
        Stack shape : OPW reg.
        Start symbol: <undetermined>. *)

  | MenhirState032 : (((('s, 'r) _menhir_cell1_OPW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 032.
        Stack shape : OPW reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState034 : (('s, 'r) _menhir_cell1_OPIW, 'r) _menhir_state
    (** State 034.
        Stack shape : OPIW.
        Start symbol: <undetermined>. *)

  | MenhirState036 : ((('s, 'r) _menhir_cell1_OPIW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 036.
        Stack shape : OPIW reg.
        Start symbol: <undetermined>. *)

  | MenhirState038 : (((('s, 'r) _menhir_cell1_OPIW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 038.
        Stack shape : OPIW reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState042 : (('s, 'r) _menhir_cell1_OPI, 'r) _menhir_state
    (** State 042.
        Stack shape : OPI.
        Start symbol: <undetermined>. *)

  | MenhirState044 : ((('s, 'r) _menhir_cell1_OPI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 044.
        Stack shape : OPI reg.
        Start symbol: <undetermined>. *)

  | MenhirState046 : (((('s, 'r) _menhir_cell1_OPI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 046.
        Stack shape : OPI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState048 : (('s, 'r) _menhir_cell1_OP, 'r) _menhir_state
    (** State 048.
        Stack shape : OP.
        Start symbol: <undetermined>. *)

  | MenhirState050 : ((('s, 'r) _menhir_cell1_OP, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 050.
        Stack shape : OP reg.
        Start symbol: <undetermined>. *)

  | MenhirState052 : (((('s, 'r) _menhir_cell1_OP, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 052.
        Stack shape : OP reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState056 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 056.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (('s, 'r) _menhir_cell1_MV, 'r) _menhir_state
    (** State 057.
        Stack shape : MV.
        Start symbol: <undetermined>. *)

  | MenhirState059 : ((('s, 'r) _menhir_cell1_MV, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 059.
        Stack shape : MV reg.
        Start symbol: <undetermined>. *)

  | MenhirState061 : (('s, 'r) _menhir_cell1_LUI, 'r) _menhir_state
    (** State 061.
        Stack shape : LUI.
        Start symbol: <undetermined>. *)

  | MenhirState063 : ((('s, 'r) _menhir_cell1_LUI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 063.
        Stack shape : LUI reg.
        Start symbol: <undetermined>. *)

  | MenhirState065 : (('s, 'r) _menhir_cell1_LR, 'r) _menhir_state
    (** State 065.
        Stack shape : LR.
        Start symbol: <undetermined>. *)

  | MenhirState067 : ((('s, 'r) _menhir_cell1_LR, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 067.
        Stack shape : LR reg.
        Start symbol: <undetermined>. *)

  | MenhirState069 : (('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_state
    (** State 069.
        Stack shape : LOAD.
        Start symbol: <undetermined>. *)

  | MenhirState071 : ((('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 071.
        Stack shape : LOAD reg.
        Start symbol: <undetermined>. *)

  | MenhirState073 : (('s, 'r) _menhir_cell1_LI, 'r) _menhir_state
    (** State 073.
        Stack shape : LI.
        Start symbol: <undetermined>. *)

  | MenhirState075 : ((('s, 'r) _menhir_cell1_LI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 075.
        Stack shape : LI reg.
        Start symbol: <undetermined>. *)

  | MenhirState077 : (('s, 'r) _menhir_cell1_LA, 'r) _menhir_state
    (** State 077.
        Stack shape : LA.
        Start symbol: <undetermined>. *)

  | MenhirState089 : (('s, 'r) _menhir_cell1_EXT, 'r) _menhir_state
    (** State 089.
        Stack shape : EXT.
        Start symbol: <undetermined>. *)

  | MenhirState091 : ((('s, 'r) _menhir_cell1_EXT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 091.
        Stack shape : EXT reg.
        Start symbol: <undetermined>. *)

  | MenhirState093 : (('s, 'r) _menhir_cell1_BCC, 'r) _menhir_state
    (** State 093.
        Stack shape : BCC.
        Start symbol: <undetermined>. *)

  | MenhirState095 : ((('s, 'r) _menhir_cell1_BCC, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 095.
        Stack shape : BCC reg.
        Start symbol: <undetermined>. *)

  | MenhirState099 : (('s, 'r) _menhir_cell1_AUIPC, 'r) _menhir_state
    (** State 099.
        Stack shape : AUIPC.
        Start symbol: <undetermined>. *)

  | MenhirState101 : ((('s, 'r) _menhir_cell1_AUIPC, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 101.
        Stack shape : AUIPC reg.
        Start symbol: <undetermined>. *)

  | MenhirState103 : (('s, 'r) _menhir_cell1_AMO, 'r) _menhir_state
    (** State 103.
        Stack shape : AMO.
        Start symbol: <undetermined>. *)

  | MenhirState105 : ((('s, 'r) _menhir_cell1_AMO, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 105.
        Stack shape : AMO reg.
        Start symbol: <undetermined>. *)

  | MenhirState107 : (((('s, 'r) _menhir_cell1_AMO, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 107.
        Stack shape : AMO reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState115 : (('s, _menhir_box_instr_option_seq) _menhir_cell1_instr_option, _menhir_box_instr_option_seq) _menhir_state
    (** State 115.
        Stack shape : instr_option.
        Start symbol: instr_option_seq. *)

  | MenhirState119 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 119.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState121 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 121.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState125 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 125.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState129 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 129.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState132 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 132.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (RISCVBase.parsedPseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (RISCVBase.parsedPseudo list)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (A.reg_arg)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and ('s, 'r) _menhir_cell1_AMO = 
  | MenhirCell1_AMO of 's * ('s, 'r) _menhir_state * (
# 52 "lib/RISCVParser.mly"
       (RISCVBase.opamo * RISCVBase.width * RISCVBase.mo)
# 418 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_AUIPC = 
  | MenhirCell1_AUIPC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BCC = 
  | MenhirCell1_BCC of 's * ('s, 'r) _menhir_state * (
# 47 "lib/RISCVParser.mly"
       (RISCVBase.cond)
# 428 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_EXT = 
  | MenhirCell1_EXT of 's * ('s, 'r) _menhir_state * (
# 56 "lib/RISCVParser.mly"
       (RISCVBase.signed * RISCVBase.width)
# 435 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_LA = 
  | MenhirCell1_LA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LI = 
  | MenhirCell1_LI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOAD = 
  | MenhirCell1_LOAD of 's * ('s, 'r) _menhir_state * (
# 48 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.signed * RISCVBase.mo )
# 448 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LR = 
  | MenhirCell1_LR of 's * ('s, 'r) _menhir_state * (
# 50 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 458 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_LUI = 
  | MenhirCell1_LUI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MV = 
  | MenhirCell1_MV of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 35 "lib/RISCVParser.mly"
       (string)
# 471 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_NUM = 
  | MenhirCell1_NUM of 's * ('s, 'r) _menhir_state * (
# 34 "lib/RISCVParser.mly"
       (int)
# 478 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_OP = 
  | MenhirCell1_OP of 's * ('s, 'r) _menhir_state * (
# 44 "lib/RISCVParser.mly"
       (RISCVBase.op)
# 485 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_OPI = 
  | MenhirCell1_OPI of 's * ('s, 'r) _menhir_state * (
# 41 "lib/RISCVParser.mly"
       (RISCVBase.opi)
# 492 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_OPIW = 
  | MenhirCell1_OPIW of 's * ('s, 'r) _menhir_state * (
# 42 "lib/RISCVParser.mly"
       (RISCVBase.opiw)
# 499 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_OPW = 
  | MenhirCell1_OPW of 's * ('s, 'r) _menhir_state * (
# 45 "lib/RISCVParser.mly"
       (RISCVBase.opw)
# 506 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 36 "lib/RISCVParser.mly"
       (int)
# 513 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_SC = 
  | MenhirCell1_SC of 's * ('s, 'r) _menhir_state * (
# 51 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 520 "lib/RISCVParser.ml"
)

and ('s, 'r) _menhir_cell1_STORE = 
  | MenhirCell1_STORE of 's * ('s, 'r) _menhir_state * (
# 49 "lib/RISCVParser.mly"
       (RISCVBase.width * RISCVBase.mo)
# 527 "lib/RISCVParser.ml"
)

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * RISCVBase.parsedPseudo list list) [@@unboxed]

and _menhir_box_instr_option_seq = 
  | MenhirBox_instr_option_seq of (RISCVBase.parsedPseudo list) [@@unboxed]

let _menhir_action_02 =
  fun _1 _3 ->
    (
# 104 "lib/RISCVParser.mly"
    ( _1,_3 )
# 541 "lib/RISCVParser.ml"
     : (int * A.reg_arg))

let _menhir_action_03 =
  fun _2 ->
    (
# 106 "lib/RISCVParser.mly"
    ( 0,_2 )
# 549 "lib/RISCVParser.ml"
     : (int * A.reg_arg))

let _menhir_action_04 =
  fun _1 _3 ->
    (
# 110 "lib/RISCVParser.mly"
    ( if _1 <> 0 then raise Parsing.Parse_error;
      _3 )
# 558 "lib/RISCVParser.ml"
     : (A.reg_arg))

let _menhir_action_05 =
  fun _2 ->
    (
# 113 "lib/RISCVParser.mly"
    ( _2 )
# 566 "lib/RISCVParser.ml"
     : (A.reg_arg))

let _menhir_action_06 =
  fun () ->
    (
# 117 "lib/RISCVParser.mly"
  ( A.INop )
# 574 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_07 =
  fun () ->
    (
# 119 "lib/RISCVParser.mly"
  ( A.Ret )
# 582 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_08 =
  fun _2 _4 ->
    (
# 122 "lib/RISCVParser.mly"
  ( A.OpI (A.ORI,_2,A.Ireg A.X0,_4) )
# 590 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_09 =
  fun _2 _4 ->
    (
# 124 "lib/RISCVParser.mly"
  ( A.OpA (A.LA,_2,_4) )
# 598 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_10 =
  fun _2 _4 ->
    (
# 126 "lib/RISCVParser.mly"
  ( A.OpI2 (A.LUI,_2,_4) )
# 606 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_11 =
  fun _1 _2 _4 _6 ->
    (
# 128 "lib/RISCVParser.mly"
  ( A.OpI (_1,_2,_4,_6) )
# 614 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_12 =
  fun _1 _2 _4 _6 ->
    (
# 130 "lib/RISCVParser.mly"
  ( A.OpIW (_1,_2,_4,_6) )
# 622 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_13 =
  fun _1 _2 _4 _6 ->
    (
# 132 "lib/RISCVParser.mly"
  ( A.Op (_1,_2,_4,_6) )
# 630 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_14 =
  fun _1 _2 _4 _6 ->
    (
# 134 "lib/RISCVParser.mly"
  ( A.OpW (_1,_2,_4,_6) )
# 638 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_15 =
  fun _2 ->
    (
# 136 "lib/RISCVParser.mly"
    ( A.J _2 )
# 646 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_16 =
  fun _1 _2 _4 _6 ->
    (
# 138 "lib/RISCVParser.mly"
    ( A.Bcc (_1,_2,_4,_6) )
# 654 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_17 =
  fun _2 _4 ->
    (
# 140 "lib/RISCVParser.mly"
    ( A.OpI (A.ADDI, _2, _4, MetaConst.Int 0) )
# 662 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_18 =
  fun _1 _2 _4 ->
    (
# 142 "lib/RISCVParser.mly"
    ( let w,s,mo = _1 in
    let off,r = _4 in
    A.Load (w,s,mo,_2,off,r) )
# 672 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_19 =
  fun _1 _2 _4 ->
    (
# 146 "lib/RISCVParser.mly"
    (let w,mo = _1 in
     let off,r = _4 in
     A.Store (w,mo,_2,off,r) )
# 682 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_20 =
  fun _1 _2 _4 ->
    (
# 150 "lib/RISCVParser.mly"
    ( let w,mo = _1 in
    A.LoadReserve (w,mo,_2,_4) )
# 691 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_21 =
  fun _1 _2 _4 _6 ->
    (
# 153 "lib/RISCVParser.mly"
    ( let w,mo = _1 in
    A.StoreConditional (w,mo,_2,_4,_6) )
# 700 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_22 =
  fun _2 _4 ->
    (
# 156 "lib/RISCVParser.mly"
    ( A.AUIPC (_2, _4) )
# 708 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_23 =
  fun _1 _2 _4 _6 ->
    (
# 158 "lib/RISCVParser.mly"
    ( let op,w,mo = _1 in
    A.Amo (op,w,mo,_2,_4,_6) )
# 717 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_24 =
  fun () ->
    (
# 161 "lib/RISCVParser.mly"
    ( A.FenceIns A.FenceI )
# 725 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_25 =
  fun () ->
    (
# 163 "lib/RISCVParser.mly"
    ( A.FenceIns A.FenceTSO )
# 733 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_26 =
  fun () ->
    (
# 165 "lib/RISCVParser.mly"
    ( A.FenceIns (A.Fence (A.RW,A.RW)) )
# 741 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_27 =
  fun _2 _4 ->
    (
# 167 "lib/RISCVParser.mly"
    ( A.FenceIns (A.Fence (tr_rw _2,tr_rw _4)) )
# 749 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_28 =
  fun _1 _2 _4 ->
    (
# 169 "lib/RISCVParser.mly"
    ( let s,w = _1 in A.Ext (s,w,_2,_4) )
# 757 "lib/RISCVParser.ml"
     : (RISCVBase.pins))

let _menhir_action_29 =
  fun () ->
    (
# 90 "lib/RISCVParser.mly"
             ( A.Nop )
# 765 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo))

let _menhir_action_30 =
  fun _1 _3 ->
    (
# 91 "lib/RISCVParser.mly"
                          ( A.Label (_1,_3) )
# 773 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo))

let _menhir_action_31 =
  fun _1 ->
    (
# 92 "lib/RISCVParser.mly"
             ( A.Instruction _1)
# 781 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo))

let _menhir_action_32 =
  fun _1 ->
    (
# 81 "lib/RISCVParser.mly"
      ([_1])
# 789 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list))

let _menhir_action_33 =
  fun _1 _3 ->
    (
# 83 "lib/RISCVParser.mly"
      (_1::_3)
# 797 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list))

let _menhir_action_34 =
  fun is ->
    (
# 87 "lib/RISCVParser.mly"
                                                      ( is )
# 805 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list))

let _menhir_action_35 =
  fun _1 ->
    (
# 76 "lib/RISCVParser.mly"
    ([_1])
# 813 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list list))

let _menhir_action_36 =
  fun _1 _3 ->
    (
# 77 "lib/RISCVParser.mly"
                                   (_1::_3)
# 821 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list list))

let _menhir_action_37 =
  fun _1 ->
    (
# 99 "lib/RISCVParser.mly"
       ( MetaConst.Int _1 )
# 829 "lib/RISCVParser.ml"
     : (MetaConst.k))

let _menhir_action_38 =
  fun _1 ->
    (
# 100 "lib/RISCVParser.mly"
       ( MetaConst.Meta _1 )
# 837 "lib/RISCVParser.ml"
     : (MetaConst.k))

let _menhir_action_39 =
  fun _2 _3 ->
    (
# 64 "lib/RISCVParser.mly"
                                  ( _2,_3 )
# 845 "lib/RISCVParser.ml"
     : (MiscParser.proc list * RISCVBase.parsedPseudo list list))

let _menhir_action_40 =
  fun ps ->
    (
# 72 "lib/RISCVParser.mly"
  ( List.map (fun p -> p,None,MiscParser.Main) ps )
# 853 "lib/RISCVParser.ml"
     : (MiscParser.proc list))

let _menhir_action_41 =
  fun _1 ->
    (
# 95 "lib/RISCVParser.mly"
           ( A.Symbolic_reg _1 )
# 861 "lib/RISCVParser.ml"
     : (A.reg_arg))

let _menhir_action_42 =
  fun _1 ->
    (
# 96 "lib/RISCVParser.mly"
           ( _1 )
# 869 "lib/RISCVParser.ml"
     : (A.reg_arg))

let _menhir_action_43 =
  fun () ->
    (
# 67 "lib/RISCVParser.mly"
  ( () )
# 877 "lib/RISCVParser.ml"
     : (unit))

let _menhir_action_44 =
  fun () ->
    (
# 68 "lib/RISCVParser.mly"
       ( () )
# 885 "lib/RISCVParser.ml"
     : (unit))

let _menhir_action_45 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 893 "lib/RISCVParser.ml"
     : (int list))

let _menhir_action_46 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 901 "lib/RISCVParser.ml"
     : (int list))

let _menhir_action_47 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 909 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list))

let _menhir_action_48 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 917 "lib/RISCVParser.ml"
     : (RISCVBase.parsedPseudo list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | AMO _ ->
        "AMO"
    | ARCH_REG _ ->
        "ARCH_REG"
    | AUIPC ->
        "AUIPC"
    | BCC _ ->
        "BCC"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | EOF ->
        "EOF"
    | EXT _ ->
        "EXT"
    | FENCE ->
        "FENCE"
    | FENCEI ->
        "FENCEI"
    | FENCETSO ->
        "FENCETSO"
    | J ->
        "J"
    | LA ->
        "LA"
    | LI ->
        "LI"
    | LOAD _ ->
        "LOAD"
    | LPAR ->
        "LPAR"
    | LR _ ->
        "LR"
    | LUI ->
        "LUI"
    | META _ ->
        "META"
    | MV ->
        "MV"
    | NAME _ ->
        "NAME"
    | NOP ->
        "NOP"
    | NUM _ ->
        "NUM"
    | OP _ ->
        "OP"
    | OPI _ ->
        "OPI"
    | OPIW _ ->
        "OPIW"
    | OPW _ ->
        "OPW"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RET ->
        "RET"
    | RPAR ->
        "RPAR"
    | SC _ ->
        "SC"
    | SEMI ->
        "SEMI"
    | STORE _ ->
        "STORE"
    | SYMB_REG _ ->
        "SYMB_REG"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_126 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_39 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState129 ->
          _menhir_run_130 _menhir_stack _v
      | MenhirState125 ->
          _menhir_run_126 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_130 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_36 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let _menhir_run_111 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let is = _v in
      let _v = _menhir_action_34 is in
      MenhirBox_instr_option_seq _v
  
  let rec _menhir_goto_separated_nonempty_list_SEMI_instr_option_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState115 ->
          _menhir_run_116 _menhir_stack _v
      | MenhirState000 ->
          _menhir_run_111 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_116 : type  ttv_stack. (ttv_stack, _menhir_box_instr_option_seq) _menhir_cell1_instr_option -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_48 x xs in
      _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_STORE (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState001 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_41 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState105 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState095 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState093 ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState073 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState065 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState057 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState050 ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState048 ->
          _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState036 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState034 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState030 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState028 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState020 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState016 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState014 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState007 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState001 ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_106 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AMO, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState107 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_019 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NUM (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState020 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_42 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_023 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState023 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AMO as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState105 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AUIPC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState101 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_039 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_37 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_k : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState101 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState075 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState063 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState046 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState038 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_102 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AUIPC, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_AUIPC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_22 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_31 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState125 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState129 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState115 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_131 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | STORE _v_0 ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState132
          | SC _v_1 ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState132
          | RET ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | OPW _v_2 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState132
          | OPIW _v_3 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState132
          | OPI _v_4 ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState132
          | OP _v_5 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState132
          | NOP ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | NAME _v_6 ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState132
          | MV ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LUI ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LR _v_7 ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState132
          | LOAD _v_8 ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState132
          | LI ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LA ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | J ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | FENCETSO ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | FENCEI ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | FENCE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | EXT _v_9 ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState132
          | BCC _v_10 ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState132
          | AUIPC ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | AMO _v_11 ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState132
          | PIPE | SEMI ->
              let _v_12 = _menhir_action_29 () in
              _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState132 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_32 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_014 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_SC (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState014 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_07 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_OPW (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState028 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_OPIW (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState034 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_042 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_OPI (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState042 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_OP (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState048 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_054 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_06 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_055 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | STORE _v_0 ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState056
          | SC _v_1 ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState056
          | RET ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | OPW _v_2 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState056
          | OPIW _v_3 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState056
          | OPI _v_4 ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState056
          | OP _v_5 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState056
          | NOP ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | NAME _v_6 ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState056
          | MV ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | LUI ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | LR _v_7 ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState056
          | LOAD _v_8 ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState056
          | LI ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | LA ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | J ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | FENCETSO ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | FENCEI ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | FENCE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | EXT _v_9 ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState056
          | BCC _v_10 ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState056
          | AUIPC ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
          | AMO _v_11 ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState056
          | EOF | PIPE | SEMI ->
              let _v_12 = _menhir_action_29 () in
              _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_057 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MV (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState057 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LUI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState061 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_LR (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState065 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_069 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_LOAD (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState069 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_073 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState073 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState077 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_081 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_15 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_083 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_25 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_24 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | NAME _v_0 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_2, _4) = (_v, _v_0) in
                  let _v = _menhir_action_27 _2 _4 in
                  _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | EOF | PIPE | SEMI ->
          let _v = _menhir_action_26 () in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_EXT (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState089 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_BCC (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState093 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_AUIPC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState099 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_103 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_AMO (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState103 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_109 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_30 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState129 ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState125 ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_133 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_33 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_128 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STORE _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState129
      | SC _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState129
      | RET ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | OPW _v_2 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState129
      | OPIW _v_3 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState129
      | OPI _v_4 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState129
      | OP _v_5 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState129
      | NOP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | NAME _v_6 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState129
      | MV ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | LUI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | LR _v_7 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState129
      | LOAD _v_8 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState129
      | LI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | LA ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | J ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | FENCETSO ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | FENCEI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | FENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | EXT _v_9 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState129
      | BCC _v_10 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState129
      | AUIPC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState129
      | AMO _v_11 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState129
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_12 = _menhir_action_29 () in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState129 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_35 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | STORE _v_0 ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState115
          | SC _v_1 ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState115
          | RET ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | OPW _v_2 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState115
          | OPIW _v_3 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState115
          | OPI _v_4 ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState115
          | OP _v_5 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState115
          | NOP ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | NAME _v_6 ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState115
          | MV ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | LUI ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | LR _v_7 ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState115
          | LOAD _v_8 ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState115
          | LI ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | LA ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | J ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | FENCETSO ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | FENCEI ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | FENCE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | EXT _v_9 ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState115
          | BCC _v_10 ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState115
          | AUIPC ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | AMO _v_11 ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState115
          | EOF | SEMI ->
              let _v_12 = _menhir_action_29 () in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState115 _tok
          | _ ->
              _eRR ())
      | EOF ->
          let x = _v in
          let _v = _menhir_action_47 x in
          _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LI, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_08 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_064 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LUI, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LUI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_10 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_047 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OPI (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_11 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_041 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPIW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OPIW (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_12 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_040 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_38 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_096 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BCC, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_BCC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
              let (_4, _6) = (_v, _v_0) in
              let _v = _menhir_action_16 _1 _2 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BCC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState095 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_092 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_EXT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_28 _1 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_090 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState091 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_LA (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_09 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState075 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOAD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState071 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NUM (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState007 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState010 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState067 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LUI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState063 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MV, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MV (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_17 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MV as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState059 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OP, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OP (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_13 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_051 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OP, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState052 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OP as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState050 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_045 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState046 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState044 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPIW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState038 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPIW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState036 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_033 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OPW (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_14 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_031 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState032 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState030 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_05 _2 in
          _menhir_goto_addr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_addr0 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState107 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState067 ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState018 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_108 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AMO, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_AMO (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_23 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_068 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LR, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LR (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_20 _1 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_026 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SC, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_21 _1 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_021 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_NUM -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NUM (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_04 _1 _3 in
          _menhir_goto_addr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_017 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SC, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState018 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_015 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState016 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_03 _2 in
          _menhir_goto_addr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_addr : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState071 ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState005 ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOAD, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LOAD (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_18 _1 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_013 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STORE, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STORE (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_19 _1 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_008 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_NUM -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NUM (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_02 _1 _3 in
          _menhir_goto_addr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_004 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STORE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState005 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STORE _v ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | SC _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | RET ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | OPW _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | OPIW _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | OPI _v ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | OP _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | NOP ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NAME _v ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | MV ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LUI ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LR _v ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | LOAD _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | LI ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LA ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | J ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | FENCETSO ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | FENCEI ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | FENCE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EXT _v ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | BCC _v ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | AUIPC ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | AMO _v ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | EOF | SEMI ->
          let _v = _menhir_action_29 () in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_123 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let ps = _v in
      let _v = _menhir_action_40 ps in
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | STORE _v_0 ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState125
      | SC _v_1 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState125
      | RET ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | OPW _v_2 ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState125
      | OPIW _v_3 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState125
      | OPI _v_4 ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState125
      | OP _v_5 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState125
      | NOP ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | NAME _v_6 ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState125
      | MV ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | LUI ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | LR _v_7 ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState125
      | LOAD _v_8 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState125
      | LI ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | LA ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | J ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | FENCETSO ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | FENCEI ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | FENCE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | EXT _v_9 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState125
      | BCC _v_10 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState125
      | AUIPC ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState125
      | AMO _v_11 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState125
      | PIPE | SEMI ->
          let _v_12 = _menhir_action_29 () in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState125 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_PROC_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState119 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_122 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_46 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_120 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState121 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_45 x in
          _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState119
      | _ ->
          _eRR ()
  
  let _menhir_run_117 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_44 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ ->
          let _v = _menhir_action_43 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let instr_option_seq =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_instr_option_seq v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
