
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | SYMB_REG of (
# 23 "lib/X86Parser.mly"
       (string)
# 15 "lib/X86Parser.ml"
  )
    | SEMI
    | RPAR
    | RBRK
    | PROC of (
# 27 "lib/X86Parser.mly"
       (int)
# 23 "lib/X86Parser.ml"
  )
    | PIPE
    | NUM of (
# 24 "lib/X86Parser.mly"
       (string)
# 29 "lib/X86Parser.ml"
  )
    | NAME of (
# 26 "lib/X86Parser.mly"
       (string)
# 34 "lib/X86Parser.ml"
  )
    | LPAR
    | LBRK
    | I_XOR
    | I_XCHG
    | I_SFENCE
    | I_SETNB
    | I_OR
    | I_MOVW
    | I_MOVT
    | I_MOVSD
    | I_MOVQ
    | I_MOVL
    | I_MOVB
    | I_MOV
    | I_MFENCE
    | I_LOCK
    | I_LFENCE
    | I_JNE
    | I_JMP
    | I_JE
    | I_INC
    | I_DEC
    | I_CMPXCHG
    | I_CMP
    | I_CMOVC
    | I_ADD
    | INTEL_NUM of (
# 25 "lib/X86Parser.mly"
       (string)
# 65 "lib/X86Parser.ml"
  )
    | EOF
    | COMMA
    | COLON
    | ARCH_REG of (
# 22 "lib/X86Parser.mly"
       (X86Base.reg)
# 73 "lib/X86Parser.ml"
  )
  
end

include MenhirBasics

# 1 "lib/X86Parser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2010-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module X86 = X86Base

# 100 "lib/X86Parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_main) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: main. *)

  | MenhirState002 : (('s, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_state
    (** State 002.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState005 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 005.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState007 : ((('s, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 007.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState009 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 009.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState010 : (('s, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_state
    (** State 010.
        Stack shape : I_XOR.
        Start symbol: main. *)

  | MenhirState012 : (('s, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 012.
        Stack shape : LPAR.
        Start symbol: main. *)

  | MenhirState016 : (('s, _menhir_box_main) _menhir_cell1_LBRK, _menhir_box_main) _menhir_state
    (** State 016.
        Stack shape : LBRK.
        Start symbol: main. *)

  | MenhirState026 : ((('s, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 026.
        Stack shape : I_XOR effaddr.
        Start symbol: main. *)

  | MenhirState032 : (('s, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_state
    (** State 032.
        Stack shape : I_XCHG.
        Start symbol: main. *)

  | MenhirState034 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 034.
        Stack shape : I_XCHG effaddr.
        Start symbol: main. *)

  | MenhirState037 : (('s, _menhir_box_main) _menhir_cell1_I_SETNB, _menhir_box_main) _menhir_state
    (** State 037.
        Stack shape : I_SETNB.
        Start symbol: main. *)

  | MenhirState039 : (('s, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_state
    (** State 039.
        Stack shape : I_OR.
        Start symbol: main. *)

  | MenhirState041 : ((('s, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 041.
        Stack shape : I_OR effaddr.
        Start symbol: main. *)

  | MenhirState043 : (('s, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_state
    (** State 043.
        Stack shape : I_MOVW.
        Start symbol: main. *)

  | MenhirState045 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 045.
        Stack shape : I_MOVW effaddr.
        Start symbol: main. *)

  | MenhirState047 : (('s, _menhir_box_main) _menhir_cell1_I_MOVT, _menhir_box_main) _menhir_state
    (** State 047.
        Stack shape : I_MOVT.
        Start symbol: main. *)

  | MenhirState049 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVT, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 049.
        Stack shape : I_MOVT effaddr.
        Start symbol: main. *)

  | MenhirState052 : (('s, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_state
    (** State 052.
        Stack shape : I_MOVQ.
        Start symbol: main. *)

  | MenhirState054 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 054.
        Stack shape : I_MOVQ effaddr.
        Start symbol: main. *)

  | MenhirState056 : (('s, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_state
    (** State 056.
        Stack shape : I_MOVL.
        Start symbol: main. *)

  | MenhirState058 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 058.
        Stack shape : I_MOVL effaddr.
        Start symbol: main. *)

  | MenhirState060 : (('s, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_state
    (** State 060.
        Stack shape : I_MOVB.
        Start symbol: main. *)

  | MenhirState062 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 062.
        Stack shape : I_MOVB effaddr.
        Start symbol: main. *)

  | MenhirState064 : (('s, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_state
    (** State 064.
        Stack shape : I_MOV.
        Start symbol: main. *)

  | MenhirState066 : ((('s, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 066.
        Stack shape : I_MOV effaddr.
        Start symbol: main. *)

  | MenhirState069 : (('s, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_state
    (** State 069.
        Stack shape : I_LOCK.
        Start symbol: main. *)

  | MenhirState070 : ((('s, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_state
    (** State 070.
        Stack shape : I_LOCK semi_opt.
        Start symbol: main. *)

  | MenhirState078 : (('s, _menhir_box_main) _menhir_cell1_I_INC, _menhir_box_main) _menhir_state
    (** State 078.
        Stack shape : I_INC.
        Start symbol: main. *)

  | MenhirState080 : (('s, _menhir_box_main) _menhir_cell1_I_DEC, _menhir_box_main) _menhir_state
    (** State 080.
        Stack shape : I_DEC.
        Start symbol: main. *)

  | MenhirState082 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_state
    (** State 082.
        Stack shape : I_CMPXCHG.
        Start symbol: main. *)

  | MenhirState084 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 084.
        Stack shape : I_CMPXCHG effaddr.
        Start symbol: main. *)

  | MenhirState086 : (('s, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_state
    (** State 086.
        Stack shape : I_CMP.
        Start symbol: main. *)

  | MenhirState088 : ((('s, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 088.
        Stack shape : I_CMP effaddr.
        Start symbol: main. *)

  | MenhirState090 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_state
    (** State 090.
        Stack shape : I_CMOVC.
        Start symbol: main. *)

  | MenhirState092 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 092.
        Stack shape : I_CMOVC reg.
        Start symbol: main. *)

  | MenhirState094 : (('s, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_state
    (** State 094.
        Stack shape : I_ADD.
        Start symbol: main. *)

  | MenhirState096 : ((('s, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 096.
        Stack shape : I_ADD effaddr.
        Start symbol: main. *)

  | MenhirState104 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 104.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState107 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 107.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_effaddr = 
  | MenhirCell1_effaddr of 's * ('s, 'r) _menhir_state * (X86.effaddr)

and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (X86Base.pseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (X86Base.pseudo list)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (X86.reg_arg)

and ('s, 'r) _menhir_cell1_semi_opt = 
  | MenhirCell1_semi_opt of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_I_ADD = 
  | MenhirCell1_I_ADD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMOVC = 
  | MenhirCell1_I_CMOVC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMP = 
  | MenhirCell1_I_CMP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHG = 
  | MenhirCell1_I_CMPXCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DEC = 
  | MenhirCell1_I_DEC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INC = 
  | MenhirCell1_I_INC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_LOCK = 
  | MenhirCell1_I_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOV = 
  | MenhirCell1_I_MOV of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVB = 
  | MenhirCell1_I_MOVB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVL = 
  | MenhirCell1_I_MOVL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVQ = 
  | MenhirCell1_I_MOVQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVT = 
  | MenhirCell1_I_MOVT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVW = 
  | MenhirCell1_I_MOVW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_OR = 
  | MenhirCell1_I_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_SETNB = 
  | MenhirCell1_I_SETNB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHG = 
  | MenhirCell1_I_XCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XOR = 
  | MenhirCell1_I_XOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBRK = 
  | MenhirCell1_LBRK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 26 "lib/X86Parser.mly"
       (string)
# 383 "lib/X86Parser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 27 "lib/X86Parser.mly"
       (int)
# 390 "lib/X86Parser.ml"
)

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * X86Base.pseudo list list) [@@unboxed]

let _menhir_action_01 =
  fun _1 ->
    (
# 127 "lib/X86Parser.mly"
          ( X86.Effaddr_rm32 _1 )
# 401 "lib/X86Parser.ml"
     : (X86.effaddr))

let _menhir_action_02 =
  fun _2 _4 ->
    (
# 79 "lib/X86Parser.mly"
    ( X86.I_XOR (_2,_4))
# 409 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_03 =
  fun _2 _4 ->
    (
# 81 "lib/X86Parser.mly"
    ( X86.I_OR (_2,_4))
# 417 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_04 =
  fun _2 _4 ->
    (
# 83 "lib/X86Parser.mly"
    ( X86.I_ADD (_2,_4))
# 425 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_05 =
  fun _2 _4 ->
    (
# 85 "lib/X86Parser.mly"
    ( X86.I_MOV (_2,_4))
# 433 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_06 =
  fun _2 _4 ->
    (
# 87 "lib/X86Parser.mly"
    ( X86.I_MOVB (_2,_4))
# 441 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_07 =
  fun _2 _4 ->
    (
# 89 "lib/X86Parser.mly"
    ( X86.I_MOVW (_2,_4))
# 449 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_08 =
  fun _2 _4 ->
    (
# 91 "lib/X86Parser.mly"
    ( X86.I_MOVL (_2,_4))
# 457 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_09 =
  fun _2 _4 ->
    (
# 93 "lib/X86Parser.mly"
    ( X86.I_MOVQ (_2,_4))
# 465 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_10 =
  fun _2 _4 ->
    (
# 95 "lib/X86Parser.mly"
    ( X86.I_MOVT (_2,_4))
# 473 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_11 =
  fun () ->
    (
# 97 "lib/X86Parser.mly"
    ( X86.I_MOVSD)
# 481 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_12 =
  fun _2 ->
    (
# 99 "lib/X86Parser.mly"
    ( X86.I_DEC _2)
# 489 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_13 =
  fun _2 _4 ->
    (
# 101 "lib/X86Parser.mly"
    ( X86.I_CMP (_2,_4))
# 497 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_14 =
  fun _2 _4 ->
    (
# 103 "lib/X86Parser.mly"
    ( X86.I_CMOVC (_2, _4))
# 505 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_15 =
  fun _2 ->
    (
# 105 "lib/X86Parser.mly"
    ( X86.I_INC _2)
# 513 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_16 =
  fun _2 ->
    (
# 107 "lib/X86Parser.mly"
    ( X86.I_JMP _2)
# 521 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_17 =
  fun _2 ->
    (
# 109 "lib/X86Parser.mly"
    ( X86.I_JCC(X86.C_EQ, _2))
# 529 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_18 =
  fun _2 ->
    (
# 111 "lib/X86Parser.mly"
    ( X86.I_JCC(X86.C_NE, _2))
# 537 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_19 =
  fun _3 ->
    (
# 113 "lib/X86Parser.mly"
    ( X86.I_LOCK _3 )
# 545 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_20 =
  fun _2 _4 ->
    (
# 115 "lib/X86Parser.mly"
    ( X86.I_XCHG (_2,_4))
# 553 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_21 =
  fun _2 _4 ->
    (
# 117 "lib/X86Parser.mly"
    ( X86.I_CMPXCHG (_2,_4))
# 561 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_22 =
  fun () ->
    (
# 119 "lib/X86Parser.mly"
      ( X86.I_LFENCE)
# 569 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_23 =
  fun () ->
    (
# 121 "lib/X86Parser.mly"
      ( X86.I_SFENCE)
# 577 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_24 =
  fun () ->
    (
# 123 "lib/X86Parser.mly"
      ( X86.I_MFENCE)
# 585 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_25 =
  fun _2 ->
    (
# 124 "lib/X86Parser.mly"
                    ( X86.I_SETNB _2 )
# 593 "lib/X86Parser.ml"
     : (X86.pins))

let _menhir_action_26 =
  fun () ->
    (
# 65 "lib/X86Parser.mly"
  ( X86.Nop)
# 601 "lib/X86Parser.ml"
     : (X86Base.pseudo))

let _menhir_action_27 =
  fun _1 _3 ->
    (
# 66 "lib/X86Parser.mly"
                          ( X86.Label (_1,_3) )
# 609 "lib/X86Parser.ml"
     : (X86Base.pseudo))

let _menhir_action_28 =
  fun _1 ->
    (
# 67 "lib/X86Parser.mly"
             ( X86.Instruction _1)
# 617 "lib/X86Parser.ml"
     : (X86Base.pseudo))

let _menhir_action_29 =
  fun _1 ->
    (
# 60 "lib/X86Parser.mly"
      ([_1])
# 625 "lib/X86Parser.ml"
     : (X86Base.pseudo list))

let _menhir_action_30 =
  fun _1 _3 ->
    (
# 62 "lib/X86Parser.mly"
      (_1::_3)
# 633 "lib/X86Parser.ml"
     : (X86Base.pseudo list))

let _menhir_action_31 =
  fun _1 ->
    (
# 55 "lib/X86Parser.mly"
    ([_1])
# 641 "lib/X86Parser.ml"
     : (X86Base.pseudo list list))

let _menhir_action_32 =
  fun _1 _3 ->
    (
# 56 "lib/X86Parser.mly"
                                   (_1::_3)
# 649 "lib/X86Parser.ml"
     : (X86Base.pseudo list list))

let _menhir_action_33 =
  fun _1 ->
    (
# 75 "lib/X86Parser.mly"
      ( _1 )
# 657 "lib/X86Parser.ml"
     : (string))

let _menhir_action_34 =
  fun _2 _3 ->
    (
# 42 "lib/X86Parser.mly"
                                      ( _2,_3 )
# 665 "lib/X86Parser.ml"
     : (MiscParser.proc list * X86Base.pseudo list list))

let _menhir_action_35 =
  fun _1 ->
    (
# 137 "lib/X86Parser.mly"
            ( X86.Operand_effaddr _1)
# 673 "lib/X86Parser.ml"
     : (X86.operand))

let _menhir_action_36 =
  fun _1 ->
    (
# 138 "lib/X86Parser.mly"
      ( X86.Operand_immediate (Misc.string_as_int _1) )
# 681 "lib/X86Parser.ml"
     : (X86.operand))

let _menhir_action_37 =
  fun _1 ->
    (
# 139 "lib/X86Parser.mly"
              ( X86.Operand_immediate (Misc.string_as_int _1))
# 689 "lib/X86Parser.ml"
     : (X86.operand))

let _menhir_action_38 =
  fun _1 ->
    (
# 50 "lib/X86Parser.mly"
             ([_1,None,MiscParser.Main])
# 697 "lib/X86Parser.ml"
     : (MiscParser.proc list))

let _menhir_action_39 =
  fun _1 _3 ->
    (
# 51 "lib/X86Parser.mly"
                       ( (_1,None,MiscParser.Main)::_3 )
# 705 "lib/X86Parser.ml"
     : (MiscParser.proc list))

let _menhir_action_40 =
  fun _1 ->
    (
# 71 "lib/X86Parser.mly"
           ( X86.Symbolic_reg _1 )
# 713 "lib/X86Parser.ml"
     : (X86.reg_arg))

let _menhir_action_41 =
  fun _1 ->
    (
# 72 "lib/X86Parser.mly"
           ( _1 )
# 721 "lib/X86Parser.ml"
     : (X86.reg_arg))

let _menhir_action_42 =
  fun _1 ->
    (
# 130 "lib/X86Parser.mly"
         ( X86.Rm32_reg _1)
# 729 "lib/X86Parser.ml"
     : (X86.rm32))

let _menhir_action_43 =
  fun _2 ->
    (
# 131 "lib/X86Parser.mly"
                    ( X86.Rm32_deref _2)
# 737 "lib/X86Parser.ml"
     : (X86.rm32))

let _menhir_action_44 =
  fun _2 ->
    (
# 132 "lib/X86Parser.mly"
                    ( X86.Rm32_deref _2)
# 745 "lib/X86Parser.ml"
     : (X86.rm32))

let _menhir_action_45 =
  fun _2 ->
    (
# 133 "lib/X86Parser.mly"
                    ( X86.Rm32_abs (Constant.mk_sym _2) )
# 753 "lib/X86Parser.ml"
     : (X86.rm32))

let _menhir_action_46 =
  fun _2 ->
    (
# 134 "lib/X86Parser.mly"
                    ( X86.Rm32_abs (Constant.Concrete _2) )
# 761 "lib/X86Parser.ml"
     : (X86.rm32))

let _menhir_action_47 =
  fun () ->
    (
# 46 "lib/X86Parser.mly"
  ( () )
# 769 "lib/X86Parser.ml"
     : (unit))

let _menhir_action_48 =
  fun () ->
    (
# 47 "lib/X86Parser.mly"
       ( () )
# 777 "lib/X86Parser.ml"
     : (unit))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ARCH_REG _ ->
        "ARCH_REG"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | EOF ->
        "EOF"
    | INTEL_NUM _ ->
        "INTEL_NUM"
    | I_ADD ->
        "I_ADD"
    | I_CMOVC ->
        "I_CMOVC"
    | I_CMP ->
        "I_CMP"
    | I_CMPXCHG ->
        "I_CMPXCHG"
    | I_DEC ->
        "I_DEC"
    | I_INC ->
        "I_INC"
    | I_JE ->
        "I_JE"
    | I_JMP ->
        "I_JMP"
    | I_JNE ->
        "I_JNE"
    | I_LFENCE ->
        "I_LFENCE"
    | I_LOCK ->
        "I_LOCK"
    | I_MFENCE ->
        "I_MFENCE"
    | I_MOV ->
        "I_MOV"
    | I_MOVB ->
        "I_MOVB"
    | I_MOVL ->
        "I_MOVL"
    | I_MOVQ ->
        "I_MOVQ"
    | I_MOVSD ->
        "I_MOVSD"
    | I_MOVT ->
        "I_MOVT"
    | I_MOVW ->
        "I_MOVW"
    | I_OR ->
        "I_OR"
    | I_SETNB ->
        "I_SETNB"
    | I_SFENCE ->
        "I_SFENCE"
    | I_XCHG ->
        "I_XCHG"
    | I_XOR ->
        "I_XOR"
    | LBRK ->
        "LBRK"
    | LPAR ->
        "LPAR"
    | NAME _ ->
        "NAME"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RBRK ->
        "RBRK"
    | RPAR ->
        "RPAR"
    | SEMI ->
        "SEMI"
    | SYMB_REG _ ->
        "SYMB_REG"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_101 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_semi_opt (_menhir_stack, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_34 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState104 ->
          _menhir_run_105 _menhir_stack _v
      | MenhirState007 ->
          _menhir_run_101 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_105 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_32 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_48 () in
      _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState069 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_070 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_LOCK as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_semi_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | I_XOR ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_XCHG ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_SFENCE ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_SETNB ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_OR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVW ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVT ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVSD ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVQ ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVL ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOVB ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MOV ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_MFENCE ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_LOCK ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_LFENCE ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_JNE ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_JMP ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_JE ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_INC ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_DEC ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_CMPXCHG ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_CMP ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_CMOVC ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | I_ADD ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState010 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_40 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState096 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState045 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState041 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState034 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState016 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState012 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_091 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState092 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState012 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_013 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_41 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_016 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          let _menhir_stack = MenhirCell1_LBRK (_menhir_stack, _menhir_s) in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState016
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RBRK ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_46 _2 in
              _menhir_goto_rm32 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RBRK ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_45 _2 in
              _menhir_goto_rm32 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | ARCH_REG _v ->
          let _menhir_stack = MenhirCell1_LBRK (_menhir_stack, _menhir_s) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState016
      | _ ->
          _eRR ()
  
  and _menhir_goto_rm32 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_01 _1 in
      _menhir_goto_effaddr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_effaddr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState094 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState078 ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState064 ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState034 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState032 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState045 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState041 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_095 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADD as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState096 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_effaddr as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_33 _1 in
      let _1 = _v in
      let _v = _menhir_action_36 _1 in
      _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_operand : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_effaddr as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState096 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState062 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState058 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState054 ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState049 ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState045 ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState041 ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState026 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_097 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_04 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState007 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState070 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_100 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_28 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState007 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_106 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState107
          | I_XOR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_XCHG ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_SFENCE ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_SETNB ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_OR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVW ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVT ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVSD ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVQ ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVL ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOVB ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MOV ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_MFENCE ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_LOCK ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_LFENCE ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_JNE ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_JMP ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_JE ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_INC ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_DEC ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_CMPXCHG ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_CMP ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_CMOVC ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | I_ADD ->
              _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | PIPE | SEMI ->
              let _v_1 = _menhir_action_26 () in
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState107 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_29 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_008 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState009
          | I_XOR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHG ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_SFENCE ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_SETNB ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_OR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVW ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVT ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVSD ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVQ ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVL ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVB ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOV ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MFENCE ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_LOCK ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_LFENCE ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JNE ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JMP ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JE ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INC ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DEC ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHG ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMP ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVC ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADD ->
              _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | PIPE | SEMI ->
              let _v_1 = _menhir_action_26 () in
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_032 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHG (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState032 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_036 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_23 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_037 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_SETNB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState037 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_039 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState039 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState043 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState047 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_11 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_052 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState052 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_056 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState056 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState060 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOV (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState064 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_068 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_24 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_069 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | I_ADD | I_CMOVC | I_CMP | I_CMPXCHG | I_DEC | I_INC | I_JE | I_JMP | I_JNE | I_LFENCE | I_LOCK | I_MFENCE | I_MOV | I_MOVB | I_MOVL | I_MOVQ | I_MOVSD | I_MOVT | I_MOVW | I_OR | I_SETNB | I_SFENCE | I_XCHG | I_XOR ->
          let _v = _menhir_action_47 () in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_071 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_22 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_072 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_18 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_16 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_17 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState078 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DEC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState080 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHG (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState082 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMP (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState086 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_090 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState090 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState094 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_27 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState107 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState104 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState007 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_108 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_30 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_103 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState104
      | I_XOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_XCHG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_SFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_SETNB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_OR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVSD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOVB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MOV ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_MFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_LOCK ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_LFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_JNE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_JMP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_JE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_INC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_DEC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_CMPXCHG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_CMP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_CMOVC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | I_ADD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_1 = _menhir_action_26 () in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState104 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_31 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_cell1_semi_opt -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_semi_opt (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_I_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_19 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_089 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMP (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_13 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_067 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOV (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_05 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_063 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_06 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_059 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_08 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_055 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_09 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_050 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVT, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_10 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_046 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_07 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_042 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_OR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_03 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_029 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_02 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_028 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_effaddr as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_37 _1 in
      _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_093 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_14 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_087 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMP as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState088 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_083 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHG as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState084 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_081 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DEC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DEC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_12 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_079 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_15 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_065 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOV as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState062 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_057 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState058 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState054 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState049 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState045 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_OR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState041 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_038 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_SETNB -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_SETNB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_25 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_035 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHG (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_20 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_033 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHG as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState034 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_effaddr as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_35 _1 in
      _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_025 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XOR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState026 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEL_NUM _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHG (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_21 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_024 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_42 _1 in
      _menhir_goto_rm32 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_021 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LBRK -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRK ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LBRK (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_44 _2 in
          _menhir_goto_rm32 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_014 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_43 _2 in
          _menhir_goto_rm32 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_semi_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState002
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_38 _1 in
          _menhir_goto_proc_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState005 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_proc_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState002 ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_007 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState007
      | I_XOR ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHG ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_SFENCE ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_SETNB ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_OR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVW ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVT ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVSD ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVQ ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVL ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVB ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOV ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MFENCE ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_LOCK ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_LFENCE ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JNE ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JMP ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JE ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INC ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DEC ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHG ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMP ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVC ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADD ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | PIPE | SEMI ->
          let _v_1 = _menhir_action_26 () in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState007 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_39 _1 _3 in
      _menhir_goto_proc_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | PROC _ ->
          let _v = _menhir_action_47 () in
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
