
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | RPAR
    | PROC of (
# 22 "lib/scopeParser.mly"
       (int)
# 16 "lib/scopeParser.ml"
  )
    | NUM of (
# 21 "lib/scopeParser.mly"
       (int)
# 21 "lib/scopeParser.ml"
  )
    | NAME of (
# 23 "lib/scopeParser.mly"
       (string)
# 26 "lib/scopeParser.ml"
  )
    | LPAR
    | EOF
    | COMMA
    | COLON
  
end

include MenhirBasics

# 1 "lib/scopeParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 55 "lib/scopeParser.ml"

# 1 "lib/scopeRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2019-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 75 "lib/scopeParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState00 : ('s, _menhir_box_main) _menhir_state
    (** State 00.
        Stack shape : .
        Start symbol: main. *)

  | MenhirState02 : (('s, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME, _menhir_box_main) _menhir_state
    (** State 02.
        Stack shape : LPAR NAME.
        Start symbol: main. *)

  | MenhirState07 : (('s, _menhir_box_main) _menhir_cell1_scope_tree, _menhir_box_main) _menhir_state
    (** State 07.
        Stack shape : scope_tree.
        Start symbol: main. *)

  | MenhirState11 : (('s, _menhir_box_main) _menhir_cell1_proc, _menhir_box_main) _menhir_state
    (** State 11.
        Stack shape : proc.
        Start symbol: main. *)

  | MenhirState17 : ('s, _menhir_box_main_level) _menhir_state
    (** State 17.
        Stack shape : .
        Start symbol: main_level. *)

  | MenhirState18 : (('s, _menhir_box_main_level) _menhir_cell1_PROC, _menhir_box_main_level) _menhir_state
    (** State 18.
        Stack shape : PROC.
        Start symbol: main_level. *)

  | MenhirState20 : (('s, _menhir_box_main_level) _menhir_cell1_LPAR _menhir_cell0_NAME, _menhir_box_main_level) _menhir_state
    (** State 20.
        Stack shape : LPAR NAME.
        Start symbol: main_level. *)

  | MenhirState23 : (('s, _menhir_box_main_level) _menhir_cell1_level_tree, _menhir_box_main_level) _menhir_state
    (** State 23.
        Stack shape : level_tree.
        Start symbol: main_level. *)

  | MenhirState30 : ('s, _menhir_box_main_memory_map) _menhir_state
    (** State 30.
        Stack shape : .
        Start symbol: main_memory_map. *)

  | MenhirState32 : (('s, _menhir_box_main_memory_map) _menhir_cell1_NAME, _menhir_box_main_memory_map) _menhir_state
    (** State 32.
        Stack shape : NAME.
        Start symbol: main_memory_map. *)

  | MenhirState33 : (('s, _menhir_box_main_memory_map) _menhir_cell1_NAME, _menhir_box_main_memory_map) _menhir_state
    (** State 33.
        Stack shape : NAME.
        Start symbol: main_memory_map. *)

  | MenhirState40 : (('s, _menhir_box_main_memory_map) _menhir_cell1_memory_map_atom, _menhir_box_main_memory_map) _menhir_state
    (** State 40.
        Stack shape : memory_map_atom.
        Start symbol: main_memory_map. *)


and ('s, 'r) _menhir_cell1_level_tree = 
  | MenhirCell1_level_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_memory_map_atom = 
  | MenhirCell1_memory_map_atom of 's * ('s, 'r) _menhir_state * (string * string list)

and ('s, 'r) _menhir_cell1_proc = 
  | MenhirCell1_proc of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_scope_tree = 
  | MenhirCell1_scope_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 23 "lib/scopeParser.mly"
       (string)
# 158 "lib/scopeParser.ml"
)

and 's _menhir_cell0_NAME = 
  | MenhirCell0_NAME of 's * (
# 23 "lib/scopeParser.mly"
       (string)
# 165 "lib/scopeParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 22 "lib/scopeParser.mly"
       (int)
# 172 "lib/scopeParser.ml"
)

and _menhir_box_main_memory_map = 
  | MenhirBox_main_memory_map of (BellInfo.mem_space_map) [@@unboxed]

and _menhir_box_main_level = 
  | MenhirBox_main_level of (BellInfo.scopes) [@@unboxed]

and _menhir_box_main = 
  | MenhirBox_main of (BellInfo.scopes) [@@unboxed]

let _menhir_action_03 =
  fun _2 _3 ->
    (
# 62 "lib/scopeRules.mly"
  (
   let ps,ts = _3 in
   BellInfo.Tree (_2,ps,ts)
   )
# 192 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_04 =
  fun _1 ->
    (
# 51 "lib/scopeRules.mly"
       ( [_1],[] )
# 200 "lib/scopeParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_05 =
  fun _1 ->
    (
# 52 "lib/scopeRules.mly"
             (let ps =  [] in ps,[_1])
# 208 "lib/scopeParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_06 =
  fun _1 _2 ->
    (
# 54 "lib/scopeRules.mly"
    ( let ps,ts = _2 in
      _1::ps,ts )
# 217 "lib/scopeParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_07 =
  fun _1 _2 ->
    (
# 57 "lib/scopeRules.mly"
    (let ps,ts = _2 in
     ps,_1::ts )
# 226 "lib/scopeParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_08 =
  fun () ->
    (
# 145 "<standard.mly>"
    ( [] )
# 234 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_09 =
  fun x ->
    (
# 148 "<standard.mly>"
    ( x )
# 242 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_10 =
  fun _1 ->
    (
# 35 "lib/scopeParser.mly"
                     ( _1 )
# 250 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_11 =
  fun _1 ->
    (
# 38 "lib/scopeParser.mly"
                     ( _1 )
# 258 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_12 =
  fun _1 ->
    (
# 41 "lib/scopeParser.mly"
                     ( _1 )
# 266 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_13 =
  fun _1 _3 ->
    (
# 75 "lib/scopeRules.mly"
                                  ( (_1,_3) )
# 274 "lib/scopeParser.ml"
     : (string * string list))

let _menhir_action_14 =
  fun x ->
    (
# 228 "<standard.mly>"
    ( [ x ] )
# 282 "lib/scopeParser.ml"
     : (string list))

let _menhir_action_15 =
  fun x xs ->
    (
# 231 "<standard.mly>"
    ( x :: xs )
# 290 "lib/scopeParser.ml"
     : (string list))

let _menhir_action_16 =
  fun _1 ->
    (
# 22 "lib/scopeRules.mly"
        ( _1 )
# 298 "lib/scopeParser.ml"
     : (int))

let _menhir_action_17 =
  fun _1 ->
    (
# 23 "lib/scopeRules.mly"
        ( _1 )
# 306 "lib/scopeParser.ml"
     : (int))

let _menhir_action_18 =
  fun _1 _2 ->
    (
# 26 "lib/scopeRules.mly"
                    (_1::_2)
# 314 "lib/scopeParser.ml"
     : (int list))

let _menhir_action_19 =
  fun () ->
    (
# 27 "lib/scopeRules.mly"
  ([])
# 322 "lib/scopeParser.ml"
     : (int list))

let _menhir_action_20 =
  fun _2 _3 ->
    (
# 35 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,[],_3)
   )
# 332 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_21 =
  fun _2 _3 ->
    (
# 39 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,_3,[])
   )
# 342 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_22 =
  fun _1 ->
    (
# 30 "lib/scopeRules.mly"
             ([_1])
# 350 "lib/scopeParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_23 =
  fun _1 _2 ->
    (
# 31 "lib/scopeRules.mly"
                             (_1::_2)
# 358 "lib/scopeParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_24 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 366 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_25 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 374 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_26 =
  fun _1 ->
    (
# 69 "lib/scopeRules.mly"
    ( let ps,ts = _1 in
      match ps,ts with
      | [],[t] -> t
      | _ -> BellInfo.Tree ("",ps,ts) )
# 385 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_action_27 =
  fun xs ->
    let atoms = 
# 241 "<standard.mly>"
    ( xs )
# 393 "lib/scopeParser.ml"
     in
    (
# 78 "lib/scopeRules.mly"
                                                 ( atoms )
# 398 "lib/scopeParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_28 =
  fun _1 ->
    (
# 45 "lib/scopeRules.mly"
    ( let ts = _1 in
      match ts with
      | [t] -> t
      | _ -> BellInfo.Tree ("",[],ts) )
# 409 "lib/scopeParser.ml"
     : (BellInfo.scopes))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | EOF ->
        "EOF"
    | LPAR ->
        "LPAR"
    | NAME _ ->
        "NAME"
    | NUM _ ->
        "NUM"
    | PROC _ ->
        "PROC"
    | RPAR ->
        "RPAR"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_15 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_28 _1 in
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_10 _1 in
          MenhirBox_main _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_01 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState02
          | NUM _v_1 ->
              _menhir_run_04 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState02
          | LPAR ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState02
          | RPAR ->
              let _v_2 = _menhir_action_19 () in
              _menhir_run_09 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_03 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_16 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_proc : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState11
      | NUM _v_1 ->
          _menhir_run_04 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState11
      | RPAR ->
          let _v_2 = _menhir_action_19 () in
          _menhir_run_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
      | _ ->
          _eRR ()
  
  and _menhir_run_04 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_17 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_12 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_proc -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_proc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_18 _1 _2 in
      _menhir_goto_proc_list_sc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_proc_list_sc : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState11 ->
          _menhir_run_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState02 ->
          _menhir_run_09 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_09 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_21 _2 _3 in
      _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scope_tree : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _v) in
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState07
      | EOF | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_22 _1 in
          _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_scope_tree_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState00 ->
          _menhir_run_15 _menhir_stack _v _tok
      | MenhirState07 ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState02 ->
          _menhir_run_05 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_08 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_scope_tree -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_23 _1 _2 in
      _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_05 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_20 _2 _3 in
          _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_00 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState00 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_29 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main_level =
    fun _menhir_stack _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_26 _1 in
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_11 _1 in
          MenhirBox_main_level _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_18 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main_level) _menhir_state -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_18 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState18
      | LPAR ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_19 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState18
      | EOF | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_04 _1 in
          _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_19 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main_level) _menhir_state -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _menhir_s = MenhirState20 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_18 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_19 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_level_tree_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main_level) _menhir_state -> _ -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState17 ->
          _menhir_run_29 _menhir_stack _v _tok
      | MenhirState18 ->
          _menhir_run_25 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState23 ->
          _menhir_run_24 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState20 ->
          _menhir_run_21 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_25 : type  ttv_stack. (ttv_stack, _menhir_box_main_level) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_06 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_24 : type  ttv_stack. (ttv_stack, _menhir_box_main_level) _menhir_cell1_level_tree -> _ -> _ -> _ -> _ -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_level_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_07 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_21 : type  ttv_stack. (ttv_stack, _menhir_box_main_level) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_03 _2 _3 in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_18 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState23
          | LPAR ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_19 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState23
          | EOF | RPAR ->
              let _1 = _v in
              let _v = _menhir_action_05 _1 in
              _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_17 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main_level =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState17 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PROC _v ->
          _menhir_run_18 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_19 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ : type  ttv_stack. ttv_stack -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _v ->
      let xs = _v in
      let _v = _menhir_action_27 xs in
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      MenhirBox_main_memory_map _v
  
  let _menhir_run_38 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _v ->
      let x = _v in
      let _v = _menhir_action_09 x in
      _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _v
  
  let rec _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main_memory_map) _menhir_state -> _menhir_box_main_memory_map =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState40 ->
          _menhir_run_41 _menhir_stack _v
      | MenhirState30 ->
          _menhir_run_38 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_41 : type  ttv_stack. (ttv_stack, _menhir_box_main_memory_map) _menhir_cell1_memory_map_atom -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _v ->
      let MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_25 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _v _menhir_s
  
  let rec _menhir_run_31 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main_memory_map) _menhir_state -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState32 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_33 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_33 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main_memory_map) _menhir_state -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          _menhir_run_33 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState33
      | COMMA | EOF ->
          let x = _v in
          let _v = _menhir_action_14 x in
          _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_nonempty_list_NAME_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main_memory_map) _menhir_state -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState32 ->
          _menhir_run_35 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState33 ->
          _menhir_run_34 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_35 : type  ttv_stack. (ttv_stack, _menhir_box_main_memory_map) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_13 _1 _3 in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState40 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_31 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | EOF ->
          let x = _v in
          let _v = _menhir_action_24 x in
          _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_34 : type  ttv_stack. (ttv_stack, _menhir_box_main_memory_map) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_15 x xs in
      _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_30 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main_memory_map =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState30 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_31 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EOF ->
          let _v = _menhir_action_08 () in
          _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _v
      | _ ->
          _eRR ()
  
end

let main_memory_map =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main_memory_map v = _menhir_run_30 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let main_level =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main_level v = _menhir_run_17 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_00 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
