
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XOR
    | XCHG
    | WHILE
    | WCAS_EXPLICIT
    | WCAS
    | VOLATILE
    | VOID
    | UNLOCK
    | UNDERFENCE
    | UNDERATOMICOPRETURN
    | UNDERATOMICOP
    | UNDERATOMICFETCHOP
    | UNDERATOMICADDUNLESS
    | SUB
    | ST_EXPLICIT
    | STRUCT_TYPE of (
# 29 "lib/CParser.mly"
       (string)
# 30 "lib/CParser.ml"
  )
    | STRUCT
    | STORE
    | STAR
    | SRCU
    | SPINUNLOCK
    | SPINTRYLOCK
    | SPINLOCK
    | SPINISLOCKED
    | SEMI
    | SCOPES
    | SCAS_EXPLICIT
    | SCAS
    | RPAR
    | REGIONS
    | RBRACE
    | PROC of (
# 33 "lib/CParser.mly"
       (int)
# 50 "lib/CParser.ml"
  )
    | PIPE
    | NUM of (
# 43 "lib/CParser.mly"
       (int)
# 56 "lib/CParser.ml"
  )
    | NOT
    | NEQ_OP
    | NAME of (
# 27 "lib/CParser.mly"
       (string)
# 63 "lib/CParser.ml"
  )
    | MUTEX
    | MEMORDER of (
# 60 "lib/CParser.mly"
       (MemOrder.t)
# 69 "lib/CParser.ml"
  )
    | LT
    | LPAR
    | LONG
    | LOCK
    | LOAD
    | LEVELS
    | LE
    | LD_EXPLICIT
    | LBRACE
    | LAND
    | INT
    | IF
    | GT
    | GE
    | FENCE
    | EXC_EXPLICIT
    | EQ_OP
    | EQ
    | EOF
    | ELSE
    | DIV
    | CONSTVAR of (
# 31 "lib/CParser.mly"
       (string)
# 95 "lib/CParser.ml"
  )
    | CONSTANT of (
# 51 "lib/CParser.mly"
       (string)
# 100 "lib/CParser.ml"
  )
    | CONST
    | COMMA
    | COLON
    | CODEVAR of (
# 32 "lib/CParser.mly"
       (string)
# 108 "lib/CParser.ml"
  )
    | CMPXCHG
    | CHAR
    | BODY of (
# 46 "lib/CParser.mly"
       (string)
# 115 "lib/CParser.ml"
  )
    | BASE_TYPE of (
# 28 "lib/CParser.mly"
       (string)
# 120 "lib/CParser.ml"
  )
    | ATOMIC_TYPE of (
# 30 "lib/CParser.mly"
       (string)
# 125 "lib/CParser.ml"
  )
    | ATOMIC_FETCH_EXPLICIT of (
# 65 "lib/CParser.mly"
       (CBase.op)
# 130 "lib/CParser.ml"
  )
    | ATOMIC_BASE
    | ATOMIC
    | ADD
  
end

include MenhirBasics

# 1 "lib/BellExtraRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)
open BellInfo
let nones = { scopes=None; levels=None; regions=None; }

# 160 "lib/CParser.ml"

# 1 "lib/CParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

let mk_sym s = Constant.mk_sym s

open CBase
open MemOrder
open CType
open MemOrderOrAnnot

# 187 "lib/CParser.ml"

# 1 "lib/scopeRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2019-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 207 "lib/CParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_deep_main) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: deep_main. *)

  | MenhirState005 : (('s, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_state
    (** State 005.
        Stack shape : voidopt PROC.
        Start symbol: deep_main. *)

  | MenhirState006 : (('s, 'r) _menhir_cell1_VOLATILE, 'r) _menhir_state
    (** State 006.
        Stack shape : VOLATILE.
        Start symbol: <undetermined>. *)

  | MenhirState009 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 009.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState011 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 011.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState012 : (('s, 'r) _menhir_cell1_CONST, 'r) _menhir_state
    (** State 012.
        Stack shape : CONST.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (('s, 'r) _menhir_cell1_ATOMIC, 'r) _menhir_state
    (** State 026.
        Stack shape : ATOMIC.
        Start symbol: <undetermined>. *)

  | MenhirState046 : ((('s, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_cell1_parameter_list, _menhir_box_deep_main) _menhir_state
    (** State 046.
        Stack shape : voidopt PROC parameter_list.
        Start symbol: deep_main. *)

  | MenhirState048 : (('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_state
    (** State 048.
        Stack shape : XCHG.
        Start symbol: <undetermined>. *)

  | MenhirState055 : ((('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 055.
        Stack shape : XCHG annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_state
    (** State 057.
        Stack shape : WCAS_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState059 : (('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_state
    (** State 059.
        Stack shape : WCAS.
        Start symbol: <undetermined>. *)

  | MenhirState061 : (('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_state
    (** State 061.
        Stack shape : UNDERATOMICOPRETURN.
        Start symbol: <undetermined>. *)

  | MenhirState064 : ((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 064.
        Stack shape : UNDERATOMICOPRETURN annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState066 : (('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_state
    (** State 066.
        Stack shape : UNDERATOMICFETCHOP.
        Start symbol: <undetermined>. *)

  | MenhirState069 : ((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 069.
        Stack shape : UNDERATOMICFETCHOP annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_state
    (** State 071.
        Stack shape : UNDERATOMICADDUNLESS.
        Start symbol: <undetermined>. *)

  | MenhirState074 : ((('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 074.
        Stack shape : UNDERATOMICADDUNLESS annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState075 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 075.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState077 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 077.
        Stack shape : STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState079 : (('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_state
    (** State 079.
        Stack shape : SRCU.
        Start symbol: <undetermined>. *)

  | MenhirState082 : ((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 082.
        Stack shape : SRCU annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState084 : (('s, 'r) _menhir_cell1_SPINTRYLOCK, 'r) _menhir_state
    (** State 084.
        Stack shape : SPINTRYLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState086 : (('s, 'r) _menhir_cell1_SPINISLOCKED, 'r) _menhir_state
    (** State 086.
        Stack shape : SPINISLOCKED.
        Start symbol: <undetermined>. *)

  | MenhirState088 : (('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_state
    (** State 088.
        Stack shape : SCAS_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState090 : (('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_state
    (** State 090.
        Stack shape : SCAS.
        Start symbol: <undetermined>. *)

  | MenhirState092 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 092.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState093 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 093.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState094 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 094.
        Stack shape : LPAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState096 : (('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_state
    (** State 096.
        Stack shape : LOAD.
        Start symbol: <undetermined>. *)

  | MenhirState099 : ((('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 099.
        Stack shape : LOAD annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState101 : (('s, 'r) _menhir_cell1_LD_EXPLICIT, 'r) _menhir_state
    (** State 101.
        Stack shape : LD_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState103 : (('s, 'r) _menhir_cell1_EXC_EXPLICIT, 'r) _menhir_state
    (** State 103.
        Stack shape : EXC_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState107 : (('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_state
    (** State 107.
        Stack shape : CMPXCHG.
        Start symbol: <undetermined>. *)

  | MenhirState110 : ((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 110.
        Stack shape : CMPXCHG annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState112 : (('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, 'r) _menhir_state
    (** State 112.
        Stack shape : ATOMIC_FETCH_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState116 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 116.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState118 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 118.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState120 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 120.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState122 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 122.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState124 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 124.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState126 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 126.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState128 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 128.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState130 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 130.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState132 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 132.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState134 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 134.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState136 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 136.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState138 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 138.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState140 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 140.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState142 : ((('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 142.
        Stack shape : ATOMIC_FETCH_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState148 : (((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 148.
        Stack shape : CMPXCHG annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState150 : ((((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 150.
        Stack shape : CMPXCHG annot_list expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState154 : (('s, 'r) _menhir_cell1_annot_base, 'r) _menhir_state
    (** State 154.
        Stack shape : annot_base.
        Start symbol: <undetermined>. *)

  | MenhirState157 : (('s, 'r) _menhir_cell1_annot, 'r) _menhir_state
    (** State 157.
        Stack shape : annot.
        Start symbol: <undetermined>. *)

  | MenhirState160 : ((('s, 'r) _menhir_cell1_EXC_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 160.
        Stack shape : EXC_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState172 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_typ, 'r) _menhir_state
    (** State 172.
        Stack shape : LPAR typ.
        Start symbol: <undetermined>. *)

  | MenhirState177 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_typ, 'r) _menhir_state
    (** State 177.
        Stack shape : LPAR typ.
        Start symbol: <undetermined>. *)

  | MenhirState179 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 179.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState185 : ((('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 185.
        Stack shape : SCAS expr.
        Start symbol: <undetermined>. *)

  | MenhirState187 : (((('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 187.
        Stack shape : SCAS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState191 : ((('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 191.
        Stack shape : SCAS_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState193 : (((('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 193.
        Stack shape : SCAS_EXPLICIT expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState212 : (((('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 212.
        Stack shape : UNDERATOMICADDUNLESS annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState214 : ((((('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 214.
        Stack shape : UNDERATOMICADDUNLESS annot_list expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState218 : (((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 218.
        Stack shape : UNDERATOMICFETCHOP annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState226 : ((((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 226.
        Stack shape : UNDERATOMICFETCHOP annot_list expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState230 : (((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 230.
        Stack shape : UNDERATOMICOPRETURN annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState232 : ((((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 232.
        Stack shape : UNDERATOMICOPRETURN annot_list expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState236 : ((('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 236.
        Stack shape : WCAS expr.
        Start symbol: <undetermined>. *)

  | MenhirState238 : (((('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 238.
        Stack shape : WCAS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState242 : ((('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 242.
        Stack shape : WCAS_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState244 : (((('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 244.
        Stack shape : WCAS_EXPLICIT expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState252 : (((('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 252.
        Stack shape : XCHG annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState255 : (('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_state
    (** State 255.
        Stack shape : WHILE.
        Start symbol: <undetermined>. *)

  | MenhirState256 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 256.
        Stack shape : WHILE STAR.
        Start symbol: <undetermined>. *)

  | MenhirState258 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 258.
        Stack shape : WHILE LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState259 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr0, 'r) _menhir_state
    (** State 259.
        Stack shape : WHILE expr0.
        Start symbol: <undetermined>. *)

  | MenhirState261 : (('s, 'r) _menhir_cell1_UNLOCK, 'r) _menhir_state
    (** State 261.
        Stack shape : UNLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState266 : (('s, 'r) _menhir_cell1_UNDERFENCE, 'r) _menhir_state
    (** State 266.
        Stack shape : UNDERFENCE.
        Start symbol: <undetermined>. *)

  | MenhirState271 : (('s, 'r) _menhir_cell1_UNDERATOMICOP, 'r) _menhir_state
    (** State 271.
        Stack shape : UNDERATOMICOP.
        Start symbol: <undetermined>. *)

  | MenhirState275 : (('s, 'r) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot, 'r) _menhir_state
    (** State 275.
        Stack shape : UNDERATOMICOP opt_annot.
        Start symbol: <undetermined>. *)

  | MenhirState277 : ((('s, 'r) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 277.
        Stack shape : UNDERATOMICOP opt_annot expr.
        Start symbol: <undetermined>. *)

  | MenhirState279 : (((('s, 'r) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 279.
        Stack shape : UNDERATOMICOP opt_annot expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState284 : (('s, 'r) _menhir_cell1_ST_EXPLICIT, 'r) _menhir_state
    (** State 284.
        Stack shape : ST_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState286 : ((('s, 'r) _menhir_cell1_ST_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 286.
        Stack shape : ST_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState293 : (('s, 'r) _menhir_cell1_STORE, 'r) _menhir_state
    (** State 293.
        Stack shape : STORE.
        Start symbol: <undetermined>. *)

  | MenhirState296 : ((('s, 'r) _menhir_cell1_STORE, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 296.
        Stack shape : STORE annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState298 : (((('s, 'r) _menhir_cell1_STORE, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 298.
        Stack shape : STORE annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState302 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 302.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState303 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 303.
        Stack shape : STAR STAR.
        Start symbol: <undetermined>. *)

  | MenhirState305 : (((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 305.
        Stack shape : STAR STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState310 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 310.
        Stack shape : STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState314 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_location, 'r) _menhir_state
    (** State 314.
        Stack shape : STAR location.
        Start symbol: <undetermined>. *)

  | MenhirState318 : (('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_state
    (** State 318.
        Stack shape : SRCU.
        Start symbol: <undetermined>. *)

  | MenhirState321 : ((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 321.
        Stack shape : SRCU annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState325 : (((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 325.
        Stack shape : SRCU annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState330 : (('s, 'r) _menhir_cell1_SPINUNLOCK, 'r) _menhir_state
    (** State 330.
        Stack shape : SPINUNLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState335 : (('s, 'r) _menhir_cell1_SPINLOCK, 'r) _menhir_state
    (** State 335.
        Stack shape : SPINLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState340 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 340.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState344 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 344.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState347 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 347.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState349 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_VOID, 'r) _menhir_state
    (** State 349.
        Stack shape : LPAR VOID.
        Start symbol: <undetermined>. *)

  | MenhirState353 : (('s, 'r) _menhir_cell1_LOCK, 'r) _menhir_state
    (** State 353.
        Stack shape : LOCK.
        Start symbol: <undetermined>. *)

  | MenhirState357 : (('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_state
    (** State 357.
        Stack shape : LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState359 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 359.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState361 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 361.
        Stack shape : IF expr.
        Start symbol: <undetermined>. *)

  | MenhirState371 : (('s, 'r) _menhir_cell1_typ _menhir_cell0_NAME, 'r) _menhir_state
    (** State 371.
        Stack shape : typ NAME.
        Start symbol: <undetermined>. *)

  | MenhirState379 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 379.
        Stack shape : IF expr block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState386 : (('s, 'r) _menhir_cell1_declaration, 'r) _menhir_state
    (** State 386.
        Stack shape : declaration.
        Start symbol: <undetermined>. *)

  | MenhirState388 : (('s, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 388.
        Stack shape : block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState393 : (('s, 'r) _menhir_cell1_declaration, 'r) _menhir_state
    (** State 393.
        Stack shape : declaration.
        Start symbol: <undetermined>. *)

  | MenhirState395 : (('s, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 395.
        Stack shape : block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState398 : (('s, 'r) _menhir_cell1_parameter_declaration, 'r) _menhir_state
    (** State 398.
        Stack shape : parameter_declaration.
        Start symbol: <undetermined>. *)

  | MenhirState400 : (('s, _menhir_box_deep_main) _menhir_cell1_trans_unit, _menhir_box_deep_main) _menhir_state
    (** State 400.
        Stack shape : trans_unit.
        Start symbol: deep_main. *)

  | MenhirState402 : (('s, 'r) _menhir_cell1_SCOPES, 'r) _menhir_state
    (** State 402.
        Stack shape : SCOPES.
        Start symbol: <undetermined>. *)

  | MenhirState404 : (('s, 'r) _menhir_cell1_LPAR _menhir_cell0_NAME, 'r) _menhir_state
    (** State 404.
        Stack shape : LPAR NAME.
        Start symbol: <undetermined>. *)

  | MenhirState409 : (('s, 'r) _menhir_cell1_scope_tree, 'r) _menhir_state
    (** State 409.
        Stack shape : scope_tree.
        Start symbol: <undetermined>. *)

  | MenhirState413 : (('s, 'r) _menhir_cell1_proc, 'r) _menhir_state
    (** State 413.
        Stack shape : proc.
        Start symbol: <undetermined>. *)

  | MenhirState418 : (('s, 'r) _menhir_cell1_REGIONS, 'r) _menhir_state
    (** State 418.
        Stack shape : REGIONS.
        Start symbol: <undetermined>. *)

  | MenhirState420 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 420.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState421 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 421.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState427 : (('s, 'r) _menhir_cell1_memory_map_atom, 'r) _menhir_state
    (** State 427.
        Stack shape : memory_map_atom.
        Start symbol: <undetermined>. *)

  | MenhirState431 : (('s, 'r) _menhir_cell1_LEVELS, 'r) _menhir_state
    (** State 431.
        Stack shape : LEVELS.
        Start symbol: <undetermined>. *)

  | MenhirState432 : (('s, 'r) _menhir_cell1_PROC, 'r) _menhir_state
    (** State 432.
        Stack shape : PROC.
        Start symbol: <undetermined>. *)

  | MenhirState434 : (('s, 'r) _menhir_cell1_LPAR _menhir_cell0_NAME, 'r) _menhir_state
    (** State 434.
        Stack shape : LPAR NAME.
        Start symbol: <undetermined>. *)

  | MenhirState437 : (('s, 'r) _menhir_cell1_level_tree, 'r) _menhir_state
    (** State 437.
        Stack shape : level_tree.
        Start symbol: <undetermined>. *)

  | MenhirState442 : (('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 442.
        Stack shape : scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState443 : ((('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 443.
        Stack shape : scopes_key memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState445 : ((('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 445.
        Stack shape : scopes_key levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState450 : (('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 450.
        Stack shape : memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState451 : ((('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 451.
        Stack shape : memory_map_key scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState453 : ((('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 453.
        Stack shape : memory_map_key levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState455 : (('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 455.
        Stack shape : levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState456 : ((('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 456.
        Stack shape : levels_key scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState458 : ((('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 458.
        Stack shape : levels_key memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState463 : ('s, _menhir_box_macros) _menhir_state
    (** State 463.
        Stack shape : .
        Start symbol: macros. *)

  | MenhirState465 : (('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_state
    (** State 465.
        Stack shape : NAME.
        Start symbol: macros. *)

  | MenhirState467 : (('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_state
    (** State 467.
        Stack shape : NAME.
        Start symbol: macros. *)

  | MenhirState471 : ((('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_state
    (** State 471.
        Stack shape : NAME formals.
        Start symbol: macros. *)

  | MenhirState472 : (((('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_cell1_LBRACE, _menhir_box_macros) _menhir_state
    (** State 472.
        Stack shape : NAME formals LBRACE.
        Start symbol: macros. *)

  | MenhirState478 : (('s, _menhir_box_macros) _menhir_cell1_macro, _menhir_box_macros) _menhir_state
    (** State 478.
        Stack shape : macro.
        Start symbol: macros. *)

  | MenhirState482 : ('s, _menhir_box_pseudo_seq) _menhir_state
    (** State 482.
        Stack shape : .
        Start symbol: pseudo_seq. *)

  | MenhirState486 : ('s, _menhir_box_shallow_main) _menhir_state
    (** State 486.
        Stack shape : .
        Start symbol: shallow_main. *)

  | MenhirState487 : (('s, _menhir_box_shallow_main) _menhir_cell1_BODY, _menhir_box_shallow_main) _menhir_state
    (** State 487.
        Stack shape : BODY.
        Start symbol: shallow_main. *)

  | MenhirState490 : (('s, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_state
    (** State 490.
        Stack shape : voidopt PROC.
        Start symbol: shallow_main. *)

  | MenhirState493 : ((('s, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_cell1_parameter_list _menhir_cell0_BODY, _menhir_box_shallow_main) _menhir_state
    (** State 493.
        Stack shape : voidopt PROC parameter_list BODY.
        Start symbol: shallow_main. *)


and ('s, 'r) _menhir_cell1_annot = 
  | MenhirCell1_annot of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annot_base = 
  | MenhirCell1_annot_base of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annot_list = 
  | MenhirCell1_annot_list of 's * ('s, 'r) _menhir_state * (MemOrderOrAnnot.annot)

and ('s, 'r) _menhir_cell1_atomic_op = 
  | MenhirCell1_atomic_op of 's * ('s, 'r) _menhir_state * (CBase.op)

and ('s, 'r) _menhir_cell1_block_ins = 
  | MenhirCell1_block_ins of 's * ('s, 'r) _menhir_state * (CBase.pins)

and ('s, 'r) _menhir_cell1_declaration = 
  | MenhirCell1_declaration of 's * ('s, 'r) _menhir_state * (CBase.pins)

and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_expr0 = 
  | MenhirCell1_expr0 of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_formals = 
  | MenhirCell1_formals of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_level_tree = 
  | MenhirCell1_level_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_levels_key = 
  | MenhirCell1_levels_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_location = 
  | MenhirCell1_location of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_macro = 
  | MenhirCell1_macro of 's * ('s, 'r) _menhir_state * (CBase.macro)

and ('s, 'r) _menhir_cell1_memory_map_atom = 
  | MenhirCell1_memory_map_atom of 's * ('s, 'r) _menhir_state * (string * string list)

and ('s, 'r) _menhir_cell1_memory_map_key = 
  | MenhirCell1_memory_map_key of 's * ('s, 'r) _menhir_state * (BellInfo.mem_space_map)

and 's _menhir_cell0_opt_annot = 
  | MenhirCell0_opt_annot of 's * (MemOrderOrAnnot.annot)

and ('s, 'r) _menhir_cell1_parameter_declaration = 
  | MenhirCell1_parameter_declaration of 's * ('s, 'r) _menhir_state * (CAst.param)

and ('s, 'r) _menhir_cell1_parameter_list = 
  | MenhirCell1_parameter_list of 's * ('s, 'r) _menhir_state * (CAst.param list)

and ('s, 'r) _menhir_cell1_proc = 
  | MenhirCell1_proc of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_scope_tree = 
  | MenhirCell1_scope_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_scopes_key = 
  | MenhirCell1_scopes_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_trans_unit = 
  | MenhirCell1_trans_unit of 's * ('s, 'r) _menhir_state * (CBase.pseudo list CAst.test list)

and ('s, 'r) _menhir_cell1_typ = 
  | MenhirCell1_typ of 's * ('s, 'r) _menhir_state * (CType.t)

and ('s, 'r) _menhir_cell1_voidopt = 
  | MenhirCell1_voidopt of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_ATOMIC = 
  | MenhirCell1_ATOMIC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT = 
  | MenhirCell1_ATOMIC_FETCH_EXPLICIT of 's * ('s, 'r) _menhir_state * (
# 65 "lib/CParser.mly"
       (CBase.op)
# 1020 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_BODY = 
  | MenhirCell1_BODY of 's * ('s, 'r) _menhir_state * (
# 46 "lib/CParser.mly"
       (string)
# 1027 "lib/CParser.ml"
)

and 's _menhir_cell0_BODY = 
  | MenhirCell0_BODY of 's * (
# 46 "lib/CParser.mly"
       (string)
# 1034 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_CMPXCHG = 
  | MenhirCell1_CMPXCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CONST = 
  | MenhirCell1_CONST of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_EXC_EXPLICIT = 
  | MenhirCell1_EXC_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBRACE = 
  | MenhirCell1_LBRACE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LD_EXPLICIT = 
  | MenhirCell1_LD_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LEVELS = 
  | MenhirCell1_LEVELS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOAD = 
  | MenhirCell1_LOAD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOCK = 
  | MenhirCell1_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 27 "lib/CParser.mly"
       (string)
# 1071 "lib/CParser.ml"
)

and 's _menhir_cell0_NAME = 
  | MenhirCell0_NAME of 's * (
# 27 "lib/CParser.mly"
       (string)
# 1078 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 33 "lib/CParser.mly"
       (int)
# 1085 "lib/CParser.ml"
)

and 's _menhir_cell0_PROC = 
  | MenhirCell0_PROC of 's * (
# 33 "lib/CParser.mly"
       (int)
# 1092 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_REGIONS = 
  | MenhirCell1_REGIONS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCAS = 
  | MenhirCell1_SCAS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCAS_EXPLICIT = 
  | MenhirCell1_SCAS_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCOPES = 
  | MenhirCell1_SCOPES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINISLOCKED = 
  | MenhirCell1_SPINISLOCKED of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINLOCK = 
  | MenhirCell1_SPINLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINTRYLOCK = 
  | MenhirCell1_SPINTRYLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINUNLOCK = 
  | MenhirCell1_SPINUNLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SRCU = 
  | MenhirCell1_SRCU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STAR = 
  | MenhirCell1_STAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STORE = 
  | MenhirCell1_STORE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ST_EXPLICIT = 
  | MenhirCell1_ST_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS = 
  | MenhirCell1_UNDERATOMICADDUNLESS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP = 
  | MenhirCell1_UNDERATOMICFETCHOP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICOP = 
  | MenhirCell1_UNDERATOMICOP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN = 
  | MenhirCell1_UNDERATOMICOPRETURN of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERFENCE = 
  | MenhirCell1_UNDERFENCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNLOCK = 
  | MenhirCell1_UNLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_VOID = 
  | MenhirCell1_VOID of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_VOLATILE = 
  | MenhirCell1_VOLATILE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WCAS = 
  | MenhirCell1_WCAS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WCAS_EXPLICIT = 
  | MenhirCell1_WCAS_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WHILE = 
  | MenhirCell1_WHILE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XCHG = 
  | MenhirCell1_XCHG of 's * ('s, 'r) _menhir_state

and _menhir_box_shallow_main = 
  | MenhirBox_shallow_main of (string CAst.t list * MiscParser.extra_data) [@@unboxed]

and _menhir_box_pseudo_seq = 
  | MenhirBox_pseudo_seq of (CBase.pseudo list) [@@unboxed]

and _menhir_box_macros = 
  | MenhirBox_macros of (CBase.macro list) [@@unboxed]

and _menhir_box_deep_main = 
  | MenhirBox_deep_main of (CBase.pseudo list CAst.test list * MiscParser.extra_data) [@@unboxed]

let _menhir_action_004 =
  fun _1 ->
    (
# 169 "lib/CParser.mly"
              ( _1 )
# 1184 "lib/CParser.ml"
     : (string))

let _menhir_action_005 =
  fun _1 _3 ->
    (
# 170 "lib/CParser.mly"
                       ( _1 ^ "-" ^ _3 )
# 1192 "lib/CParser.ml"
     : (string))

let _menhir_action_006 =
  fun () ->
    (
# 173 "lib/CParser.mly"
             ( "lock" )
# 1200 "lib/CParser.ml"
     : (string))

let _menhir_action_007 =
  fun () ->
    (
# 174 "lib/CParser.mly"
             ( "unlock" )
# 1208 "lib/CParser.ml"
     : (string))

let _menhir_action_008 =
  fun () ->
    (
# 175 "lib/CParser.mly"
              ( "atomic" )
# 1216 "lib/CParser.ml"
     : (string))

let _menhir_action_009 =
  fun _1 ->
    (
# 176 "lib/CParser.mly"
       ( _1 )
# 1224 "lib/CParser.ml"
     : (string))

let _menhir_action_010 =
  fun _1 _3 ->
    (
# 182 "lib/CParser.mly"
  (_1::_3)
# 1232 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_011 =
  fun _1 ->
    (
# 184 "lib/CParser.mly"
  ([_1])
# 1240 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_012 =
  fun () ->
    (
# 247 "lib/CParser.mly"
  ( [] )
# 1248 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_013 =
  fun _1 ->
    (
# 248 "lib/CParser.mly"
          ( _1 )
# 1256 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_014 =
  fun _1 ->
    (
# 251 "lib/CParser.mly"
       ( [_1] )
# 1264 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_015 =
  fun _1 _3 ->
    (
# 252 "lib/CParser.mly"
                     ( _1 :: _3 )
# 1272 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_016 =
  fun () ->
    (
# 161 "lib/CParser.mly"
      ( Op.Add )
# 1280 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_017 =
  fun () ->
    (
# 162 "lib/CParser.mly"
      ( Op.Sub )
# 1288 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_018 =
  fun () ->
    (
# 163 "lib/CParser.mly"
       ( Op.And )
# 1296 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_019 =
  fun () ->
    (
# 164 "lib/CParser.mly"
      ( Op.Xor )
# 1304 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_020 =
  fun () ->
    (
# 165 "lib/CParser.mly"
       ( Op.Or )
# 1312 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_021 =
  fun () ->
    (
# 166 "lib/CParser.mly"
           ( Op.AndNot2 )
# 1320 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_022 =
  fun _1 ->
    (
# 132 "lib/CParser.mly"
        ( _1 )
# 1328 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_023 =
  fun _2 ->
    (
# 133 "lib/CParser.mly"
                 ( _2 )
# 1336 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_024 =
  fun _1 ->
    (
# 120 "lib/CParser.mly"
              ( Atomic (Base _1) )
# 1344 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_025 =
  fun _3 ->
    (
# 121 "lib/CParser.mly"
                              ( Atomic (Base _3) )
# 1352 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_026 =
  fun _1 ->
    (
# 122 "lib/CParser.mly"
            ( (Base _1) )
# 1360 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_027 =
  fun _2 ->
    (
# 123 "lib/CParser.mly"
                     ( Base ("struct " ^ _2) )
# 1368 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_028 =
  fun _1 ->
    (
# 124 "lib/CParser.mly"
                ( Base (_1 ^ "mutex") )
# 1376 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_029 =
  fun _1 ->
    (
# 125 "lib/CParser.mly"
               ( Base (_1 ^ "char") )
# 1384 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_030 =
  fun _1 ->
    (
# 126 "lib/CParser.mly"
              ( Base (_1 ^ "int") )
# 1392 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_031 =
  fun _1 ->
    (
# 127 "lib/CParser.mly"
               ( Base (_1 ^ "long") )
# 1400 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_032 =
  fun _1 ->
    (
# 313 "lib/CParser.mly"
              ( _1 )
# 1408 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_033 =
  fun _2 ->
    (
# 314 "lib/CParser.mly"
                        ( Seq(_2,true) )
# 1416 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_034 =
  fun _2 ->
    (
# 349 "lib/CParser.mly"
                        ( Seq (_2,true) )
# 1424 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_035 =
  fun _1 _2 ->
    (
# 151 "lib/CParser.mly"
                ( DeclReg (_1,_2) )
# 1432 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_036 =
  fun _1 _2 ->
    (
# 338 "lib/CParser.mly"
                                       ( _1, [MiscParser.BellExtra _2] )
# 1440 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list * MiscParser.extra_data))

let _menhir_action_037 =
  fun _1 ->
    (
# 317 "lib/CParser.mly"
            ( [Instruction _1] )
# 1448 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_038 =
  fun _1 _2 ->
    (
# 318 "lib/CParser.mly"
                          ( (Instruction _1)::_2 )
# 1456 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_039 =
  fun () ->
    (
# 319 "lib/CParser.mly"
              ( [] )
# 1464 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_040 =
  fun _2 ->
    (
# 320 "lib/CParser.mly"
                            ( _2 )
# 1472 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_041 =
  fun _1 ->
    (
# 187 "lib/CParser.mly"
        ( _1 )
# 1480 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_042 =
  fun _1 ->
    (
# 188 "lib/CParser.mly"
        ( _1 )
# 1488 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_043 =
  fun _1 ->
    (
# 191 "lib/CParser.mly"
           ( CBase.Const(Constant.Concrete _1) )
# 1496 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_044 =
  fun _1 ->
    (
# 192 "lib/CParser.mly"
           ( CBase.Const(mk_sym _1) )
# 1504 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_045 =
  fun _1 ->
    (
# 193 "lib/CParser.mly"
       ( CBase.LoadReg _1 )
# 1512 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_046 =
  fun _2 ->
    (
# 194 "lib/CParser.mly"
            ( CBase.LoadMem (CBase.LoadReg _2,AN []) )
# 1520 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_047 =
  fun _2 ->
    (
# 195 "lib/CParser.mly"
                 ( _2 )
# 1528 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_048 =
  fun e ->
    (
# 198 "lib/CParser.mly"
                                  ( e )
# 1536 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_049 =
  fun _5 ->
    (
# 199 "lib/CParser.mly"
                          ( LoadMem (LoadReg _5,AN []) )
# 1544 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_050 =
  fun _3 ->
    (
# 200 "lib/CParser.mly"
                      ( LoadMem (_3,AN []) )
# 1552 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_051 =
  fun _3 _6 ->
    (
# 201 "lib/CParser.mly"
                                               ( LoadMem(_6,AN _3) )
# 1560 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_052 =
  fun _3 _6 ->
    (
# 202 "lib/CParser.mly"
                                                           ( ExpSRCU(_6,_3) )
# 1568 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_053 =
  fun _3 _5 ->
    (
# 203 "lib/CParser.mly"
                                            ( LoadMem(_3,MO _5) )
# 1576 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_054 =
  fun _1 _3 ->
    (
# 204 "lib/CParser.mly"
                 ( Op(Op.Mul,_1,_3) )
# 1584 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_055 =
  fun _1 _3 ->
    (
# 205 "lib/CParser.mly"
                ( Op(Op.Add,_1,_3) )
# 1592 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_056 =
  fun _1 _3 ->
    (
# 206 "lib/CParser.mly"
                ( Op(Op.Sub,_1,_3) )
# 1600 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_057 =
  fun _1 _3 ->
    (
# 207 "lib/CParser.mly"
                ( Op(Op.Div,_1,_3) )
# 1608 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_058 =
  fun _1 _3 ->
    (
# 208 "lib/CParser.mly"
                 ( Op(Op.And,_1,_3) )
# 1616 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_059 =
  fun _1 _3 ->
    (
# 209 "lib/CParser.mly"
                 ( Op(Op.Or,_1,_3) )
# 1624 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_060 =
  fun _1 _3 ->
    (
# 210 "lib/CParser.mly"
                ( Op(Op.Xor,_1,_3) )
# 1632 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_061 =
  fun _1 _3 ->
    (
# 211 "lib/CParser.mly"
                  ( Op(Op.Eq,_1,_3) )
# 1640 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_062 =
  fun _1 _3 ->
    (
# 212 "lib/CParser.mly"
                   ( Op(Op.Ne,_1,_3) )
# 1648 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_063 =
  fun _1 _3 ->
    (
# 213 "lib/CParser.mly"
               ( Op(Op.Lt,_1,_3) )
# 1656 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_064 =
  fun _1 _3 ->
    (
# 214 "lib/CParser.mly"
               ( Op(Op.Gt,_1,_3) )
# 1664 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_065 =
  fun _1 _3 ->
    (
# 215 "lib/CParser.mly"
               ( Op(Op.Le,_1,_3) )
# 1672 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_066 =
  fun _1 _3 ->
    (
# 216 "lib/CParser.mly"
               ( Op(Op.Ge,_1,_3) )
# 1680 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_067 =
  fun _3 _5 _7 ->
    (
# 218 "lib/CParser.mly"
  ( Exchange(_3, _5, MO _7) )
# 1688 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_068 =
  fun _3 _6 _8 ->
    (
# 220 "lib/CParser.mly"
  ( Exchange(_6,_8,AN _3) )
# 1696 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_069 =
  fun _10 _3 _6 _8 ->
    (
# 222 "lib/CParser.mly"
  ( CmpExchange(_6,_8,_10,_3) )
# 1704 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_070 =
  fun _1 _3 _5 _7 ->
    (
# 224 "lib/CParser.mly"
  ( Fetch(_3, _1, _5, _7) )
# 1712 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_071 =
  fun _1 _3 ->
    (
# 226 "lib/CParser.mly"
  ( ECall (_1,_3) )
# 1720 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_072 =
  fun _3 _5 _7 ->
    (
# 228 "lib/CParser.mly"
  ( ECas (_3,_5,_7,SC,SC,false) )
# 1728 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_073 =
  fun _11 _3 _5 _7 _9 ->
    (
# 230 "lib/CParser.mly"
  ( ECas (_3,_5,_7,_9,_11,false) )
# 1736 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_074 =
  fun _3 _5 _7 ->
    (
# 232 "lib/CParser.mly"
  ( ECas (_3,_5,_7,SC,SC,true) )
# 1744 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_075 =
  fun _11 _3 _5 _7 _9 ->
    (
# 234 "lib/CParser.mly"
  ( ECas (_3,_5,_7,_9,_11,true) )
# 1752 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_076 =
  fun _3 ->
    (
# 236 "lib/CParser.mly"
  ( TryLock (_3,MutexLinux) )
# 1760 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_077 =
  fun _3 ->
    (
# 238 "lib/CParser.mly"
  ( IsLocked (_3,MutexLinux) )
# 1768 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_078 =
  fun _10 _3 _6 _8 ->
    (
# 240 "lib/CParser.mly"
  ( AtomicOpReturn(_6,_8,_10,OpReturn,_3) )
# 1776 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_079 =
  fun _10 _3 _6 _8 ->
    (
# 242 "lib/CParser.mly"
  ( AtomicOpReturn(_6,_8,_10,FetchOp,_3) )
# 1784 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_080 =
  fun _10 _3 _6 _8 ->
    (
# 244 "lib/CParser.mly"
  ( AtomicAddUnless(_6,_8,_10,true,_3) )
# 1792 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_081 =
  fun e ->
    (
# 158 "lib/CParser.mly"
         ( StoreReg(None,None,e) )
# 1800 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_082 =
  fun () ->
    (
# 345 "lib/CParser.mly"
  ( [] )
# 1808 "lib/CParser.ml"
     : (string list))

let _menhir_action_083 =
  fun _1 ->
    (
# 346 "lib/CParser.mly"
             ( _1 )
# 1816 "lib/CParser.ml"
     : (string list))

let _menhir_action_084 =
  fun _1 ->
    (
# 341 "lib/CParser.mly"
       ( [ _1 ] )
# 1824 "lib/CParser.ml"
     : (string list))

let _menhir_action_085 =
  fun _1 _3 ->
    (
# 342 "lib/CParser.mly"
                        ( _1 :: _3 )
# 1832 "lib/CParser.ml"
     : (string list))

let _menhir_action_086 =
  fun _2 _4 _7 ->
    (
# 327 "lib/CParser.mly"
  ( { CAst.proc = _2;
      CAst.params = _4;
      CAst.body = _7 } )
# 1842 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test))

let _menhir_action_087 =
  fun _1 _2 _4 ->
    (
# 154 "lib/CParser.mly"
                   ( StoreReg (Some _1,Some _2,_4) ; )
# 1850 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_088 =
  fun _1 ->
    (
# 155 "lib/CParser.mly"
            ( _1 )
# 1858 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_089 =
  fun _1 ->
    (
# 307 "lib/CParser.mly"
            ( [_1] )
# 1866 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_090 =
  fun _1 _2 ->
    (
# 308 "lib/CParser.mly"
                    ( _1::_2 )
# 1874 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_091 =
  fun _1 ->
    (
# 309 "lib/CParser.mly"
              ( [_1] )
# 1882 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_092 =
  fun _1 _2 ->
    (
# 310 "lib/CParser.mly"
                      ( _1::_2 )
# 1890 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_093 =
  fun _3 _5 ->
    (
# 261 "lib/CParser.mly"
  ( If(_3,_5,None) )
# 1898 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_094 =
  fun _3 _5 _7 ->
    (
# 263 "lib/CParser.mly"
  ( If(_3,_5,Some _7) )
# 1906 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_095 =
  fun _2 _3 ->
    (
# 265 "lib/CParser.mly"
  ( While (_2,_3,0) )
# 1914 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_096 =
  fun _1 ->
    (
# 267 "lib/CParser.mly"
  ( _1 )
# 1922 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_097 =
  fun _1 _3 ->
    (
# 269 "lib/CParser.mly"
  ( StoreReg(None,Some _1,_3) )
# 1930 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_098 =
  fun _4 ->
    (
# 271 "lib/CParser.mly"
  ( CastExpr _4 )
# 1938 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_099 =
  fun _2 _4 ->
    (
# 273 "lib/CParser.mly"
  ( StoreMem(_2,_4,AN []) )
# 1946 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_100 =
  fun _3 _6 _8 ->
    (
# 275 "lib/CParser.mly"
  ( StoreMem(_6,_8,AN _3) )
# 1954 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_101 =
  fun _3 _6 ->
    (
# 277 "lib/CParser.mly"
  ( InstrSRCU(_6,_3,None) )
# 1962 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_102 =
  fun _3 _6 _8 ->
    (
# 279 "lib/CParser.mly"
  ( InstrSRCU(_6,_3,Some _8) )
# 1970 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_103 =
  fun _3 _5 _7 ->
    (
# 281 "lib/CParser.mly"
  ( StoreMem(_3, _5, MO _7) )
# 1978 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_104 =
  fun _3 ->
    (
# 283 "lib/CParser.mly"
  ( Lock (_3,MutexC11) )
# 1986 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_105 =
  fun _3 ->
    (
# 285 "lib/CParser.mly"
  ( Unlock (_3,MutexC11) )
# 1994 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_106 =
  fun _3 ->
    (
# 287 "lib/CParser.mly"
  ( Lock (_3,MutexLinux) )
# 2002 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_107 =
  fun _3 ->
    (
# 289 "lib/CParser.mly"
  ( Unlock (_3,MutexLinux) )
# 2010 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_108 =
  fun _3 ->
    (
# 291 "lib/CParser.mly"
  ( Fence(AN _3) )
# 2018 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_109 =
  fun _2 _4 _6 _8 ->
    (
# 293 "lib/CParser.mly"
  ( AtomicOp(_4,_6,_8,_2) )
# 2026 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_110 =
  fun _3 ->
    (
# 295 "lib/CParser.mly"
  ( Fence(MO _3) )
# 2034 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_111 =
  fun _1 ->
    (
# 297 "lib/CParser.mly"
  ( Symb _1 )
# 2042 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_112 =
  fun _1 _3 ->
    (
# 299 "lib/CParser.mly"
  ( PCall (_1,_3) )
# 2050 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_113 =
  fun _2 _3 ->
    (
# 62 "lib/scopeRules.mly"
  (
   let ps,ts = _3 in
   BellInfo.Tree (_2,ps,ts)
   )
# 2061 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_114 =
  fun _1 ->
    (
# 51 "lib/scopeRules.mly"
       ( [_1],[] )
# 2069 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_115 =
  fun _1 ->
    (
# 52 "lib/scopeRules.mly"
             (let ps =  [] in ps,[_1])
# 2077 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_116 =
  fun _1 _2 ->
    (
# 54 "lib/scopeRules.mly"
    ( let ps,ts = _2 in
      _1::ps,ts )
# 2086 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_117 =
  fun _1 _2 ->
    (
# 57 "lib/scopeRules.mly"
    (let ps,ts = _2 in
     ps,_1::ts )
# 2095 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_118 =
  fun _3 ->
    (
# 53 "lib/BellExtraRules.mly"
                              ( _3 )
# 2103 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_119 =
  fun () ->
    (
# 216 "<standard.mly>"
    ( [] )
# 2111 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_120 =
  fun x xs ->
    (
# 219 "<standard.mly>"
    ( x :: xs )
# 2119 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_121 =
  fun _1 ->
    (
# 255 "lib/CParser.mly"
       ( LoadReg(_1) )
# 2127 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_122 =
  fun _2 ->
    (
# 256 "lib/CParser.mly"
                ( LoadMem(_2,AN []) )
# 2135 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_123 =
  fun _2 ->
    (
# 257 "lib/CParser.mly"
                 ( _2 )
# 2143 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_124 =
  fun () ->
    (
# 145 "<standard.mly>"
    ( [] )
# 2151 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_125 =
  fun x ->
    (
# 148 "<standard.mly>"
    ( x )
# 2159 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_126 =
  fun _1 _3 _5 ->
    (
# 352 "lib/CParser.mly"
                              ( EDef (_1,_3,_5) )
# 2167 "lib/CParser.ml"
     : (CBase.macro))

let _menhir_action_127 =
  fun _1 _3 _5 ->
    (
# 353 "lib/CParser.mly"
                              ( PDef (_1,_3,_5) )
# 2175 "lib/CParser.ml"
     : (CBase.macro))

let _menhir_action_128 =
  fun ms ->
    (
# 356 "lib/CParser.mly"
                     ( ms )
# 2183 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_129 =
  fun _1 _3 ->
    (
# 75 "lib/scopeRules.mly"
                                  ( (_1,_3) )
# 2191 "lib/CParser.ml"
     : (string * string list))

let _menhir_action_130 =
  fun _3 ->
    (
# 56 "lib/BellExtraRules.mly"
                               ( _3 )
# 2199 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_131 =
  fun x ->
    (
# 228 "<standard.mly>"
    ( [ x ] )
# 2207 "lib/CParser.ml"
     : (string list))

let _menhir_action_132 =
  fun x xs ->
    (
# 231 "<standard.mly>"
    ( x :: xs )
# 2215 "lib/CParser.ml"
     : (string list))

let _menhir_action_133 =
  fun () ->
    (
# 303 "lib/CParser.mly"
  ( [""] )
# 2223 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_134 =
  fun _2 ->
    (
# 304 "lib/CParser.mly"
                           ( _2 )
# 2231 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_135 =
  fun _1 _2 ->
    (
# 96 "lib/CParser.mly"
               ( {CAst.param_ty = _1; param_name = _2} )
# 2239 "lib/CParser.ml"
     : (CAst.param))

let _menhir_action_136 =
  fun () ->
    (
# 91 "lib/CParser.mly"
  ( [] )
# 2247 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_137 =
  fun _1 ->
    (
# 92 "lib/CParser.mly"
                        ( [ _1 ] )
# 2255 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_138 =
  fun _1 _3 ->
    (
# 93 "lib/CParser.mly"
                                             ( _1 :: _3 )
# 2263 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_139 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2271 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_140 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2279 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_141 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2287 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_142 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2295 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_143 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2303 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_144 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2311 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_145 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 2319 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_146 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 2327 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_147 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 2335 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_148 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 2343 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_149 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 2351 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_150 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 2359 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_151 =
  fun scopes ->
    (
# 41 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; } )
# 2367 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_152 =
  fun levels ->
    (
# 43 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; } )
# 2375 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_153 =
  fun regions ->
    (
# 45 "lib/BellExtraRules.mly"
    ( { nones with regions=Some regions; } )
# 2383 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_154 =
  fun () ->
    (
# 47 "lib/BellExtraRules.mly"
    (  nones )
# 2391 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_155 =
  fun _1 ->
    (
# 22 "lib/scopeRules.mly"
        ( _1 )
# 2399 "lib/CParser.ml"
     : (int))

let _menhir_action_156 =
  fun _1 ->
    (
# 23 "lib/scopeRules.mly"
        ( _1 )
# 2407 "lib/CParser.ml"
     : (int))

let _menhir_action_157 =
  fun _1 _2 ->
    (
# 26 "lib/scopeRules.mly"
                    (_1::_2)
# 2415 "lib/CParser.ml"
     : (int list))

let _menhir_action_158 =
  fun () ->
    (
# 27 "lib/scopeRules.mly"
  ([])
# 2423 "lib/CParser.ml"
     : (int list))

let _menhir_action_159 =
  fun p ->
    (
# 323 "lib/CParser.mly"
                      ( p )
# 2431 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_160 =
  fun _2 _3 ->
    (
# 35 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,[],_3)
   )
# 2441 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_161 =
  fun _2 _3 ->
    (
# 39 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,_3,[])
   )
# 2451 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_162 =
  fun _1 ->
    (
# 30 "lib/scopeRules.mly"
             ([_1])
# 2459 "lib/CParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_163 =
  fun _1 _2 ->
    (
# 31 "lib/scopeRules.mly"
                             (_1::_2)
# 2467 "lib/CParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_164 =
  fun x ->
    (
# 61 "lib/BellExtraRules.mly"
                                                    ( x )
# 2475 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_165 =
  fun _3 ->
    (
# 50 "lib/BellExtraRules.mly"
                              ( _3 )
# 2483 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_166 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 2491 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_167 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 2499 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_168 =
  fun _1 ->
    (
# 139 "lib/CParser.mly"
                            ( [], [MiscParser.BellExtra _1] )
# 2507 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_169 =
  fun _1 _2 ->
    (
# 140 "lib/CParser.mly"
                    ( CAst.Global _1 :: (fst _2), (snd _2) )
# 2515 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_170 =
  fun _2 _4 _6 _7 ->
    (
# 142 "lib/CParser.mly"
    ( CAst.Test {CAst.proc = _2; params = _4; body = _6} :: (fst _7),
      (snd _7) )
# 2524 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_171 =
  fun _1 ->
    (
# 69 "lib/scopeRules.mly"
    ( let ps,ts = _1 in
      match ps,ts with
      | [],[t] -> t
      | _ -> BellInfo.Tree ("",ps,ts) )
# 2535 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_172 =
  fun xs ->
    let atoms = 
# 241 "<standard.mly>"
    ( xs )
# 2543 "lib/CParser.ml"
     in
    (
# 78 "lib/scopeRules.mly"
                                                 ( atoms )
# 2548 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_173 =
  fun _1 ->
    (
# 45 "lib/scopeRules.mly"
    ( let ts = _1 in
      match ts with
      | [t] -> t
      | _ -> BellInfo.Tree ("",[],ts) )
# 2559 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_174 =
  fun _1 ->
    (
# 333 "lib/CParser.mly"
  ( [_1] )
# 2567 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list))

let _menhir_action_175 =
  fun _1 _2 ->
    (
# 335 "lib/CParser.mly"
  ( _1 @ [_2] )
# 2575 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list))

let _menhir_action_176 =
  fun () ->
    (
# 136 "lib/CParser.mly"
  ( "" )
# 2583 "lib/CParser.ml"
     : (string))

let _menhir_action_177 =
  fun _1 ->
    (
# 111 "lib/CParser.mly"
          ( _1 )
# 2591 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_178 =
  fun _1 ->
    (
# 112 "lib/CParser.mly"
                   ( Volatile _1 )
# 2599 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_179 =
  fun _1 ->
    (
# 113 "lib/CParser.mly"
                ( CType.Const _1 )
# 2607 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_180 =
  fun _2 ->
    (
# 114 "lib/CParser.mly"
              ( Atomic _2 )
# 2615 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_181 =
  fun _2 ->
    (
# 115 "lib/CParser.mly"
                ( Volatile _2 )
# 2623 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_182 =
  fun _2 ->
    (
# 116 "lib/CParser.mly"
             ( Const _2 )
# 2631 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_183 =
  fun _1 ->
    (
# 117 "lib/CParser.mly"
        ( _1 )
# 2639 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_184 =
  fun t ->
    (
# 107 "lib/CParser.mly"
       ( t )
# 2647 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_185 =
  fun t ->
    (
# 108 "lib/CParser.mly"
                  ( t )
# 2655 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_186 =
  fun _1 ->
    (
# 99 "lib/CParser.mly"
           ( Pointer _1 )
# 2663 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_187 =
  fun _1 ->
    (
# 100 "lib/CParser.mly"
            ( Pointer _1 )
# 2671 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_188 =
  fun () ->
    (
# 103 "lib/CParser.mly"
       ( Base "void" )
# 2679 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_189 =
  fun () ->
    (
# 146 "lib/CParser.mly"
       ( () )
# 2687 "lib/CParser.ml"
     : (unit))

let _menhir_action_190 =
  fun () ->
    (
# 147 "lib/CParser.mly"
            ( () )
# 2695 "lib/CParser.ml"
     : (unit))

let _menhir_action_191 =
  fun () ->
    (
# 148 "lib/CParser.mly"
  ( () )
# 2703 "lib/CParser.ml"
     : (unit))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADD ->
        "ADD"
    | ATOMIC ->
        "ATOMIC"
    | ATOMIC_BASE ->
        "ATOMIC_BASE"
    | ATOMIC_FETCH_EXPLICIT _ ->
        "ATOMIC_FETCH_EXPLICIT"
    | ATOMIC_TYPE _ ->
        "ATOMIC_TYPE"
    | BASE_TYPE _ ->
        "BASE_TYPE"
    | BODY _ ->
        "BODY"
    | CHAR ->
        "CHAR"
    | CMPXCHG ->
        "CMPXCHG"
    | CODEVAR _ ->
        "CODEVAR"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | CONST ->
        "CONST"
    | CONSTANT _ ->
        "CONSTANT"
    | CONSTVAR _ ->
        "CONSTVAR"
    | DIV ->
        "DIV"
    | ELSE ->
        "ELSE"
    | EOF ->
        "EOF"
    | EQ ->
        "EQ"
    | EQ_OP ->
        "EQ_OP"
    | EXC_EXPLICIT ->
        "EXC_EXPLICIT"
    | FENCE ->
        "FENCE"
    | GE ->
        "GE"
    | GT ->
        "GT"
    | IF ->
        "IF"
    | INT ->
        "INT"
    | LAND ->
        "LAND"
    | LBRACE ->
        "LBRACE"
    | LD_EXPLICIT ->
        "LD_EXPLICIT"
    | LE ->
        "LE"
    | LEVELS ->
        "LEVELS"
    | LOAD ->
        "LOAD"
    | LOCK ->
        "LOCK"
    | LONG ->
        "LONG"
    | LPAR ->
        "LPAR"
    | LT ->
        "LT"
    | MEMORDER _ ->
        "MEMORDER"
    | MUTEX ->
        "MUTEX"
    | NAME _ ->
        "NAME"
    | NEQ_OP ->
        "NEQ_OP"
    | NOT ->
        "NOT"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RBRACE ->
        "RBRACE"
    | REGIONS ->
        "REGIONS"
    | RPAR ->
        "RPAR"
    | SCAS ->
        "SCAS"
    | SCAS_EXPLICIT ->
        "SCAS_EXPLICIT"
    | SCOPES ->
        "SCOPES"
    | SEMI ->
        "SEMI"
    | SPINISLOCKED ->
        "SPINISLOCKED"
    | SPINLOCK ->
        "SPINLOCK"
    | SPINTRYLOCK ->
        "SPINTRYLOCK"
    | SPINUNLOCK ->
        "SPINUNLOCK"
    | SRCU ->
        "SRCU"
    | STAR ->
        "STAR"
    | STORE ->
        "STORE"
    | STRUCT ->
        "STRUCT"
    | STRUCT_TYPE _ ->
        "STRUCT_TYPE"
    | ST_EXPLICIT ->
        "ST_EXPLICIT"
    | SUB ->
        "SUB"
    | UNDERATOMICADDUNLESS ->
        "UNDERATOMICADDUNLESS"
    | UNDERATOMICFETCHOP ->
        "UNDERATOMICFETCHOP"
    | UNDERATOMICOP ->
        "UNDERATOMICOP"
    | UNDERATOMICOPRETURN ->
        "UNDERATOMICOPRETURN"
    | UNDERFENCE ->
        "UNDERFENCE"
    | UNLOCK ->
        "UNLOCK"
    | VOID ->
        "VOID"
    | VOLATILE ->
        "VOLATILE"
    | WCAS ->
        "WCAS"
    | WCAS_EXPLICIT ->
        "WCAS_EXPLICIT"
    | WHILE ->
        "WHILE"
    | XCHG ->
        "XCHG"
    | XOR ->
        "XOR"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_498 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      MenhirBox_shallow_main _v
  
  let rec _menhir_goto_shallow_main : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState486 ->
          _menhir_run_498 _menhir_stack _v
      | MenhirState487 ->
          _menhir_run_497 _menhir_stack _v
      | MenhirState493 ->
          _menhir_run_494 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_497 : type  ttv_stack. (ttv_stack, _menhir_box_shallow_main) _menhir_cell1_BODY -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      let MenhirCell1_BODY (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_169 _1 _2 in
      _menhir_goto_shallow_main _menhir_stack _v _menhir_s
  
  and _menhir_run_494 : type  ttv_stack. ((ttv_stack, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_cell1_parameter_list _menhir_cell0_BODY -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      let MenhirCell0_BODY (_menhir_stack, _6) = _menhir_stack in
      let MenhirCell1_parameter_list (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell0_PROC (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_voidopt (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_170 _2 _4 _6 _7 in
      _menhir_goto_shallow_main _menhir_stack _v _menhir_s
  
  let _menhir_run_495 : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_168 _1 in
          _menhir_goto_shallow_main _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_447 : type  ttv_stack. (ttv_stack, _menhir_box_deep_main) _menhir_cell1_trans_unit -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let MenhirCell1_trans_unit (_menhir_stack, _, _1) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_036 _1 _2 in
          MenhirBox_deep_main _v
      | _ ->
          _eRR ()
  
  let _menhir_goto_scopes_and_memory_map : type  ttv_stack ttv_result. ttv_stack -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState486 ->
          _menhir_run_495 _menhir_stack _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_495 _menhir_stack _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_495 _menhir_stack _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_447 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  let _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ : type  ttv_stack ttv_result. ttv_stack -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _v _menhir_s _tok ->
      let x = _v in
      let _v = _menhir_action_164 x in
      _menhir_goto_scopes_and_memory_map _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_459 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key, ttv_result) _menhir_cell1_memory_map_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_142 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_457 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key, ttv_result) _menhir_cell1_scopes_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_140 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_452 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key, ttv_result) _menhir_cell1_scopes_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_143 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_444 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key, ttv_result) _menhir_cell1_memory_map_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_144 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_446 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key, ttv_result) _menhir_cell1_levels_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_139 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_454 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key, ttv_result) _menhir_cell1_levels_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_141 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let rec _menhir_run_401 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCOPES (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState402 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_403 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              _menhir_run_405 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState404
          | NUM _v_1 ->
              _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState404
          | LPAR ->
              _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
          | RPAR ->
              let _v_2 = _menhir_action_158 () in
              _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_405 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_155 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_proc : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_405 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState413
      | NUM _v_1 ->
          _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState413
      | RPAR ->
          let _v_2 = _menhir_action_158 () in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
      | _ ->
          _eRR ()
  
  and _menhir_run_406 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_156 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_414 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_proc -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_proc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_157 _1 _2 in
      _menhir_goto_proc_list_sc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_proc_list_sc : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState413 ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState404 ->
          _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_411 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_161 _2 _3 in
      _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scope_tree : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _v) in
          _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | EOF | LEVELS | REGIONS | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_162 _1 in
          _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_scope_tree_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState402 ->
          _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState409 ->
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState404 ->
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_416 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SCOPES -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_173 _1 in
      let MenhirCell1_SCOPES (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_165 _3 in
      _menhir_goto_scopes_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scopes_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState458 ->
          _menhir_run_459 _menhir_stack _v _tok
      | MenhirState455 ->
          _menhir_run_456 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState453 ->
          _menhir_run_454 _menhir_stack _v _tok
      | MenhirState450 ->
          _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState486 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_456 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState456
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_146 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_417 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_REGIONS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState418 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EOF | LEVELS | SCOPES ->
              let _v = _menhir_action_124 () in
              _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_419 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState420 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_421 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState421
      | COMMA | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_131 x in
          _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_nonempty_list_NAME_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState420 ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState421 ->
          _menhir_run_422 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_423 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_129 _1 _3 in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState427 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_166 x in
          _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState427 ->
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState418 ->
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_428 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_memory_map_atom -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_167 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_425 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let x = _v in
      let _v = _menhir_action_125 x in
      _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let xs = _v in
      let _v = _menhir_action_172 xs in
      let MenhirCell1_REGIONS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_130 _3 in
      _menhir_goto_memory_map_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_memory_map_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState455 ->
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState456 ->
          _menhir_run_457 _menhir_stack _v _tok
      | MenhirState486 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState445 ->
          _menhir_run_446 _menhir_stack _v _tok
      | MenhirState442 ->
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_458 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_149 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_450 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState450
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState450
      | EOF ->
          let regions = _v in
          let _v = _menhir_action_153 regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_430 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LEVELS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState431 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_433 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_432 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState432
      | LPAR ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_433 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | EOF | REGIONS | RPAR | SCOPES ->
          let _1 = _v in
          let _v = _menhir_action_114 _1 in
          _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_433 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _menhir_s = MenhirState434 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_433 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_level_tree_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState431 ->
          _menhir_run_441 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState432 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState437 ->
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState434 ->
          _menhir_run_435 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_441 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LEVELS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_171 _1 in
      let MenhirCell1_LEVELS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_118 _3 in
      _menhir_goto_levels_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_levels_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState486 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState450 ->
          _menhir_run_453 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState451 ->
          _menhir_run_452 _menhir_stack _v _tok
      | MenhirState442 ->
          _menhir_run_445 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState443 ->
          _menhir_run_444 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | EOF ->
          let levels = _v in
          let _v = _menhir_action_152 levels in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_453 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_150 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_445 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState445
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_145 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_439 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_116 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_438 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_level_tree -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_level_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_117 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_435 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_113 _2 _3 in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState437
          | LPAR ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_433 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
          | EOF | REGIONS | RPAR | SCOPES ->
              let _1 = _v in
              let _v = _menhir_action_115 _1 in
              _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_443 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_147 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_422 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_132 x xs in
      _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_451 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_148 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_442 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState442
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState442
      | EOF ->
          let scopes = _v in
          let _v = _menhir_action_151 scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_410 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_scope_tree -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_163 _1 _2 in
      _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_407 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_160 _2 _3 in
          _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_484 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_pseudo_seq =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let p = _v in
          let _v = _menhir_action_159 p in
          MenhirBox_pseudo_seq _v
      | _ ->
          _eRR ()
  
  let _menhir_run_480 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_macros =
    fun _menhir_stack _v ->
      let ms = _v in
      let _v = _menhir_action_128 ms in
      MenhirBox_macros _v
  
  let rec _menhir_run_479 : type  ttv_stack. (ttv_stack, _menhir_box_macros) _menhir_cell1_macro -> _ -> _menhir_box_macros =
    fun _menhir_stack _v ->
      let MenhirCell1_macro (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_120 x xs in
      _menhir_goto_list_macro_ _menhir_stack _v _menhir_s
  
  and _menhir_goto_list_macro_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState463 ->
          _menhir_run_480 _menhir_stack _v
      | MenhirState478 ->
          _menhir_run_479 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_190 () in
          _menhir_goto_voidopt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PROC _ ->
          let _v = _menhir_action_189 () in
          _menhir_goto_voidopt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_voidopt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState486 ->
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState493 ->
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_488 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_voidopt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell0_PROC (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | BASE_TYPE _v_1 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState490
              | ATOMIC_TYPE _v_2 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState490
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
              | RPAR ->
                  let _v_3 = _menhir_action_136 () in
                  _menhir_run_491 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState490
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState490 in
                  let _v = _menhir_action_176 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_VOLATILE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState006 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_007 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT_TYPE _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_027 _2 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_base0 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState490 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState482 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState361 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState347 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState006 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState012 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_183 _1 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_typ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState482 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState361 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState347 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_381 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NAME _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _2) = (_v, _v_0) in
              let _v = _menhir_action_035 _1 _2 in
              _menhir_goto_declaration _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v_0) in
              _menhir_run_371 _menhir_stack _menhir_lexbuf _menhir_lexer
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_typ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_typ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _v = _menhir_action_186 _1 in
      _menhir_goto_typ_ptr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_typ_ptr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState490 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState482 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState361 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState347 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_041 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_1, _2) = (_v, _v_0) in
          let _v = _menhir_action_135 _1 _2 in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_parameter_declaration (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | BASE_TYPE _v_0 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState398
              | ATOMIC_TYPE _v_1 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState398
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
              | RPAR ->
                  let _v_2 = _menhir_action_136 () in
                  _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState398 in
                  let _v = _menhir_action_176 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | RPAR ->
              let _1 = _v in
              let _v = _menhir_action_137 _1 in
              _menhir_goto_parameter_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | CONST | STAR | VOLATILE ->
          let _1 = _v in
          let _v = _menhir_action_177 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_188 () in
      _menhir_goto_void _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_void : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_187 _1 in
          _menhir_goto_typ_ptr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState011 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CONST (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState012 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_009 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState009 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_013 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_026 _1 in
      _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_014 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_024 _1 in
      _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_015 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | BASE_TYPE _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | GT ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _3 = _v in
                  let _v = _menhir_action_025 _3 in
                  _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ATOMIC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState026 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_reduce_176 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok ->
      let _v = _menhir_action_176 () in
      _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ty_attr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | MUTEX ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_028 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | LONG ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_031 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | INT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_030 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_029 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_399 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_parameter_declaration -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_parameter_declaration (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_138 _1 _3 in
      _menhir_goto_parameter_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_parameter_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState490 ->
          _menhir_run_491 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState398 ->
          _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState005 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_491 : type  ttv_stack. ((ttv_stack, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_parameter_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BODY _v_0 ->
          let _menhir_stack = MenhirCell0_BODY (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
          | SCOPES ->
              _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
          | REGIONS ->
              _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
          | LEVELS ->
              _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
          | BODY _v_1 ->
              _menhir_run_487 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState493
          | EOF ->
              let _menhir_s = MenhirState493 in
              let _v = _menhir_action_154 () in
              _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
          | PROC _ ->
              let _v_3 = _menhir_action_191 () in
              _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState493 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_487 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_BODY (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
      | SCOPES ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
      | REGIONS ->
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
      | LEVELS ->
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
      | BODY _v_0 ->
          _menhir_run_487 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState487
      | EOF ->
          let _menhir_s = MenhirState487 in
          let _v = _menhir_action_154 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v_2 = _menhir_action_191 () in
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState487 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack. ((ttv_stack, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_deep_main) _menhir_state -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_parameter_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState046 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XCHG (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState048 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_007 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annot_base : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_annot_base (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState154 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_004 _1 in
          _menhir_goto_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_009 _1 in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_006 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_008 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annot : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState318 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState271 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState266 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState048 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState079 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState157 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState154 ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_156 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_annot (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState157 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_011 _1 in
          _menhir_goto_annot_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_annot_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState318 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState293 ->
          _menhir_run_294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState271 ->
          _menhir_run_272 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState266 ->
          _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState157 ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState107 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState096 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState079 ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState071 ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState061 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState048 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRCU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState321 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_056 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WCAS_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState057 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WCAS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState059 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICOPRETURN (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState061 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICFETCHOP (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICADDUNLESS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState071 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_075 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState075 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
          let _menhir_s = MenhirState077 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_046 _2 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr0 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState255 ->
          _menhir_run_259 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState482 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState471 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState361 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState371 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState359 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState353 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState347 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState349 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState340 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState335 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState330 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState321 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState314 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState305 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState296 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState286 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState284 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState279 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState275 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState258 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState055 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState244 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState242 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState236 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState226 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState214 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState212 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState193 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState191 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState187 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState185 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState177 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState172 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState101 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState150 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState148 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState134 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_259 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr0 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | WHILE ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNLOCK ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNDERFENCE ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNDERATOMICOP ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | ST_EXPLICIT ->
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | STORE ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | STAR ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SRCU ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SPINUNLOCK ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SPINLOCK ->
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | NAME _v_0 ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState259
      | LPAR ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | LOCK ->
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | LBRACE ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | IF ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | FENCE ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | CONSTVAR _v_1 ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState259
      | CONSTANT _v_2 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState259
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | CODEVAR _v_3 ->
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState259
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | BASE_TYPE _v_4 ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState259
      | ATOMIC_TYPE _v_5 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState259
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState259
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_s = MenhirState259 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_255 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WHILE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, MenhirState255) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let _1 = _v in
            _menhir_action_045 _1
          in
          _menhir_run_259 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState255 _tok
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState255) in
          let _menhir_s = MenhirState258 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState255
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState255
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRCU (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState079 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_083 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINTRYLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState084 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINISLOCKED (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState086 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCAS_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState088 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCAS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState090 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | NAME _v_0 ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState092
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | CONSTVAR _v_1 ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState092
          | CONSTANT _v_2 ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState092
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState092
          | RPAR ->
              let _v_4 = _menhir_action_012 () in
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | ADD | COMMA | DIV | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | STAR | SUB | XOR ->
          let _1 = _v in
          let _v = _menhir_action_045 _1 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState093 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState094 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_095 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOAD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState096 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LD_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState101 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_102 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_EXC_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState103 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_044 _1 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_105 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_043 _1 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_106 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CMPXCHG (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState107 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_111 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_ATOMIC_FETCH_EXPLICIT (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState112 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_071 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr1 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_042 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState471 ->
          _menhir_run_475 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState482 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState361 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState371 ->
          _menhir_run_372 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState359 ->
          _menhir_run_360 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState353 ->
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState349 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState335 ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState330 ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState321 ->
          _menhir_run_322 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState314 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState305 ->
          _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState298 ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState296 ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState286 ->
          _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState284 ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState279 ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState275 ->
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState055 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState244 ->
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState242 ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState236 ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState226 ->
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState214 ->
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState212 ->
          _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState193 ->
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState191 ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState187 ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState185 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_184 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState340 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState347 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState258 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState177 ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState172 ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState099 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState101 ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_159 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState150 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState148 ->
          _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState134 ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState120 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState118 ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_475 : type  ttv_stack. (((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EOF | NAME _ ->
          let MenhirCell1_formals (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_126 _1 _3 _5 in
          _menhir_goto_macro _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_116 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState116 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_118 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState118 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_120 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState120 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState140 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_124 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState124 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState128 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_130 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState130 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState132 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_134 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState134 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_136 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState136 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_138 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState138 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState122 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_126 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState126 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_macro : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_macro (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState478
      | EOF ->
          let _v_1 = _menhir_action_119 () in
          _menhir_run_479 _menhir_stack _v_1
      | _ ->
          _eRR ()
  
  and _menhir_run_464 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState465 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_466 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | RPAR ->
              let _v = _menhir_action_082 () in
              _menhir_goto_formals _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_466 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState467 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_466 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_084 _1 in
          _menhir_goto_formals_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_formals_ne : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState465 ->
          _menhir_run_469 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState467 ->
          _menhir_run_468 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_469 : type  ttv_stack. ((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _1 = _v in
      let _v = _menhir_action_083 _1 in
      _menhir_goto_formals _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_formals : type  ttv_stack. ((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_formals (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState471 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s) in
          let _menhir_s = MenhirState472 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_260 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState261 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERFENCE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState266 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_270 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICOP (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState271 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | LPAR ->
          let _v = _menhir_action_133 () in
          _menhir_goto_opt_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_opt_annot : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_opt_annot (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState275 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_283 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ST_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState284 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_292 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STORE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState293 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_302 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
              let _2 = _v in
              let _v = _menhir_action_046 _2 in
              _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
              let _v =
                let _1 = _v in
                _menhir_action_121 _1
              in
              _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState302 _tok
          | _ ->
              _eRR ())
      | LPAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState302) in
          let _menhir_s = MenhirState310 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_303 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState303
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let _1 = _v in
            _menhir_action_121 _1
          in
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState303) in
          let _menhir_s = MenhirState305 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_308 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_122 _2 in
      _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_location : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState302 ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_313 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_location (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQ ->
          let _menhir_s = MenhirState314 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_317 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRCU (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState318 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_329 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINUNLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState330 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_334 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState335 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_339 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | NAME _v_0 ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState340
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | CONSTVAR _v_1 ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState340
          | CONSTANT _v_2 ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState340
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState340
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState340
          | RPAR ->
              let _v_4 = _menhir_action_012 () in
              _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | EQ ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState344 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
          let _1 = _v in
          let _v = _menhir_action_045 _1 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_341 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_112 _1 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | STAR | SUB | XOR ->
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_071 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_instruction : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_032 _1 in
      _menhir_goto_block_ins _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_block_ins : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState482 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState472 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState361 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_395 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | WHILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | WCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | VOID ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | STRUCT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | STORE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | STAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SRCU ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | SCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState395
      | LPAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | LOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | LOAD ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | LBRACE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | IF ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | FENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState395
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState395
      | CONST ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState395
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState395
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState395
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState395
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
      | EOF | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_037 _1 in
          _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState395 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_347 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | VOID ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RPAR ->
              let _menhir_stack = MenhirCell1_VOID (_menhir_stack, MenhirState347) in
              let _menhir_s = MenhirState349 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | XCHG ->
                  _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | WCAS_EXPLICIT ->
                  _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | WCAS ->
                  _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICOPRETURN ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICFETCHOP ->
                  _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICADDUNLESS ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | STAR ->
                  _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SRCU ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SPINTRYLOCK ->
                  _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SPINISLOCKED ->
                  _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SCAS_EXPLICIT ->
                  _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SCAS ->
                  _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NAME _v ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | LPAR ->
                  _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LOAD ->
                  _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LD_EXPLICIT ->
                  _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXC_EXPLICIT ->
                  _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CONSTVAR _v ->
                  _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | CONSTANT _v ->
                  _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | CMPXCHG ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ATOMIC_FETCH_EXPLICIT _v ->
                  _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | STAR ->
              let _menhir_s = MenhirState347 in
              let _v = _menhir_action_188 () in
              _menhir_goto_void _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | LPAR ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState347
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState347
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_s = MenhirState347 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_352 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState353 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_357 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState357 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WHILE ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNLOCK ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERFENCE ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOP ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ST_EXPLICIT ->
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STORE ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINUNLOCK ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINLOCK ->
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOCK ->
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FENCE ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CODEVAR _v ->
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_358 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState359 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_362 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SEMI ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let _3 = _v in
                      let _v = _menhir_action_110 _3 in
                      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_367 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_111 _1 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_do_pseudo_seq : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState482 ->
          _menhir_run_484 _menhir_stack _v _tok
      | MenhirState395 ->
          _menhir_run_396 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState393 ->
          _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState046 ->
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_396 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_block_ins (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_038 _1 _2 in
      _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_394 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_declaration -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_declaration (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_040 _2 in
      _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_391 : type  ttv_stack. ((ttv_stack, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_cell1_parameter_list -> _ -> _ -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_parameter_list (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell0_PROC (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_voidopt (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_086 _2 _4 _7 in
          _menhir_goto_function_def _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_function_def : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState000 ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_460 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_461 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_174 _1 in
      _menhir_goto_trans_unit _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_trans_unit : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_trans_unit (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | SCOPES ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | REGIONS ->
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | LEVELS ->
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | EOF ->
          let _menhir_s = MenhirState400 in
          let _v = _menhir_action_154 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v_1 = _menhir_action_191 () in
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState400 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_voidopt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell0_PROC (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | BASE_TYPE _v_1 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState005
              | ATOMIC_TYPE _v_2 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState005
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | RPAR ->
                  let _v_3 = _menhir_action_136 () in
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState005
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState005 in
                  let _v = _menhir_action_176 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_460 : type  ttv_stack. (ttv_stack, _menhir_box_deep_main) _menhir_cell1_trans_unit -> _ -> _ -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_trans_unit (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_175 _1 _2 in
      _menhir_goto_trans_unit _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_390 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr0 -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr0 (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_WHILE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_095 _2 _3 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_388 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | WHILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | WCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | VOID ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | STRUCT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | STORE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | STAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SRCU ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | SCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState388
      | LPAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | LOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | LOAD ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | LBRACE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | IF ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | FENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState388
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState388
      | CONST ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState388
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState388
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState388
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState388
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_089 _1 in
          _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState388 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ins_seq : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState472 ->
          _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState388 ->
          _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState386 ->
          _menhir_run_387 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState357 ->
          _menhir_run_384 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_473 : type  ttv_stack. (((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_cell1_LBRACE -> _ -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_034 _2 in
      let MenhirCell1_formals (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_127 _1 _3 _5 in
      _menhir_goto_macro _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_389 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_block_ins (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_090 _1 _2 in
      _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_387 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_declaration -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_declaration (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_092 _1 _2 in
      _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_384 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_033 _2 in
      _menhir_goto_block_ins _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_380 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_block_ins (_menhir_stack, _, _5) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_094 _3 _5 _7 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_378 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ELSE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState379 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | ATOMIC | ATOMIC_BASE | ATOMIC_FETCH_EXPLICIT _ | ATOMIC_TYPE _ | BASE_TYPE _ | CHAR | CMPXCHG | CODEVAR _ | CONST | CONSTANT _ | CONSTVAR _ | EOF | EXC_EXPLICIT | FENCE | IF | INT | LBRACE | LD_EXPLICIT | LOAD | LOCK | LONG | LPAR | MUTEX | NAME _ | RBRACE | SCAS | SCAS_EXPLICIT | SPINISLOCKED | SPINLOCK | SPINTRYLOCK | SPINUNLOCK | SRCU | STAR | STORE | STRUCT | ST_EXPLICIT | UNDERATOMICADDUNLESS | UNDERATOMICFETCHOP | UNDERATOMICOP | UNDERATOMICOPRETURN | UNDERFENCE | UNLOCK | VOID | VOLATILE | WCAS | WCAS_EXPLICIT | WHILE | XCHG ->
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_093 _3 _5 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_468 : type  ttv_stack. (ttv_stack, _menhir_box_macros) _menhir_cell1_NAME -> _ -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_085 _1 _3 in
      _menhir_goto_formals_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_377 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let e = _v in
          let _v = _menhir_action_081 e in
          let _1 = _v in
          let _v = _menhir_action_088 _1 in
          _menhir_goto_initialisation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_initialisation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_096 _1 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_372 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_typ _menhir_cell0_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_typ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_087 _1 _2 _4 in
          _menhir_goto_initialisation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_360 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _menhir_s = MenhirState361 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_354 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_104 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_350 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_VOID as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VOID (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_098 _4 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_345 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_097 _1 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_336 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SPINLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_106 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_331 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINUNLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SPINUNLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_107 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_326 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _8 = _v in
              let _v = _menhir_action_102 _3 _6 _8 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_322 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _6 = _v in
              let _v = _menhir_action_101 _3 _6 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | STAR | SUB | XOR ->
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _6 = _v in
              let _v = _menhir_action_052 _3 _6 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState325 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_315 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_location as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_location (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_099 _2 _4 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_311 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
              let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_050 _3 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _2 = _v in
              let _v = _menhir_action_123 _2 in
              _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_306 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_123 _2 in
          _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_299 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_STORE, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_STORE (_menhir_stack, _menhir_s) = _menhir_stack in
              let _8 = _v in
              let _v = _menhir_action_100 _3 _6 _8 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_297 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STORE, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState298 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_287 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ST_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SEMI ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                      let MenhirCell1_ST_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                      let (_5, _7) = (_v, _v_0) in
                      let _v = _menhir_action_103 _3 _5 _7 in
                      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_285 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ST_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState286 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_280 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_atomic_op (_menhir_stack, _, _6) = _menhir_stack in
              let MenhirCell1_expr (_menhir_stack, _, _4) = _menhir_stack in
              let MenhirCell0_opt_annot (_menhir_stack, _2) = _menhir_stack in
              let MenhirCell1_UNDERATOMICOP (_menhir_stack, _menhir_s) = _menhir_stack in
              let _8 = _v in
              let _v = _menhir_action_109 _2 _4 _6 _8 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_276 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState277 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XOR ->
              _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SUB ->
              _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PIPE ->
              _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAND ->
              _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_219 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_019 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_atomic_op : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState277 ->
          _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState230 ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState218 ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_278 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP _menhir_cell0_opt_annot, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState279 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_231 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState232 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState226 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_220 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_017 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_221 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_020 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_222 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NOT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_021 () in
          _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COMMA ->
          let _v = _menhir_action_018 () in
          _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_016 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_262 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_UNLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_105 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_253 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_XCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_XCHG (_menhir_stack, _menhir_s) = _menhir_stack in
          let _8 = _v in
          let _v = _menhir_action_068 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_251 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XCHG, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState252 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_245 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COMMA ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | MEMORDER _v_1 ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
                          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                          let MenhirCell1_WCAS_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                          let (_7, _9, _11) = (_v, _v_0, _v_1) in
                          let _v = _menhir_action_073 _11 _3 _5 _7 _9 in
                          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_243 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState244 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState242 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_239 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_WCAS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_WCAS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_072 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_237 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WCAS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState238 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WCAS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState236 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_atomic_op (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICOPRETURN (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_078 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState230 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XOR ->
              _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SUB ->
              _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PIPE ->
              _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAND ->
              _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_227 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_atomic_op (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICFETCHOP (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_079 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_217 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState218 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XOR ->
              _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SUB ->
              _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PIPE ->
              _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAND ->
              _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_215 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICADDUNLESS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_080 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_213 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState214 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_211 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState212 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_209 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_050 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_204 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_052 _3 _6 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_202 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINTRYLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SPINTRYLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_076 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINISLOCKED as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SPINISLOCKED (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_077 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_194 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COMMA ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | MEMORDER _v_1 ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
                          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                          let MenhirCell1_SCAS_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                          let (_7, _9, _11) = (_v, _v_0, _v_1) in
                          let _v = _menhir_action_075 _11 _3 _5 _7 _9 in
                          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState193 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_190 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState191 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SCAS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_SCAS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_074 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_186 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SCAS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState187 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_184 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SCAS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState185 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_178 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState179 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_014 _1 in
          _menhir_goto_args_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_args_ne : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState340 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState092 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState179 ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_181 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _1 = _v in
      let _v = _menhir_action_013 _1 in
      _menhir_goto_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_args : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState340 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState092 ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_180 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_015 _1 _3 in
      _menhir_goto_args_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_174 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_047 _2 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_173 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_typ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_typ (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let e = _v in
      let _v = _menhir_action_048 e in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_169 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOAD, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LOAD (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_051 _3 _6 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_165 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LD_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_LD_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                  let (_3, _5) = (_v, _v_0) in
                  let _v = _menhir_action_053 _3 _5 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_EXC_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                  let MenhirCell1_EXC_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                  let (_5, _7) = (_v, _v_0) in
                  let _v = _menhir_action_067 _3 _5 _7 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_159 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXC_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState160 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_151 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_CMPXCHG (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_069 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_149 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState150 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_147 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState148 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_143 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                  let MenhirCell1_ATOMIC_FETCH_EXPLICIT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
                  let (_5, _7) = (_v, _v_0) in
                  let _v = _menhir_action_070 _1 _3 _5 _7 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_141 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | NAME _ | PIPE | RPAR | SEMI ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_059 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_139 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_061 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_137 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_066 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_135 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_064 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_058 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_131 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_065 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_063 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_127 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD | COMMA | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | SUB | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_055 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_062 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_057 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_121 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_054 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_119 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD | COMMA | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | SUB | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_056 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_060 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_115 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ATOMIC_FETCH_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState142 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_041 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_294 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STORE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState296 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_272 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _2 = _v in
      let _v = _menhir_action_134 _2 in
      _menhir_goto_opt_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_267 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERFENCE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNDERFENCE (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_108 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_158 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_annot -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_annot (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_010 _1 _3 in
      _menhir_goto_annot_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_108 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState110 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_097 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOAD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState099 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRCU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState082 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState074 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState069 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState064 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_XCHG as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState055 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_155 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_annot_base -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_annot_base (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_005 _1 _3 in
      _menhir_goto_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_177 _1 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_declaration : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState482 ->
          _menhir_run_393 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_393 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_393 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_393 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState472 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState357 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_393 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | WHILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | WCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | VOID ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | STRUCT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | STORE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | STAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SRCU ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | SCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState393
      | LPAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | LOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | LOAD ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | LBRACE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | IF ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | FENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState393
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState393
      | CONST ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState393
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState393
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState393
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState393
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState393
      | EOF | RBRACE ->
          let _v = _menhir_action_039 () in
          _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState393 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_386 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | WHILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | WCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | VOID ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | STRUCT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | STORE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | STAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SRCU ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | SCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState386
      | LPAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | LOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | LOAD ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | LBRACE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | IF ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | FENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState386
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState386
      | CONST ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState386
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState386
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState386
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState386
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState386
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_091 _1 in
          _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState386 in
          let _v = _menhir_action_176 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_371 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_typ _menhir_cell0_NAME -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState371 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_typ_par : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_178 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_179 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_369 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EQ ->
              _menhir_run_371 _menhir_stack _menhir_lexbuf _menhir_lexer
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_206 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _5 = _v_0 in
              let _v = _menhir_action_049 _5 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState177 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_171 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | WCAS_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | WCAS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | UNDERATOMICOPRETURN ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | UNDERATOMICFETCHOP ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | UNDERATOMICADDUNLESS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | STAR ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | SRCU ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | SPINTRYLOCK ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | SPINISLOCKED ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | SCAS_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | SCAS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | NAME _v_0 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState172
          | LPAR ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LOAD ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LD_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | EXC_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | CONSTVAR _v_1 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState172
          | CONSTANT _v_2 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState172
          | CMPXCHG ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState172
          | CONST | VOLATILE ->
              let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let t = _v in
              let _v = _menhir_action_185 t in
              _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_038 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_023 _2 in
          _menhir_goto_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_base : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState006 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState026 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState012 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_040 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VOLATILE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VOLATILE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_181 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_027 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ATOMIC -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ATOMIC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_180 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_025 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_CONST -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_CONST (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_182 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let t = _v in
          let _v = _menhir_action_185 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_184 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_022 _1 in
      _menhir_goto_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | PROC _ ->
          let _v = _menhir_action_191 () in
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_463 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState463
      | EOF ->
          let _v = _menhir_action_119 () in
          _menhir_run_480 _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_run_482 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_pseudo_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState482 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WHILE ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNLOCK ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERFENCE ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOP ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ST_EXPLICIT ->
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STORE ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINUNLOCK ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINLOCK ->
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOCK ->
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FENCE ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CODEVAR _v ->
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_486 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState486
      | SCOPES ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState486
      | REGIONS ->
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState486
      | LEVELS ->
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState486
      | BODY _v ->
          _menhir_run_487 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState486
      | EOF ->
          let _menhir_s = MenhirState486 in
          let _v = _menhir_action_154 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v = _menhir_action_191 () in
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState486 _tok
      | _ ->
          _eRR ()
  
end

let shallow_main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_shallow_main v = _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let pseudo_seq =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_pseudo_seq v = _menhir_run_482 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let macros =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_macros v = _menhir_run_463 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let deep_main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_deep_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
