
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XOR
    | WRITE
    | SYMB_REG of (
# 28 "lib/LISAParser.mly"
       (BellBase.reg)
# 17 "lib/LISAParser.ml"
  )
    | SEMI
    | SCOPES
    | RPAR
    | RMW
    | REGIONS
    | REG of (
# 23 "lib/LISAParser.mly"
       (BellBase.reg)
# 27 "lib/LISAParser.ml"
  )
    | READ
    | RBRACE
    | RBRAC
    | PROCFH of (
# 19 "lib/procRules.mly"
       (int)
# 35 "lib/LISAParser.ml"
  )
    | PROC of (
# 29 "lib/LISAParser.mly"
       (int)
# 40 "lib/LISAParser.ml"
  )
    | PLUS
    | PIPE
    | NUM of (
# 24 "lib/LISAParser.mly"
       (int)
# 47 "lib/LISAParser.ml"
  )
    | NEQ
    | NAME of (
# 26 "lib/LISAParser.mly"
       (string)
# 53 "lib/LISAParser.ml"
  )
    | MOV
    | META of (
# 27 "lib/LISAParser.mly"
       (string)
# 59 "lib/LISAParser.ml"
  )
    | LPAR
    | LEVELS
    | LBRACE
    | LBRAC
    | FENCE
    | EQ
    | EOF
    | COMMA
    | COLON
    | CODEVAR of (
# 25 "lib/LISAParser.mly"
       (string)
# 73 "lib/LISAParser.ml"
  )
    | CALL
    | BRANCH
    | AND
    | ADD
  
end

include MenhirBasics

# 1 "lib/BellExtraRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)
open BellInfo
let nones = { scopes=None; levels=None; regions=None; }

# 104 "lib/LISAParser.ml"

# 1 "lib/LISAParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2013-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module Bell = BellBase
open Bell

# 127 "lib/LISAParser.ml"

# 1 "lib/procRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2019-present Institut National de Recherche en Informatique et *)
(* en Automatique, ARM Ltd and the authors. All rights reserved.            *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 147 "lib/LISAParser.ml"

# 1 "lib/scopeRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2019-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 167 "lib/LISAParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_instr_option_seq) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: instr_option_seq. *)

  | MenhirState001 : (('s, 'r) _menhir_cell1_WRITE, 'r) _menhir_state
    (** State 001.
        Stack shape : WRITE.
        Start symbol: <undetermined>. *)

  | MenhirState002 : (('s, 'r) _menhir_cell1_LBRAC, 'r) _menhir_state
    (** State 002.
        Stack shape : LBRAC.
        Start symbol: <undetermined>. *)

  | MenhirState012 : (('s, 'r) _menhir_cell1_name, 'r) _menhir_state
    (** State 012.
        Stack shape : name.
        Start symbol: <undetermined>. *)

  | MenhirState014 : ((('s, 'r) _menhir_cell1_WRITE, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_state
    (** State 014.
        Stack shape : WRITE annot_list_option.
        Start symbol: <undetermined>. *)

  | MenhirState018 : (('s, 'r) _menhir_cell1_reg_or_addr, 'r) _menhir_state
    (** State 018.
        Stack shape : reg_or_addr.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (((('s, 'r) _menhir_cell1_WRITE, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_cell1_addr_op, 'r) _menhir_state
    (** State 026.
        Stack shape : WRITE annot_list_option addr_op.
        Start symbol: <undetermined>. *)

  | MenhirState028 : (('s, 'r) _menhir_cell1_RMW, 'r) _menhir_state
    (** State 028.
        Stack shape : RMW.
        Start symbol: <undetermined>. *)

  | MenhirState029 : ((('s, 'r) _menhir_cell1_RMW, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_state
    (** State 029.
        Stack shape : RMW annot_list_option.
        Start symbol: <undetermined>. *)

  | MenhirState030 : (((('s, 'r) _menhir_cell1_RMW, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 030.
        Stack shape : RMW annot_list_option reg.
        Start symbol: <undetermined>. *)

  | MenhirState032 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 032.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState035 : (((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_any_value, 'r) _menhir_state
    (** State 035.
        Stack shape : reg LPAR any_value.
        Start symbol: <undetermined>. *)

  | MenhirState038 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 038.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState039 : (((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_any_value, 'r) _menhir_state
    (** State 039.
        Stack shape : reg LPAR any_value.
        Start symbol: <undetermined>. *)

  | MenhirState042 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 042.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState043 : (((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_any_value, 'r) _menhir_state
    (** State 043.
        Stack shape : reg LPAR any_value.
        Start symbol: <undetermined>. *)

  | MenhirState046 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 046.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState047 : (((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_any_value, 'r) _menhir_state
    (** State 047.
        Stack shape : reg LPAR any_value.
        Start symbol: <undetermined>. *)

  | MenhirState050 : ((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 050.
        Stack shape : reg LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState051 : (((('s, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_any_value, 'r) _menhir_state
    (** State 051.
        Stack shape : reg LPAR any_value.
        Start symbol: <undetermined>. *)

  | MenhirState054 : ((((('s, 'r) _menhir_cell1_RMW, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_operation, 'r) _menhir_state
    (** State 054.
        Stack shape : RMW annot_list_option reg operation.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (('s, 'r) _menhir_cell1_READ, 'r) _menhir_state
    (** State 057.
        Stack shape : READ.
        Start symbol: <undetermined>. *)

  | MenhirState058 : ((('s, 'r) _menhir_cell1_READ, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_state
    (** State 058.
        Stack shape : READ annot_list_option.
        Start symbol: <undetermined>. *)

  | MenhirState059 : (((('s, 'r) _menhir_cell1_READ, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 059.
        Stack shape : READ annot_list_option reg.
        Start symbol: <undetermined>. *)

  | MenhirState062 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 062.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState063 : (('s, 'r) _menhir_cell1_MOV, 'r) _menhir_state
    (** State 063.
        Stack shape : MOV.
        Start symbol: <undetermined>. *)

  | MenhirState064 : ((('s, 'r) _menhir_cell1_MOV, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 064.
        Stack shape : MOV reg.
        Start symbol: <undetermined>. *)

  | MenhirState066 : (('s, 'r) _menhir_cell1_FENCE, 'r) _menhir_state
    (** State 066.
        Stack shape : FENCE.
        Start symbol: <undetermined>. *)

  | MenhirState068 : ((('s, 'r) _menhir_cell1_FENCE, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_state
    (** State 068.
        Stack shape : FENCE annot_list_option.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (((('s, 'r) _menhir_cell1_FENCE, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_cell1_name_set, 'r) _menhir_state
    (** State 071.
        Stack shape : FENCE annot_list_option name_set.
        Start symbol: <undetermined>. *)

  | MenhirState078 : (('s, 'r) _menhir_cell1_CALL, 'r) _menhir_state
    (** State 078.
        Stack shape : CALL.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (('s, 'r) _menhir_cell1_BRANCH, 'r) _menhir_state
    (** State 081.
        Stack shape : BRANCH.
        Start symbol: <undetermined>. *)

  | MenhirState082 : ((('s, 'r) _menhir_cell1_BRANCH, 'r) _menhir_cell1_annot_list_option, 'r) _menhir_state
    (** State 082.
        Stack shape : BRANCH annot_list_option.
        Start symbol: <undetermined>. *)

  | MenhirState092 : (('s, _menhir_box_instr_option_seq) _menhir_cell1_instr_option, _menhir_box_instr_option_seq) _menhir_state
    (** State 092.
        Stack shape : instr_option.
        Start symbol: instr_option_seq. *)

  | MenhirState096 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 096.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState097 : (('s, _menhir_box_main) _menhir_cell1_PROCFH, _menhir_box_main) _menhir_state
    (** State 097.
        Stack shape : PROCFH.
        Start symbol: main. *)

  | MenhirState098 : (('s, _menhir_box_main) _menhir_cell1_COLON, _menhir_box_main) _menhir_state
    (** State 098.
        Stack shape : COLON.
        Start symbol: main. *)

  | MenhirState100 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 100.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState106 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 106.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState110 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 110.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState111 : ((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_state
    (** State 111.
        Stack shape : semi_opt proc_list iol_list.
        Start symbol: main. *)

  | MenhirState113 : (('s, _menhir_box_main) _menhir_cell1_SCOPES, _menhir_box_main) _menhir_state
    (** State 113.
        Stack shape : SCOPES.
        Start symbol: main. *)

  | MenhirState115 : (('s, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME, _menhir_box_main) _menhir_state
    (** State 115.
        Stack shape : LPAR NAME.
        Start symbol: main. *)

  | MenhirState120 : (('s, _menhir_box_main) _menhir_cell1_scope_tree, _menhir_box_main) _menhir_state
    (** State 120.
        Stack shape : scope_tree.
        Start symbol: main. *)

  | MenhirState124 : (('s, _menhir_box_main) _menhir_cell1_proc, _menhir_box_main) _menhir_state
    (** State 124.
        Stack shape : proc.
        Start symbol: main. *)

  | MenhirState129 : (('s, _menhir_box_main) _menhir_cell1_REGIONS, _menhir_box_main) _menhir_state
    (** State 129.
        Stack shape : REGIONS.
        Start symbol: main. *)

  | MenhirState131 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 131.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState132 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 132.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState138 : (('s, _menhir_box_main) _menhir_cell1_memory_map_atom, _menhir_box_main) _menhir_state
    (** State 138.
        Stack shape : memory_map_atom.
        Start symbol: main. *)

  | MenhirState142 : (('s, _menhir_box_main) _menhir_cell1_LEVELS, _menhir_box_main) _menhir_state
    (** State 142.
        Stack shape : LEVELS.
        Start symbol: main. *)

  | MenhirState143 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 143.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState145 : (('s, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME, _menhir_box_main) _menhir_state
    (** State 145.
        Stack shape : LPAR NAME.
        Start symbol: main. *)

  | MenhirState148 : (('s, _menhir_box_main) _menhir_cell1_level_tree, _menhir_box_main) _menhir_state
    (** State 148.
        Stack shape : level_tree.
        Start symbol: main. *)

  | MenhirState153 : (((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_state
    (** State 153.
        Stack shape : semi_opt proc_list iol_list scopes_key.
        Start symbol: main. *)

  | MenhirState154 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_state
    (** State 154.
        Stack shape : semi_opt proc_list iol_list scopes_key memory_map_key.
        Start symbol: main. *)

  | MenhirState156 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_state
    (** State 156.
        Stack shape : semi_opt proc_list iol_list scopes_key levels_key.
        Start symbol: main. *)

  | MenhirState161 : (((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_state
    (** State 161.
        Stack shape : semi_opt proc_list iol_list memory_map_key.
        Start symbol: main. *)

  | MenhirState162 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_state
    (** State 162.
        Stack shape : semi_opt proc_list iol_list memory_map_key scopes_key.
        Start symbol: main. *)

  | MenhirState164 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_state
    (** State 164.
        Stack shape : semi_opt proc_list iol_list memory_map_key levels_key.
        Start symbol: main. *)

  | MenhirState166 : (((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_state
    (** State 166.
        Stack shape : semi_opt proc_list iol_list levels_key.
        Start symbol: main. *)

  | MenhirState167 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_state
    (** State 167.
        Stack shape : semi_opt proc_list iol_list levels_key scopes_key.
        Start symbol: main. *)

  | MenhirState169 : ((((('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_state
    (** State 169.
        Stack shape : semi_opt proc_list iol_list levels_key memory_map_key.
        Start symbol: main. *)

  | MenhirState172 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 172.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState175 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 175.
        Stack shape : instr_option.
        Start symbol: main. *)

  | MenhirState178 : (('s, _menhir_box_main) _menhir_cell1_proc_annotated, _menhir_box_main) _menhir_state
    (** State 178.
        Stack shape : proc_annotated.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_addr_op = 
  | MenhirCell1_addr_op of 's * ('s, 'r) _menhir_state * (MetaConst.k Bell.addr_op)

and ('s, 'r) _menhir_cell1_annot_list_option = 
  | MenhirCell1_annot_list_option of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_any_value = 
  | MenhirCell1_any_value of 's * ('s, 'r) _menhir_state * (MetaConst.k Bell.imm_or_addr_or_reg)

and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (BellBase.parsedPseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (BellBase.parsedPseudo list)

and ('s, 'r) _menhir_cell1_iol_list = 
  | MenhirCell1_iol_list of 's * ('s, 'r) _menhir_state * (BellBase.parsedPseudo list list)

and ('s, 'r) _menhir_cell1_level_tree = 
  | MenhirCell1_level_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_levels_key = 
  | MenhirCell1_levels_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_memory_map_atom = 
  | MenhirCell1_memory_map_atom of 's * ('s, 'r) _menhir_state * (string * string list)

and ('s, 'r) _menhir_cell1_memory_map_key = 
  | MenhirCell1_memory_map_key of 's * ('s, 'r) _menhir_state * (BellInfo.mem_space_map)

and ('s, 'r) _menhir_cell1_name = 
  | MenhirCell1_name of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_name_set = 
  | MenhirCell1_name_set of 's * ('s, 'r) _menhir_state * (Label.Set.t)

and ('s, 'r) _menhir_cell1_operation = 
  | MenhirCell1_operation of 's * ('s, 'r) _menhir_state * (MetaConst.k Bell.op)

and ('s, 'r) _menhir_cell1_proc = 
  | MenhirCell1_proc of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_proc_annotated = 
  | MenhirCell1_proc_annotated of 's * ('s, 'r) _menhir_state * (MiscParser.proc)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (Bell.reg_arg)

and ('s, 'r) _menhir_cell1_reg_or_addr = 
  | MenhirCell1_reg_or_addr of 's * ('s, 'r) _menhir_state * (Bell.reg_or_addr)

and ('s, 'r) _menhir_cell1_scope_tree = 
  | MenhirCell1_scope_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_scopes_key = 
  | MenhirCell1_scopes_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and ('s, 'r) _menhir_cell1_BRANCH = 
  | MenhirCell1_BRANCH of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CALL = 
  | MenhirCell1_CALL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLON = 
  | MenhirCell1_COLON of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_FENCE = 
  | MenhirCell1_FENCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBRAC = 
  | MenhirCell1_LBRAC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LEVELS = 
  | MenhirCell1_LEVELS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MOV = 
  | MenhirCell1_MOV of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 26 "lib/LISAParser.mly"
       (string)
# 587 "lib/LISAParser.ml"
)

and 's _menhir_cell0_NAME = 
  | MenhirCell0_NAME of 's * (
# 26 "lib/LISAParser.mly"
       (string)
# 594 "lib/LISAParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 29 "lib/LISAParser.mly"
       (int)
# 601 "lib/LISAParser.ml"
)

and ('s, 'r) _menhir_cell1_PROCFH = 
  | MenhirCell1_PROCFH of 's * ('s, 'r) _menhir_state * (
# 19 "lib/procRules.mly"
       (int)
# 608 "lib/LISAParser.ml"
)

and ('s, 'r) _menhir_cell1_READ = 
  | MenhirCell1_READ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_REGIONS = 
  | MenhirCell1_REGIONS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_RMW = 
  | MenhirCell1_RMW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCOPES = 
  | MenhirCell1_SCOPES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WRITE = 
  | MenhirCell1_WRITE of 's * ('s, 'r) _menhir_state

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * BellBase.parsedPseudo list list *
  MiscParser.extra_data) [@@unboxed]

and _menhir_box_instr_option_seq = 
  | MenhirBox_instr_option_seq of (BellBase.parsedPseudo list) [@@unboxed]

let _menhir_action_002 =
  fun _1 ->
    (
# 113 "lib/LISAParser.mly"
              (BellBase.Addr_op_atom(_1))
# 638 "lib/LISAParser.ml"
     : (MetaConst.k Bell.addr_op))

let _menhir_action_003 =
  fun _1 _3 ->
    (
# 114 "lib/LISAParser.mly"
                              ( BellBase.Addr_op_add(_1,_3) )
# 646 "lib/LISAParser.ml"
     : (MetaConst.k Bell.addr_op))

let _menhir_action_004 =
  fun _2 ->
    (
# 89 "lib/LISAParser.mly"
                        (_2)
# 654 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_005 =
  fun () ->
    (
# 90 "lib/LISAParser.mly"
  ([])
# 662 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_006 =
  fun _1 ->
    (
# 109 "lib/LISAParser.mly"
              ( IAR_roa _1 )
# 670 "lib/LISAParser.ml"
     : (MetaConst.k Bell.imm_or_addr_or_reg))

let _menhir_action_007 =
  fun _1 ->
    (
# 110 "lib/LISAParser.mly"
    ( IAR_imm _1)
# 678 "lib/LISAParser.ml"
     : (MetaConst.k Bell.imm_or_addr_or_reg))

let _menhir_action_008 =
  fun () ->
    (
# 136 "lib/LISAParser.mly"
  ( None )
# 686 "lib/LISAParser.ml"
     : ((Label.Set.t * Label.Set.t) option))

let _menhir_action_009 =
  fun _2 _5 ->
    (
# 137 "lib/LISAParser.mly"
                                                (Some(_2,_5))
# 694 "lib/LISAParser.ml"
     : ((Label.Set.t * Label.Set.t) option))

let _menhir_action_010 =
  fun _2 _3 _4 ->
    (
# 142 "lib/LISAParser.mly"
  ( Pld(_3,_4,_2) )
# 702 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_011 =
  fun _2 _3 _4 ->
    (
# 145 "lib/LISAParser.mly"
  ( Pst(_3,_4,_2) )
# 710 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_012 =
  fun _2 _3 ->
    (
# 148 "lib/LISAParser.mly"
 ( Pfence(Fence (_2,_3)) )
# 718 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_013 =
  fun _3 ->
    (
# 151 "lib/LISAParser.mly"
  ( Pcall _3 )
# 726 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_014 =
  fun _2 _3 _4 _5 ->
    (
# 154 "lib/LISAParser.mly"
  ( Prmw(_3,_4,_5,_2))
# 734 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_015 =
  fun _2 _3 _4 ->
    (
# 157 "lib/LISAParser.mly"
  ( Pbranch (Some _3,_4,_2) )
# 742 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_016 =
  fun _2 _3 ->
    (
# 160 "lib/LISAParser.mly"
  ( Pbranch (None,_3,_2) )
# 750 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_017 =
  fun _2 _3 ->
    (
# 163 "lib/LISAParser.mly"
  ( Pmov (_2,_3) )
# 758 "lib/LISAParser.ml"
     : (BellBase.pins))

let _menhir_action_018 =
  fun () ->
    (
# 47 "lib/LISAParser.mly"
             ( Nop )
# 766 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo))

let _menhir_action_019 =
  fun _1 _3 ->
    (
# 48 "lib/LISAParser.mly"
                          ( Label (_1,_3) )
# 774 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo))

let _menhir_action_020 =
  fun _1 ->
    (
# 49 "lib/LISAParser.mly"
             ( Instruction _1)
# 782 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo))

let _menhir_action_021 =
  fun _1 ->
    (
# 50 "lib/LISAParser.mly"
             ( Symbolic _1 )
# 790 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo))

let _menhir_action_022 =
  fun _1 ->
    (
# 54 "lib/LISAParser.mly"
      ([_1])
# 798 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list))

let _menhir_action_023 =
  fun _1 _3 ->
    (
# 56 "lib/LISAParser.mly"
      (_1::_3)
# 806 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list))

let _menhir_action_024 =
  fun xs ->
    (
# 59 "lib/LISAParser.mly"
                                                      ( xs )
# 814 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list))

let _menhir_action_025 =
  fun _1 ->
    (
# 63 "lib/LISAParser.mly"
    ([_1])
# 822 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list list))

let _menhir_action_026 =
  fun _1 _3 ->
    (
# 64 "lib/LISAParser.mly"
                                   (_1::_3)
# 830 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list list))

let _menhir_action_027 =
  fun _1 ->
    (
# 101 "lib/LISAParser.mly"
      ( MetaConst.Int _1 )
# 838 "lib/LISAParser.ml"
     : (MetaConst.k))

let _menhir_action_028 =
  fun _1 ->
    (
# 102 "lib/LISAParser.mly"
       ( MetaConst.Meta _1 )
# 846 "lib/LISAParser.ml"
     : (MetaConst.k))

let _menhir_action_029 =
  fun _2 _3 ->
    (
# 62 "lib/scopeRules.mly"
  (
   let ps,ts = _3 in
   BellInfo.Tree (_2,ps,ts)
   )
# 857 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_030 =
  fun _1 ->
    (
# 51 "lib/scopeRules.mly"
       ( [_1],[] )
# 865 "lib/LISAParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_031 =
  fun _1 ->
    (
# 52 "lib/scopeRules.mly"
             (let ps =  [] in ps,[_1])
# 873 "lib/LISAParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_032 =
  fun _1 _2 ->
    (
# 54 "lib/scopeRules.mly"
    ( let ps,ts = _2 in
      _1::ps,ts )
# 882 "lib/LISAParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_033 =
  fun _1 _2 ->
    (
# 57 "lib/scopeRules.mly"
    (let ps,ts = _2 in
     ps,_1::ts )
# 891 "lib/LISAParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_034 =
  fun _3 ->
    (
# 53 "lib/BellExtraRules.mly"
                              ( _3 )
# 899 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_035 =
  fun () ->
    (
# 145 "<standard.mly>"
    ( [] )
# 907 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_036 =
  fun x ->
    (
# 148 "<standard.mly>"
    ( x )
# 915 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_037 =
  fun () ->
    (
# 145 "<standard.mly>"
    ( [] )
# 923 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_038 =
  fun x ->
    (
# 148 "<standard.mly>"
    ( x )
# 931 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_039 =
  fun _2 _3 _4 ->
    (
# 40 "lib/LISAParser.mly"
   ( _2,_3, [MiscParser.BellExtra _4] )
# 939 "lib/LISAParser.ml"
     : (MiscParser.proc list * BellBase.parsedPseudo list list *
  MiscParser.extra_data))

let _menhir_action_040 =
  fun _1 _3 ->
    (
# 75 "lib/scopeRules.mly"
                                  ( (_1,_3) )
# 948 "lib/LISAParser.ml"
     : (string * string list))

let _menhir_action_041 =
  fun _3 ->
    (
# 56 "lib/BellExtraRules.mly"
                               ( _3 )
# 956 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_042 =
  fun _1 ->
    (
# 67 "lib/LISAParser.mly"
       ( _1)
# 964 "lib/LISAParser.ml"
     : (string))

let _menhir_action_043 =
  fun () ->
    (
# 69 "lib/LISAParser.mly"
       ("r")
# 972 "lib/LISAParser.ml"
     : (string))

let _menhir_action_044 =
  fun () ->
    (
# 70 "lib/LISAParser.mly"
        ("w")
# 980 "lib/LISAParser.ml"
     : (string))

let _menhir_action_045 =
  fun () ->
    (
# 71 "lib/LISAParser.mly"
         ("b")
# 988 "lib/LISAParser.ml"
     : (string))

let _menhir_action_046 =
  fun () ->
    (
# 72 "lib/LISAParser.mly"
        ("f")
# 996 "lib/LISAParser.ml"
     : (string))

let _menhir_action_047 =
  fun _1 ->
    (
# 81 "lib/LISAParser.mly"
               (_1)
# 1004 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_048 =
  fun () ->
    (
# 82 "lib/LISAParser.mly"
  ([])
# 1012 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_049 =
  fun _1 _3 ->
    (
# 76 "lib/LISAParser.mly"
  (_1::_3)
# 1020 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_050 =
  fun _1 ->
    (
# 78 "lib/LISAParser.mly"
  ([_1])
# 1028 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_051 =
  fun _1 ->
    (
# 85 "lib/LISAParser.mly"
            ( Label.Set.of_list _1)
# 1036 "lib/LISAParser.ml"
     : (Label.Set.t))

let _menhir_action_052 =
  fun x ->
    (
# 228 "<standard.mly>"
    ( [ x ] )
# 1044 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_053 =
  fun x xs ->
    (
# 231 "<standard.mly>"
    ( x :: xs )
# 1052 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_054 =
  fun _1 ->
    (
# 118 "lib/LISAParser.mly"
  ( RAI(_1) )
# 1060 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_055 =
  fun _3 _4 ->
    (
# 121 "lib/LISAParser.mly"
 ( OP (Add,_3,_4) )
# 1068 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_056 =
  fun _3 _4 ->
    (
# 124 "lib/LISAParser.mly"
 ( OP (Xor,_3,_4) )
# 1076 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_057 =
  fun _3 _4 ->
    (
# 127 "lib/LISAParser.mly"
 ( OP (And,_3,_4) )
# 1084 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_058 =
  fun _3 _4 ->
    (
# 130 "lib/LISAParser.mly"
  ( OP (Eq,_3,_4) )
# 1092 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_059 =
  fun _3 _4 ->
    (
# 133 "lib/LISAParser.mly"
  ( OP (Neq,_3,_4) )
# 1100 "lib/LISAParser.ml"
     : (MetaConst.k Bell.op))

let _menhir_action_060 =
  fun () ->
    (
# 111 "<standard.mly>"
    ( None )
# 1108 "lib/LISAParser.ml"
     : (string list option))

let _menhir_action_061 =
  fun x ->
    (
# 114 "<standard.mly>"
    ( Some x )
# 1116 "lib/LISAParser.ml"
     : (string list option))

let _menhir_action_062 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1124 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_063 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1132 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_064 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1140 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_065 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1148 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_066 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1156 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_067 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 1164 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_068 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 1172 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_069 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 1180 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_070 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 1188 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_071 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 1196 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_072 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 1204 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_073 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 1212 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_074 =
  fun scopes ->
    (
# 41 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; } )
# 1220 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_075 =
  fun levels ->
    (
# 43 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; } )
# 1228 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_076 =
  fun regions ->
    (
# 45 "lib/BellExtraRules.mly"
    ( { nones with regions=Some regions; } )
# 1236 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_077 =
  fun () ->
    (
# 47 "lib/BellExtraRules.mly"
    (  nones )
# 1244 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_078 =
  fun _1 ->
    (
# 22 "lib/scopeRules.mly"
        ( _1 )
# 1252 "lib/LISAParser.ml"
     : (int))

let _menhir_action_079 =
  fun _1 ->
    (
# 23 "lib/scopeRules.mly"
        ( _1 )
# 1260 "lib/LISAParser.ml"
     : (int))

let _menhir_action_080 =
  fun xs ->
    let os = 
# 241 "<standard.mly>"
    ( xs )
# 1268 "lib/LISAParser.ml"
     in
    (
# 24 "lib/procRules.mly"
                                      ( os )
# 1273 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_081 =
  fun os p ->
    (
# 27 "lib/procRules.mly"
                                 ( p,os,MiscParser.FaultHandler )
# 1281 "lib/LISAParser.ml"
     : (MiscParser.proc))

let _menhir_action_082 =
  fun os p ->
    (
# 28 "lib/procRules.mly"
                               ( p,os,MiscParser.Main )
# 1289 "lib/LISAParser.ml"
     : (MiscParser.proc))

let _menhir_action_083 =
  fun _1 ->
    (
# 31 "lib/procRules.mly"
                                                    ( _1 )
# 1297 "lib/LISAParser.ml"
     : (MiscParser.proc list))

let _menhir_action_084 =
  fun _1 _2 ->
    (
# 26 "lib/scopeRules.mly"
                    (_1::_2)
# 1305 "lib/LISAParser.ml"
     : (int list))

let _menhir_action_085 =
  fun () ->
    (
# 27 "lib/scopeRules.mly"
  ([])
# 1313 "lib/LISAParser.ml"
     : (int list))

let _menhir_action_086 =
  fun _1 ->
    (
# 93 "lib/LISAParser.mly"
      ( _1)
# 1321 "lib/LISAParser.ml"
     : (Bell.reg_arg))

let _menhir_action_087 =
  fun _1 ->
    (
# 94 "lib/LISAParser.mly"
           ( _1 )
# 1329 "lib/LISAParser.ml"
     : (Bell.reg_arg))

let _menhir_action_088 =
  fun _1 ->
    (
# 97 "lib/LISAParser.mly"
       (Rega _1)
# 1337 "lib/LISAParser.ml"
     : (Bell.reg_or_addr))

let _menhir_action_089 =
  fun _1 ->
    (
# 98 "lib/LISAParser.mly"
       ( Abs _1)
# 1345 "lib/LISAParser.ml"
     : (Bell.reg_or_addr))

let _menhir_action_090 =
  fun _1 ->
    (
# 105 "lib/LISAParser.mly"
      (Regi _1)
# 1353 "lib/LISAParser.ml"
     : (MetaConst.k Bell.reg_or_imm))

let _menhir_action_091 =
  fun _1 ->
    (
# 106 "lib/LISAParser.mly"
      ( Imm _1)
# 1361 "lib/LISAParser.ml"
     : (MetaConst.k Bell.reg_or_imm))

let _menhir_action_092 =
  fun _2 _3 ->
    (
# 35 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,[],_3)
   )
# 1371 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_093 =
  fun _2 _3 ->
    (
# 39 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,_3,[])
   )
# 1381 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_094 =
  fun _1 ->
    (
# 30 "lib/scopeRules.mly"
             ([_1])
# 1389 "lib/LISAParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_095 =
  fun _1 _2 ->
    (
# 31 "lib/scopeRules.mly"
                             (_1::_2)
# 1397 "lib/LISAParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_096 =
  fun x ->
    (
# 61 "lib/BellExtraRules.mly"
                                                    ( x )
# 1405 "lib/LISAParser.ml"
     : (BellInfo.test))

let _menhir_action_097 =
  fun _3 ->
    (
# 50 "lib/BellExtraRules.mly"
                              ( _3 )
# 1413 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_098 =
  fun () ->
    (
# 43 "lib/LISAParser.mly"
  ( () )
# 1421 "lib/LISAParser.ml"
     : (unit))

let _menhir_action_099 =
  fun () ->
    (
# 44 "lib/LISAParser.mly"
       ( () )
# 1429 "lib/LISAParser.ml"
     : (unit))

let _menhir_action_100 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 1437 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_101 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 1445 "lib/LISAParser.ml"
     : (string list))

let _menhir_action_102 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 1453 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_103 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 1461 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_104 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 1469 "lib/LISAParser.ml"
     : (MiscParser.proc list))

let _menhir_action_105 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 1477 "lib/LISAParser.ml"
     : (MiscParser.proc list))

let _menhir_action_106 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 1485 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list))

let _menhir_action_107 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 1493 "lib/LISAParser.ml"
     : (BellBase.parsedPseudo list))

let _menhir_action_108 =
  fun _1 ->
    (
# 69 "lib/scopeRules.mly"
    ( let ps,ts = _1 in
      match ps,ts with
      | [],[t] -> t
      | _ -> BellInfo.Tree ("",ps,ts) )
# 1504 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_action_109 =
  fun xs ->
    let atoms = 
# 241 "<standard.mly>"
    ( xs )
# 1512 "lib/LISAParser.ml"
     in
    (
# 78 "lib/scopeRules.mly"
                                                 ( atoms )
# 1517 "lib/LISAParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_110 =
  fun _1 ->
    (
# 45 "lib/scopeRules.mly"
    ( let ts = _1 in
      match ts with
      | [t] -> t
      | _ -> BellInfo.Tree ("",[],ts) )
# 1528 "lib/LISAParser.ml"
     : (BellInfo.scopes))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADD ->
        "ADD"
    | AND ->
        "AND"
    | BRANCH ->
        "BRANCH"
    | CALL ->
        "CALL"
    | CODEVAR _ ->
        "CODEVAR"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | EOF ->
        "EOF"
    | EQ ->
        "EQ"
    | FENCE ->
        "FENCE"
    | LBRAC ->
        "LBRAC"
    | LBRACE ->
        "LBRACE"
    | LEVELS ->
        "LEVELS"
    | LPAR ->
        "LPAR"
    | META _ ->
        "META"
    | MOV ->
        "MOV"
    | NAME _ ->
        "NAME"
    | NEQ ->
        "NEQ"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PLUS ->
        "PLUS"
    | PROC _ ->
        "PROC"
    | PROCFH _ ->
        "PROCFH"
    | RBRAC ->
        "RBRAC"
    | RBRACE ->
        "RBRACE"
    | READ ->
        "READ"
    | REG _ ->
        "REG"
    | REGIONS ->
        "REGIONS"
    | RMW ->
        "RMW"
    | RPAR ->
        "RPAR"
    | SCOPES ->
        "SCOPES"
    | SEMI ->
        "SEMI"
    | SYMB_REG _ ->
        "SYMB_REG"
    | WRITE ->
        "WRITE"
    | XOR ->
        "XOR"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ : type  ttv_stack. ((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let x = _v in
      let _v = _menhir_action_096 x in
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let MenhirCell1_iol_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_039 _2 _3 _4 in
          MenhirBox_main _v
      | _ ->
          _eRR ()
  
  let _menhir_run_170 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_cell1_memory_map_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_065 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let _menhir_run_168 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key, _menhir_box_main) _menhir_cell1_scopes_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_063 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let _menhir_run_163 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_cell1_scopes_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_066 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let _menhir_run_155 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_cell1_memory_map_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_067 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let _menhir_run_157 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key, _menhir_box_main) _menhir_cell1_levels_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_062 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let _menhir_run_165 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key, _menhir_box_main) _menhir_cell1_levels_key -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_064 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
  
  let rec _menhir_run_112 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCOPES (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState113 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState115
          | NUM _v_1 ->
              _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState115
          | LPAR ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState115
          | RPAR ->
              let _v_2 = _menhir_action_085 () in
              _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_116 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_078 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_proc : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState124
      | NUM _v_1 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState124
      | RPAR ->
          let _v_2 = _menhir_action_085 () in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_079 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_125 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_proc -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_proc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_084 _1 _2 in
      _menhir_goto_proc_list_sc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_proc_list_sc : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState115 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_122 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_093 _2 _3 in
      _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scope_tree : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _v) in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | EOF | LEVELS | REGIONS | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_094 _1 in
          _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_scope_tree_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState113 ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState120 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState115 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_127 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_SCOPES -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_110 _1 in
      let MenhirCell1_SCOPES (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_097 _3 in
      _menhir_goto_scopes_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scopes_key : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState169 ->
          _menhir_run_170 _menhir_stack _v _tok
      | MenhirState166 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_165 _menhir_stack _v _tok
      | MenhirState161 ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_167 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState167
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_069 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_REGIONS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState129 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EOF | LEVELS | SCOPES ->
              let _v = _menhir_action_037 () in
              _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_130 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState131 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState132
      | COMMA | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_052 x in
          _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_nonempty_list_NAME_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState131 ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_134 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_040 _1 _3 in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState138 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_102 x in
          _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState138 ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState129 ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_139 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_memory_map_atom -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_103 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_136 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let x = _v in
      let _v = _menhir_action_038 x in
      _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let xs = _v in
      let _v = _menhir_action_109 xs in
      let MenhirCell1_REGIONS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_041 _3 in
      _menhir_goto_memory_map_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_memory_map_key : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState166 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState167 ->
          _menhir_run_168 _menhir_stack _v _tok
      | MenhirState111 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_157 _menhir_stack _v _tok
      | MenhirState153 ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_169 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState169
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_072 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack. (((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | EOF ->
          let regions = _v in
          let _v = _menhir_action_076 regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_141 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LEVELS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState142 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_143 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState143
      | LPAR ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState143
      | EOF | REGIONS | RPAR | SCOPES ->
          let _1 = _v in
          let _v = _menhir_action_030 _1 in
          _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_144 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _menhir_s = MenhirState145 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_level_tree_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState142 ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState143 ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState148 ->
          _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState145 ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_152 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LEVELS -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_108 _1 in
      let MenhirCell1_LEVELS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_034 _3 in
      _menhir_goto_levels_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_levels_key : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState111 ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState161 ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState162 ->
          _menhir_run_163 _menhir_stack _v _tok
      | MenhirState153 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState154 ->
          _menhir_run_155 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_166 : type  ttv_stack. (((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | EOF ->
          let levels = _v in
          let _v = _menhir_action_075 levels in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_073 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_156 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_068 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_150 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_032 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_149 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_level_tree -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_level_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_033 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_146 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_029 _2 _3 in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState148
          | LPAR ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
          | EOF | REGIONS | RPAR | SCOPES ->
              let _1 = _v in
              let _v = _menhir_action_031 _1 in
              _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_154 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_070 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_053 x xs in
      _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_162 : type  ttv_stack. ((((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list, _menhir_box_main) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_071 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_153 : type  ttv_stack. (((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_cell1_iol_list as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState153
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState153
      | EOF ->
          let scopes = _v in
          let _v = _menhir_action_074 scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_121 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_scope_tree -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_095 _1 _2 in
      _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_118 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_092 _2 _3 in
          _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_111 : type  ttv_stack. ((ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_iol_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | REGIONS ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | LEVELS ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
      | EOF ->
          let _v = _menhir_action_077 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState172 ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState110 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_173 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_026 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_088 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let xs = _v in
      let _v = _menhir_action_024 xs in
      MenhirBox_instr_option_seq _v
  
  let rec _menhir_goto_separated_nonempty_list_SEMI_instr_option_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState092 ->
          _menhir_run_093 _menhir_stack _v
      | MenhirState000 ->
          _menhir_run_088 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_093 : type  ttv_stack. (ttv_stack, _menhir_box_instr_option_seq) _menhir_cell1_instr_option -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_107 x xs in
      _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WRITE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState001
      | BRANCH | FENCE | NAME _ | READ | REG _ | SYMB_REG _ | WRITE ->
          let _v = _menhir_action_005 () in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState001 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LBRAC (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState002
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState002
      | NAME _v ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState002
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState002
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState002
      | RBRAC ->
          let _v = _menhir_action_048 () in
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_044 () in
      _menhir_goto_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_name : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState078 ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState064 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState014 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState012 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState002 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_079 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_CALL -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRAC ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_CALL (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_013 _3 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_instr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_020 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState110 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState175 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState172 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_174 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | RMW ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | READ ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | NAME _v_0 ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState175
          | MOV ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | FENCE ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | CODEVAR _v_1 ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState175
          | CALL ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | BRANCH ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
          | PIPE | SEMI ->
              let _v_2 = _menhir_action_018 () in
              _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState175 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_022 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_RMW (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState028
      | REG _ | SYMB_REG _ ->
          let _v = _menhir_action_005 () in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState028 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_RMW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState029
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState029
      | _ ->
          _eRR ()
  
  and _menhir_run_015 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_087 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState082 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState063 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState014 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState018 ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_084 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BRANCH, ttv_result) _menhir_cell1_annot_list_option -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annot_list_option (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_BRANCH (_menhir_stack, _menhir_s) = _menhir_stack in
          let (_3, _4) = (_v, _v_0) in
          let _v = _menhir_action_015 _2 _3 _4 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MOV as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState064
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState064
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState064
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState064
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState064
      | LPAR ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | _ ->
          _eRR ()
  
  and _menhir_run_016 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_086 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_004 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_043 () in
      _menhir_goto_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_019 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_027 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_k : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState064 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState018 ->
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_007 _1 in
      _menhir_goto_any_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_any_value : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState064 ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState050 ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState046 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState042 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState038 ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState032 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_056 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_054 _1 in
      _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_operation : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState064 ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState030 ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MOV, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MOV (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_017 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_054 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_RMW, ttv_result) _menhir_cell1_annot_list_option, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operation (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState054
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState054
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | NAME _v_2 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState054
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState054
      | _ ->
          _eRR ()
  
  and _menhir_run_005 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_042 _1 in
      _menhir_goto_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_006 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_046 () in
      _menhir_goto_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_007 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_045 () in
      _menhir_goto_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_052 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_any_value -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_value (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_055 _3 _4 in
          _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_any_value (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState051
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState051
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState051
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState051
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState051
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | _ ->
          _eRR ()
  
  and _menhir_run_020 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_028 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_048 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_any_value -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_value (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_057 _3 _4 in
          _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_any_value (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState047
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState047
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState047
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState047
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState047
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_any_value -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_value (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_058 _3 _4 in
          _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_any_value (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState043
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState043
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState043
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState043
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState043
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_any_value -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_value (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_059 _3 _4 in
          _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_039 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_any_value (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState039
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState039
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState039
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState039
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState039
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | _ ->
          _eRR ()
  
  and _menhir_run_036 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_any_value -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_value (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_056 _3 _4 in
          _menhir_goto_operation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_any_value (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState035
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState035
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState035
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState035
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState035
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState035
      | _ ->
          _eRR ()
  
  and _menhir_run_023 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_091 _1 in
      _menhir_goto_reg_or_imm _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg_or_imm : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState026 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState018 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WRITE, ttv_result) _menhir_cell1_annot_list_option, ttv_result) _menhir_cell1_addr_op -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_addr_op (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_annot_list_option (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_WRITE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_011 _2 _3 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_021 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_reg_or_addr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg_or_addr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_003 _1 _3 in
      _menhir_goto_addr_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_addr_op : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState059 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState054 ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState014 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_060 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_READ, ttv_result) _menhir_cell1_annot_list_option, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_annot_list_option (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_READ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_010 _2 _3 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_055 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_RMW, ttv_result) _menhir_cell1_annot_list_option, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_operation -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operation (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_annot_list_option (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_RMW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_014 _2 _3 _4 _5 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_026 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WRITE, ttv_result) _menhir_cell1_annot_list_option as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_addr_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState026
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState026
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState026
      | META _v_3 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState026
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_s = MenhirState032 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | NEQ ->
          let _menhir_s = MenhirState038 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | EQ ->
          let _menhir_s = MenhirState042 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | AND ->
          let _menhir_s = MenhirState046 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_s = MenhirState050 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_059 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_READ, ttv_result) _menhir_cell1_annot_list_option as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState059
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState059
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | NAME _v_2 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState059
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | _ ->
          _eRR ()
  
  and _menhir_run_030 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_RMW, ttv_result) _menhir_cell1_annot_list_option as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState030
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState030
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
      | NUM _v_2 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState030
      | NAME _v_3 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState030
      | META _v_4 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState030
      | LPAR ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_088 _1 in
      _menhir_goto_reg_or_addr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg_or_addr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState064 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState014 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_006 _1 in
      _menhir_goto_any_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_017 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          let _menhir_stack = MenhirCell1_reg_or_addr (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState018 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | META _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | EOF | META _ | NUM _ | PIPE | REG _ | SEMI | SYMB_REG _ ->
          let _1 = _v in
          let _v = _menhir_action_002 _1 in
          _menhir_goto_addr_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_022 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_090 _1 in
      _menhir_goto_reg_or_imm _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_057 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_READ (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
      | REG _ | SYMB_REG _ ->
          let _v = _menhir_action_005 () in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState057 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_READ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState058
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState058
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | RMW ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | READ ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | NAME _v_0 ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState062
          | MOV ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | FENCE ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | CODEVAR _v_1 ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState062
          | CALL ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | BRANCH ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | EOF | PIPE | SEMI ->
              let _v_2 = _menhir_action_018 () in
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_063 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MOV (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState063 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_FENCE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState066
      | EOF | LBRACE | PIPE | SEMI ->
          let _v = _menhir_action_005 () in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState066 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FENCE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | NAME _v_0 ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState068
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | RBRACE ->
              let _v_1 = _menhir_action_048 () in
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState068 _tok
          | _ ->
              _eRR ())
      | EOF | PIPE | SEMI ->
          let _v = _menhir_action_008 () in
          _menhir_goto_fence_labels_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_051 _1 in
      _menhir_goto_name_set _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_name_set : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState071 ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState068 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FENCE, ttv_result) _menhir_cell1_annot_list_option, ttv_result) _menhir_cell1_name_set -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_name_set (_menhir_stack, _, _2) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_009 _2 _5 in
          _menhir_goto_fence_labels_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_fence_labels_option : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FENCE, ttv_result) _menhir_cell1_annot_list_option -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_annot_list_option (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_FENCE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_012 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_069 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FENCE, ttv_result) _menhir_cell1_annot_list_option as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_name_set (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRACE ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WRITE ->
                  _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | READ ->
                  _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | NAME _v_0 ->
                  _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState071
              | FENCE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | BRANCH ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
              | RBRACE ->
                  let _v_1 = _menhir_action_048 () in
                  _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState071 _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_021 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CALL (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          let _menhir_s = MenhirState078 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_081 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BRANCH (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRAC ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | NAME _ | REG _ | SYMB_REG _ ->
          let _v = _menhir_action_005 () in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState081 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BRANCH as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState082
      | REG _v_1 ->
          let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState082
      | NAME _v_2 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_BRANCH (_menhir_stack, _menhir_s) = _menhir_stack in
          let (_3, _2) = (_v_2, _v) in
          let _v = _menhir_action_016 _2 _3 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_019 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState175 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState172 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState110 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_176 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_023 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_171 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | RMW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | READ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState172
      | MOV ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | FENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | CODEVAR _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState172
      | CALL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | BRANCH ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_2 = _menhir_action_018 () in
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState172 _tok
      | EOF | LEVELS | REGIONS | SCOPES ->
          let _1 = _v in
          let _v = _menhir_action_025 _1 in
          _menhir_goto_iol_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | RMW ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | READ ->
              _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | NAME _v_0 ->
              _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState092
          | MOV ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | FENCE ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | CODEVAR _v_1 ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState092
          | CALL ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | BRANCH ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState092
          | EOF | SEMI ->
              let _v_2 = _menhir_action_018 () in
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState092 _tok
          | _ ->
              _eRR ())
      | EOF ->
          let x = _v in
          let _v = _menhir_action_106 x in
          _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_089 _1 in
      _menhir_goto_reg_or_addr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_name (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState012 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITE ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READ ->
              _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FENCE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BRANCH ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRAC | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_050 _1 in
          _menhir_goto_name_list_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_name_list_ne : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState012 ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState068 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState002 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_013 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_name -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_name (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_049 _1 _3 in
      _menhir_goto_name_list_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_008 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_047 _1 in
      _menhir_goto_name_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_name_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState068 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState002 ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_009 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRAC -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRAC ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LBRAC (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_004 _2 in
          _menhir_goto_annot_list_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_annot_list_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState081 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState028 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState001 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_014 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WRITE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annot_list_option (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState014
      | SYMB_REG _v_0 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState014
      | REG _v_1 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState014
      | READ ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState014
      | NAME _v_2 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState014
      | FENCE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState014
      | BRANCH ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState014
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | RMW ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | READ ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NAME _v ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | MOV ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | FENCE ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | CODEVAR _v ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | CALL ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BRANCH ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EOF | SEMI ->
          let _v = _menhir_action_018 () in
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_108 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_083 _1 in
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITE ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | RMW ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | READ ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | NAME _v_0 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState110
      | MOV ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | FENCE ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | CODEVAR _v_1 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState110
      | CALL ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | BRANCH ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState110
      | PIPE | SEMI ->
          let _v_2 = _menhir_action_018 () in
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState110 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_proc_annotated_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState178 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState096 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_179 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_proc_annotated -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_proc_annotated (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_105 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_proc_annotated_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_097 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_PROCFH (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState097
      | PIPE | SEMI ->
          let _v_0 = _menhir_action_060 () in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COLON (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState098 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | PIPE | SEMI ->
          let _v = _menhir_action_035 () in
          _menhir_goto_loption_separated_nonempty_list_COMMA_NAME__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState100 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | PIPE | SEMI ->
          let x = _v in
          let _v = _menhir_action_100 x in
          _menhir_goto_separated_nonempty_list_COMMA_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_NAME_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState098 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState100 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_102 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let x = _v in
      let _v = _menhir_action_036 x in
      _menhir_goto_loption_separated_nonempty_list_COMMA_NAME__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_loption_separated_nonempty_list_COMMA_NAME__ : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_COLON (_menhir_stack, _menhir_s) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_080 xs in
      let x = _v in
      let _v = _menhir_action_061 x in
      _menhir_goto_option_proc_annot_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_option_proc_annot_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState097 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_107 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, p) = _menhir_stack in
      let os = _v in
      let _v = _menhir_action_082 os p in
      _menhir_goto_proc_annotated _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_proc_annotated : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_proc_annotated (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState178 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROCFH _v ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PROC _v ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_104 x in
          _menhir_goto_separated_nonempty_list_PIPE_proc_annotated_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_106 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState106
      | PIPE | SEMI ->
          let _v_0 = _menhir_action_060 () in
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_105 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROCFH -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROCFH (_menhir_stack, _menhir_s, p) = _menhir_stack in
      let os = _v in
      let _v = _menhir_action_081 os p in
      _menhir_goto_proc_annotated _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_101 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_101 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROCFH _v_0 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState096
      | PROC _v_1 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState096
      | _ ->
          _eRR ()
  
  let _menhir_run_094 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_099 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ | PROCFH _ ->
          let _v = _menhir_action_098 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let instr_option_seq =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_instr_option_seq v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
