
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XORI
    | XOR
    | SYNC
    | SYMB_REG of (
# 24 "lib/MIPSParser.mly"
       (string)
# 18 "lib/MIPSParser.ml"
  )
    | SW
    | SUBU
    | SUBIU
    | SUBI
    | SUB
    | SLTU
    | SLTIU
    | SLTI
    | SLT
    | SEMI
    | SC
    | RPAR
    | PROC of (
# 27 "lib/MIPSParser.mly"
       (int)
# 35 "lib/MIPSParser.ml"
  )
    | PIPE
    | ORI
    | OR
    | NUM of (
# 25 "lib/MIPSParser.mly"
       (int)
# 43 "lib/MIPSParser.ml"
  )
    | NOR
    | NOP
    | NAME of (
# 26 "lib/MIPSParser.mly"
       (string)
# 50 "lib/MIPSParser.ml"
  )
    | MOVE
    | LW
    | LUI
    | LPAR
    | LL
    | LI
    | LD
    | JR
    | EOF
    | DSLL
    | DEXT
    | DADDU
    | DADDIU
    | COMMA
    | COLON
    | BNE
    | BLTZ
    | BLEZ
    | BGTZ
    | BGEZ
    | BEQ
    | B
    | ARCH_REG of (
# 23 "lib/MIPSParser.mly"
       (MIPSBase.reg)
# 77 "lib/MIPSParser.ml"
  )
    | ANDI
    | AND
    | ADDU
    | ADDIU
    | ADDI
    | ADD
  
end

include MenhirBasics

# 1 "lib/MIPSParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2014-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module A=MIPSBase


# 111 "lib/MIPSParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState002 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 002.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState004 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 004.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState008 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 008.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState009 : (('s, _menhir_box_main) _menhir_cell1_XORI, _menhir_box_main) _menhir_state
    (** State 009.
        Stack shape : XORI.
        Start symbol: main. *)

  | MenhirState013 : ((('s, _menhir_box_main) _menhir_cell1_XORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 013.
        Stack shape : XORI reg.
        Start symbol: main. *)

  | MenhirState015 : (((('s, _menhir_box_main) _menhir_cell1_XORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 015.
        Stack shape : XORI reg reg.
        Start symbol: main. *)

  | MenhirState018 : (('s, _menhir_box_main) _menhir_cell1_XOR, _menhir_box_main) _menhir_state
    (** State 018.
        Stack shape : XOR.
        Start symbol: main. *)

  | MenhirState020 : ((('s, _menhir_box_main) _menhir_cell1_XOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 020.
        Stack shape : XOR reg.
        Start symbol: main. *)

  | MenhirState022 : (((('s, _menhir_box_main) _menhir_cell1_XOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 022.
        Stack shape : XOR reg reg.
        Start symbol: main. *)

  | MenhirState025 : (('s, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_state
    (** State 025.
        Stack shape : SW.
        Start symbol: main. *)

  | MenhirState027 : ((('s, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 027.
        Stack shape : SW reg.
        Start symbol: main. *)

  | MenhirState028 : (((('s, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 028.
        Stack shape : SW reg LPAR.
        Start symbol: main. *)

  | MenhirState032 : (((('s, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 032.
        Stack shape : SW reg k.
        Start symbol: main. *)

  | MenhirState035 : (('s, _menhir_box_main) _menhir_cell1_SUBU, _menhir_box_main) _menhir_state
    (** State 035.
        Stack shape : SUBU.
        Start symbol: main. *)

  | MenhirState037 : ((('s, _menhir_box_main) _menhir_cell1_SUBU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 037.
        Stack shape : SUBU reg.
        Start symbol: main. *)

  | MenhirState039 : (((('s, _menhir_box_main) _menhir_cell1_SUBU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 039.
        Stack shape : SUBU reg reg.
        Start symbol: main. *)

  | MenhirState041 : (('s, _menhir_box_main) _menhir_cell1_SUBIU, _menhir_box_main) _menhir_state
    (** State 041.
        Stack shape : SUBIU.
        Start symbol: main. *)

  | MenhirState043 : ((('s, _menhir_box_main) _menhir_cell1_SUBIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 043.
        Stack shape : SUBIU reg.
        Start symbol: main. *)

  | MenhirState045 : (((('s, _menhir_box_main) _menhir_cell1_SUBIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 045.
        Stack shape : SUBIU reg reg.
        Start symbol: main. *)

  | MenhirState047 : (('s, _menhir_box_main) _menhir_cell1_SUBI, _menhir_box_main) _menhir_state
    (** State 047.
        Stack shape : SUBI.
        Start symbol: main. *)

  | MenhirState049 : ((('s, _menhir_box_main) _menhir_cell1_SUBI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 049.
        Stack shape : SUBI reg.
        Start symbol: main. *)

  | MenhirState051 : (((('s, _menhir_box_main) _menhir_cell1_SUBI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 051.
        Stack shape : SUBI reg reg.
        Start symbol: main. *)

  | MenhirState053 : (('s, _menhir_box_main) _menhir_cell1_SUB, _menhir_box_main) _menhir_state
    (** State 053.
        Stack shape : SUB.
        Start symbol: main. *)

  | MenhirState055 : ((('s, _menhir_box_main) _menhir_cell1_SUB, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 055.
        Stack shape : SUB reg.
        Start symbol: main. *)

  | MenhirState057 : (((('s, _menhir_box_main) _menhir_cell1_SUB, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 057.
        Stack shape : SUB reg reg.
        Start symbol: main. *)

  | MenhirState059 : (('s, _menhir_box_main) _menhir_cell1_SLTU, _menhir_box_main) _menhir_state
    (** State 059.
        Stack shape : SLTU.
        Start symbol: main. *)

  | MenhirState061 : ((('s, _menhir_box_main) _menhir_cell1_SLTU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 061.
        Stack shape : SLTU reg.
        Start symbol: main. *)

  | MenhirState063 : (((('s, _menhir_box_main) _menhir_cell1_SLTU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 063.
        Stack shape : SLTU reg reg.
        Start symbol: main. *)

  | MenhirState065 : (('s, _menhir_box_main) _menhir_cell1_SLTIU, _menhir_box_main) _menhir_state
    (** State 065.
        Stack shape : SLTIU.
        Start symbol: main. *)

  | MenhirState067 : ((('s, _menhir_box_main) _menhir_cell1_SLTIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 067.
        Stack shape : SLTIU reg.
        Start symbol: main. *)

  | MenhirState069 : (((('s, _menhir_box_main) _menhir_cell1_SLTIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 069.
        Stack shape : SLTIU reg reg.
        Start symbol: main. *)

  | MenhirState071 : (('s, _menhir_box_main) _menhir_cell1_SLTI, _menhir_box_main) _menhir_state
    (** State 071.
        Stack shape : SLTI.
        Start symbol: main. *)

  | MenhirState073 : ((('s, _menhir_box_main) _menhir_cell1_SLTI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 073.
        Stack shape : SLTI reg.
        Start symbol: main. *)

  | MenhirState075 : (((('s, _menhir_box_main) _menhir_cell1_SLTI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 075.
        Stack shape : SLTI reg reg.
        Start symbol: main. *)

  | MenhirState077 : (('s, _menhir_box_main) _menhir_cell1_SLT, _menhir_box_main) _menhir_state
    (** State 077.
        Stack shape : SLT.
        Start symbol: main. *)

  | MenhirState079 : ((('s, _menhir_box_main) _menhir_cell1_SLT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 079.
        Stack shape : SLT reg.
        Start symbol: main. *)

  | MenhirState081 : (((('s, _menhir_box_main) _menhir_cell1_SLT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 081.
        Stack shape : SLT reg reg.
        Start symbol: main. *)

  | MenhirState083 : (('s, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_state
    (** State 083.
        Stack shape : SC.
        Start symbol: main. *)

  | MenhirState085 : ((('s, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 085.
        Stack shape : SC reg.
        Start symbol: main. *)

  | MenhirState086 : (((('s, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 086.
        Stack shape : SC reg LPAR.
        Start symbol: main. *)

  | MenhirState090 : (((('s, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 090.
        Stack shape : SC reg k.
        Start symbol: main. *)

  | MenhirState093 : (('s, _menhir_box_main) _menhir_cell1_ORI, _menhir_box_main) _menhir_state
    (** State 093.
        Stack shape : ORI.
        Start symbol: main. *)

  | MenhirState095 : ((('s, _menhir_box_main) _menhir_cell1_ORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 095.
        Stack shape : ORI reg.
        Start symbol: main. *)

  | MenhirState097 : (((('s, _menhir_box_main) _menhir_cell1_ORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 097.
        Stack shape : ORI reg reg.
        Start symbol: main. *)

  | MenhirState099 : (('s, _menhir_box_main) _menhir_cell1_OR, _menhir_box_main) _menhir_state
    (** State 099.
        Stack shape : OR.
        Start symbol: main. *)

  | MenhirState101 : ((('s, _menhir_box_main) _menhir_cell1_OR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 101.
        Stack shape : OR reg.
        Start symbol: main. *)

  | MenhirState103 : (((('s, _menhir_box_main) _menhir_cell1_OR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 103.
        Stack shape : OR reg reg.
        Start symbol: main. *)

  | MenhirState105 : (('s, _menhir_box_main) _menhir_cell1_NOR, _menhir_box_main) _menhir_state
    (** State 105.
        Stack shape : NOR.
        Start symbol: main. *)

  | MenhirState107 : ((('s, _menhir_box_main) _menhir_cell1_NOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 107.
        Stack shape : NOR reg.
        Start symbol: main. *)

  | MenhirState109 : (((('s, _menhir_box_main) _menhir_cell1_NOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 109.
        Stack shape : NOR reg reg.
        Start symbol: main. *)

  | MenhirState113 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 113.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState114 : (('s, _menhir_box_main) _menhir_cell1_MOVE, _menhir_box_main) _menhir_state
    (** State 114.
        Stack shape : MOVE.
        Start symbol: main. *)

  | MenhirState116 : ((('s, _menhir_box_main) _menhir_cell1_MOVE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 116.
        Stack shape : MOVE reg.
        Start symbol: main. *)

  | MenhirState118 : (('s, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_state
    (** State 118.
        Stack shape : LW.
        Start symbol: main. *)

  | MenhirState120 : ((('s, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 120.
        Stack shape : LW reg.
        Start symbol: main. *)

  | MenhirState121 : (((('s, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 121.
        Stack shape : LW reg LPAR.
        Start symbol: main. *)

  | MenhirState125 : (((('s, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 125.
        Stack shape : LW reg k.
        Start symbol: main. *)

  | MenhirState128 : (('s, _menhir_box_main) _menhir_cell1_LUI, _menhir_box_main) _menhir_state
    (** State 128.
        Stack shape : LUI.
        Start symbol: main. *)

  | MenhirState130 : ((('s, _menhir_box_main) _menhir_cell1_LUI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 130.
        Stack shape : LUI reg.
        Start symbol: main. *)

  | MenhirState132 : (('s, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_state
    (** State 132.
        Stack shape : LL.
        Start symbol: main. *)

  | MenhirState134 : ((('s, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 134.
        Stack shape : LL reg.
        Start symbol: main. *)

  | MenhirState135 : (((('s, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 135.
        Stack shape : LL reg LPAR.
        Start symbol: main. *)

  | MenhirState139 : (((('s, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 139.
        Stack shape : LL reg k.
        Start symbol: main. *)

  | MenhirState142 : (('s, _menhir_box_main) _menhir_cell1_LI, _menhir_box_main) _menhir_state
    (** State 142.
        Stack shape : LI.
        Start symbol: main. *)

  | MenhirState144 : ((('s, _menhir_box_main) _menhir_cell1_LI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 144.
        Stack shape : LI reg.
        Start symbol: main. *)

  | MenhirState146 : (('s, _menhir_box_main) _menhir_cell1_LD, _menhir_box_main) _menhir_state
    (** State 146.
        Stack shape : LD.
        Start symbol: main. *)

  | MenhirState148 : ((('s, _menhir_box_main) _menhir_cell1_LD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 148.
        Stack shape : LD reg.
        Start symbol: main. *)

  | MenhirState150 : (((('s, _menhir_box_main) _menhir_cell1_LD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 150.
        Stack shape : LD reg k.
        Start symbol: main. *)

  | MenhirState153 : (('s, _menhir_box_main) _menhir_cell1_JR, _menhir_box_main) _menhir_state
    (** State 153.
        Stack shape : JR.
        Start symbol: main. *)

  | MenhirState155 : (('s, _menhir_box_main) _menhir_cell1_DSLL, _menhir_box_main) _menhir_state
    (** State 155.
        Stack shape : DSLL.
        Start symbol: main. *)

  | MenhirState157 : ((('s, _menhir_box_main) _menhir_cell1_DSLL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 157.
        Stack shape : DSLL reg.
        Start symbol: main. *)

  | MenhirState159 : (((('s, _menhir_box_main) _menhir_cell1_DSLL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 159.
        Stack shape : DSLL reg reg.
        Start symbol: main. *)

  | MenhirState161 : (('s, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_state
    (** State 161.
        Stack shape : DEXT.
        Start symbol: main. *)

  | MenhirState163 : ((('s, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 163.
        Stack shape : DEXT reg.
        Start symbol: main. *)

  | MenhirState165 : (((('s, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 165.
        Stack shape : DEXT reg reg.
        Start symbol: main. *)

  | MenhirState167 : ((((('s, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 167.
        Stack shape : DEXT reg reg k.
        Start symbol: main. *)

  | MenhirState169 : (('s, _menhir_box_main) _menhir_cell1_DADDU, _menhir_box_main) _menhir_state
    (** State 169.
        Stack shape : DADDU.
        Start symbol: main. *)

  | MenhirState171 : ((('s, _menhir_box_main) _menhir_cell1_DADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 171.
        Stack shape : DADDU reg.
        Start symbol: main. *)

  | MenhirState173 : (((('s, _menhir_box_main) _menhir_cell1_DADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 173.
        Stack shape : DADDU reg reg.
        Start symbol: main. *)

  | MenhirState175 : (('s, _menhir_box_main) _menhir_cell1_DADDIU, _menhir_box_main) _menhir_state
    (** State 175.
        Stack shape : DADDIU.
        Start symbol: main. *)

  | MenhirState177 : ((('s, _menhir_box_main) _menhir_cell1_DADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 177.
        Stack shape : DADDIU reg.
        Start symbol: main. *)

  | MenhirState179 : (((('s, _menhir_box_main) _menhir_cell1_DADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 179.
        Stack shape : DADDIU reg reg.
        Start symbol: main. *)

  | MenhirState181 : (('s, _menhir_box_main) _menhir_cell1_BNE, _menhir_box_main) _menhir_state
    (** State 181.
        Stack shape : BNE.
        Start symbol: main. *)

  | MenhirState183 : ((('s, _menhir_box_main) _menhir_cell1_BNE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 183.
        Stack shape : BNE reg.
        Start symbol: main. *)

  | MenhirState187 : (('s, _menhir_box_main) _menhir_cell1_BLTZ, _menhir_box_main) _menhir_state
    (** State 187.
        Stack shape : BLTZ.
        Start symbol: main. *)

  | MenhirState191 : (('s, _menhir_box_main) _menhir_cell1_BLEZ, _menhir_box_main) _menhir_state
    (** State 191.
        Stack shape : BLEZ.
        Start symbol: main. *)

  | MenhirState195 : (('s, _menhir_box_main) _menhir_cell1_BGTZ, _menhir_box_main) _menhir_state
    (** State 195.
        Stack shape : BGTZ.
        Start symbol: main. *)

  | MenhirState199 : (('s, _menhir_box_main) _menhir_cell1_BGEZ, _menhir_box_main) _menhir_state
    (** State 199.
        Stack shape : BGEZ.
        Start symbol: main. *)

  | MenhirState203 : (('s, _menhir_box_main) _menhir_cell1_BEQ, _menhir_box_main) _menhir_state
    (** State 203.
        Stack shape : BEQ.
        Start symbol: main. *)

  | MenhirState205 : ((('s, _menhir_box_main) _menhir_cell1_BEQ, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 205.
        Stack shape : BEQ reg.
        Start symbol: main. *)

  | MenhirState211 : (('s, _menhir_box_main) _menhir_cell1_ANDI, _menhir_box_main) _menhir_state
    (** State 211.
        Stack shape : ANDI.
        Start symbol: main. *)

  | MenhirState213 : ((('s, _menhir_box_main) _menhir_cell1_ANDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 213.
        Stack shape : ANDI reg.
        Start symbol: main. *)

  | MenhirState215 : (((('s, _menhir_box_main) _menhir_cell1_ANDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 215.
        Stack shape : ANDI reg reg.
        Start symbol: main. *)

  | MenhirState217 : (('s, _menhir_box_main) _menhir_cell1_AND, _menhir_box_main) _menhir_state
    (** State 217.
        Stack shape : AND.
        Start symbol: main. *)

  | MenhirState219 : ((('s, _menhir_box_main) _menhir_cell1_AND, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 219.
        Stack shape : AND reg.
        Start symbol: main. *)

  | MenhirState221 : (((('s, _menhir_box_main) _menhir_cell1_AND, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 221.
        Stack shape : AND reg reg.
        Start symbol: main. *)

  | MenhirState223 : (('s, _menhir_box_main) _menhir_cell1_ADDU, _menhir_box_main) _menhir_state
    (** State 223.
        Stack shape : ADDU.
        Start symbol: main. *)

  | MenhirState225 : ((('s, _menhir_box_main) _menhir_cell1_ADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 225.
        Stack shape : ADDU reg.
        Start symbol: main. *)

  | MenhirState227 : (((('s, _menhir_box_main) _menhir_cell1_ADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 227.
        Stack shape : ADDU reg reg.
        Start symbol: main. *)

  | MenhirState229 : (('s, _menhir_box_main) _menhir_cell1_ADDIU, _menhir_box_main) _menhir_state
    (** State 229.
        Stack shape : ADDIU.
        Start symbol: main. *)

  | MenhirState231 : ((('s, _menhir_box_main) _menhir_cell1_ADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 231.
        Stack shape : ADDIU reg.
        Start symbol: main. *)

  | MenhirState233 : (((('s, _menhir_box_main) _menhir_cell1_ADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 233.
        Stack shape : ADDIU reg reg.
        Start symbol: main. *)

  | MenhirState235 : (('s, _menhir_box_main) _menhir_cell1_ADDI, _menhir_box_main) _menhir_state
    (** State 235.
        Stack shape : ADDI.
        Start symbol: main. *)

  | MenhirState237 : ((('s, _menhir_box_main) _menhir_cell1_ADDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 237.
        Stack shape : ADDI reg.
        Start symbol: main. *)

  | MenhirState239 : (((('s, _menhir_box_main) _menhir_cell1_ADDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 239.
        Stack shape : ADDI reg reg.
        Start symbol: main. *)

  | MenhirState241 : (('s, _menhir_box_main) _menhir_cell1_ADD, _menhir_box_main) _menhir_state
    (** State 241.
        Stack shape : ADD.
        Start symbol: main. *)

  | MenhirState243 : ((('s, _menhir_box_main) _menhir_cell1_ADD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 243.
        Stack shape : ADD reg.
        Start symbol: main. *)

  | MenhirState245 : (((('s, _menhir_box_main) _menhir_cell1_ADD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 245.
        Stack shape : ADD reg reg.
        Start symbol: main. *)

  | MenhirState252 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 252.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState255 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 255.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (MIPSBase.pseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (MIPSBase.pseudo list)

and ('s, 'r) _menhir_cell1_k = 
  | MenhirCell1_k of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (A.reg_arg)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and ('s, 'r) _menhir_cell1_ADD = 
  | MenhirCell1_ADD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDI = 
  | MenhirCell1_ADDI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDIU = 
  | MenhirCell1_ADDIU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDU = 
  | MenhirCell1_ADDU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_AND = 
  | MenhirCell1_AND of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ANDI = 
  | MenhirCell1_ANDI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BEQ = 
  | MenhirCell1_BEQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BGEZ = 
  | MenhirCell1_BGEZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BGTZ = 
  | MenhirCell1_BGTZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BLEZ = 
  | MenhirCell1_BLEZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BLTZ = 
  | MenhirCell1_BLTZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BNE = 
  | MenhirCell1_BNE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DADDIU = 
  | MenhirCell1_DADDIU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DADDU = 
  | MenhirCell1_DADDU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DEXT = 
  | MenhirCell1_DEXT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DSLL = 
  | MenhirCell1_DSLL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_JR = 
  | MenhirCell1_JR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LD = 
  | MenhirCell1_LD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LI = 
  | MenhirCell1_LI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LL = 
  | MenhirCell1_LL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LUI = 
  | MenhirCell1_LUI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LW = 
  | MenhirCell1_LW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MOVE = 
  | MenhirCell1_MOVE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 26 "lib/MIPSParser.mly"
       (string)
# 759 "lib/MIPSParser.ml"
)

and ('s, 'r) _menhir_cell1_NOR = 
  | MenhirCell1_NOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_OR = 
  | MenhirCell1_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ORI = 
  | MenhirCell1_ORI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 27 "lib/MIPSParser.mly"
       (int)
# 775 "lib/MIPSParser.ml"
)

and ('s, 'r) _menhir_cell1_SC = 
  | MenhirCell1_SC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLT = 
  | MenhirCell1_SLT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLTI = 
  | MenhirCell1_SLTI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLTIU = 
  | MenhirCell1_SLTIU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLTU = 
  | MenhirCell1_SLTU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUB = 
  | MenhirCell1_SUB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBI = 
  | MenhirCell1_SUBI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBIU = 
  | MenhirCell1_SUBIU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBU = 
  | MenhirCell1_SUBU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SW = 
  | MenhirCell1_SW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XOR = 
  | MenhirCell1_XOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XORI = 
  | MenhirCell1_XORI of 's * ('s, 'r) _menhir_state

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * MIPSBase.pseudo list list) [@@unboxed]

let _menhir_action_01 =
  fun () ->
    (
# 85 "lib/MIPSParser.mly"
  ( A.NOP )
# 822 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_02 =
  fun _2 _4 _6 ->
    (
# 88 "lib/MIPSParser.mly"
  ( A.OP (A.ADD,_2,_4,_6) )
# 830 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_03 =
  fun _2 _4 _6 ->
    (
# 90 "lib/MIPSParser.mly"
  ( A.OPI (A.ADD,_2,_4,_6) )
# 838 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_04 =
  fun _2 _4 _6 ->
    (
# 92 "lib/MIPSParser.mly"
  ( A.OP (A.ADDU,_2,_4,_6) )
# 846 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_05 =
  fun _2 _4 _6 ->
    (
# 94 "lib/MIPSParser.mly"
  ( A.OP (A.DADDU,_2,_4,_6) )
# 854 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_06 =
  fun _2 _4 _6 ->
    (
# 96 "lib/MIPSParser.mly"
  ( A.OPI (A.ADDU,_2,_4,_6) )
# 862 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_07 =
  fun _2 _4 _6 ->
    (
# 98 "lib/MIPSParser.mly"
  ( A.OPI (A.DADDU,_2,_4,_6) )
# 870 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_08 =
  fun _2 _4 _6 ->
    (
# 100 "lib/MIPSParser.mly"
  ( A.OPI (A.DSLL,_2,_4,_6) )
# 878 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_09 =
  fun _2 _4 _6 _8 ->
    (
# 103 "lib/MIPSParser.mly"
  ( A.EBF (_2, _4, _6, _8) )
# 886 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_10 =
  fun _2 _4 _6 ->
    (
# 106 "lib/MIPSParser.mly"
  ( A.OP (A.SUB,_2,_4,_6) )
# 894 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_11 =
  fun _2 _4 _6 ->
    (
# 108 "lib/MIPSParser.mly"
  ( A.OPI (A.SUB,_2,_4,_6) )
# 902 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_12 =
  fun _2 _4 _6 ->
    (
# 110 "lib/MIPSParser.mly"
  ( A.OP (A.SUBU,_2,_4,_6) )
# 910 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_13 =
  fun _2 _4 _6 ->
    (
# 112 "lib/MIPSParser.mly"
  ( A.OPI (A.SUBU,_2,_4,_6) )
# 918 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_14 =
  fun _2 _4 _6 ->
    (
# 115 "lib/MIPSParser.mly"
  ( A.OP (A.SLT,_2,_4,_6) )
# 926 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_15 =
  fun _2 _4 _6 ->
    (
# 117 "lib/MIPSParser.mly"
  ( A.OPI (A.SLT,_2,_4,_6) )
# 934 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_16 =
  fun _2 _4 _6 ->
    (
# 119 "lib/MIPSParser.mly"
  ( A.OP (A.SLTU,_2,_4,_6) )
# 942 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_17 =
  fun _2 _4 _6 ->
    (
# 121 "lib/MIPSParser.mly"
  ( A.OPI (A.SLTU,_2,_4,_6) )
# 950 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_18 =
  fun _2 _4 _6 ->
    (
# 124 "lib/MIPSParser.mly"
  ( A.OP (A.AND,_2,_4,_6) )
# 958 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_19 =
  fun _2 _4 _6 ->
    (
# 126 "lib/MIPSParser.mly"
  ( A.OPI (A.AND,_2,_4,_6) )
# 966 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_20 =
  fun _2 _4 _6 ->
    (
# 129 "lib/MIPSParser.mly"
  ( A.OP (A.OR,_2,_4,_6) )
# 974 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_21 =
  fun _2 _4 _6 ->
    (
# 131 "lib/MIPSParser.mly"
  ( A.OPI (A.OR,_2,_4,_6) )
# 982 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_22 =
  fun _2 _4 _6 ->
    (
# 134 "lib/MIPSParser.mly"
  ( A.OP (A.XOR,_2,_4,_6) )
# 990 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_23 =
  fun _2 _4 _6 ->
    (
# 136 "lib/MIPSParser.mly"
  ( A.OPI (A.XOR,_2,_4,_6) )
# 998 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_24 =
  fun _2 _4 _6 ->
    (
# 139 "lib/MIPSParser.mly"
  ( A.OP (A.NOR,_2,_4,_6) )
# 1006 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_25 =
  fun _2 ->
    (
# 142 "lib/MIPSParser.mly"
  ( A.B _2 )
# 1014 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_26 =
  fun _2 ->
    (
# 144 "lib/MIPSParser.mly"
  ( A.JR _2 )
# 1022 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_27 =
  fun _2 _4 _6 ->
    (
# 146 "lib/MIPSParser.mly"
  ( A.BC (A.EQ,_2,_4,_6) )
# 1030 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_28 =
  fun _2 _4 _6 ->
    (
# 148 "lib/MIPSParser.mly"
  ( A.BC (A.NE,_2,_4,_6) )
# 1038 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_29 =
  fun _2 _4 ->
    (
# 150 "lib/MIPSParser.mly"
  ( A.BCZ (A.LEZ,_2,_4) )
# 1046 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_30 =
  fun _2 _4 ->
    (
# 152 "lib/MIPSParser.mly"
  ( A.BCZ (A.GTZ,_2,_4) )
# 1054 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_31 =
  fun _2 _4 ->
    (
# 154 "lib/MIPSParser.mly"
  ( A.BCZ (A.LTZ,_2,_4) )
# 1062 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_32 =
  fun _2 _4 ->
    (
# 156 "lib/MIPSParser.mly"
  ( A.BCZ (A.GEZ,_2,_4) )
# 1070 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_33 =
  fun _2 _4 _6 ->
    (
# 159 "lib/MIPSParser.mly"
  ( A.LW (_2,_4,_6) )
# 1078 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_34 =
  fun _2 _4 _6 ->
    (
# 161 "lib/MIPSParser.mly"
  ( A.LD (_2,_4,_6) )
# 1086 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_35 =
  fun _2 _5 ->
    (
# 163 "lib/MIPSParser.mly"
  ( A.LW (_2,0,_5) )
# 1094 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_36 =
  fun _2 _4 _6 ->
    (
# 165 "lib/MIPSParser.mly"
  ( A.SW (_2,_4,_6) )
# 1102 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_37 =
  fun _2 _5 ->
    (
# 167 "lib/MIPSParser.mly"
  ( A.SW (_2,0,_5) )
# 1110 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_38 =
  fun _2 _4 _6 ->
    (
# 169 "lib/MIPSParser.mly"
  ( A.LL (_2,_4,_6) )
# 1118 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_39 =
  fun _2 _5 ->
    (
# 171 "lib/MIPSParser.mly"
  ( A.LL (_2,0,_5) )
# 1126 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_40 =
  fun _2 _4 _6 ->
    (
# 173 "lib/MIPSParser.mly"
  ( A.SC (_2,_4,_6) )
# 1134 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_41 =
  fun _2 _5 ->
    (
# 175 "lib/MIPSParser.mly"
  ( A.SC (_2,0,_5) )
# 1142 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_42 =
  fun _2 _4 ->
    (
# 178 "lib/MIPSParser.mly"
  ( A.LI (_2,_4) )
# 1150 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_43 =
  fun _2 _4 ->
    (
# 180 "lib/MIPSParser.mly"
  ( A.MOVE (_2,_4) )
# 1158 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_44 =
  fun _2 _4 ->
    (
# 182 "lib/MIPSParser.mly"
  ( A.LUI(_2,_4) )
# 1166 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_45 =
  fun () ->
    (
# 184 "lib/MIPSParser.mly"
  ( A.SYNC )
# 1174 "lib/MIPSParser.ml"
     : (A.pins))

let _menhir_action_46 =
  fun () ->
    (
# 72 "lib/MIPSParser.mly"
             ( A.Nop )
# 1182 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo))

let _menhir_action_47 =
  fun _1 _3 ->
    (
# 73 "lib/MIPSParser.mly"
                          ( A.Label (_1,_3) )
# 1190 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo))

let _menhir_action_48 =
  fun _1 ->
    (
# 74 "lib/MIPSParser.mly"
             ( A.Instruction _1)
# 1198 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo))

let _menhir_action_49 =
  fun _1 ->
    (
# 67 "lib/MIPSParser.mly"
      ([_1])
# 1206 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo list))

let _menhir_action_50 =
  fun _1 _3 ->
    (
# 69 "lib/MIPSParser.mly"
      (_1::_3)
# 1214 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo list))

let _menhir_action_51 =
  fun _1 ->
    (
# 62 "lib/MIPSParser.mly"
    ([_1])
# 1222 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo list list))

let _menhir_action_52 =
  fun _1 _3 ->
    (
# 63 "lib/MIPSParser.mly"
                                   (_1::_3)
# 1230 "lib/MIPSParser.ml"
     : (MIPSBase.pseudo list list))

let _menhir_action_53 =
  fun _1 ->
    (
# 81 "lib/MIPSParser.mly"
      ( _1 )
# 1238 "lib/MIPSParser.ml"
     : (int))

let _menhir_action_54 =
  fun _2 _3 ->
    (
# 50 "lib/MIPSParser.mly"
                                  ( _2,_3 )
# 1246 "lib/MIPSParser.ml"
     : (MiscParser.proc list * MIPSBase.pseudo list list))

let _menhir_action_55 =
  fun ps ->
    (
# 58 "lib/MIPSParser.mly"
  ( List.map (fun p -> p,None,MiscParser.Main) ps )
# 1254 "lib/MIPSParser.ml"
     : (MiscParser.proc list))

let _menhir_action_56 =
  fun _1 ->
    (
# 77 "lib/MIPSParser.mly"
           ( A.Symbolic_reg _1 )
# 1262 "lib/MIPSParser.ml"
     : (A.reg_arg))

let _menhir_action_57 =
  fun _1 ->
    (
# 78 "lib/MIPSParser.mly"
           ( _1 )
# 1270 "lib/MIPSParser.ml"
     : (A.reg_arg))

let _menhir_action_58 =
  fun () ->
    (
# 53 "lib/MIPSParser.mly"
  ( () )
# 1278 "lib/MIPSParser.ml"
     : (unit))

let _menhir_action_59 =
  fun () ->
    (
# 54 "lib/MIPSParser.mly"
       ( () )
# 1286 "lib/MIPSParser.ml"
     : (unit))

let _menhir_action_60 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 1294 "lib/MIPSParser.ml"
     : (int list))

let _menhir_action_61 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 1302 "lib/MIPSParser.ml"
     : (int list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADD ->
        "ADD"
    | ADDI ->
        "ADDI"
    | ADDIU ->
        "ADDIU"
    | ADDU ->
        "ADDU"
    | AND ->
        "AND"
    | ANDI ->
        "ANDI"
    | ARCH_REG _ ->
        "ARCH_REG"
    | B ->
        "B"
    | BEQ ->
        "BEQ"
    | BGEZ ->
        "BGEZ"
    | BGTZ ->
        "BGTZ"
    | BLEZ ->
        "BLEZ"
    | BLTZ ->
        "BLTZ"
    | BNE ->
        "BNE"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | DADDIU ->
        "DADDIU"
    | DADDU ->
        "DADDU"
    | DEXT ->
        "DEXT"
    | DSLL ->
        "DSLL"
    | EOF ->
        "EOF"
    | JR ->
        "JR"
    | LD ->
        "LD"
    | LI ->
        "LI"
    | LL ->
        "LL"
    | LPAR ->
        "LPAR"
    | LUI ->
        "LUI"
    | LW ->
        "LW"
    | MOVE ->
        "MOVE"
    | NAME _ ->
        "NAME"
    | NOP ->
        "NOP"
    | NOR ->
        "NOR"
    | NUM _ ->
        "NUM"
    | OR ->
        "OR"
    | ORI ->
        "ORI"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RPAR ->
        "RPAR"
    | SC ->
        "SC"
    | SEMI ->
        "SEMI"
    | SLT ->
        "SLT"
    | SLTI ->
        "SLTI"
    | SLTIU ->
        "SLTIU"
    | SLTU ->
        "SLTU"
    | SUB ->
        "SUB"
    | SUBI ->
        "SUBI"
    | SUBIU ->
        "SUBIU"
    | SUBU ->
        "SUBU"
    | SW ->
        "SW"
    | SYMB_REG _ ->
        "SYMB_REG"
    | SYNC ->
        "SYNC"
    | XOR ->
        "XOR"
    | XORI ->
        "XORI"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_249 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_54 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState252 ->
          _menhir_run_253 _menhir_stack _v
      | MenhirState008 ->
          _menhir_run_249 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_253 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_52 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let rec _menhir_run_009 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XORI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState009 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_56 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState245 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState243 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState235 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState231 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState229 ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState225 ->
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState223 ->
          _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState221 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState219 ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState217 ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState213 ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState211 ->
          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState205 ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState203 ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState199 ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState195 ->
          _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState191 ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState187 ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState183 ->
          _menhir_run_184 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState181 ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState177 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState175 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState173 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState171 ->
          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState169 ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState163 ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState161 ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState157 ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState155 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState153 ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState150 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState146 ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState135 ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState125 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState118 ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState114 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState107 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState105 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState101 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState095 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState083 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState079 ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState077 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState067 ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState065 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState063 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState061 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState055 ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState053 ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState041 ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState037 ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState035 ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState032 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState028 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState025 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState022 ->
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState020 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState018 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState013 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_246 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_02 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_48 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState008 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState255 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_254 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XORI ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | XOR ->
              _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SYNC ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SW ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SUBU ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SUBIU ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SUBI ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SUB ->
              _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SLTU ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SLTIU ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SLTI ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SLT ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | SC ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ORI ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | OR ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | NOR ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | NOP ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | NAME _v_0 ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState255
          | MOVE ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | LW ->
              _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | LUI ->
              _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | LL ->
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | LI ->
              _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | LD ->
              _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | JR ->
              _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | DSLL ->
              _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | DEXT ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | DADDU ->
              _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | DADDIU ->
              _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BNE ->
              _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BLTZ ->
              _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BLEZ ->
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BGTZ ->
              _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BGEZ ->
              _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | BEQ ->
              _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | B ->
              _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ANDI ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | AND ->
              _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ADDU ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ADDIU ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ADDI ->
              _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | ADD ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
          | PIPE | SEMI ->
              let _v_1 = _menhir_action_46 () in
              _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState255 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_49 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_018 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState018 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_57 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_024 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_45 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_025 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState025 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState035 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_041 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBIU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState041 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState047 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState053 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_059 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SLTU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState059 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SLTIU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState065 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_071 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SLTI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState071 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SLT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState077 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_083 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState083 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ORI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState093 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState099 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_105 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_NOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState105 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_111 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_01 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_112 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XORI ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | XOR ->
              _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SYNC ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SW ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SUBU ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SUBIU ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SUBI ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SUB ->
              _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SLTU ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SLTIU ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SLTI ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SLT ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | SC ->
              _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ORI ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | OR ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | NOR ->
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | NOP ->
              _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | NAME _v_0 ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState113
          | MOVE ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LW ->
              _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LUI ->
              _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LL ->
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LI ->
              _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LD ->
              _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | JR ->
              _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | DSLL ->
              _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | DEXT ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | DADDU ->
              _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | DADDIU ->
              _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BNE ->
              _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BLTZ ->
              _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BLEZ ->
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BGTZ ->
              _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BGEZ ->
              _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | BEQ ->
              _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | B ->
              _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ANDI ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | AND ->
              _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ADDU ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ADDIU ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ADDI ->
              _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | ADD ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | PIPE | SEMI ->
              let _v_1 = _menhir_action_46 () in
              _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MOVE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState114 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_118 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState118 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LUI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState128 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState132 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_142 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState142 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_146 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState146 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_153 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_JR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState153 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_155 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DSLL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState155 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DEXT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState161 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_169 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DADDU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState169 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_175 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DADDIU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState175 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_181 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BNE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState181 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_187 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BLTZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState187 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_191 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BLEZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState191 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_195 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BGTZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState195 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_199 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BGEZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState199 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_203 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_BEQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState203 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_209 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_25 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_211 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ANDI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState211 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_217 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_AND (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState217 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_223 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState223 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDIU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState229 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState235 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState241 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_247 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_47 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState255 ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState252 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState008 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_256 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_50 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_251 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XORI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | XOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SYNC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SUBU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SUBIU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SUBI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SUB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SLTU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SLTIU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SLTI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SLT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | SC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ORI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | OR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | NOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | NOP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState252
      | MOVE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | LW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | LUI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | LL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | LI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | LD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | JR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | DSLL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | DEXT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | DADDU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | DADDIU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BNE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BLTZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BLEZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BGTZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BGEZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | BEQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | B ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ANDI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | AND ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ADDU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ADDIU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ADDI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | ADD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_1 = _menhir_action_46 () in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState252 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_51 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_244 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADD, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState245 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ADD as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState243 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_238 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState239 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_016 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_53 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_k : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState239 ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState233 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState215 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState179 ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState167 ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState165 ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState159 ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState148 ->
          _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState144 ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState134 ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState120 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState085 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState075 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState069 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState051 ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState045 ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState027 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState015 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_240 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_03 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_234 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDIU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_06 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_216 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ANDI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ANDI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_19 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_180 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DADDIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DADDIU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_07 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_168 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DEXT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _8 = _v in
      let _v = _menhir_action_09 _2 _4 _6 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_166 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState167 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_160 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DSLL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DSLL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_08 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_149 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LD, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState150 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_145 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LI, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_42 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_138 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState139 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_131 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LUI, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LUI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_44 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_124 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState125 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ORI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_21 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_089 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState090 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SLTI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_15 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_070 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SLTIU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_17 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_052 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_11 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_046 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBIU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBIU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_13 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_031 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState032 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_017 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_XORI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_XORI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_23 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_236 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ADDI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState237 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDIU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState233 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_230 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ADDIU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState231 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_228 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_04 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_226 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ADDU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState227 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_224 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ADDU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState225 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_222 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_AND, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_AND (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_18 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_220 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_AND, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState221 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_218 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_AND as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState219 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_214 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ANDI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState215 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_212 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ANDI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState213 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_206 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_BEQ, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_BEQ (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_27 _2 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_204 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_BEQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState205 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_BGEZ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_BGEZ (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_32 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_196 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_BGTZ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_BGTZ (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_30 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_BLEZ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_BLEZ (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_29 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_BLTZ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_BLTZ (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_31 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_184 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_BNE, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_BNE (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_28 _2 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_BNE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState183 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_178 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DADDIU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState179 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_DADDIU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState177 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_174 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DADDU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DADDU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_05 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_172 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DADDU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState173 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_170 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_DADDU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState171 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DEXT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState165 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_162 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_DEXT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState163 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_158 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_DSLL, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState159 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_156 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_DSLL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState157 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_154 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_JR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_JR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_26 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_151 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LD, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LD (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_34 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_147 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LD as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState148 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_143 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState144 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LL (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_38 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_136 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LL (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_39 _2 _5 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState134 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
              let _menhir_s = MenhirState135 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LUI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState130 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_126 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_33 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_35 _2 _5 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_119 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState120 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
              let _menhir_s = MenhirState121 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_MOVE, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MOVE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_43 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_115 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_MOVE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState116 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_NOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_NOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_24 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_108 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_NOR, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState109 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_106 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_NOR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState107 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_OR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_20 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_102 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_OR, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState103 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_OR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState101 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_096 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_ORI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState097 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_ORI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState095 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_SC (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_40 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_SC (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_41 _2 _5 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState085 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
              let _menhir_s = MenhirState086 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SLT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_14 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_080 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState081 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SLT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState079 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_074 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState075 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SLTI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState073 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_068 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTIU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState069 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SLTIU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState067 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SLTU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_16 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_062 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SLTU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState063 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SLTU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState061 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUB, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_10 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_056 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUB, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState057 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_054 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SUB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState055 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_050 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState051 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SUBI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState049 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBIU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState045 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_042 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SUBIU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState043 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBU, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_12 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_038 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SUBU, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState039 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_036 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SUBU as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState037 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_033 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_SW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_36 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_SW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_SW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_37 _2 _5 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_SW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState027 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
              let _menhir_s = MenhirState028 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_023 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_XOR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_XOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_22 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_021 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_XOR, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState022 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_019 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_XOR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState020 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_014 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_XORI, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState015 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_XORI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState013 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_006 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let ps = _v in
      let _v = _menhir_action_55 ps in
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XORI ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | XOR ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SYNC ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SW ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SUBU ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SUBIU ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SUBI ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SUB ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SLTU ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SLTIU ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SLTI ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SLT ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | SC ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ORI ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | OR ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | NOR ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | NOP ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | NAME _v_0 ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState008
      | MOVE ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | LW ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | LUI ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | LL ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | LI ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | LD ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | JR ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | DSLL ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | DEXT ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | DADDU ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | DADDIU ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BNE ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BLTZ ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BLEZ ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BGTZ ->
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BGEZ ->
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | BEQ ->
          _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | B ->
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ANDI ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | AND ->
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ADDU ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ADDIU ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ADDI ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ADD ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | PIPE | SEMI ->
          let _v_1 = _menhir_action_46 () in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState008 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_PROC_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState002 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState004 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_005 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_61 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState004 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_60 x in
          _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState002
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_59 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ ->
          let _v = _menhir_action_58 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
