
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XORI
    | XORDOT
    | XOR
    | SYNC
    | SYMB_REG of (
# 25 "lib/PPCParser.mly"
       (string)
# 19 "lib/PPCParser.ml"
  )
    | SUBI
    | SUBFDOT
    | SUBF
    | SUBDOT
    | SUB
    | STWX
    | STWU
    | STWCX
    | STW
    | STRING of (
# 49 "lib/PPCParser.mly"
       (string)
# 33 "lib/PPCParser.ml"
  )
    | STMW
    | STHX
    | STH
    | STDX
    | STD
    | STBX
    | STB
    | SRAWI
    | SRAW
    | SLW
    | SEMI
    | RPAR
    | RLWINM
    | RLWIMI
    | PROC of (
# 30 "lib/PPCParser.mly"
       (int)
# 52 "lib/PPCParser.ml"
  )
    | PIPE
    | ORI
    | ORDOT
    | OR
    | NUM of (
# 27 "lib/PPCParser.mly"
       (int)
# 61 "lib/PPCParser.ml"
  )
    | NORDOT
    | NOR
    | NOP
    | NEGDOT
    | NEG
    | NAME of (
# 28 "lib/PPCParser.mly"
       (string)
# 71 "lib/PPCParser.ml"
  )
    | MULLI
    | MULLDOT
    | MULL
    | MTLR
    | MR
    | MFLR
    | MFCR
    | LWZX
    | LWZU
    | LWZ
    | LWSYNC
    | LWAX
    | LWARX
    | LWA
    | LPAR
    | LMW
    | LIS
    | LI
    | LHZX
    | LHZ
    | LDX
    | LD
    | LBZX
    | LBZ
    | ISYNC
    | HWSYNC
    | EXTSW
    | EOF
    | EIEIO
    | DIVDOT
    | DIV
    | DCBF
    | CSTVAR of (
# 29 "lib/PPCParser.mly"
       (string)
# 108 "lib/PPCParser.ml"
  )
    | CRK of (
# 34 "lib/PPCParser.mly"
       (int)
# 113 "lib/PPCParser.ml"
  )
    | COMMENT
    | COMMA
    | COLON
    | CODEVAR of (
# 26 "lib/PPCParser.mly"
       (string)
# 121 "lib/PPCParser.ml"
  )
    | CMPWI
    | CMPW
    | CMPLWI
    | CLRLDI
    | BNL
    | BNG
    | BNE
    | BLT
    | BLR
    | BLE
    | BL
    | BGT
    | BGE
    | BEQ
    | B
    | ARCH_REG of (
# 24 "lib/PPCParser.mly"
       (PPCBase.reg)
# 141 "lib/PPCParser.ml"
  )
    | ANDIDOT
    | ANDDOT
    | AND
    | ADDIS
    | ADDI
    | ADDDOT
    | ADD
  
end

include MenhirBasics

# 1 "lib/PPCParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2010-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module PPC = PPCBase
open PPC
open MachSize

# 177 "lib/PPCParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_instr_option_seq) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: instr_option_seq. *)

  | MenhirState001 : (('s, 'r) _menhir_cell1_XORI, 'r) _menhir_state
    (** State 001.
        Stack shape : XORI.
        Start symbol: <undetermined>. *)

  | MenhirState005 : ((('s, 'r) _menhir_cell1_XORI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 005.
        Stack shape : XORI reg.
        Start symbol: <undetermined>. *)

  | MenhirState007 : (((('s, 'r) _menhir_cell1_XORI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 007.
        Stack shape : XORI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState011 : (('s, 'r) _menhir_cell1_XORDOT, 'r) _menhir_state
    (** State 011.
        Stack shape : XORDOT.
        Start symbol: <undetermined>. *)

  | MenhirState013 : ((('s, 'r) _menhir_cell1_XORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 013.
        Stack shape : XORDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState015 : (((('s, 'r) _menhir_cell1_XORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 015.
        Stack shape : XORDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState017 : (('s, 'r) _menhir_cell1_XOR, 'r) _menhir_state
    (** State 017.
        Stack shape : XOR.
        Start symbol: <undetermined>. *)

  | MenhirState019 : ((('s, 'r) _menhir_cell1_XOR, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 019.
        Stack shape : XOR reg.
        Start symbol: <undetermined>. *)

  | MenhirState021 : (((('s, 'r) _menhir_cell1_XOR, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 021.
        Stack shape : XOR reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState024 : (('s, 'r) _menhir_cell1_SUBI, 'r) _menhir_state
    (** State 024.
        Stack shape : SUBI.
        Start symbol: <undetermined>. *)

  | MenhirState026 : ((('s, 'r) _menhir_cell1_SUBI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 026.
        Stack shape : SUBI reg.
        Start symbol: <undetermined>. *)

  | MenhirState028 : (((('s, 'r) _menhir_cell1_SUBI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 028.
        Stack shape : SUBI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState030 : (('s, 'r) _menhir_cell1_SUBFDOT, 'r) _menhir_state
    (** State 030.
        Stack shape : SUBFDOT.
        Start symbol: <undetermined>. *)

  | MenhirState032 : ((('s, 'r) _menhir_cell1_SUBFDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 032.
        Stack shape : SUBFDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState034 : (((('s, 'r) _menhir_cell1_SUBFDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 034.
        Stack shape : SUBFDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState036 : (('s, 'r) _menhir_cell1_SUBF, 'r) _menhir_state
    (** State 036.
        Stack shape : SUBF.
        Start symbol: <undetermined>. *)

  | MenhirState038 : ((('s, 'r) _menhir_cell1_SUBF, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 038.
        Stack shape : SUBF reg.
        Start symbol: <undetermined>. *)

  | MenhirState040 : (((('s, 'r) _menhir_cell1_SUBF, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 040.
        Stack shape : SUBF reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState042 : (('s, 'r) _menhir_cell1_SUBDOT, 'r) _menhir_state
    (** State 042.
        Stack shape : SUBDOT.
        Start symbol: <undetermined>. *)

  | MenhirState044 : ((('s, 'r) _menhir_cell1_SUBDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 044.
        Stack shape : SUBDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState046 : (((('s, 'r) _menhir_cell1_SUBDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 046.
        Stack shape : SUBDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState048 : (('s, 'r) _menhir_cell1_SUB, 'r) _menhir_state
    (** State 048.
        Stack shape : SUB.
        Start symbol: <undetermined>. *)

  | MenhirState050 : ((('s, 'r) _menhir_cell1_SUB, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 050.
        Stack shape : SUB reg.
        Start symbol: <undetermined>. *)

  | MenhirState052 : (((('s, 'r) _menhir_cell1_SUB, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 052.
        Stack shape : SUB reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState054 : (('s, 'r) _menhir_cell1_STWX, 'r) _menhir_state
    (** State 054.
        Stack shape : STWX.
        Start symbol: <undetermined>. *)

  | MenhirState056 : ((('s, 'r) _menhir_cell1_STWX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 056.
        Stack shape : STWX reg.
        Start symbol: <undetermined>. *)

  | MenhirState058 : (((('s, 'r) _menhir_cell1_STWX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 058.
        Stack shape : STWX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState060 : (('s, 'r) _menhir_cell1_STWU, 'r) _menhir_state
    (** State 060.
        Stack shape : STWU.
        Start symbol: <undetermined>. *)

  | MenhirState062 : ((('s, 'r) _menhir_cell1_STWU, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 062.
        Stack shape : STWU reg.
        Start symbol: <undetermined>. *)

  | MenhirState066 : (((('s, 'r) _menhir_cell1_STWU, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 066.
        Stack shape : STWU reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState069 : (((('s, 'r) _menhir_cell1_STWU, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 069.
        Stack shape : STWU reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (('s, 'r) _menhir_cell1_STWCX, 'r) _menhir_state
    (** State 071.
        Stack shape : STWCX.
        Start symbol: <undetermined>. *)

  | MenhirState073 : ((('s, 'r) _menhir_cell1_STWCX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 073.
        Stack shape : STWCX reg.
        Start symbol: <undetermined>. *)

  | MenhirState075 : (((('s, 'r) _menhir_cell1_STWCX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 075.
        Stack shape : STWCX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState077 : (('s, 'r) _menhir_cell1_STW, 'r) _menhir_state
    (** State 077.
        Stack shape : STW.
        Start symbol: <undetermined>. *)

  | MenhirState079 : ((('s, 'r) _menhir_cell1_STW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 079.
        Stack shape : STW reg.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (((('s, 'r) _menhir_cell1_STW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 081.
        Stack shape : STW reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState084 : (((('s, 'r) _menhir_cell1_STW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 084.
        Stack shape : STW reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState086 : (('s, 'r) _menhir_cell1_STMW, 'r) _menhir_state
    (** State 086.
        Stack shape : STMW.
        Start symbol: <undetermined>. *)

  | MenhirState088 : ((('s, 'r) _menhir_cell1_STMW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 088.
        Stack shape : STMW reg.
        Start symbol: <undetermined>. *)

  | MenhirState090 : (((('s, 'r) _menhir_cell1_STMW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 090.
        Stack shape : STMW reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState093 : (('s, 'r) _menhir_cell1_STHX, 'r) _menhir_state
    (** State 093.
        Stack shape : STHX.
        Start symbol: <undetermined>. *)

  | MenhirState095 : ((('s, 'r) _menhir_cell1_STHX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 095.
        Stack shape : STHX reg.
        Start symbol: <undetermined>. *)

  | MenhirState097 : (((('s, 'r) _menhir_cell1_STHX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 097.
        Stack shape : STHX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState099 : (('s, 'r) _menhir_cell1_STH, 'r) _menhir_state
    (** State 099.
        Stack shape : STH.
        Start symbol: <undetermined>. *)

  | MenhirState101 : ((('s, 'r) _menhir_cell1_STH, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 101.
        Stack shape : STH reg.
        Start symbol: <undetermined>. *)

  | MenhirState103 : (((('s, 'r) _menhir_cell1_STH, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 103.
        Stack shape : STH reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState106 : (((('s, 'r) _menhir_cell1_STH, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 106.
        Stack shape : STH reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState108 : (('s, 'r) _menhir_cell1_STDX, 'r) _menhir_state
    (** State 108.
        Stack shape : STDX.
        Start symbol: <undetermined>. *)

  | MenhirState110 : ((('s, 'r) _menhir_cell1_STDX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 110.
        Stack shape : STDX reg.
        Start symbol: <undetermined>. *)

  | MenhirState112 : (((('s, 'r) _menhir_cell1_STDX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 112.
        Stack shape : STDX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState114 : (('s, 'r) _menhir_cell1_STD, 'r) _menhir_state
    (** State 114.
        Stack shape : STD.
        Start symbol: <undetermined>. *)

  | MenhirState116 : ((('s, 'r) _menhir_cell1_STD, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 116.
        Stack shape : STD reg.
        Start symbol: <undetermined>. *)

  | MenhirState118 : (((('s, 'r) _menhir_cell1_STD, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 118.
        Stack shape : STD reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState121 : (((('s, 'r) _menhir_cell1_STD, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 121.
        Stack shape : STD reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState123 : (('s, 'r) _menhir_cell1_STBX, 'r) _menhir_state
    (** State 123.
        Stack shape : STBX.
        Start symbol: <undetermined>. *)

  | MenhirState125 : ((('s, 'r) _menhir_cell1_STBX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 125.
        Stack shape : STBX reg.
        Start symbol: <undetermined>. *)

  | MenhirState127 : (((('s, 'r) _menhir_cell1_STBX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 127.
        Stack shape : STBX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState129 : (('s, 'r) _menhir_cell1_STB, 'r) _menhir_state
    (** State 129.
        Stack shape : STB.
        Start symbol: <undetermined>. *)

  | MenhirState131 : ((('s, 'r) _menhir_cell1_STB, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 131.
        Stack shape : STB reg.
        Start symbol: <undetermined>. *)

  | MenhirState133 : (((('s, 'r) _menhir_cell1_STB, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 133.
        Stack shape : STB reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState136 : (((('s, 'r) _menhir_cell1_STB, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 136.
        Stack shape : STB reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState138 : (('s, 'r) _menhir_cell1_SRAWI, 'r) _menhir_state
    (** State 138.
        Stack shape : SRAWI.
        Start symbol: <undetermined>. *)

  | MenhirState140 : ((('s, 'r) _menhir_cell1_SRAWI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 140.
        Stack shape : SRAWI reg.
        Start symbol: <undetermined>. *)

  | MenhirState142 : (((('s, 'r) _menhir_cell1_SRAWI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 142.
        Stack shape : SRAWI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState144 : (('s, 'r) _menhir_cell1_SRAW, 'r) _menhir_state
    (** State 144.
        Stack shape : SRAW.
        Start symbol: <undetermined>. *)

  | MenhirState146 : ((('s, 'r) _menhir_cell1_SRAW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 146.
        Stack shape : SRAW reg.
        Start symbol: <undetermined>. *)

  | MenhirState148 : (((('s, 'r) _menhir_cell1_SRAW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 148.
        Stack shape : SRAW reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState150 : (('s, 'r) _menhir_cell1_SLW, 'r) _menhir_state
    (** State 150.
        Stack shape : SLW.
        Start symbol: <undetermined>. *)

  | MenhirState152 : ((('s, 'r) _menhir_cell1_SLW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 152.
        Stack shape : SLW reg.
        Start symbol: <undetermined>. *)

  | MenhirState154 : (((('s, 'r) _menhir_cell1_SLW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 154.
        Stack shape : SLW reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState156 : (('s, 'r) _menhir_cell1_RLWINM, 'r) _menhir_state
    (** State 156.
        Stack shape : RLWINM.
        Start symbol: <undetermined>. *)

  | MenhirState158 : ((('s, 'r) _menhir_cell1_RLWINM, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 158.
        Stack shape : RLWINM reg.
        Start symbol: <undetermined>. *)

  | MenhirState160 : (((('s, 'r) _menhir_cell1_RLWINM, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 160.
        Stack shape : RLWINM reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState162 : ((((('s, 'r) _menhir_cell1_RLWINM, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_k, 'r) _menhir_state
    (** State 162.
        Stack shape : RLWINM reg reg k.
        Start symbol: <undetermined>. *)

  | MenhirState164 : (((((('s, 'r) _menhir_cell1_RLWINM, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_k, 'r) _menhir_cell1_k, 'r) _menhir_state
    (** State 164.
        Stack shape : RLWINM reg reg k k.
        Start symbol: <undetermined>. *)

  | MenhirState166 : (('s, 'r) _menhir_cell1_RLWIMI, 'r) _menhir_state
    (** State 166.
        Stack shape : RLWIMI.
        Start symbol: <undetermined>. *)

  | MenhirState168 : ((('s, 'r) _menhir_cell1_RLWIMI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 168.
        Stack shape : RLWIMI reg.
        Start symbol: <undetermined>. *)

  | MenhirState170 : (((('s, 'r) _menhir_cell1_RLWIMI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 170.
        Stack shape : RLWIMI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState172 : ((((('s, 'r) _menhir_cell1_RLWIMI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_k, 'r) _menhir_state
    (** State 172.
        Stack shape : RLWIMI reg reg k.
        Start symbol: <undetermined>. *)

  | MenhirState174 : (((((('s, 'r) _menhir_cell1_RLWIMI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_k, 'r) _menhir_cell1_k, 'r) _menhir_state
    (** State 174.
        Stack shape : RLWIMI reg reg k k.
        Start symbol: <undetermined>. *)

  | MenhirState176 : (('s, 'r) _menhir_cell1_ORI, 'r) _menhir_state
    (** State 176.
        Stack shape : ORI.
        Start symbol: <undetermined>. *)

  | MenhirState178 : ((('s, 'r) _menhir_cell1_ORI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 178.
        Stack shape : ORI reg.
        Start symbol: <undetermined>. *)

  | MenhirState180 : (((('s, 'r) _menhir_cell1_ORI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 180.
        Stack shape : ORI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState182 : (('s, 'r) _menhir_cell1_ORDOT, 'r) _menhir_state
    (** State 182.
        Stack shape : ORDOT.
        Start symbol: <undetermined>. *)

  | MenhirState184 : ((('s, 'r) _menhir_cell1_ORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 184.
        Stack shape : ORDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState186 : (((('s, 'r) _menhir_cell1_ORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 186.
        Stack shape : ORDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState188 : (('s, 'r) _menhir_cell1_OR, 'r) _menhir_state
    (** State 188.
        Stack shape : OR.
        Start symbol: <undetermined>. *)

  | MenhirState190 : ((('s, 'r) _menhir_cell1_OR, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 190.
        Stack shape : OR reg.
        Start symbol: <undetermined>. *)

  | MenhirState192 : (((('s, 'r) _menhir_cell1_OR, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 192.
        Stack shape : OR reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState194 : (('s, 'r) _menhir_cell1_NORDOT, 'r) _menhir_state
    (** State 194.
        Stack shape : NORDOT.
        Start symbol: <undetermined>. *)

  | MenhirState196 : ((('s, 'r) _menhir_cell1_NORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 196.
        Stack shape : NORDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState198 : (((('s, 'r) _menhir_cell1_NORDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 198.
        Stack shape : NORDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState200 : (('s, 'r) _menhir_cell1_NOR, 'r) _menhir_state
    (** State 200.
        Stack shape : NOR.
        Start symbol: <undetermined>. *)

  | MenhirState202 : ((('s, 'r) _menhir_cell1_NOR, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 202.
        Stack shape : NOR reg.
        Start symbol: <undetermined>. *)

  | MenhirState204 : (((('s, 'r) _menhir_cell1_NOR, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 204.
        Stack shape : NOR reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState207 : (('s, 'r) _menhir_cell1_NEGDOT, 'r) _menhir_state
    (** State 207.
        Stack shape : NEGDOT.
        Start symbol: <undetermined>. *)

  | MenhirState209 : ((('s, 'r) _menhir_cell1_NEGDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 209.
        Stack shape : NEGDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState211 : (('s, 'r) _menhir_cell1_NEG, 'r) _menhir_state
    (** State 211.
        Stack shape : NEG.
        Start symbol: <undetermined>. *)

  | MenhirState213 : ((('s, 'r) _menhir_cell1_NEG, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 213.
        Stack shape : NEG reg.
        Start symbol: <undetermined>. *)

  | MenhirState216 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 216.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState220 : (('s, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 220.
        Stack shape : reg.
        Start symbol: <undetermined>. *)

  | MenhirState222 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 222.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState223 : (('s, 'r) _menhir_cell1_MULLI, 'r) _menhir_state
    (** State 223.
        Stack shape : MULLI.
        Start symbol: <undetermined>. *)

  | MenhirState225 : ((('s, 'r) _menhir_cell1_MULLI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 225.
        Stack shape : MULLI reg.
        Start symbol: <undetermined>. *)

  | MenhirState227 : (((('s, 'r) _menhir_cell1_MULLI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 227.
        Stack shape : MULLI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState229 : (('s, 'r) _menhir_cell1_MULLDOT, 'r) _menhir_state
    (** State 229.
        Stack shape : MULLDOT.
        Start symbol: <undetermined>. *)

  | MenhirState231 : ((('s, 'r) _menhir_cell1_MULLDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 231.
        Stack shape : MULLDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState233 : (((('s, 'r) _menhir_cell1_MULLDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 233.
        Stack shape : MULLDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState235 : (('s, 'r) _menhir_cell1_MULL, 'r) _menhir_state
    (** State 235.
        Stack shape : MULL.
        Start symbol: <undetermined>. *)

  | MenhirState237 : ((('s, 'r) _menhir_cell1_MULL, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 237.
        Stack shape : MULL reg.
        Start symbol: <undetermined>. *)

  | MenhirState239 : (((('s, 'r) _menhir_cell1_MULL, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 239.
        Stack shape : MULL reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState241 : (('s, 'r) _menhir_cell1_MTLR, 'r) _menhir_state
    (** State 241.
        Stack shape : MTLR.
        Start symbol: <undetermined>. *)

  | MenhirState243 : (('s, 'r) _menhir_cell1_MR, 'r) _menhir_state
    (** State 243.
        Stack shape : MR.
        Start symbol: <undetermined>. *)

  | MenhirState245 : ((('s, 'r) _menhir_cell1_MR, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 245.
        Stack shape : MR reg.
        Start symbol: <undetermined>. *)

  | MenhirState247 : (('s, 'r) _menhir_cell1_MFLR, 'r) _menhir_state
    (** State 247.
        Stack shape : MFLR.
        Start symbol: <undetermined>. *)

  | MenhirState249 : (('s, 'r) _menhir_cell1_MFCR, 'r) _menhir_state
    (** State 249.
        Stack shape : MFCR.
        Start symbol: <undetermined>. *)

  | MenhirState251 : (('s, 'r) _menhir_cell1_LWZX, 'r) _menhir_state
    (** State 251.
        Stack shape : LWZX.
        Start symbol: <undetermined>. *)

  | MenhirState253 : ((('s, 'r) _menhir_cell1_LWZX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 253.
        Stack shape : LWZX reg.
        Start symbol: <undetermined>. *)

  | MenhirState255 : (((('s, 'r) _menhir_cell1_LWZX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 255.
        Stack shape : LWZX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState257 : (('s, 'r) _menhir_cell1_LWZU, 'r) _menhir_state
    (** State 257.
        Stack shape : LWZU.
        Start symbol: <undetermined>. *)

  | MenhirState259 : ((('s, 'r) _menhir_cell1_LWZU, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 259.
        Stack shape : LWZU reg.
        Start symbol: <undetermined>. *)

  | MenhirState261 : (((('s, 'r) _menhir_cell1_LWZU, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 261.
        Stack shape : LWZU reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState264 : (((('s, 'r) _menhir_cell1_LWZU, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 264.
        Stack shape : LWZU reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState266 : (('s, 'r) _menhir_cell1_LWZ, 'r) _menhir_state
    (** State 266.
        Stack shape : LWZ.
        Start symbol: <undetermined>. *)

  | MenhirState268 : ((('s, 'r) _menhir_cell1_LWZ, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 268.
        Stack shape : LWZ reg.
        Start symbol: <undetermined>. *)

  | MenhirState270 : (((('s, 'r) _menhir_cell1_LWZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 270.
        Stack shape : LWZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState273 : (((('s, 'r) _menhir_cell1_LWZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 273.
        Stack shape : LWZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState276 : (('s, 'r) _menhir_cell1_LWAX, 'r) _menhir_state
    (** State 276.
        Stack shape : LWAX.
        Start symbol: <undetermined>. *)

  | MenhirState278 : ((('s, 'r) _menhir_cell1_LWAX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 278.
        Stack shape : LWAX reg.
        Start symbol: <undetermined>. *)

  | MenhirState280 : (((('s, 'r) _menhir_cell1_LWAX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 280.
        Stack shape : LWAX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState282 : (('s, 'r) _menhir_cell1_LWARX, 'r) _menhir_state
    (** State 282.
        Stack shape : LWARX.
        Start symbol: <undetermined>. *)

  | MenhirState284 : ((('s, 'r) _menhir_cell1_LWARX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 284.
        Stack shape : LWARX reg.
        Start symbol: <undetermined>. *)

  | MenhirState286 : (((('s, 'r) _menhir_cell1_LWARX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 286.
        Stack shape : LWARX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState288 : (('s, 'r) _menhir_cell1_LWA, 'r) _menhir_state
    (** State 288.
        Stack shape : LWA.
        Start symbol: <undetermined>. *)

  | MenhirState290 : ((('s, 'r) _menhir_cell1_LWA, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 290.
        Stack shape : LWA reg.
        Start symbol: <undetermined>. *)

  | MenhirState292 : (((('s, 'r) _menhir_cell1_LWA, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 292.
        Stack shape : LWA reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState295 : (('s, 'r) _menhir_cell1_LMW, 'r) _menhir_state
    (** State 295.
        Stack shape : LMW.
        Start symbol: <undetermined>. *)

  | MenhirState297 : ((('s, 'r) _menhir_cell1_LMW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 297.
        Stack shape : LMW reg.
        Start symbol: <undetermined>. *)

  | MenhirState299 : (((('s, 'r) _menhir_cell1_LMW, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 299.
        Stack shape : LMW reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState302 : (('s, 'r) _menhir_cell1_LIS, 'r) _menhir_state
    (** State 302.
        Stack shape : LIS.
        Start symbol: <undetermined>. *)

  | MenhirState304 : ((('s, 'r) _menhir_cell1_LIS, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 304.
        Stack shape : LIS reg.
        Start symbol: <undetermined>. *)

  | MenhirState306 : (('s, 'r) _menhir_cell1_LI, 'r) _menhir_state
    (** State 306.
        Stack shape : LI.
        Start symbol: <undetermined>. *)

  | MenhirState308 : ((('s, 'r) _menhir_cell1_LI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 308.
        Stack shape : LI reg.
        Start symbol: <undetermined>. *)

  | MenhirState310 : (('s, 'r) _menhir_cell1_LHZX, 'r) _menhir_state
    (** State 310.
        Stack shape : LHZX.
        Start symbol: <undetermined>. *)

  | MenhirState312 : ((('s, 'r) _menhir_cell1_LHZX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 312.
        Stack shape : LHZX reg.
        Start symbol: <undetermined>. *)

  | MenhirState314 : (((('s, 'r) _menhir_cell1_LHZX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 314.
        Stack shape : LHZX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState316 : (('s, 'r) _menhir_cell1_LHZ, 'r) _menhir_state
    (** State 316.
        Stack shape : LHZ.
        Start symbol: <undetermined>. *)

  | MenhirState318 : ((('s, 'r) _menhir_cell1_LHZ, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 318.
        Stack shape : LHZ reg.
        Start symbol: <undetermined>. *)

  | MenhirState320 : (((('s, 'r) _menhir_cell1_LHZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 320.
        Stack shape : LHZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState323 : (((('s, 'r) _menhir_cell1_LHZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 323.
        Stack shape : LHZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState325 : (('s, 'r) _menhir_cell1_LDX, 'r) _menhir_state
    (** State 325.
        Stack shape : LDX.
        Start symbol: <undetermined>. *)

  | MenhirState327 : ((('s, 'r) _menhir_cell1_LDX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 327.
        Stack shape : LDX reg.
        Start symbol: <undetermined>. *)

  | MenhirState329 : (((('s, 'r) _menhir_cell1_LDX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 329.
        Stack shape : LDX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState331 : (('s, 'r) _menhir_cell1_LD, 'r) _menhir_state
    (** State 331.
        Stack shape : LD.
        Start symbol: <undetermined>. *)

  | MenhirState333 : ((('s, 'r) _menhir_cell1_LD, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 333.
        Stack shape : LD reg.
        Start symbol: <undetermined>. *)

  | MenhirState335 : (((('s, 'r) _menhir_cell1_LD, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 335.
        Stack shape : LD reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState338 : (((('s, 'r) _menhir_cell1_LD, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 338.
        Stack shape : LD reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState340 : (('s, 'r) _menhir_cell1_LBZX, 'r) _menhir_state
    (** State 340.
        Stack shape : LBZX.
        Start symbol: <undetermined>. *)

  | MenhirState342 : ((('s, 'r) _menhir_cell1_LBZX, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 342.
        Stack shape : LBZX reg.
        Start symbol: <undetermined>. *)

  | MenhirState344 : (((('s, 'r) _menhir_cell1_LBZX, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 344.
        Stack shape : LBZX reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState346 : (('s, 'r) _menhir_cell1_LBZ, 'r) _menhir_state
    (** State 346.
        Stack shape : LBZ.
        Start symbol: <undetermined>. *)

  | MenhirState348 : ((('s, 'r) _menhir_cell1_LBZ, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 348.
        Stack shape : LBZ reg.
        Start symbol: <undetermined>. *)

  | MenhirState350 : (((('s, 'r) _menhir_cell1_LBZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 350.
        Stack shape : LBZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState353 : (((('s, 'r) _menhir_cell1_LBZ, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_idx, 'r) _menhir_state
    (** State 353.
        Stack shape : LBZ reg idx.
        Start symbol: <undetermined>. *)

  | MenhirState357 : (('s, 'r) _menhir_cell1_EXTSW, 'r) _menhir_state
    (** State 357.
        Stack shape : EXTSW.
        Start symbol: <undetermined>. *)

  | MenhirState359 : ((('s, 'r) _menhir_cell1_EXTSW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 359.
        Stack shape : EXTSW reg.
        Start symbol: <undetermined>. *)

  | MenhirState362 : (('s, 'r) _menhir_cell1_DIVDOT, 'r) _menhir_state
    (** State 362.
        Stack shape : DIVDOT.
        Start symbol: <undetermined>. *)

  | MenhirState364 : ((('s, 'r) _menhir_cell1_DIVDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 364.
        Stack shape : DIVDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState366 : (((('s, 'r) _menhir_cell1_DIVDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 366.
        Stack shape : DIVDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState368 : (('s, 'r) _menhir_cell1_DIV, 'r) _menhir_state
    (** State 368.
        Stack shape : DIV.
        Start symbol: <undetermined>. *)

  | MenhirState370 : ((('s, 'r) _menhir_cell1_DIV, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 370.
        Stack shape : DIV reg.
        Start symbol: <undetermined>. *)

  | MenhirState372 : (((('s, 'r) _menhir_cell1_DIV, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 372.
        Stack shape : DIV reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState374 : (('s, 'r) _menhir_cell1_DCBF, 'r) _menhir_state
    (** State 374.
        Stack shape : DCBF.
        Start symbol: <undetermined>. *)

  | MenhirState376 : ((('s, 'r) _menhir_cell1_DCBF, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 376.
        Stack shape : DCBF reg.
        Start symbol: <undetermined>. *)

  | MenhirState381 : (('s, 'r) _menhir_cell1_CMPWI, 'r) _menhir_state
    (** State 381.
        Stack shape : CMPWI.
        Start symbol: <undetermined>. *)

  | MenhirState384 : ((('s, 'r) _menhir_cell1_CMPWI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 384.
        Stack shape : CMPWI reg.
        Start symbol: <undetermined>. *)

  | MenhirState387 : ((('s, 'r) _menhir_cell1_CMPWI, 'r) _menhir_cell1_crindex, 'r) _menhir_state
    (** State 387.
        Stack shape : CMPWI crindex.
        Start symbol: <undetermined>. *)

  | MenhirState389 : (((('s, 'r) _menhir_cell1_CMPWI, 'r) _menhir_cell1_crindex, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 389.
        Stack shape : CMPWI crindex reg.
        Start symbol: <undetermined>. *)

  | MenhirState391 : (('s, 'r) _menhir_cell1_CMPW, 'r) _menhir_state
    (** State 391.
        Stack shape : CMPW.
        Start symbol: <undetermined>. *)

  | MenhirState393 : ((('s, 'r) _menhir_cell1_CMPW, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 393.
        Stack shape : CMPW reg.
        Start symbol: <undetermined>. *)

  | MenhirState396 : ((('s, 'r) _menhir_cell1_CMPW, 'r) _menhir_cell1_crindex, 'r) _menhir_state
    (** State 396.
        Stack shape : CMPW crindex.
        Start symbol: <undetermined>. *)

  | MenhirState398 : (((('s, 'r) _menhir_cell1_CMPW, 'r) _menhir_cell1_crindex, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 398.
        Stack shape : CMPW crindex reg.
        Start symbol: <undetermined>. *)

  | MenhirState400 : (('s, 'r) _menhir_cell1_CMPLWI, 'r) _menhir_state
    (** State 400.
        Stack shape : CMPLWI.
        Start symbol: <undetermined>. *)

  | MenhirState402 : ((('s, 'r) _menhir_cell1_CMPLWI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 402.
        Stack shape : CMPLWI reg.
        Start symbol: <undetermined>. *)

  | MenhirState404 : (('s, 'r) _menhir_cell1_CLRLDI, 'r) _menhir_state
    (** State 404.
        Stack shape : CLRLDI.
        Start symbol: <undetermined>. *)

  | MenhirState406 : ((('s, 'r) _menhir_cell1_CLRLDI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 406.
        Stack shape : CLRLDI reg.
        Start symbol: <undetermined>. *)

  | MenhirState408 : (((('s, 'r) _menhir_cell1_CLRLDI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 408.
        Stack shape : CLRLDI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState431 : (('s, 'r) _menhir_cell1_ANDIDOT, 'r) _menhir_state
    (** State 431.
        Stack shape : ANDIDOT.
        Start symbol: <undetermined>. *)

  | MenhirState433 : ((('s, 'r) _menhir_cell1_ANDIDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 433.
        Stack shape : ANDIDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState435 : (((('s, 'r) _menhir_cell1_ANDIDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 435.
        Stack shape : ANDIDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState437 : (('s, 'r) _menhir_cell1_ANDDOT, 'r) _menhir_state
    (** State 437.
        Stack shape : ANDDOT.
        Start symbol: <undetermined>. *)

  | MenhirState439 : ((('s, 'r) _menhir_cell1_ANDDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 439.
        Stack shape : ANDDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState441 : (((('s, 'r) _menhir_cell1_ANDDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 441.
        Stack shape : ANDDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState443 : (('s, 'r) _menhir_cell1_AND, 'r) _menhir_state
    (** State 443.
        Stack shape : AND.
        Start symbol: <undetermined>. *)

  | MenhirState445 : ((('s, 'r) _menhir_cell1_AND, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 445.
        Stack shape : AND reg.
        Start symbol: <undetermined>. *)

  | MenhirState447 : (((('s, 'r) _menhir_cell1_AND, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 447.
        Stack shape : AND reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState449 : (('s, 'r) _menhir_cell1_ADDIS, 'r) _menhir_state
    (** State 449.
        Stack shape : ADDIS.
        Start symbol: <undetermined>. *)

  | MenhirState451 : ((('s, 'r) _menhir_cell1_ADDIS, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 451.
        Stack shape : ADDIS reg.
        Start symbol: <undetermined>. *)

  | MenhirState453 : (((('s, 'r) _menhir_cell1_ADDIS, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 453.
        Stack shape : ADDIS reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState455 : (('s, 'r) _menhir_cell1_ADDI, 'r) _menhir_state
    (** State 455.
        Stack shape : ADDI.
        Start symbol: <undetermined>. *)

  | MenhirState457 : ((('s, 'r) _menhir_cell1_ADDI, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 457.
        Stack shape : ADDI reg.
        Start symbol: <undetermined>. *)

  | MenhirState459 : (((('s, 'r) _menhir_cell1_ADDI, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 459.
        Stack shape : ADDI reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState461 : (('s, 'r) _menhir_cell1_ADDDOT, 'r) _menhir_state
    (** State 461.
        Stack shape : ADDDOT.
        Start symbol: <undetermined>. *)

  | MenhirState463 : ((('s, 'r) _menhir_cell1_ADDDOT, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 463.
        Stack shape : ADDDOT reg.
        Start symbol: <undetermined>. *)

  | MenhirState465 : (((('s, 'r) _menhir_cell1_ADDDOT, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 465.
        Stack shape : ADDDOT reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState467 : (('s, 'r) _menhir_cell1_ADD, 'r) _menhir_state
    (** State 467.
        Stack shape : ADD.
        Start symbol: <undetermined>. *)

  | MenhirState469 : ((('s, 'r) _menhir_cell1_ADD, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 469.
        Stack shape : ADD reg.
        Start symbol: <undetermined>. *)

  | MenhirState471 : (((('s, 'r) _menhir_cell1_ADD, 'r) _menhir_cell1_reg, 'r) _menhir_cell1_reg, 'r) _menhir_state
    (** State 471.
        Stack shape : ADD reg reg.
        Start symbol: <undetermined>. *)

  | MenhirState479 : (('s, _menhir_box_instr_option_seq) _menhir_cell1_instr_option, _menhir_box_instr_option_seq) _menhir_state
    (** State 479.
        Stack shape : instr_option.
        Start symbol: instr_option_seq. *)

  | MenhirState483 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 483.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState485 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 485.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState489 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 489.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState494 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 494.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState497 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 497.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_crindex = 
  | MenhirCell1_crindex of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_idx = 
  | MenhirCell1_idx of 's * ('s, 'r) _menhir_state * (MetaConst.k)

and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (PPCBase.parsedPseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (PPCBase.parsedPseudo list)

and ('s, 'r) _menhir_cell1_k = 
  | MenhirCell1_k of 's * ('s, 'r) _menhir_state * (MetaConst.k)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (PPC.reg_arg)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and ('s, 'r) _menhir_cell1_ADD = 
  | MenhirCell1_ADD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDDOT = 
  | MenhirCell1_ADDDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDI = 
  | MenhirCell1_ADDI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ADDIS = 
  | MenhirCell1_ADDIS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_AND = 
  | MenhirCell1_AND of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ANDDOT = 
  | MenhirCell1_ANDDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ANDIDOT = 
  | MenhirCell1_ANDIDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CLRLDI = 
  | MenhirCell1_CLRLDI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CMPLWI = 
  | MenhirCell1_CMPLWI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CMPW = 
  | MenhirCell1_CMPW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CMPWI = 
  | MenhirCell1_CMPWI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DCBF = 
  | MenhirCell1_DCBF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DIV = 
  | MenhirCell1_DIV of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DIVDOT = 
  | MenhirCell1_DIVDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_EXTSW = 
  | MenhirCell1_EXTSW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBZ = 
  | MenhirCell1_LBZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBZX = 
  | MenhirCell1_LBZX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LD = 
  | MenhirCell1_LD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LDX = 
  | MenhirCell1_LDX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LHZ = 
  | MenhirCell1_LHZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LHZX = 
  | MenhirCell1_LHZX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LI = 
  | MenhirCell1_LI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LIS = 
  | MenhirCell1_LIS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LMW = 
  | MenhirCell1_LMW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWA = 
  | MenhirCell1_LWA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWARX = 
  | MenhirCell1_LWARX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWAX = 
  | MenhirCell1_LWAX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWZ = 
  | MenhirCell1_LWZ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWZU = 
  | MenhirCell1_LWZU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LWZX = 
  | MenhirCell1_LWZX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MFCR = 
  | MenhirCell1_MFCR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MFLR = 
  | MenhirCell1_MFLR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MR = 
  | MenhirCell1_MR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MTLR = 
  | MenhirCell1_MTLR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MULL = 
  | MenhirCell1_MULL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MULLDOT = 
  | MenhirCell1_MULLDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MULLI = 
  | MenhirCell1_MULLI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 28 "lib/PPCParser.mly"
       (string)
# 1400 "lib/PPCParser.ml"
)

and ('s, 'r) _menhir_cell1_NEG = 
  | MenhirCell1_NEG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NEGDOT = 
  | MenhirCell1_NEGDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NOR = 
  | MenhirCell1_NOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NORDOT = 
  | MenhirCell1_NORDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_OR = 
  | MenhirCell1_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ORDOT = 
  | MenhirCell1_ORDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ORI = 
  | MenhirCell1_ORI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 30 "lib/PPCParser.mly"
       (int)
# 1428 "lib/PPCParser.ml"
)

and ('s, 'r) _menhir_cell1_RLWIMI = 
  | MenhirCell1_RLWIMI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_RLWINM = 
  | MenhirCell1_RLWINM of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLW = 
  | MenhirCell1_SLW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SRAW = 
  | MenhirCell1_SRAW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SRAWI = 
  | MenhirCell1_SRAWI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STB = 
  | MenhirCell1_STB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STBX = 
  | MenhirCell1_STBX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STD = 
  | MenhirCell1_STD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STDX = 
  | MenhirCell1_STDX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STH = 
  | MenhirCell1_STH of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STHX = 
  | MenhirCell1_STHX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STMW = 
  | MenhirCell1_STMW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STW = 
  | MenhirCell1_STW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STWCX = 
  | MenhirCell1_STWCX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STWU = 
  | MenhirCell1_STWU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STWX = 
  | MenhirCell1_STWX of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUB = 
  | MenhirCell1_SUB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBDOT = 
  | MenhirCell1_SUBDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBF = 
  | MenhirCell1_SUBF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBFDOT = 
  | MenhirCell1_SUBFDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SUBI = 
  | MenhirCell1_SUBI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XOR = 
  | MenhirCell1_XOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XORDOT = 
  | MenhirCell1_XORDOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XORI = 
  | MenhirCell1_XORI of 's * ('s, 'r) _menhir_state

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * PPCBase.parsedPseudo list list) [@@unboxed]

and _menhir_box_instr_option_seq = 
  | MenhirBox_instr_option_seq of (PPCBase.parsedPseudo list) [@@unboxed]

let _menhir_action_002 =
  fun _1 ->
    (
# 290 "lib/PPCParser.mly"
       ( _1 )
# 1514 "lib/PPCParser.ml"
     : (int))

let _menhir_action_003 =
  fun _1 ->
    (
# 285 "lib/PPCParser.mly"
       ( MetaConst.Int _1 )
# 1522 "lib/PPCParser.ml"
     : (MetaConst.k))

let _menhir_action_004 =
  fun _1 ->
    (
# 286 "lib/PPCParser.mly"
         ( MetaConst.Meta _1 )
# 1530 "lib/PPCParser.ml"
     : (MetaConst.k))

let _menhir_action_005 =
  fun () ->
    (
# 100 "lib/PPCParser.mly"
    ( Pnop )
# 1538 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_006 =
  fun _2 _4 _6 ->
    (
# 102 "lib/PPCParser.mly"
    ( Padd (DontSetCR0,_2,_4,_6) )
# 1546 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_007 =
  fun _2 _4 _6 ->
    (
# 104 "lib/PPCParser.mly"
    ( Padd (SetCR0,_2,_4,_6) )
# 1554 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_008 =
  fun _2 _4 _6 ->
    (
# 106 "lib/PPCParser.mly"
    ( Psub (DontSetCR0,_2,_4,_6) )
# 1562 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_009 =
  fun _2 _4 _6 ->
    (
# 108 "lib/PPCParser.mly"
    ( Psub (SetCR0,_2,_4,_6) )
# 1570 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_010 =
  fun _2 _4 _6 ->
    (
# 110 "lib/PPCParser.mly"
    ( Psubf (DontSetCR0,_2,_4,_6) )
# 1578 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_011 =
  fun _2 _4 _6 ->
    (
# 112 "lib/PPCParser.mly"
    ( Psubf (SetCR0,_2,_4,_6) )
# 1586 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_012 =
  fun _2 _4 _6 ->
    (
# 114 "lib/PPCParser.mly"
    ( Paddis (_2,_4,_6) )
# 1594 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_013 =
  fun _2 _4 _6 ->
    (
# 116 "lib/PPCParser.mly"
    ( Paddi (_2,_4,_6) )
# 1602 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_014 =
  fun _2 _4 _6 ->
    (
# 118 "lib/PPCParser.mly"
      ( Paddi (_2,_4, match _6 with MetaConst.Meta _ as k -> k
                     | MetaConst.Int i -> MetaConst.Int(-i)) )
# 1611 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_015 =
  fun _10 _2 _4 _6 _8 ->
    (
# 121 "lib/PPCParser.mly"
    ( Prlwinm (_2,_4,_6,_8,_10) )
# 1619 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_016 =
  fun _10 _2 _4 _6 _8 ->
    (
# 123 "lib/PPCParser.mly"
    ( Prlwimi (_2,_4,_6,_8,_10) )
# 1627 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_017 =
  fun _2 _4 _6 ->
    (
# 125 "lib/PPCParser.mly"
    ( Pclrldi (_2,_4,_6) )
# 1635 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_018 =
  fun _2 _4 ->
    (
# 127 "lib/PPCParser.mly"
    ( Pextsw (_2,_4) )
# 1643 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_019 =
  fun _2 _4 ->
    (
# 129 "lib/PPCParser.mly"
    ( Pcmpwi (0,_2,_4) )
# 1651 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_020 =
  fun _2 _4 ->
    (
# 131 "lib/PPCParser.mly"
    ( Pcmplwi (0,_2,_4) )
# 1659 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_021 =
  fun _2 _4 _6 ->
    (
# 133 "lib/PPCParser.mly"
    ( Pcmpwi (_2,_4,_6) )
# 1667 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_022 =
  fun _2 _4 _6 ->
    (
# 135 "lib/PPCParser.mly"
    ( Pcmpw (_2,_4,_6))
# 1675 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_023 =
  fun _2 _4 ->
    (
# 137 "lib/PPCParser.mly"
    ( Pcmpw (0,_2,_4))
# 1683 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_024 =
  fun _2 _4 ->
    (
# 139 "lib/PPCParser.mly"
    ( Pli (_2,_4) )
# 1691 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_025 =
  fun _2 _4 ->
    (
# 141 "lib/PPCParser.mly"
    ( Plis (_2,_4) )
# 1699 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_026 =
  fun _2 _4 _6 ->
    (
# 143 "lib/PPCParser.mly"
    ( Pxor (DontSetCR0,_2,_4,_6) )
# 1707 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_027 =
  fun _2 _4 _6 ->
    (
# 145 "lib/PPCParser.mly"
    ( Pxor (SetCR0,_2,_4,_6) )
# 1715 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_028 =
  fun _2 _4 _6 ->
    (
# 147 "lib/PPCParser.mly"
    ( Pxori (_2,_4,_6) )
# 1723 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_029 =
  fun _2 _4 _6 ->
    (
# 149 "lib/PPCParser.mly"
    ( Pand (DontSetCR0,_2,_4,_6) )
# 1731 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_030 =
  fun _2 _4 _6 ->
    (
# 151 "lib/PPCParser.mly"
    ( Pand (SetCR0,_2,_4,_6) )
# 1739 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_031 =
  fun _2 _4 _6 ->
    (
# 153 "lib/PPCParser.mly"
    ( Pandi (_2,_4,_6) )
# 1747 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_032 =
  fun _2 _4 _6 ->
    (
# 155 "lib/PPCParser.mly"
    ( Por (DontSetCR0,_2,_4,_6) )
# 1755 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_033 =
  fun _2 _4 _6 ->
    (
# 157 "lib/PPCParser.mly"
    ( Por (SetCR0,_2,_4,_6) )
# 1763 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_034 =
  fun _2 _4 _6 ->
    (
# 159 "lib/PPCParser.mly"
    ( Pori (_2,_4,_6) )
# 1771 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_035 =
  fun _2 _4 _6 ->
    (
# 161 "lib/PPCParser.mly"
    ( Pmull (DontSetCR0,_2,_4,_6) )
# 1779 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_036 =
  fun _2 _4 _6 ->
    (
# 163 "lib/PPCParser.mly"
    ( Pmull (SetCR0,_2,_4,_6) )
# 1787 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_037 =
  fun _2 _4 _6 ->
    (
# 165 "lib/PPCParser.mly"
    ( Pmulli (_2,_4,_6) )
# 1795 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_038 =
  fun _2 _4 _6 ->
    (
# 167 "lib/PPCParser.mly"
    ( Pdiv (DontSetCR0,_2,_4,_6) )
# 1803 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_039 =
  fun _2 _4 _6 ->
    (
# 169 "lib/PPCParser.mly"
    ( Pdiv (SetCR0,_2,_4,_6) )
# 1811 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_040 =
  fun _2 _4 _6 ->
    (
# 171 "lib/PPCParser.mly"
    ( Pload (Byte,_2,_4,_6))
# 1819 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_041 =
  fun _2 _4 _6 ->
    (
# 173 "lib/PPCParser.mly"
    ( Pload (Byte,_2,_4,_6))
# 1827 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_042 =
  fun _2 _4 _6 ->
    (
# 175 "lib/PPCParser.mly"
    ( Pload (Short,_2,_4,_6))
# 1835 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_043 =
  fun _2 _4 _6 ->
    (
# 177 "lib/PPCParser.mly"
    ( Pload (Short,_2,_4,_6))
# 1843 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_044 =
  fun _2 _4 _6 ->
    (
# 179 "lib/PPCParser.mly"
    ( Pload (Word,_2,_4,_6))
# 1851 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_045 =
  fun _2 _4 _6 ->
    (
# 181 "lib/PPCParser.mly"
    ( Plwa (_2,_4,_6) )
# 1859 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_046 =
  fun _2 _4 _6 ->
    (
# 183 "lib/PPCParser.mly"
    ( Plwax (Word,_2,_4,_6))
# 1867 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_047 =
  fun _2 _4 _6 ->
    (
# 185 "lib/PPCParser.mly"
    ( Pload (Word,_2,_4,_6))
# 1875 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_048 =
  fun _2 _4 _6 ->
    (
# 187 "lib/PPCParser.mly"
    ( Plwzu (_2,_4,_6))
# 1883 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_049 =
  fun _2 _4 _6 ->
    (
# 189 "lib/PPCParser.mly"
    ( Plwzu (_2,_4,_6))
# 1891 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_050 =
  fun _2 _4 _6 ->
    (
# 191 "lib/PPCParser.mly"
    ( Pload (Quad,_2,_4,_6))
# 1899 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_051 =
  fun _2 _4 _6 ->
    (
# 193 "lib/PPCParser.mly"
    ( Pload (Quad,_2,_4,_6))
# 1907 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_052 =
  fun _2 _4 _6 ->
    (
# 195 "lib/PPCParser.mly"
    ( Ploadx (Byte,_2,_4,_6))
# 1915 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_053 =
  fun _2 _4 _6 ->
    (
# 197 "lib/PPCParser.mly"
    ( Ploadx (Short,_2,_4,_6))
# 1923 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_054 =
  fun _2 _4 _6 ->
    (
# 199 "lib/PPCParser.mly"
    ( Ploadx (Word,_2,_4,_6))
# 1931 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_055 =
  fun _2 _4 _6 ->
    (
# 201 "lib/PPCParser.mly"
    ( Ploadx (Quad,_2,_4,_6))
# 1939 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_056 =
  fun _2 _4 ->
    (
# 203 "lib/PPCParser.mly"
    ( Pmr (_2,_4) )
# 1947 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_057 =
  fun _2 _4 _6 ->
    (
# 205 "lib/PPCParser.mly"
    ( Pstore (Byte,_2,_4,_6) )
# 1955 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_058 =
  fun _2 _4 _6 ->
    (
# 207 "lib/PPCParser.mly"
    ( Pstore (Byte,_2,_4,_6) )
# 1963 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_059 =
  fun _2 _4 _6 ->
    (
# 209 "lib/PPCParser.mly"
    ( Pstore (Short,_2,_4,_6) )
# 1971 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_060 =
  fun _2 _4 _6 ->
    (
# 211 "lib/PPCParser.mly"
    ( Pstore (Short,_2,_4,_6) )
# 1979 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_061 =
  fun _2 _4 _6 ->
    (
# 213 "lib/PPCParser.mly"
    ( Pstore (Word,_2,_4,_6) )
# 1987 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_062 =
  fun _2 _4 _6 ->
    (
# 215 "lib/PPCParser.mly"
    ( Pstore (Word,_2,_4,_6) )
# 1995 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_063 =
  fun _2 _4 _6 ->
    (
# 217 "lib/PPCParser.mly"
    ( Pstwu (_2,_4,_6) )
# 2003 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_064 =
  fun _2 _4 _6 ->
    (
# 219 "lib/PPCParser.mly"
    ( Pstwu (_2,_4,_6) )
# 2011 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_065 =
  fun _2 _4 _6 ->
    (
# 221 "lib/PPCParser.mly"
    ( Pstore (Quad,_2,_4,_6) )
# 2019 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_066 =
  fun _2 _4 _6 ->
    (
# 223 "lib/PPCParser.mly"
    ( Pstore (Quad,_2,_4,_6) )
# 2027 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_067 =
  fun _2 _4 _6 ->
    (
# 225 "lib/PPCParser.mly"
    ( Pstorex (Byte,_2,_4,_6) )
# 2035 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_068 =
  fun _2 _4 _6 ->
    (
# 227 "lib/PPCParser.mly"
    ( Pstorex (Short,_2,_4,_6) )
# 2043 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_069 =
  fun _2 _4 _6 ->
    (
# 229 "lib/PPCParser.mly"
    ( Pstorex (Word,_2,_4,_6) )
# 2051 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_070 =
  fun _2 _4 _6 ->
    (
# 231 "lib/PPCParser.mly"
    ( Pstorex (Quad,_2,_4,_6) )
# 2059 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_071 =
  fun _2 _4 _6 ->
    (
# 233 "lib/PPCParser.mly"
    ( Plwarx (_2,_4,_6))
# 2067 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_072 =
  fun _2 _4 _6 ->
    (
# 235 "lib/PPCParser.mly"
    ( Pstwcx (_2,_4,_6) )
# 2075 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_073 =
  fun () ->
    (
# 237 "lib/PPCParser.mly"
    ( Psync )
# 2083 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_074 =
  fun () ->
    (
# 239 "lib/PPCParser.mly"
    ( Peieio )
# 2091 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_075 =
  fun () ->
    (
# 241 "lib/PPCParser.mly"
    ( Plwsync )
# 2099 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_076 =
  fun () ->
    (
# 243 "lib/PPCParser.mly"
    ( Psync )
# 2107 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_077 =
  fun () ->
    (
# 245 "lib/PPCParser.mly"
    ( Pisync )
# 2115 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_078 =
  fun _2 _4 ->
    (
# 247 "lib/PPCParser.mly"
    ( Pdcbf (_2,_4) )
# 2123 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_079 =
  fun _2 ->
    (
# 248 "lib/PPCParser.mly"
           ( Pb _2 )
# 2131 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_080 =
  fun _2 ->
    (
# 249 "lib/PPCParser.mly"
             ( Pbcc (Eq,_2) )
# 2139 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_081 =
  fun _2 ->
    (
# 250 "lib/PPCParser.mly"
             ( Pbcc (Ne,_2) )
# 2147 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_082 =
  fun _2 ->
    (
# 251 "lib/PPCParser.mly"
             ( Pbcc (Lt,_2) )
# 2155 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_083 =
  fun _2 ->
    (
# 252 "lib/PPCParser.mly"
             ( Pbcc (Ge,_2) )
# 2163 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_084 =
  fun _2 ->
    (
# 253 "lib/PPCParser.mly"
             ( Pbcc (Ge,_2) )
# 2171 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_085 =
  fun _2 ->
    (
# 254 "lib/PPCParser.mly"
             ( Pbcc (Gt,_2) )
# 2179 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_086 =
  fun _2 ->
    (
# 255 "lib/PPCParser.mly"
             ( Pbcc (Le,_2) )
# 2187 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_087 =
  fun _2 ->
    (
# 256 "lib/PPCParser.mly"
             ( Pbcc (Le,_2) )
# 2195 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_088 =
  fun _2 _4 _6 ->
    (
# 258 "lib/PPCParser.mly"
    ( Pnor (DontSetCR0,_2,_4,_6))
# 2203 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_089 =
  fun _2 _4 _6 ->
    (
# 260 "lib/PPCParser.mly"
    ( Pnor (SetCR0,_2,_4,_6))
# 2211 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_090 =
  fun _2 _4 ->
    (
# 262 "lib/PPCParser.mly"
    ( Pneg (DontSetCR0,_2,_4))
# 2219 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_091 =
  fun _2 _4 ->
    (
# 264 "lib/PPCParser.mly"
    ( Pneg (SetCR0,_2,_4))
# 2227 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_092 =
  fun _2 _4 _6 ->
    (
# 266 "lib/PPCParser.mly"
    ( Pslw (DontSetCR0,_2,_4,_6))
# 2235 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_093 =
  fun _2 _4 _6 ->
    (
# 268 "lib/PPCParser.mly"
    ( Psrawi (DontSetCR0,_2,_4,_6))
# 2243 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_094 =
  fun _2 _4 _6 ->
    (
# 270 "lib/PPCParser.mly"
    ( Psraw (DontSetCR0,_2,_4,_6))
# 2251 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_095 =
  fun _2 ->
    (
# 271 "lib/PPCParser.mly"
            ( Pbl _2 )
# 2259 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_096 =
  fun () ->
    (
# 272 "lib/PPCParser.mly"
        ( Pblr )
# 2267 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_097 =
  fun _2 ->
    (
# 273 "lib/PPCParser.mly"
             ( Pmtlr _2)
# 2275 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_098 =
  fun _2 ->
    (
# 274 "lib/PPCParser.mly"
             ( Pmflr _2)
# 2283 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_099 =
  fun _2 ->
    (
# 275 "lib/PPCParser.mly"
             ( Pmfcr _2)
# 2291 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_100 =
  fun _2 _4 _6 ->
    (
# 276 "lib/PPCParser.mly"
                                     ( Plmw (_2,_4,_6) )
# 2299 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_101 =
  fun _2 _4 _6 ->
    (
# 277 "lib/PPCParser.mly"
                                      ( Pstmw (_2,_4,_6) )
# 2307 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_102 =
  fun _2 ->
    (
# 278 "lib/PPCParser.mly"
                   ( Pcomment _2 )
# 2315 "lib/PPCParser.ml"
     : (PPCBase.pins))

let _menhir_action_103 =
  fun () ->
    (
# 86 "lib/PPCParser.mly"
             ( Nop )
# 2323 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo))

let _menhir_action_104 =
  fun _1 _3 ->
    (
# 87 "lib/PPCParser.mly"
                          ( Label (_1,_3) )
# 2331 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo))

let _menhir_action_105 =
  fun _1 ->
    (
# 88 "lib/PPCParser.mly"
             ( Symbolic _1 )
# 2339 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo))

let _menhir_action_106 =
  fun _1 _3 ->
    (
# 90 "lib/PPCParser.mly"
             ( Macro (_1,_3) )
# 2347 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo))

let _menhir_action_107 =
  fun _1 ->
    (
# 91 "lib/PPCParser.mly"
             ( Instruction _1)
# 2355 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo))

let _menhir_action_108 =
  fun _1 ->
    (
# 79 "lib/PPCParser.mly"
      ([_1])
# 2363 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list))

let _menhir_action_109 =
  fun _1 _3 ->
    (
# 81 "lib/PPCParser.mly"
      (_1::_3)
# 2371 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list))

let _menhir_action_110 =
  fun xs ->
    (
# 83 "lib/PPCParser.mly"
                                                                     ( xs )
# 2379 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list))

let _menhir_action_111 =
  fun _1 ->
    (
# 74 "lib/PPCParser.mly"
    ([_1])
# 2387 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list list))

let _menhir_action_112 =
  fun _1 _3 ->
    (
# 75 "lib/PPCParser.mly"
                                   (_1::_3)
# 2395 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list list))

let _menhir_action_113 =
  fun _1 ->
    (
# 281 "lib/PPCParser.mly"
       ( MetaConst.Int _1 )
# 2403 "lib/PPCParser.ml"
     : (MetaConst.k))

let _menhir_action_114 =
  fun _1 ->
    (
# 282 "lib/PPCParser.mly"
         ( MetaConst.Meta _1 )
# 2411 "lib/PPCParser.ml"
     : (MetaConst.k))

let _menhir_action_115 =
  fun _2 _3 ->
    (
# 61 "lib/PPCParser.mly"
                                  ( _2,_3 )
# 2419 "lib/PPCParser.ml"
     : (MiscParser.proc list * PPCBase.parsedPseudo list list))

let _menhir_action_116 =
  fun _2 ->
    (
# 62 "lib/PPCParser.mly"
                         ( _2,[] )
# 2427 "lib/PPCParser.ml"
     : (MiscParser.proc list * PPCBase.parsedPseudo list list))

let _menhir_action_117 =
  fun ps ->
    (
# 66 "lib/PPCParser.mly"
  ( List.map (fun p -> p,None,MiscParser.Main) ps )
# 2435 "lib/PPCParser.ml"
     : (MiscParser.proc list))

let _menhir_action_118 =
  fun _1 ->
    (
# 293 "lib/PPCParser.mly"
           ( Symbolic_reg _1 )
# 2443 "lib/PPCParser.ml"
     : (PPC.reg_arg))

let _menhir_action_119 =
  fun _1 ->
    (
# 294 "lib/PPCParser.mly"
           ( _1 )
# 2451 "lib/PPCParser.ml"
     : (PPC.reg_arg))

let _menhir_action_120 =
  fun () ->
    (
# 94 "lib/PPCParser.mly"
  ( [] )
# 2459 "lib/PPCParser.ml"
     : (PPC.reg_arg list))

let _menhir_action_121 =
  fun _1 ->
    (
# 95 "lib/PPCParser.mly"
      ( [_1] )
# 2467 "lib/PPCParser.ml"
     : (PPC.reg_arg list))

let _menhir_action_122 =
  fun _1 _3 ->
    (
# 96 "lib/PPCParser.mly"
                     ( _1 :: _3 )
# 2475 "lib/PPCParser.ml"
     : (PPC.reg_arg list))

let _menhir_action_123 =
  fun () ->
    (
# 69 "lib/PPCParser.mly"
  ( () )
# 2483 "lib/PPCParser.ml"
     : (unit))

let _menhir_action_124 =
  fun () ->
    (
# 70 "lib/PPCParser.mly"
       ( () )
# 2491 "lib/PPCParser.ml"
     : (unit))

let _menhir_action_125 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 2499 "lib/PPCParser.ml"
     : (int list))

let _menhir_action_126 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 2507 "lib/PPCParser.ml"
     : (int list))

let _menhir_action_127 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 2515 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list))

let _menhir_action_128 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 2523 "lib/PPCParser.ml"
     : (PPCBase.parsedPseudo list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADD ->
        "ADD"
    | ADDDOT ->
        "ADDDOT"
    | ADDI ->
        "ADDI"
    | ADDIS ->
        "ADDIS"
    | AND ->
        "AND"
    | ANDDOT ->
        "ANDDOT"
    | ANDIDOT ->
        "ANDIDOT"
    | ARCH_REG _ ->
        "ARCH_REG"
    | B ->
        "B"
    | BEQ ->
        "BEQ"
    | BGE ->
        "BGE"
    | BGT ->
        "BGT"
    | BL ->
        "BL"
    | BLE ->
        "BLE"
    | BLR ->
        "BLR"
    | BLT ->
        "BLT"
    | BNE ->
        "BNE"
    | BNG ->
        "BNG"
    | BNL ->
        "BNL"
    | CLRLDI ->
        "CLRLDI"
    | CMPLWI ->
        "CMPLWI"
    | CMPW ->
        "CMPW"
    | CMPWI ->
        "CMPWI"
    | CODEVAR _ ->
        "CODEVAR"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | COMMENT ->
        "COMMENT"
    | CRK _ ->
        "CRK"
    | CSTVAR _ ->
        "CSTVAR"
    | DCBF ->
        "DCBF"
    | DIV ->
        "DIV"
    | DIVDOT ->
        "DIVDOT"
    | EIEIO ->
        "EIEIO"
    | EOF ->
        "EOF"
    | EXTSW ->
        "EXTSW"
    | HWSYNC ->
        "HWSYNC"
    | ISYNC ->
        "ISYNC"
    | LBZ ->
        "LBZ"
    | LBZX ->
        "LBZX"
    | LD ->
        "LD"
    | LDX ->
        "LDX"
    | LHZ ->
        "LHZ"
    | LHZX ->
        "LHZX"
    | LI ->
        "LI"
    | LIS ->
        "LIS"
    | LMW ->
        "LMW"
    | LPAR ->
        "LPAR"
    | LWA ->
        "LWA"
    | LWARX ->
        "LWARX"
    | LWAX ->
        "LWAX"
    | LWSYNC ->
        "LWSYNC"
    | LWZ ->
        "LWZ"
    | LWZU ->
        "LWZU"
    | LWZX ->
        "LWZX"
    | MFCR ->
        "MFCR"
    | MFLR ->
        "MFLR"
    | MR ->
        "MR"
    | MTLR ->
        "MTLR"
    | MULL ->
        "MULL"
    | MULLDOT ->
        "MULLDOT"
    | MULLI ->
        "MULLI"
    | NAME _ ->
        "NAME"
    | NEG ->
        "NEG"
    | NEGDOT ->
        "NEGDOT"
    | NOP ->
        "NOP"
    | NOR ->
        "NOR"
    | NORDOT ->
        "NORDOT"
    | NUM _ ->
        "NUM"
    | OR ->
        "OR"
    | ORDOT ->
        "ORDOT"
    | ORI ->
        "ORI"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RLWIMI ->
        "RLWIMI"
    | RLWINM ->
        "RLWINM"
    | RPAR ->
        "RPAR"
    | SEMI ->
        "SEMI"
    | SLW ->
        "SLW"
    | SRAW ->
        "SRAW"
    | SRAWI ->
        "SRAWI"
    | STB ->
        "STB"
    | STBX ->
        "STBX"
    | STD ->
        "STD"
    | STDX ->
        "STDX"
    | STH ->
        "STH"
    | STHX ->
        "STHX"
    | STMW ->
        "STMW"
    | STRING _ ->
        "STRING"
    | STW ->
        "STW"
    | STWCX ->
        "STWCX"
    | STWU ->
        "STWU"
    | STWX ->
        "STWX"
    | SUB ->
        "SUB"
    | SUBDOT ->
        "SUBDOT"
    | SUBF ->
        "SUBF"
    | SUBFDOT ->
        "SUBFDOT"
    | SUBI ->
        "SUBI"
    | SYMB_REG _ ->
        "SYMB_REG"
    | SYNC ->
        "SYNC"
    | XOR ->
        "XOR"
    | XORDOT ->
        "XORDOT"
    | XORI ->
        "XORI"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_goto_main : type  ttv_stack. ttv_stack -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      MenhirBox_main _v
  
  let _menhir_run_491 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_115 _2 _3 in
      _menhir_goto_main _menhir_stack _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState494 ->
          _menhir_run_495 _menhir_stack _v
      | MenhirState489 ->
          _menhir_run_491 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_495 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_112 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let _menhir_run_475 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let xs = _v in
      let _v = _menhir_action_110 xs in
      MenhirBox_instr_option_seq _v
  
  let rec _menhir_goto_separated_nonempty_list_SEMI_instr_option_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState479 ->
          _menhir_run_480 _menhir_stack _v
      | MenhirState000 ->
          _menhir_run_475 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_480 : type  ttv_stack. (ttv_stack, _menhir_box_instr_option_seq) _menhir_cell1_instr_option -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_128 x xs in
      _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XORI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState001 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_118 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState471 ->
          _menhir_run_472 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState469 ->
          _menhir_run_470 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_468 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState465 ->
          _menhir_run_466 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState463 ->
          _menhir_run_464 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_462 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState457 ->
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState455 ->
          _menhir_run_456 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState451 ->
          _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState449 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState447 ->
          _menhir_run_448 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState445 ->
          _menhir_run_446 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState443 ->
          _menhir_run_444 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState441 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState439 ->
          _menhir_run_440 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState437 ->
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState433 ->
          _menhir_run_434 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState431 ->
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState406 ->
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState404 ->
          _menhir_run_405 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState396 ->
          _menhir_run_397 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState393 ->
          _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState391 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState387 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState381 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState374 ->
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState372 ->
          _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState370 ->
          _menhir_run_371 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState366 ->
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState364 ->
          _menhir_run_365 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState362 ->
          _menhir_run_363 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState359 ->
          _menhir_run_360 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState357 ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState353 ->
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState350 ->
          _menhir_run_351 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState346 ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState342 ->
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState340 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState338 ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState335 ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState331 ->
          _menhir_run_332 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState329 ->
          _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState327 ->
          _menhir_run_328 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState320 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState316 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState314 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState312 ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState306 ->
          _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState295 ->
          _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState292 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState288 ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState286 ->
          _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState284 ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState282 ->
          _menhir_run_283 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState280 ->
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState278 ->
          _menhir_run_279 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState276 ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState273 ->
          _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState270 ->
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState266 ->
          _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState264 ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState261 ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState257 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState255 ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState253 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState251 ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState249 ->
          _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState247 ->
          _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState245 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState243 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState239 ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState237 ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState235 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState231 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState229 ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState225 ->
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState223 ->
          _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState220 ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState216 ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState213 ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState211 ->
          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState209 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState207 ->
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState204 ->
          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState202 ->
          _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState200 ->
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState198 ->
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState196 ->
          _menhir_run_197 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState194 ->
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState190 ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState184 ->
          _menhir_run_185 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState178 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState176 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState168 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState166 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState158 ->
          _menhir_run_159 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState154 ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState152 ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState150 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState148 ->
          _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState146 ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState144 ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState133 ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState129 ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState127 ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState125 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState123 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState118 ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState114 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState110 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState103 ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState099 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState095 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState081 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState077 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState075 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState073 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState060 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState056 ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState054 ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState050 ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState048 ->
          _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState044 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState038 ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState036 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState034 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState032 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState024 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState021 ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState019 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState017 ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState015 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState013 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState001 ->
          _menhir_run_004 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_472 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADD, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_006 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_107 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState489 ->
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState497 ->
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState479 ->
          _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState222 ->
          _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_496 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XORI ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | XORDOT ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | XOR ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SYNC ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SUBI ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SUBFDOT ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SUBF ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SUBDOT ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SUB ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STWX ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STWU ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STWCX ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STW ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STMW ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STHX ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STH ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STDX ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STD ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STBX ->
              _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | STB ->
              _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SRAWI ->
              _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SRAW ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | SLW ->
              _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | RLWINM ->
              _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | RLWIMI ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ORI ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ORDOT ->
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | OR ->
              _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NORDOT ->
              _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NOR ->
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NOP ->
              _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NEGDOT ->
              _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NEG ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | NAME _v_0 ->
              _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState497
          | MULLI ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MULLDOT ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MULL ->
              _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MTLR ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MR ->
              _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MFLR ->
              _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | MFCR ->
              _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWZX ->
              _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWZU ->
              _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWZ ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWSYNC ->
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWAX ->
              _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWARX ->
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LWA ->
              _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LMW ->
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LIS ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LI ->
              _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LHZX ->
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LHZ ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LDX ->
              _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LD ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LBZX ->
              _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | LBZ ->
              _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ISYNC ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | HWSYNC ->
              _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | EXTSW ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | EIEIO ->
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | DIVDOT ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | DIV ->
              _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | DCBF ->
              _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | COMMENT ->
              _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | CODEVAR _v_1 ->
              _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState497
          | CMPWI ->
              _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | CMPW ->
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | CMPLWI ->
              _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | CLRLDI ->
              _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BNL ->
              _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BNG ->
              _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BNE ->
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BLT ->
              _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BLR ->
              _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BLE ->
              _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BL ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BGT ->
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BGE ->
              _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | BEQ ->
              _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | B ->
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ANDIDOT ->
              _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ANDDOT ->
              _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | AND ->
              _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ADDIS ->
              _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ADDI ->
              _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ADDDOT ->
              _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | ADD ->
              _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState497
          | PIPE | SEMI ->
              let _v_2 = _menhir_action_103 () in
              _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState497 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_108 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XORDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState011 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_119 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_017 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState017 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_023 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_073 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState024 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBFDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState030 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState036 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_042 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUBDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState042 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SUB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState048 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_054 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STWX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState054 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STWU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState060 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_071 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STWCX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState071 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState077 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STMW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState086 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STHX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState093 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STH (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState099 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_108 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STDX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState108 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState114 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STBX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState123 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState129 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_138 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRAWI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState138 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_144 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRAW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState144 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_150 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SLW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState150 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_156 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_RLWINM (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState156 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_166 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_RLWIMI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState166 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ORI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState176 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ORDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState182 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState188 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_194 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_NORDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState194 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_NOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState200 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_206 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_005 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_207 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_NEGDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState207 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_211 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_NEG (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState211 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_215 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState216
          | ARCH_REG _v_1 ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState216
          | RPAR ->
              let _v_2 = _menhir_action_120 () in
              _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XORI ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | XORDOT ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | XOR ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SYNC ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SUBI ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SUBFDOT ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SUBF ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SUBDOT ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SUB ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STWX ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STWU ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STWCX ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STW ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STMW ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STHX ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STH ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STDX ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STD ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STBX ->
              _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | STB ->
              _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SRAWI ->
              _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SRAW ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | SLW ->
              _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | RLWINM ->
              _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | RLWIMI ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ORI ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ORDOT ->
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | OR ->
              _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NORDOT ->
              _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NOR ->
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NOP ->
              _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NEGDOT ->
              _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NEG ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | NAME _v_3 ->
              _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState222
          | MULLI ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MULLDOT ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MULL ->
              _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MTLR ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MR ->
              _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MFLR ->
              _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | MFCR ->
              _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWZX ->
              _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWZU ->
              _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWZ ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWSYNC ->
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWAX ->
              _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWARX ->
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LWA ->
              _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LMW ->
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LIS ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LI ->
              _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LHZX ->
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LHZ ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LDX ->
              _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LD ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LBZX ->
              _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LBZ ->
              _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ISYNC ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | HWSYNC ->
              _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | EXTSW ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | EIEIO ->
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | DIVDOT ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | DIV ->
              _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | DCBF ->
              _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | COMMENT ->
              _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | CODEVAR _v_4 ->
              _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState222
          | CMPWI ->
              _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | CMPW ->
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | CMPLWI ->
              _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | CLRLDI ->
              _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BNL ->
              _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BNG ->
              _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BNE ->
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BLT ->
              _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BLR ->
              _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BLE ->
              _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BL ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BGT ->
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BGE ->
              _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | BEQ ->
              _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | B ->
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ANDIDOT ->
              _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ANDDOT ->
              _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | AND ->
              _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ADDIS ->
              _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ADDI ->
              _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ADDDOT ->
              _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | ADD ->
              _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | EOF | PIPE | SEMI ->
              let _v_5 = _menhir_action_103 () in
              _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_217 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_106 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_223 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MULLI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState223 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MULLDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState229 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MULL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState235 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MTLR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState241 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_243 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState243 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_247 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MFLR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState247 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_249 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_MFCR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState249 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_251 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWZX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState251 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_257 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWZU (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState257 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_266 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState266 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_275 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_075 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_276 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWAX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState276 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_282 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWARX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState282 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_288 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LWA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState288 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_295 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LMW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState295 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_302 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LIS (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState302 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_306 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState306 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_310 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LHZX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState310 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_316 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LHZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState316 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_325 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LDX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState325 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_331 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState331 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_340 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LBZX (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState340 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_346 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LBZ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState346 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_355 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_077 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_356 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_076 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_357 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_EXTSW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState357 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_361 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_074 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_362 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DIVDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState362 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_368 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DIV (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState368 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_374 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DCBF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState374 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_378 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRING _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_102 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_380 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_105 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_381 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CMPWI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState381 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CRK _v ->
          _menhir_run_382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_382 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_002 _1 in
      _menhir_goto_crindex _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_crindex : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState391 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState381 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_395 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_crindex (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState396 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_386 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPWI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_crindex (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState387 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_391 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CMPW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState391 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CRK _v ->
          _menhir_run_382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_400 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CMPLWI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState400 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_404 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CLRLDI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState404 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_410 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_084 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_412 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_087 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_414 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_081 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_416 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_082 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_418 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_096 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_419 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_086 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_421 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_095 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_423 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_085 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_425 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_083 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_427 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_080 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_429 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_079 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_431 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ANDIDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState431 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_437 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ANDDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState437 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_443 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_AND (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState443 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_449 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDIS (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState449 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState455 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_461 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADDDOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState461 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_467 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ADD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState467 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_473 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_104 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState497 ->
          _menhir_run_498 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState494 ->
          _menhir_run_493 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState489 ->
          _menhir_run_493 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_498 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_109 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_493 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XORI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | XORDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | XOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SYNC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SUBI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SUBFDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SUBF ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SUBDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SUB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STWX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STWU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STWCX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STMW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STHX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STH ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STDX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STBX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | STB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SRAWI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SRAW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | SLW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | RLWINM ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | RLWIMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ORI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ORDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | OR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NORDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NOP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NEGDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NEG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState494
      | MULLI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MULLDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MULL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MTLR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MFLR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | MFCR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWZX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWZU ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWSYNC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWAX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWARX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LWA ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LMW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LIS ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LHZX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LHZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LDX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LBZX ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | LBZ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ISYNC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | HWSYNC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | EXTSW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | EIEIO ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | DIVDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | DIV ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | DCBF ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | COMMENT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | CODEVAR _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState494
      | CMPWI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | CMPW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | CMPLWI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | CLRLDI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BNL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BNG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BNE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BLT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BLR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BLE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BGT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BGE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | BEQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | B ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ANDIDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ANDDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | AND ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ADDIS ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ADDI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ADDDOT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | ADD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState494
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_2 = _menhir_action_103 () in
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState494 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_111 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_478 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_instr_option_seq) _menhir_state -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XORI ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | XORDOT ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | XOR ->
              _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SYNC ->
              _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SUBI ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SUBFDOT ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SUBF ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SUBDOT ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SUB ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STWX ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STWU ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STWCX ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STW ->
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STMW ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STHX ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STH ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STDX ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STD ->
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STBX ->
              _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | STB ->
              _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SRAWI ->
              _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SRAW ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | SLW ->
              _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | RLWINM ->
              _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | RLWIMI ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ORI ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ORDOT ->
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | OR ->
              _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NORDOT ->
              _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NOR ->
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NOP ->
              _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NEGDOT ->
              _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NEG ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | NAME _v_0 ->
              _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState479
          | MULLI ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MULLDOT ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MULL ->
              _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MTLR ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MR ->
              _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MFLR ->
              _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | MFCR ->
              _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWZX ->
              _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWZU ->
              _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWZ ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWSYNC ->
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWAX ->
              _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWARX ->
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LWA ->
              _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LMW ->
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LIS ->
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LI ->
              _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LHZX ->
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LHZ ->
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LDX ->
              _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LD ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LBZX ->
              _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | LBZ ->
              _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ISYNC ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | HWSYNC ->
              _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | EXTSW ->
              _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | EIEIO ->
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | DIVDOT ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | DIV ->
              _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | DCBF ->
              _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | COMMENT ->
              _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | CODEVAR _v_1 ->
              _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState479
          | CMPWI ->
              _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | CMPW ->
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | CMPLWI ->
              _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | CLRLDI ->
              _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BNL ->
              _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BNG ->
              _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BNE ->
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BLT ->
              _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BLR ->
              _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BLE ->
              _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BL ->
              _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BGT ->
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BGE ->
              _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | BEQ ->
              _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | B ->
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ANDIDOT ->
              _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ANDDOT ->
              _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | AND ->
              _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ADDIS ->
              _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ADDI ->
              _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ADDDOT ->
              _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | ADD ->
              _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState479
          | EOF | SEMI ->
              let _v_2 = _menhir_action_103 () in
              _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState479 _tok
          | _ ->
              _eRR ())
      | EOF ->
          let x = _v in
          let _v = _menhir_action_127 x in
          _menhir_goto_separated_nonempty_list_SEMI_instr_option_ _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_470 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADD, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState471 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_468 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState469 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_466 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_007 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_464 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState465 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_462 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADDDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState463 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_458 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState459 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_008 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_113 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_k : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState459 ->
          _menhir_run_460 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState453 ->
          _menhir_run_454 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState435 ->
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState408 ->
          _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState402 ->
          _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState389 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState384 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState308 ->
          _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState304 ->
          _menhir_run_305 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState227 ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState180 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState174 ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState172 ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState170 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState162 ->
          _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState028 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState007 ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_460 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_013 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_454 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDIS, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ADDIS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_012 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_436 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ANDIDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ANDIDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_031 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_409 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CLRLDI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CLRLDI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_017 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_403 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPLWI, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CMPLWI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_020 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_390 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPWI, ttv_result) _menhir_cell1_crindex, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_crindex (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CMPWI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_021 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_385 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPWI, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CMPWI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_019 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_309 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LI, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_024 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_305 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LIS, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LIS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_025 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_228 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULLI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MULLI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_037 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_181 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ORI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ORI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_034 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_175 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_RLWIMI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_k, ttv_result) _menhir_cell1_k -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_RLWIMI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _10 = _v in
      let _v = _menhir_action_016 _10 _2 _4 _6 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_173 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_RLWIMI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState174 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_009 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_114 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_171 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_RLWIMI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState172 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_165 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_RLWINM, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_k, ttv_result) _menhir_cell1_k -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_RLWINM (_menhir_stack, _menhir_s) = _menhir_stack in
      let _10 = _v in
      let _v = _menhir_action_015 _10 _2 _4 _6 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_163 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_RLWINM, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState164 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_RLWINM, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState162 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_143 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRAWI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SRAWI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_093 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_029 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_014 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_010 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XORI, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_XORI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_028 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_456 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADDI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState457 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_452 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADDIS, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState453 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_450 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADDIS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState451 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_448 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AND, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_AND (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_029 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_446 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AND, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState447 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_444 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AND as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState445 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_442 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ANDDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ANDDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_030 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_440 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ANDDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState441 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_438 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ANDDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState439 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_434 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ANDIDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState435 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_432 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ANDIDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState433 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_407 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CLRLDI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState408 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_405 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CLRLDI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState406 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_401 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPLWI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState402 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_399 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPW, ttv_result) _menhir_cell1_crindex, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_crindex (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CMPW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_022 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_397 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPW, ttv_result) _menhir_cell1_crindex as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState398 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_394 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPW, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CMPW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_023 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_392 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState393 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_388 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPWI, ttv_result) _menhir_cell1_crindex as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState389 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_383 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPWI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState384 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_377 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DCBF, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DCBF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_078 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_375 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DCBF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState376 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_373 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DIV, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DIV (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_038 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_371 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DIV, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState372 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_369 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DIV as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState370 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_367 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DIVDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_DIVDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_039 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_365 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DIVDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState366 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_363 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DIVDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState364 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_360 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXTSW, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_EXTSW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_018 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_358 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXTSW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState359 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_354 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LBZ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_040 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_351 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LBZ (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_041 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_347 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBZ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState348 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_063 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_003 _1 in
      _menhir_goto_idx _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_idx : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState348 ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState333 ->
          _menhir_run_334 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState318 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState297 ->
          _menhir_run_298 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState290 ->
          _menhir_run_291 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState268 ->
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState131 ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState101 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState079 ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_349 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBZ, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState350 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState353 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_334 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LD, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState335 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState338 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LHZ, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState320 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState323 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_298 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LMW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState299 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_291 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWA, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState292 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_269 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZ, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState270 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState273 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_260 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZU, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState261 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState264 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STB, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState133 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState136 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STD, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState118 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState121 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_102 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STH, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState103 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState106 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STMW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState090 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState081 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState084 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWU, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_idx (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_s = MenhirState069 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_004 _1 in
      _menhir_goto_idx _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_345 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBZX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LBZX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_052 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_343 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBZX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState344 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_341 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBZX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState342 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_339 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LD, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_050 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_336 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LD, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LD (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_051 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_332 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState333 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_330 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LDX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LDX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_055 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_328 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LDX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState329 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_326 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LDX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState327 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_324 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LHZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LHZ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_042 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_321 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LHZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LHZ (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_043 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_317 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LHZ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState318 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_315 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LHZX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LHZX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_053 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_313 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LHZX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState314 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_311 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LHZX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState312 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_307 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState308 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_303 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LIS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState304 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_300 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LMW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LMW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_100 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_296 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LMW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState297 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_293 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWA, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LWA (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_045 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_289 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState290 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_287 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWARX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LWARX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_071 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_285 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWARX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState286 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_283 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWARX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState284 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_281 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWAX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LWAX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_046 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_279 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWAX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState280 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_277 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWAX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState278 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_274 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LWZ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_044 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_271 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZ, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LWZ (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_047 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_267 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWZ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState268 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZU, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LWZU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_048 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_262 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZU, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LWZU (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_049 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_258 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWZU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState259 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_256 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LWZX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_054 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_254 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LWZX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState255 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_252 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LWZX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState253 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_250 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_MFCR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_MFCR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_099 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_248 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_MFLR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_MFLR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_098 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_246 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MR, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_056 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_244 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState245 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_MTLR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_MTLR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_097 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_240 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULL, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MULL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_035 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_238 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULL, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState239 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MULL as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState237 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_234 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULLDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_MULLDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_036 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_232 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULLDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState233 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_230 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MULLDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState231 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_226 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MULLI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState227 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MULLI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState225 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_219 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState220
          | ARCH_REG _v_1 ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState220
          | RPAR ->
              let _v_2 = _menhir_action_120 () in
              _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_121 _1 in
          _menhir_goto_reg_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_221 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_122 _1 _3 in
      _menhir_goto_reg_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_reg_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState220 ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState216 ->
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_214 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NEG, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_NEG (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_090 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_212 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NEG as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState213 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_210 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NEGDOT, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_NEGDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_091 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_208 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NEGDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState209 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_NOR, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_NOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_088 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_203 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_NOR, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState204 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_201 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NOR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState202 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_199 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_NORDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_NORDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_089 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_197 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_NORDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState198 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_195 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NORDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState196 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_193 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OR, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_OR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_032 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_191 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OR, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState192 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_189 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState190 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_187 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ORDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ORDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_033 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_185 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ORDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState186 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_183 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ORDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState184 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_179 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ORI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState180 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_177 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ORI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState178 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_169 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_RLWIMI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState170 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_167 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_RLWIMI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState168 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_159 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_RLWINM, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState160 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_157 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_RLWINM as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState158 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_155 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SLW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SLW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_092 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_153 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SLW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState154 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_151 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SLW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState152 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_149 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRAW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SRAW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_094 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_147 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRAW, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState148 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_145 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRAW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState146 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_141 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRAWI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState142 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_139 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRAWI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState140 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_137 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STB, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_057 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_134 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STB, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STB (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_058 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_130 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STB as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState131 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STBX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STBX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_067 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_126 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STBX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState127 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_124 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STBX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState125 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STD, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_065 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_119 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STD, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STD (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_066 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_115 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState116 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_113 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STDX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STDX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_070 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_111 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STDX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState112 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_109 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STDX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState110 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_107 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STH, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STH (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_059 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_104 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STH, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STH (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_060 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STH as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState101 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STHX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STHX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_068 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_096 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STHX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState097 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STHX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState095 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STMW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STMW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_101 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STMW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState088 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_061 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_082 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STW, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STW (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_062 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STW as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState079 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWCX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STWCX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_072 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_074 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWCX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState075 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STWCX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState073 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWU, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STWU (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_063 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_067 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWU, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_idx -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_idx (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STWU (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_064 _2 _4 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STWU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState062 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_059 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWX, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_STWX (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_069 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_057 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STWX, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState058 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_055 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STWX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState056 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUB, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_008 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_051 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUB, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState052 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SUB as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState050 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_009 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_045 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState046 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SUBDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState044 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_041 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBF, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_010 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_039 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBF, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState040 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SUBF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState038 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBFDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_SUBFDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_011 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_033 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBFDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState034 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SUBFDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState032 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SUBI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState028 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_025 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SUBI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState026 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_022 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XOR, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_XOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_026 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_020 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XOR, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState021 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_018 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_XOR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState019 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_016 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XORDOT, ttv_result) _menhir_cell1_reg, ttv_result) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_XORDOT (_menhir_stack, _menhir_s) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_027 _2 _4 _6 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_014 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XORDOT, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState015 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_XORDOT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState013 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XORI, ttv_result) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState007 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CSTVAR _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_004 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_XORI as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState005 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_instr_option_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XORI ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | XORDOT ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | XOR ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SYNC ->
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SUBI ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SUBFDOT ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SUBF ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SUBDOT ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SUB ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STWX ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STWU ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STWCX ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STW ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STMW ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STHX ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STH ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STDX ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STD ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STBX ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | STB ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SRAWI ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SRAW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | SLW ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | RLWINM ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | RLWIMI ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ORI ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ORDOT ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | OR ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NORDOT ->
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NOR ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NOP ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NEGDOT ->
          _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NEG ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | NAME _v ->
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | MULLI ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MULLDOT ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MULL ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MTLR ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MR ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MFLR ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | MFCR ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWZX ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWZU ->
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWZ ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWSYNC ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWAX ->
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWARX ->
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LWA ->
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LMW ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LIS ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LI ->
          _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LHZX ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LHZ ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LDX ->
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LD ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LBZX ->
          _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LBZ ->
          _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ISYNC ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | HWSYNC ->
          _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EXTSW ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EIEIO ->
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | DIVDOT ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | DIV ->
          _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | DCBF ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | COMMENT ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | CODEVAR _v ->
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000
      | CMPWI ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | CMPW ->
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | CMPLWI ->
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | CLRLDI ->
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BNL ->
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BNG ->
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BNE ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BLT ->
          _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BLR ->
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BLE ->
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BL ->
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BGT ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BGE ->
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | BEQ ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | B ->
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ANDIDOT ->
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ANDDOT ->
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | AND ->
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ADDIS ->
          _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ADDI ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ADDDOT ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | ADD ->
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EOF | SEMI ->
          let _v = _menhir_action_103 () in
          _menhir_run_478 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_487 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let ps = _v in
      let _v = _menhir_action_117 ps in
      match (_tok : MenhirBasics.token) with
      | XORI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | XORDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | XOR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SYNC ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SUBI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SUBFDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SUBF ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SUBDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SUB ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STWX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STWU ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STWCX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STMW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STHX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STH ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STDX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STD ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STBX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | STB ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SRAWI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SRAW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SLW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | RLWINM ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | RLWIMI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ORI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ORDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | OR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NORDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NOR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NOP ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NEGDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NEG ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState489
      | MULLI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MULLDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MULL ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MTLR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MFLR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MFCR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWZX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWZU ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWZ ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWSYNC ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWAX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWARX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LWA ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LMW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LIS ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LHZX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LHZ ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LDX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LD ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LBZX ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | LBZ ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ISYNC ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | HWSYNC ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | EXTSW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | EOF ->
          let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_116 _2 in
          _menhir_goto_main _menhir_stack _v
      | EIEIO ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | DIVDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | DIV ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | DCBF ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | COMMENT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | CODEVAR _v_1 ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState489
      | CMPWI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | CMPW ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | CMPLWI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | CLRLDI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BNL ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BNG ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BNE ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BLT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BLR ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BLE ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BL ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BGT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BGE ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BEQ ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | B ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ANDIDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ANDDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | AND ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ADDIS ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ADDI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ADDDOT ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | ADD ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
          let _v_2 = _menhir_action_103 () in
          _menhir_run_496 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState489 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_PROC_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_487 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState485 ->
          _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_486 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_126 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_484 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState485 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_125 x in
          _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState483
      | _ ->
          _eRR ()
  
  let _menhir_run_481 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_124 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ ->
          let _v = _menhir_action_123 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_481 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let instr_option_seq =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_instr_option_seq v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
