
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XMM of (
# 23 "lib/X86_64Parser.mly"
       (X86_64Base.xmm)
# 15 "lib/X86_64Parser.ml"
  )
    | SYMB_REG of (
# 24 "lib/X86_64Parser.mly"
       (string)
# 20 "lib/X86_64Parser.ml"
  )
    | SEMI
    | RPAR
    | RBRK
    | PROC of (
# 28 "lib/X86_64Parser.mly"
       (int)
# 28 "lib/X86_64Parser.ml"
  )
    | PIPE
    | NUM of (
# 25 "lib/X86_64Parser.mly"
       (string)
# 34 "lib/X86_64Parser.ml"
  )
    | NAME of (
# 27 "lib/X86_64Parser.mly"
       (string)
# 39 "lib/X86_64Parser.ml"
  )
    | LPAR
    | LBRK
    | I_XORW
    | I_XORQ
    | I_XORL
    | I_XORB
    | I_XOR
    | I_XCHGW
    | I_XCHGQ
    | I_XCHGL
    | I_XCHGB
    | I_XCHG
    | I_UXCHW
    | I_UXCHQ
    | I_UXCHL
    | I_UXCHB
    | I_UXCH
    | I_SHL
    | I_SFENCE
    | I_SETNB
    | I_RET
    | I_ORW
    | I_ORQ
    | I_ORL
    | I_ORB
    | I_OR
    | I_NOPA
    | I_NOP
    | I_MOVW
    | I_MOVQ
    | I_MOVNTIQ
    | I_MOVNTIL
    | I_MOVNTI
    | I_MOVNTDQA
    | I_MOVL
    | I_MOVD
    | I_MOVB
    | I_MOV
    | I_MFENCE
    | I_LOCK
    | I_LFENCE
    | I_JS
    | I_JNS
    | I_JNE
    | I_JMP
    | I_JLT
    | I_JLE
    | I_JGT
    | I_JGE
    | I_JE
    | I_INCW
    | I_INCQ
    | I_INCL
    | I_INCB
    | I_INC
    | I_ENDBR64
    | I_DECW
    | I_DECQ
    | I_DECL
    | I_DECB
    | I_DEC
    | I_CMPXCHGW
    | I_CMPXCHGQ
    | I_CMPXCHGL
    | I_CMPXCHGB
    | I_CMPXCHG
    | I_CMPW
    | I_CMPQ
    | I_CMPL
    | I_CMPB
    | I_CMP
    | I_CMOVCW
    | I_CMOVCQ
    | I_CMOVCL
    | I_CMOVCB
    | I_CMOVC
    | I_CLFLUSH of (
# 51 "lib/X86_64Parser.mly"
       (X86_64Base.opt)
# 120 "lib/X86_64Parser.ml"
  )
    | I_AND
    | I_ADDW
    | I_ADDQ
    | I_ADDL
    | I_ADDB
    | I_ADD
    | INTEL_NUM of (
# 26 "lib/X86_64Parser.mly"
       (string)
# 131 "lib/X86_64Parser.ml"
  )
    | EOF
    | COMMA
    | COLON
    | ARCH_REG of (
# 22 "lib/X86_64Parser.mly"
       (X86_64Base.reg)
# 139 "lib/X86_64Parser.ml"
  )
  
end

include MenhirBasics

# 1 "lib/X86_64Parser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2010-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

open struct module X86_64 = X86_64Base end

# 166 "lib/X86_64Parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_main) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: main. *)

  | MenhirState002 : (('s, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_state
    (** State 002.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState005 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 005.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState007 : ((('s, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 007.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState009 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 009.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState010 : (('s, _menhir_box_main) _menhir_cell1_I_XORW, _menhir_box_main) _menhir_state
    (** State 010.
        Stack shape : I_XORW.
        Start symbol: main. *)

  | MenhirState013 : (('s, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_state
    (** State 013.
        Stack shape : LPAR.
        Start symbol: main. *)

  | MenhirState019 : ((('s, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 019.
        Stack shape : LPAR reg.
        Start symbol: main. *)

  | MenhirState021 : (((('s, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 021.
        Stack shape : LPAR reg reg.
        Start symbol: main. *)

  | MenhirState024 : (('s, _menhir_box_main) _menhir_cell1_LBRK, _menhir_box_main) _menhir_state
    (** State 024.
        Stack shape : LBRK.
        Start symbol: main. *)

  | MenhirState034 : (('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 034.
        Stack shape : reg.
        Start symbol: main. *)

  | MenhirState036 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 036.
        Stack shape : reg k.
        Start symbol: main. *)

  | MenhirState038 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 038.
        Stack shape : reg k reg.
        Start symbol: main. *)

  | MenhirState040 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 040.
        Stack shape : reg k reg reg.
        Start symbol: main. *)

  | MenhirState044 : ((('s, _menhir_box_main) _menhir_cell1_I_XORW, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 044.
        Stack shape : I_XORW operand.
        Start symbol: main. *)

  | MenhirState046 : (('s, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 046.
        Stack shape : k.
        Start symbol: main. *)

  | MenhirState049 : ((('s, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 049.
        Stack shape : k reg.
        Start symbol: main. *)

  | MenhirState051 : (((('s, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 051.
        Stack shape : k reg reg.
        Start symbol: main. *)

  | MenhirState054 : (('s, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 054.
        Stack shape : k.
        Start symbol: main. *)

  | MenhirState060 : (('s, _menhir_box_main) _menhir_cell1_I_XORQ, _menhir_box_main) _menhir_state
    (** State 060.
        Stack shape : I_XORQ.
        Start symbol: main. *)

  | MenhirState062 : ((('s, _menhir_box_main) _menhir_cell1_I_XORQ, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 062.
        Stack shape : I_XORQ operand.
        Start symbol: main. *)

  | MenhirState064 : (('s, _menhir_box_main) _menhir_cell1_I_XORL, _menhir_box_main) _menhir_state
    (** State 064.
        Stack shape : I_XORL.
        Start symbol: main. *)

  | MenhirState066 : ((('s, _menhir_box_main) _menhir_cell1_I_XORL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 066.
        Stack shape : I_XORL operand.
        Start symbol: main. *)

  | MenhirState068 : (('s, _menhir_box_main) _menhir_cell1_I_XORB, _menhir_box_main) _menhir_state
    (** State 068.
        Stack shape : I_XORB.
        Start symbol: main. *)

  | MenhirState070 : ((('s, _menhir_box_main) _menhir_cell1_I_XORB, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 070.
        Stack shape : I_XORB operand.
        Start symbol: main. *)

  | MenhirState072 : (('s, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_state
    (** State 072.
        Stack shape : I_XOR.
        Start symbol: main. *)

  | MenhirState074 : ((('s, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 074.
        Stack shape : I_XOR operand.
        Start symbol: main. *)

  | MenhirState076 : (('s, _menhir_box_main) _menhir_cell1_I_XCHGW, _menhir_box_main) _menhir_state
    (** State 076.
        Stack shape : I_XCHGW.
        Start symbol: main. *)

  | MenhirState078 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHGW, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 078.
        Stack shape : I_XCHGW effaddr.
        Start symbol: main. *)

  | MenhirState080 : (('s, _menhir_box_main) _menhir_cell1_I_XCHGQ, _menhir_box_main) _menhir_state
    (** State 080.
        Stack shape : I_XCHGQ.
        Start symbol: main. *)

  | MenhirState082 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHGQ, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 082.
        Stack shape : I_XCHGQ effaddr.
        Start symbol: main. *)

  | MenhirState084 : (('s, _menhir_box_main) _menhir_cell1_I_XCHGL, _menhir_box_main) _menhir_state
    (** State 084.
        Stack shape : I_XCHGL.
        Start symbol: main. *)

  | MenhirState086 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHGL, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 086.
        Stack shape : I_XCHGL effaddr.
        Start symbol: main. *)

  | MenhirState088 : (('s, _menhir_box_main) _menhir_cell1_I_XCHGB, _menhir_box_main) _menhir_state
    (** State 088.
        Stack shape : I_XCHGB.
        Start symbol: main. *)

  | MenhirState090 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHGB, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 090.
        Stack shape : I_XCHGB effaddr.
        Start symbol: main. *)

  | MenhirState092 : (('s, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_state
    (** State 092.
        Stack shape : I_XCHG.
        Start symbol: main. *)

  | MenhirState094 : ((('s, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 094.
        Stack shape : I_XCHG effaddr.
        Start symbol: main. *)

  | MenhirState096 : (('s, _menhir_box_main) _menhir_cell1_I_UXCHW, _menhir_box_main) _menhir_state
    (** State 096.
        Stack shape : I_UXCHW.
        Start symbol: main. *)

  | MenhirState098 : ((('s, _menhir_box_main) _menhir_cell1_I_UXCHW, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 098.
        Stack shape : I_UXCHW effaddr.
        Start symbol: main. *)

  | MenhirState100 : (('s, _menhir_box_main) _menhir_cell1_I_UXCHQ, _menhir_box_main) _menhir_state
    (** State 100.
        Stack shape : I_UXCHQ.
        Start symbol: main. *)

  | MenhirState102 : ((('s, _menhir_box_main) _menhir_cell1_I_UXCHQ, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 102.
        Stack shape : I_UXCHQ effaddr.
        Start symbol: main. *)

  | MenhirState104 : (('s, _menhir_box_main) _menhir_cell1_I_UXCHL, _menhir_box_main) _menhir_state
    (** State 104.
        Stack shape : I_UXCHL.
        Start symbol: main. *)

  | MenhirState106 : ((('s, _menhir_box_main) _menhir_cell1_I_UXCHL, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 106.
        Stack shape : I_UXCHL effaddr.
        Start symbol: main. *)

  | MenhirState108 : (('s, _menhir_box_main) _menhir_cell1_I_UXCHB, _menhir_box_main) _menhir_state
    (** State 108.
        Stack shape : I_UXCHB.
        Start symbol: main. *)

  | MenhirState110 : ((('s, _menhir_box_main) _menhir_cell1_I_UXCHB, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 110.
        Stack shape : I_UXCHB effaddr.
        Start symbol: main. *)

  | MenhirState112 : (('s, _menhir_box_main) _menhir_cell1_I_UXCH, _menhir_box_main) _menhir_state
    (** State 112.
        Stack shape : I_UXCH.
        Start symbol: main. *)

  | MenhirState114 : ((('s, _menhir_box_main) _menhir_cell1_I_UXCH, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 114.
        Stack shape : I_UXCH effaddr.
        Start symbol: main. *)

  | MenhirState116 : (('s, _menhir_box_main) _menhir_cell1_I_SHL, _menhir_box_main) _menhir_state
    (** State 116.
        Stack shape : I_SHL.
        Start symbol: main. *)

  | MenhirState118 : ((('s, _menhir_box_main) _menhir_cell1_I_SHL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 118.
        Stack shape : I_SHL operand.
        Start symbol: main. *)

  | MenhirState121 : (('s, _menhir_box_main) _menhir_cell1_I_SETNB, _menhir_box_main) _menhir_state
    (** State 121.
        Stack shape : I_SETNB.
        Start symbol: main. *)

  | MenhirState124 : (('s, _menhir_box_main) _menhir_cell1_I_ORW, _menhir_box_main) _menhir_state
    (** State 124.
        Stack shape : I_ORW.
        Start symbol: main. *)

  | MenhirState126 : ((('s, _menhir_box_main) _menhir_cell1_I_ORW, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 126.
        Stack shape : I_ORW operand.
        Start symbol: main. *)

  | MenhirState128 : (('s, _menhir_box_main) _menhir_cell1_I_ORQ, _menhir_box_main) _menhir_state
    (** State 128.
        Stack shape : I_ORQ.
        Start symbol: main. *)

  | MenhirState130 : ((('s, _menhir_box_main) _menhir_cell1_I_ORQ, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 130.
        Stack shape : I_ORQ operand.
        Start symbol: main. *)

  | MenhirState132 : (('s, _menhir_box_main) _menhir_cell1_I_ORL, _menhir_box_main) _menhir_state
    (** State 132.
        Stack shape : I_ORL.
        Start symbol: main. *)

  | MenhirState134 : ((('s, _menhir_box_main) _menhir_cell1_I_ORL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 134.
        Stack shape : I_ORL operand.
        Start symbol: main. *)

  | MenhirState136 : (('s, _menhir_box_main) _menhir_cell1_I_ORB, _menhir_box_main) _menhir_state
    (** State 136.
        Stack shape : I_ORB.
        Start symbol: main. *)

  | MenhirState138 : ((('s, _menhir_box_main) _menhir_cell1_I_ORB, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 138.
        Stack shape : I_ORB operand.
        Start symbol: main. *)

  | MenhirState140 : (('s, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_state
    (** State 140.
        Stack shape : I_OR.
        Start symbol: main. *)

  | MenhirState142 : ((('s, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 142.
        Stack shape : I_OR operand.
        Start symbol: main. *)

  | MenhirState145 : (('s, _menhir_box_main) _menhir_cell1_I_NOP, _menhir_box_main) _menhir_state
    (** State 145.
        Stack shape : I_NOP.
        Start symbol: main. *)

  | MenhirState147 : (('s, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_state
    (** State 147.
        Stack shape : I_MOVW.
        Start symbol: main. *)

  | MenhirState149 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 149.
        Stack shape : I_MOVW operand.
        Start symbol: main. *)

  | MenhirState151 : (('s, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_state
    (** State 151.
        Stack shape : I_MOVQ.
        Start symbol: main. *)

  | MenhirState153 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_XMM, _menhir_box_main) _menhir_state
    (** State 153.
        Stack shape : I_MOVQ XMM.
        Start symbol: main. *)

  | MenhirState156 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 156.
        Stack shape : I_MOVQ operand.
        Start symbol: main. *)

  | MenhirState158 : (('s, _menhir_box_main) _menhir_cell1_I_MOVNTIQ, _menhir_box_main) _menhir_state
    (** State 158.
        Stack shape : I_MOVNTIQ.
        Start symbol: main. *)

  | MenhirState160 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVNTIQ, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 160.
        Stack shape : I_MOVNTIQ reg.
        Start symbol: main. *)

  | MenhirState162 : (('s, _menhir_box_main) _menhir_cell1_I_MOVNTIL, _menhir_box_main) _menhir_state
    (** State 162.
        Stack shape : I_MOVNTIL.
        Start symbol: main. *)

  | MenhirState164 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVNTIL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 164.
        Stack shape : I_MOVNTIL reg.
        Start symbol: main. *)

  | MenhirState166 : (('s, _menhir_box_main) _menhir_cell1_I_MOVNTI, _menhir_box_main) _menhir_state
    (** State 166.
        Stack shape : I_MOVNTI.
        Start symbol: main. *)

  | MenhirState168 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVNTI, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 168.
        Stack shape : I_MOVNTI reg.
        Start symbol: main. *)

  | MenhirState170 : (('s, _menhir_box_main) _menhir_cell1_I_MOVNTDQA, _menhir_box_main) _menhir_state
    (** State 170.
        Stack shape : I_MOVNTDQA.
        Start symbol: main. *)

  | MenhirState174 : (('s, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_state
    (** State 174.
        Stack shape : I_MOVL.
        Start symbol: main. *)

  | MenhirState176 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 176.
        Stack shape : I_MOVL operand.
        Start symbol: main. *)

  | MenhirState180 : (('s, _menhir_box_main) _menhir_cell1_I_MOVD _menhir_cell0_XMM, _menhir_box_main) _menhir_state
    (** State 180.
        Stack shape : I_MOVD XMM.
        Start symbol: main. *)

  | MenhirState182 : (('s, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_state
    (** State 182.
        Stack shape : I_MOVB.
        Start symbol: main. *)

  | MenhirState184 : ((('s, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 184.
        Stack shape : I_MOVB operand.
        Start symbol: main. *)

  | MenhirState186 : (('s, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_state
    (** State 186.
        Stack shape : I_MOV.
        Start symbol: main. *)

  | MenhirState188 : ((('s, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 188.
        Stack shape : I_MOV operand.
        Start symbol: main. *)

  | MenhirState191 : (('s, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_state
    (** State 191.
        Stack shape : I_LOCK.
        Start symbol: main. *)

  | MenhirState192 : ((('s, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_state
    (** State 192.
        Stack shape : I_LOCK semi_opt.
        Start symbol: main. *)

  | MenhirState212 : (('s, _menhir_box_main) _menhir_cell1_I_INCW, _menhir_box_main) _menhir_state
    (** State 212.
        Stack shape : I_INCW.
        Start symbol: main. *)

  | MenhirState214 : (('s, _menhir_box_main) _menhir_cell1_I_INCQ, _menhir_box_main) _menhir_state
    (** State 214.
        Stack shape : I_INCQ.
        Start symbol: main. *)

  | MenhirState216 : (('s, _menhir_box_main) _menhir_cell1_I_INCL, _menhir_box_main) _menhir_state
    (** State 216.
        Stack shape : I_INCL.
        Start symbol: main. *)

  | MenhirState218 : (('s, _menhir_box_main) _menhir_cell1_I_INCB, _menhir_box_main) _menhir_state
    (** State 218.
        Stack shape : I_INCB.
        Start symbol: main. *)

  | MenhirState220 : (('s, _menhir_box_main) _menhir_cell1_I_INC, _menhir_box_main) _menhir_state
    (** State 220.
        Stack shape : I_INC.
        Start symbol: main. *)

  | MenhirState223 : (('s, _menhir_box_main) _menhir_cell1_I_DECW, _menhir_box_main) _menhir_state
    (** State 223.
        Stack shape : I_DECW.
        Start symbol: main. *)

  | MenhirState225 : (('s, _menhir_box_main) _menhir_cell1_I_DECQ, _menhir_box_main) _menhir_state
    (** State 225.
        Stack shape : I_DECQ.
        Start symbol: main. *)

  | MenhirState227 : (('s, _menhir_box_main) _menhir_cell1_I_DECL, _menhir_box_main) _menhir_state
    (** State 227.
        Stack shape : I_DECL.
        Start symbol: main. *)

  | MenhirState229 : (('s, _menhir_box_main) _menhir_cell1_I_DECB, _menhir_box_main) _menhir_state
    (** State 229.
        Stack shape : I_DECB.
        Start symbol: main. *)

  | MenhirState231 : (('s, _menhir_box_main) _menhir_cell1_I_DEC, _menhir_box_main) _menhir_state
    (** State 231.
        Stack shape : I_DEC.
        Start symbol: main. *)

  | MenhirState233 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGW, _menhir_box_main) _menhir_state
    (** State 233.
        Stack shape : I_CMPXCHGW.
        Start symbol: main. *)

  | MenhirState235 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGW, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 235.
        Stack shape : I_CMPXCHGW effaddr.
        Start symbol: main. *)

  | MenhirState237 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGQ, _menhir_box_main) _menhir_state
    (** State 237.
        Stack shape : I_CMPXCHGQ.
        Start symbol: main. *)

  | MenhirState239 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGQ, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 239.
        Stack shape : I_CMPXCHGQ effaddr.
        Start symbol: main. *)

  | MenhirState241 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGL, _menhir_box_main) _menhir_state
    (** State 241.
        Stack shape : I_CMPXCHGL.
        Start symbol: main. *)

  | MenhirState243 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGL, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 243.
        Stack shape : I_CMPXCHGL effaddr.
        Start symbol: main. *)

  | MenhirState245 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGB, _menhir_box_main) _menhir_state
    (** State 245.
        Stack shape : I_CMPXCHGB.
        Start symbol: main. *)

  | MenhirState247 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHGB, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 247.
        Stack shape : I_CMPXCHGB effaddr.
        Start symbol: main. *)

  | MenhirState249 : (('s, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_state
    (** State 249.
        Stack shape : I_CMPXCHG.
        Start symbol: main. *)

  | MenhirState251 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_cell1_effaddr, _menhir_box_main) _menhir_state
    (** State 251.
        Stack shape : I_CMPXCHG effaddr.
        Start symbol: main. *)

  | MenhirState253 : (('s, _menhir_box_main) _menhir_cell1_I_CMPW, _menhir_box_main) _menhir_state
    (** State 253.
        Stack shape : I_CMPW.
        Start symbol: main. *)

  | MenhirState255 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPW, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 255.
        Stack shape : I_CMPW operand.
        Start symbol: main. *)

  | MenhirState257 : (('s, _menhir_box_main) _menhir_cell1_I_CMPQ, _menhir_box_main) _menhir_state
    (** State 257.
        Stack shape : I_CMPQ.
        Start symbol: main. *)

  | MenhirState259 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPQ, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 259.
        Stack shape : I_CMPQ operand.
        Start symbol: main. *)

  | MenhirState261 : (('s, _menhir_box_main) _menhir_cell1_I_CMPL, _menhir_box_main) _menhir_state
    (** State 261.
        Stack shape : I_CMPL.
        Start symbol: main. *)

  | MenhirState263 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 263.
        Stack shape : I_CMPL operand.
        Start symbol: main. *)

  | MenhirState265 : (('s, _menhir_box_main) _menhir_cell1_I_CMPB, _menhir_box_main) _menhir_state
    (** State 265.
        Stack shape : I_CMPB.
        Start symbol: main. *)

  | MenhirState267 : ((('s, _menhir_box_main) _menhir_cell1_I_CMPB, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 267.
        Stack shape : I_CMPB operand.
        Start symbol: main. *)

  | MenhirState269 : (('s, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_state
    (** State 269.
        Stack shape : I_CMP.
        Start symbol: main. *)

  | MenhirState271 : ((('s, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 271.
        Stack shape : I_CMP operand.
        Start symbol: main. *)

  | MenhirState273 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVCW, _menhir_box_main) _menhir_state
    (** State 273.
        Stack shape : I_CMOVCW.
        Start symbol: main. *)

  | MenhirState275 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVCW, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 275.
        Stack shape : I_CMOVCW reg.
        Start symbol: main. *)

  | MenhirState277 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVCQ, _menhir_box_main) _menhir_state
    (** State 277.
        Stack shape : I_CMOVCQ.
        Start symbol: main. *)

  | MenhirState279 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVCQ, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 279.
        Stack shape : I_CMOVCQ reg.
        Start symbol: main. *)

  | MenhirState281 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVCL, _menhir_box_main) _menhir_state
    (** State 281.
        Stack shape : I_CMOVCL.
        Start symbol: main. *)

  | MenhirState283 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVCL, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 283.
        Stack shape : I_CMOVCL reg.
        Start symbol: main. *)

  | MenhirState285 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVCB, _menhir_box_main) _menhir_state
    (** State 285.
        Stack shape : I_CMOVCB.
        Start symbol: main. *)

  | MenhirState287 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVCB, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 287.
        Stack shape : I_CMOVCB reg.
        Start symbol: main. *)

  | MenhirState289 : (('s, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_state
    (** State 289.
        Stack shape : I_CMOVC.
        Start symbol: main. *)

  | MenhirState291 : ((('s, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 291.
        Stack shape : I_CMOVC reg.
        Start symbol: main. *)

  | MenhirState293 : (('s, _menhir_box_main) _menhir_cell1_I_CLFLUSH, _menhir_box_main) _menhir_state
    (** State 293.
        Stack shape : I_CLFLUSH.
        Start symbol: main. *)

  | MenhirState295 : (('s, _menhir_box_main) _menhir_cell1_I_AND, _menhir_box_main) _menhir_state
    (** State 295.
        Stack shape : I_AND.
        Start symbol: main. *)

  | MenhirState297 : ((('s, _menhir_box_main) _menhir_cell1_I_AND, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 297.
        Stack shape : I_AND operand.
        Start symbol: main. *)

  | MenhirState299 : (('s, _menhir_box_main) _menhir_cell1_I_ADDW, _menhir_box_main) _menhir_state
    (** State 299.
        Stack shape : I_ADDW.
        Start symbol: main. *)

  | MenhirState301 : ((('s, _menhir_box_main) _menhir_cell1_I_ADDW, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 301.
        Stack shape : I_ADDW operand.
        Start symbol: main. *)

  | MenhirState303 : (('s, _menhir_box_main) _menhir_cell1_I_ADDQ, _menhir_box_main) _menhir_state
    (** State 303.
        Stack shape : I_ADDQ.
        Start symbol: main. *)

  | MenhirState305 : ((('s, _menhir_box_main) _menhir_cell1_I_ADDQ, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 305.
        Stack shape : I_ADDQ operand.
        Start symbol: main. *)

  | MenhirState307 : (('s, _menhir_box_main) _menhir_cell1_I_ADDL, _menhir_box_main) _menhir_state
    (** State 307.
        Stack shape : I_ADDL.
        Start symbol: main. *)

  | MenhirState309 : ((('s, _menhir_box_main) _menhir_cell1_I_ADDL, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 309.
        Stack shape : I_ADDL operand.
        Start symbol: main. *)

  | MenhirState311 : (('s, _menhir_box_main) _menhir_cell1_I_ADDB, _menhir_box_main) _menhir_state
    (** State 311.
        Stack shape : I_ADDB.
        Start symbol: main. *)

  | MenhirState313 : ((('s, _menhir_box_main) _menhir_cell1_I_ADDB, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 313.
        Stack shape : I_ADDB operand.
        Start symbol: main. *)

  | MenhirState315 : (('s, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_state
    (** State 315.
        Stack shape : I_ADD.
        Start symbol: main. *)

  | MenhirState317 : ((('s, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_cell1_operand, _menhir_box_main) _menhir_state
    (** State 317.
        Stack shape : I_ADD operand.
        Start symbol: main. *)

  | MenhirState325 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 325.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState328 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 328.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_effaddr = 
  | MenhirCell1_effaddr of 's * ('s, 'r) _menhir_state * (X86_64Base.effaddr)

and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (X86_64Base.pseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (X86_64Base.pseudo list)

and ('s, 'r) _menhir_cell1_k = 
  | MenhirCell1_k of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_operand = 
  | MenhirCell1_operand of 's * ('s, 'r) _menhir_state * (X86_64Base.operand)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (X86_64Base.reg_arg)

and ('s, 'r) _menhir_cell1_semi_opt = 
  | MenhirCell1_semi_opt of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_I_ADD = 
  | MenhirCell1_I_ADD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ADDB = 
  | MenhirCell1_I_ADDB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ADDL = 
  | MenhirCell1_I_ADDL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ADDQ = 
  | MenhirCell1_I_ADDQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ADDW = 
  | MenhirCell1_I_ADDW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_AND = 
  | MenhirCell1_I_AND of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CLFLUSH = 
  | MenhirCell1_I_CLFLUSH of 's * ('s, 'r) _menhir_state * (
# 51 "lib/X86_64Parser.mly"
       (X86_64Base.opt)
# 901 "lib/X86_64Parser.ml"
)

and ('s, 'r) _menhir_cell1_I_CMOVC = 
  | MenhirCell1_I_CMOVC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMOVCB = 
  | MenhirCell1_I_CMOVCB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMOVCL = 
  | MenhirCell1_I_CMOVCL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMOVCQ = 
  | MenhirCell1_I_CMOVCQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMOVCW = 
  | MenhirCell1_I_CMOVCW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMP = 
  | MenhirCell1_I_CMP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPB = 
  | MenhirCell1_I_CMPB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPL = 
  | MenhirCell1_I_CMPL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPQ = 
  | MenhirCell1_I_CMPQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPW = 
  | MenhirCell1_I_CMPW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHG = 
  | MenhirCell1_I_CMPXCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHGB = 
  | MenhirCell1_I_CMPXCHGB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHGL = 
  | MenhirCell1_I_CMPXCHGL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHGQ = 
  | MenhirCell1_I_CMPXCHGQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_CMPXCHGW = 
  | MenhirCell1_I_CMPXCHGW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DEC = 
  | MenhirCell1_I_DEC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DECB = 
  | MenhirCell1_I_DECB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DECL = 
  | MenhirCell1_I_DECL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DECQ = 
  | MenhirCell1_I_DECQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_DECW = 
  | MenhirCell1_I_DECW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INC = 
  | MenhirCell1_I_INC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INCB = 
  | MenhirCell1_I_INCB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INCL = 
  | MenhirCell1_I_INCL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INCQ = 
  | MenhirCell1_I_INCQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_INCW = 
  | MenhirCell1_I_INCW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_LOCK = 
  | MenhirCell1_I_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOV = 
  | MenhirCell1_I_MOV of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVB = 
  | MenhirCell1_I_MOVB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVD = 
  | MenhirCell1_I_MOVD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVL = 
  | MenhirCell1_I_MOVL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVNTDQA = 
  | MenhirCell1_I_MOVNTDQA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVNTI = 
  | MenhirCell1_I_MOVNTI of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVNTIL = 
  | MenhirCell1_I_MOVNTIL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVNTIQ = 
  | MenhirCell1_I_MOVNTIQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVQ = 
  | MenhirCell1_I_MOVQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_MOVW = 
  | MenhirCell1_I_MOVW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_NOP = 
  | MenhirCell1_I_NOP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_OR = 
  | MenhirCell1_I_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ORB = 
  | MenhirCell1_I_ORB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ORL = 
  | MenhirCell1_I_ORL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ORQ = 
  | MenhirCell1_I_ORQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_ORW = 
  | MenhirCell1_I_ORW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_SETNB = 
  | MenhirCell1_I_SETNB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_SHL = 
  | MenhirCell1_I_SHL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_UXCH = 
  | MenhirCell1_I_UXCH of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_UXCHB = 
  | MenhirCell1_I_UXCHB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_UXCHL = 
  | MenhirCell1_I_UXCHL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_UXCHQ = 
  | MenhirCell1_I_UXCHQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_UXCHW = 
  | MenhirCell1_I_UXCHW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHG = 
  | MenhirCell1_I_XCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHGB = 
  | MenhirCell1_I_XCHGB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHGL = 
  | MenhirCell1_I_XCHGL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHGQ = 
  | MenhirCell1_I_XCHGQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XCHGW = 
  | MenhirCell1_I_XCHGW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XOR = 
  | MenhirCell1_I_XOR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XORB = 
  | MenhirCell1_I_XORB of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XORL = 
  | MenhirCell1_I_XORL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XORQ = 
  | MenhirCell1_I_XORQ of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_I_XORW = 
  | MenhirCell1_I_XORW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBRK = 
  | MenhirCell1_LBRK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 27 "lib/X86_64Parser.mly"
       (string)
# 1091 "lib/X86_64Parser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 28 "lib/X86_64Parser.mly"
       (int)
# 1098 "lib/X86_64Parser.ml"
)

and ('s, 'r) _menhir_cell1_XMM = 
  | MenhirCell1_XMM of 's * ('s, 'r) _menhir_state * (
# 23 "lib/X86_64Parser.mly"
       (X86_64Base.xmm)
# 1105 "lib/X86_64Parser.ml"
)

and 's _menhir_cell0_XMM = 
  | MenhirCell0_XMM of 's * (
# 23 "lib/X86_64Parser.mly"
       (X86_64Base.xmm)
# 1112 "lib/X86_64Parser.ml"
)

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * X86_64Base.pseudo list list) [@@unboxed]

let _menhir_action_001 =
  fun _1 ->
    (
# 272 "lib/X86_64Parser.mly"
          (X86_64.Effaddr_rm64 _1)
# 1123 "lib/X86_64Parser.ml"
     : (X86_64Base.effaddr))

let _menhir_action_002 =
  fun _2 _4 ->
    (
# 93 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_OR, X86_64.INSb , _4,_2))
# 1131 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_003 =
  fun _2 _4 ->
    (
# 95 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_OR, X86_64.I8b, _4,_2))
# 1139 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_004 =
  fun _2 _4 ->
    (
# 97 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_OR, X86_64.I16b, _4,_2))
# 1147 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_005 =
  fun _2 _4 ->
    (
# 99 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_OR, X86_64.I32b, _4,_2))
# 1155 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_006 =
  fun _2 _4 ->
    (
# 101 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_OR, X86_64.I64b, _4,_2))
# 1163 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_007 =
  fun _2 _4 ->
    (
# 103 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_AND, X86_64.INSb , _4,_2))
# 1171 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_008 =
  fun _2 _4 ->
    (
# 105 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_SHL, X86_64.INSb , _4,_2))
# 1179 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_009 =
  fun _2 _4 ->
    (
# 108 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_XOR, X86_64.INSb, _4,_2))
# 1187 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_010 =
  fun _2 _4 ->
    (
# 110 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_XOR, X86_64.I8b, _4,_2))
# 1195 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_011 =
  fun _2 _4 ->
    (
# 112 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_XOR, X86_64.I16b, _4,_2))
# 1203 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_012 =
  fun _2 _4 ->
    (
# 114 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_XOR, X86_64.I32b, _4,_2))
# 1211 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_013 =
  fun _2 _4 ->
    (
# 116 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_XOR, X86_64.I64b, _4,_2))
# 1219 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_014 =
  fun _2 _4 ->
    (
# 119 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_ADD, X86_64.INSb, _4,_2))
# 1227 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_015 =
  fun _2 _4 ->
    (
# 121 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_ADD, X86_64.I8b, _4,_2))
# 1235 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_016 =
  fun _2 _4 ->
    (
# 123 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_ADD, X86_64.I16b, _4,_2))
# 1243 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_017 =
  fun _2 _4 ->
    (
# 125 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_ADD, X86_64.I32b, _4,_2))
# 1251 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_018 =
  fun _2 _4 ->
    (
# 127 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_ADD, X86_64.I64b, _4,_2))
# 1259 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_019 =
  fun _2 _4 ->
    (
# 130 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_MOV, X86_64.INSb, _4,_2))
# 1267 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_020 =
  fun _2 _4 ->
    (
# 132 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_MOV, X86_64.I8b, _4,_2))
# 1275 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_021 =
  fun _2 _4 ->
    (
# 134 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_MOV, X86_64.I16b, _4,_2))
# 1283 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_022 =
  fun _2 _4 ->
    (
# 136 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_MOV, X86_64.I32b, _4,_2))
# 1291 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_023 =
  fun _2 _4 ->
    (
# 138 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_MOV, X86_64.I64b, _4,_2))
# 1299 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_024 =
  fun _2 _4 ->
    (
# 140 "lib/X86_64Parser.mly"
    ( X86_64.I_MOVD ( X86_64.I64b,_4,_2) )
# 1307 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_025 =
  fun _2 _4 ->
    (
# 142 "lib/X86_64Parser.mly"
    ( X86_64.I_MOVD ( X86_64.I32b,_4,_2) )
# 1315 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_026 =
  fun _2 _4 ->
    (
# 144 "lib/X86_64Parser.mly"
      (X86_64.I_MOVNTI (X86_64.INSb,_4,_2))
# 1323 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_027 =
  fun _2 _4 ->
    (
# 146 "lib/X86_64Parser.mly"
      (X86_64.I_MOVNTI (X86_64.I32b,_4,_2))
# 1331 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_028 =
  fun _2 _4 ->
    (
# 148 "lib/X86_64Parser.mly"
      (X86_64.I_MOVNTI (X86_64.I64b,_4,_2))
# 1339 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_029 =
  fun _2 _4 ->
    (
# 150 "lib/X86_64Parser.mly"
      (X86_64.I_MOVNTDQA (_4,_2) )
# 1347 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_030 =
  fun _2 _4 ->
    (
# 152 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_CMP, X86_64.INSb, _4,_2))
# 1355 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_031 =
  fun _2 _4 ->
    (
# 154 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_CMP, X86_64.I8b, _4,_2))
# 1363 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_032 =
  fun _2 _4 ->
    (
# 156 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_CMP, X86_64.I16b, _4,_2))
# 1371 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_033 =
  fun _2 _4 ->
    (
# 158 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_CMP, X86_64.I32b, _4,_2))
# 1379 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_034 =
  fun _2 _4 ->
    (
# 160 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_OP (X86_64.I_CMP, X86_64.I64b, _4,_2))
# 1387 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_035 =
  fun _2 ->
    (
# 163 "lib/X86_64Parser.mly"
    (X86_64.I_JMP _2)
# 1395 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_036 =
  fun () ->
    (
# 165 "lib/X86_64Parser.mly"
    (X86_64.I_RET)
# 1403 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_037 =
  fun () ->
    (
# 167 "lib/X86_64Parser.mly"
    (X86_64.I_NOP)
# 1411 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_038 =
  fun () ->
    (
# 169 "lib/X86_64Parser.mly"
    (X86_64.I_NOP)
# 1419 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_039 =
  fun () ->
    (
# 171 "lib/X86_64Parser.mly"
    (X86_64.I_NOP)
# 1427 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_040 =
  fun _2 ->
    (
# 175 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_EQ, _2))
# 1435 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_041 =
  fun _2 ->
    (
# 177 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_NE, _2))
# 1443 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_042 =
  fun _2 ->
    (
# 179 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_LE, _2))
# 1451 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_043 =
  fun _2 ->
    (
# 181 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_LT, _2))
# 1459 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_044 =
  fun _2 ->
    (
# 183 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_GE, _2))
# 1467 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_045 =
  fun _2 ->
    (
# 185 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_GT, _2))
# 1475 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_046 =
  fun _2 ->
    (
# 187 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_S, _2))
# 1483 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_047 =
  fun _2 ->
    (
# 189 "lib/X86_64Parser.mly"
    (X86_64.I_JCC(X86_64.C_NS, _2))
# 1491 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_048 =
  fun () ->
    (
# 192 "lib/X86_64Parser.mly"
      ( X86_64.I_FENCE (X86_64.MFENCE) )
# 1499 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_049 =
  fun () ->
    (
# 194 "lib/X86_64Parser.mly"
      ( X86_64.I_FENCE (X86_64.SFENCE) )
# 1507 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_050 =
  fun () ->
    (
# 196 "lib/X86_64Parser.mly"
      ( X86_64.I_FENCE (X86_64.LFENCE) )
# 1515 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_051 =
  fun _1 _2 ->
    (
# 198 "lib/X86_64Parser.mly"
      ( X86_64.I_CLFLUSH (_1,_2) )
# 1523 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_052 =
  fun _2 ->
    (
# 200 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_DEC, X86_64.INSb, _2))
# 1531 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_053 =
  fun _2 ->
    (
# 202 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_DEC, X86_64.I8b, _2))
# 1539 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_054 =
  fun _2 ->
    (
# 204 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_DEC, X86_64.I16b, _2))
# 1547 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_055 =
  fun _2 ->
    (
# 206 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_DEC, X86_64.I32b, _2))
# 1555 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_056 =
  fun _2 ->
    (
# 208 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_DEC, X86_64.I64b, _2))
# 1563 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_057 =
  fun _2 ->
    (
# 211 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_INC, X86_64.INSb, _2))
# 1571 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_058 =
  fun _2 ->
    (
# 213 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_INC, X86_64.I8b, _2))
# 1579 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_059 =
  fun _2 ->
    (
# 215 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_INC, X86_64.I16b, _2))
# 1587 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_060 =
  fun _2 ->
    (
# 217 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_INC, X86_64.I32b, _2))
# 1595 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_061 =
  fun _2 ->
    (
# 219 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_INC, X86_64.I64b, _2))
# 1603 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_062 =
  fun _2 ->
    (
# 222 "lib/X86_64Parser.mly"
    (X86_64.I_EFF (X86_64.I_SETNB, X86_64.INSb, _2))
# 1611 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_063 =
  fun _2 _4 ->
    (
# 225 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG, X86_64.INSb, _2, _4))
# 1619 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_064 =
  fun _2 _4 ->
    (
# 227 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG, X86_64.I8b, _2, _4))
# 1627 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_065 =
  fun _2 _4 ->
    (
# 229 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG, X86_64.I16b, _2, _4))
# 1635 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_066 =
  fun _2 _4 ->
    (
# 231 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG, X86_64.I32b, _2, _4))
# 1643 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_067 =
  fun _2 _4 ->
    (
# 233 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG, X86_64.I64b, _2, _4))
# 1651 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_068 =
  fun _2 _4 ->
    (
# 236 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG_UNLOCKED, X86_64.INSb, _2, _4))
# 1659 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_069 =
  fun _2 _4 ->
    (
# 238 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG_UNLOCKED, X86_64.I8b, _2, _4))
# 1667 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_070 =
  fun _2 _4 ->
    (
# 240 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG_UNLOCKED, X86_64.I16b, _2, _4))
# 1675 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_071 =
  fun _2 _4 ->
    (
# 242 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG_UNLOCKED, X86_64.I32b, _2, _4))
# 1683 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_072 =
  fun _2 _4 ->
    (
# 244 "lib/X86_64Parser.mly"
    (X86_64.I_EFF_EFF (X86_64.I_XCHG_UNLOCKED, X86_64.I64b, _2, _4))
# 1691 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_073 =
  fun _2 _4 ->
    (
# 247 "lib/X86_64Parser.mly"
    (X86_64.I_CMPXCHG (X86_64.INSb, _2, _4))
# 1699 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_074 =
  fun _2 _4 ->
    (
# 249 "lib/X86_64Parser.mly"
    (X86_64.I_CMPXCHG (X86_64.I8b, _2, _4))
# 1707 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_075 =
  fun _2 _4 ->
    (
# 251 "lib/X86_64Parser.mly"
    (X86_64.I_CMPXCHG (X86_64.I16b, _2, _4))
# 1715 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_076 =
  fun _2 _4 ->
    (
# 253 "lib/X86_64Parser.mly"
    (X86_64.I_CMPXCHG (X86_64.I32b, _2, _4))
# 1723 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_077 =
  fun _2 _4 ->
    (
# 255 "lib/X86_64Parser.mly"
    (X86_64.I_CMPXCHG (X86_64.I64b, _2, _4))
# 1731 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_078 =
  fun _2 _4 ->
    (
# 258 "lib/X86_64Parser.mly"
    (X86_64.I_CMOVC (X86_64.INSb, _2, _4))
# 1739 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_079 =
  fun _2 _4 ->
    (
# 260 "lib/X86_64Parser.mly"
    (X86_64.I_CMOVC (X86_64.I8b, _2, _4))
# 1747 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_080 =
  fun _2 _4 ->
    (
# 262 "lib/X86_64Parser.mly"
    (X86_64.I_CMOVC (X86_64.I16b, _2, _4))
# 1755 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_081 =
  fun _2 _4 ->
    (
# 264 "lib/X86_64Parser.mly"
    (X86_64.I_CMOVC (X86_64.I32b, _2, _4))
# 1763 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_082 =
  fun _2 _4 ->
    (
# 266 "lib/X86_64Parser.mly"
    (X86_64.I_CMOVC (X86_64.I64b, _2, _4))
# 1771 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_083 =
  fun _3 ->
    (
# 269 "lib/X86_64Parser.mly"
    (X86_64.I_LOCK _3 )
# 1779 "lib/X86_64Parser.ml"
     : (X86_64Base.pins))

let _menhir_action_084 =
  fun () ->
    (
# 79 "lib/X86_64Parser.mly"
  (X86_64.Nop)
# 1787 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo))

let _menhir_action_085 =
  fun _1 _3 ->
    (
# 80 "lib/X86_64Parser.mly"
                          ( X86_64.Label (_1,_3) )
# 1795 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo))

let _menhir_action_086 =
  fun _1 ->
    (
# 81 "lib/X86_64Parser.mly"
             ( X86_64.Instruction _1)
# 1803 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo))

let _menhir_action_087 =
  fun _1 ->
    (
# 74 "lib/X86_64Parser.mly"
      ([_1])
# 1811 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo list))

let _menhir_action_088 =
  fun _1 _3 ->
    (
# 76 "lib/X86_64Parser.mly"
      (_1::_3)
# 1819 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo list))

let _menhir_action_089 =
  fun _1 ->
    (
# 69 "lib/X86_64Parser.mly"
    ([_1])
# 1827 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo list list))

let _menhir_action_090 =
  fun _1 _3 ->
    (
# 70 "lib/X86_64Parser.mly"
                                   (_1::_3)
# 1835 "lib/X86_64Parser.ml"
     : (X86_64Base.pseudo list list))

let _menhir_action_091 =
  fun _1 ->
    (
# 89 "lib/X86_64Parser.mly"
      ( _1 )
# 1843 "lib/X86_64Parser.ml"
     : (string))

let _menhir_action_092 =
  fun _2 _3 ->
    (
# 56 "lib/X86_64Parser.mly"
                                      ( _2,_3 )
# 1851 "lib/X86_64Parser.ml"
     : (MiscParser.proc list * X86_64Base.pseudo list list))

let _menhir_action_093 =
  fun _1 ->
    (
# 291 "lib/X86_64Parser.mly"
            (X86_64.Operand_effaddr _1)
# 1859 "lib/X86_64Parser.ml"
     : (X86_64Base.operand))

let _menhir_action_094 =
  fun _1 ->
    (
# 292 "lib/X86_64Parser.mly"
      (X86_64.Operand_immediate (Misc.string_as_int _1) )
# 1867 "lib/X86_64Parser.ml"
     : (X86_64Base.operand))

let _menhir_action_095 =
  fun _1 ->
    (
# 293 "lib/X86_64Parser.mly"
              (X86_64.Operand_immediate (Misc.string_as_int _1))
# 1875 "lib/X86_64Parser.ml"
     : (X86_64Base.operand))

let _menhir_action_096 =
  fun _1 ->
    (
# 64 "lib/X86_64Parser.mly"
             ([_1,None,MiscParser.Main])
# 1883 "lib/X86_64Parser.ml"
     : (MiscParser.proc list))

let _menhir_action_097 =
  fun _1 _3 ->
    (
# 65 "lib/X86_64Parser.mly"
                       ( (_1,None,MiscParser.Main)::_3 )
# 1891 "lib/X86_64Parser.ml"
     : (MiscParser.proc list))

let _menhir_action_098 =
  fun _1 ->
    (
# 85 "lib/X86_64Parser.mly"
           ( X86_64.Symbolic_reg _1 )
# 1899 "lib/X86_64Parser.ml"
     : (X86_64Base.reg_arg))

let _menhir_action_099 =
  fun _1 ->
    (
# 86 "lib/X86_64Parser.mly"
           ( _1 )
# 1907 "lib/X86_64Parser.ml"
     : (X86_64Base.reg_arg))

let _menhir_action_100 =
  fun _1 ->
    (
# 275 "lib/X86_64Parser.mly"
         (X86_64.Rm64_reg _1)
# 1915 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_101 =
  fun _2 ->
    (
# 276 "lib/X86_64Parser.mly"
                   (X86_64.Rm64_deref (_2, 0))
# 1923 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_102 =
  fun _2 ->
    (
# 277 "lib/X86_64Parser.mly"
                   (X86_64.Rm64_deref (_2, 0))
# 1931 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_103 =
  fun _1 _3 ->
    (
# 278 "lib/X86_64Parser.mly"
                     (X86_64.Rm64_deref (_3, Misc.string_as_int _1))
# 1939 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_104 =
  fun _1 _3 ->
    (
# 279 "lib/X86_64Parser.mly"
                     (X86_64.Rm64_deref (_3, Misc.string_as_int _1))
# 1947 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_105 =
  fun _1 _3 _5 _7 ->
    (
# 280 "lib/X86_64Parser.mly"
                                       (X86_64.Rm64_scaled
      (Misc.string_as_int _1, _3, _5, Misc.string_as_int _7))
# 1956 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_106 =
  fun _2 _4 _6 ->
    (
# 282 "lib/X86_64Parser.mly"
                                     (X86_64.Rm64_scaled
      (0, _2, _4, Misc.string_as_int _6))
# 1965 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_107 =
  fun _3 _5 _7 _9 ->
    (
# 284 "lib/X86_64Parser.mly"
                                                 (X86_64.Rm64_scaled
      (Misc.string_as_int _3, _5, _7, Misc.string_as_int _9))
# 1974 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_108 =
  fun _2 ->
    (
# 286 "lib/X86_64Parser.mly"
                    (X86_64.Rm64_abs (Constant.mk_sym _2))
# 1982 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_109 =
  fun _2 ->
    (
# 287 "lib/X86_64Parser.mly"
                    (X86_64.Rm64_abs (Constant.mk_sym _2))
# 1990 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_110 =
  fun _2 ->
    (
# 288 "lib/X86_64Parser.mly"
                   (X86_64.Rm64_abs (Constant.Concrete _2))
# 1998 "lib/X86_64Parser.ml"
     : (X86_64Base.rm64))

let _menhir_action_111 =
  fun () ->
    (
# 60 "lib/X86_64Parser.mly"
  ( () )
# 2006 "lib/X86_64Parser.ml"
     : (unit))

let _menhir_action_112 =
  fun () ->
    (
# 61 "lib/X86_64Parser.mly"
       ( () )
# 2014 "lib/X86_64Parser.ml"
     : (unit))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ARCH_REG _ ->
        "ARCH_REG"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | EOF ->
        "EOF"
    | INTEL_NUM _ ->
        "INTEL_NUM"
    | I_ADD ->
        "I_ADD"
    | I_ADDB ->
        "I_ADDB"
    | I_ADDL ->
        "I_ADDL"
    | I_ADDQ ->
        "I_ADDQ"
    | I_ADDW ->
        "I_ADDW"
    | I_AND ->
        "I_AND"
    | I_CLFLUSH _ ->
        "I_CLFLUSH"
    | I_CMOVC ->
        "I_CMOVC"
    | I_CMOVCB ->
        "I_CMOVCB"
    | I_CMOVCL ->
        "I_CMOVCL"
    | I_CMOVCQ ->
        "I_CMOVCQ"
    | I_CMOVCW ->
        "I_CMOVCW"
    | I_CMP ->
        "I_CMP"
    | I_CMPB ->
        "I_CMPB"
    | I_CMPL ->
        "I_CMPL"
    | I_CMPQ ->
        "I_CMPQ"
    | I_CMPW ->
        "I_CMPW"
    | I_CMPXCHG ->
        "I_CMPXCHG"
    | I_CMPXCHGB ->
        "I_CMPXCHGB"
    | I_CMPXCHGL ->
        "I_CMPXCHGL"
    | I_CMPXCHGQ ->
        "I_CMPXCHGQ"
    | I_CMPXCHGW ->
        "I_CMPXCHGW"
    | I_DEC ->
        "I_DEC"
    | I_DECB ->
        "I_DECB"
    | I_DECL ->
        "I_DECL"
    | I_DECQ ->
        "I_DECQ"
    | I_DECW ->
        "I_DECW"
    | I_ENDBR64 ->
        "I_ENDBR64"
    | I_INC ->
        "I_INC"
    | I_INCB ->
        "I_INCB"
    | I_INCL ->
        "I_INCL"
    | I_INCQ ->
        "I_INCQ"
    | I_INCW ->
        "I_INCW"
    | I_JE ->
        "I_JE"
    | I_JGE ->
        "I_JGE"
    | I_JGT ->
        "I_JGT"
    | I_JLE ->
        "I_JLE"
    | I_JLT ->
        "I_JLT"
    | I_JMP ->
        "I_JMP"
    | I_JNE ->
        "I_JNE"
    | I_JNS ->
        "I_JNS"
    | I_JS ->
        "I_JS"
    | I_LFENCE ->
        "I_LFENCE"
    | I_LOCK ->
        "I_LOCK"
    | I_MFENCE ->
        "I_MFENCE"
    | I_MOV ->
        "I_MOV"
    | I_MOVB ->
        "I_MOVB"
    | I_MOVD ->
        "I_MOVD"
    | I_MOVL ->
        "I_MOVL"
    | I_MOVNTDQA ->
        "I_MOVNTDQA"
    | I_MOVNTI ->
        "I_MOVNTI"
    | I_MOVNTIL ->
        "I_MOVNTIL"
    | I_MOVNTIQ ->
        "I_MOVNTIQ"
    | I_MOVQ ->
        "I_MOVQ"
    | I_MOVW ->
        "I_MOVW"
    | I_NOP ->
        "I_NOP"
    | I_NOPA ->
        "I_NOPA"
    | I_OR ->
        "I_OR"
    | I_ORB ->
        "I_ORB"
    | I_ORL ->
        "I_ORL"
    | I_ORQ ->
        "I_ORQ"
    | I_ORW ->
        "I_ORW"
    | I_RET ->
        "I_RET"
    | I_SETNB ->
        "I_SETNB"
    | I_SFENCE ->
        "I_SFENCE"
    | I_SHL ->
        "I_SHL"
    | I_UXCH ->
        "I_UXCH"
    | I_UXCHB ->
        "I_UXCHB"
    | I_UXCHL ->
        "I_UXCHL"
    | I_UXCHQ ->
        "I_UXCHQ"
    | I_UXCHW ->
        "I_UXCHW"
    | I_XCHG ->
        "I_XCHG"
    | I_XCHGB ->
        "I_XCHGB"
    | I_XCHGL ->
        "I_XCHGL"
    | I_XCHGQ ->
        "I_XCHGQ"
    | I_XCHGW ->
        "I_XCHGW"
    | I_XOR ->
        "I_XOR"
    | I_XORB ->
        "I_XORB"
    | I_XORL ->
        "I_XORL"
    | I_XORQ ->
        "I_XORQ"
    | I_XORW ->
        "I_XORW"
    | LBRK ->
        "LBRK"
    | LPAR ->
        "LPAR"
    | NAME _ ->
        "NAME"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RBRK ->
        "RBRK"
    | RPAR ->
        "RPAR"
    | SEMI ->
        "SEMI"
    | SYMB_REG _ ->
        "SYMB_REG"
    | XMM _ ->
        "XMM"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_322 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_semi_opt (_menhir_stack, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_092 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState325 ->
          _menhir_run_326 _menhir_stack _v
      | MenhirState007 ->
          _menhir_run_322 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_326 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_090 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_112 () in
      _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState191 ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_192 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_LOCK as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_semi_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | I_XORW ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XORQ ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XORL ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XORB ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XOR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XCHGW ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XCHGQ ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XCHGL ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XCHGB ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_XCHG ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_UXCHW ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_UXCHQ ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_UXCHL ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_UXCHB ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_UXCH ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_SHL ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_SFENCE ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_SETNB ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_RET ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ORW ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ORQ ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ORL ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ORB ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_OR ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_NOPA ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_NOP ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVW ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVQ ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVNTIQ ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVNTIL ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVNTI ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVNTDQA ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVL ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVD ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOVB ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MOV ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_MFENCE ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_LOCK ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_LFENCE ->
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JS ->
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JNS ->
          _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JNE ->
          _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JMP ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JLT ->
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JLE ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JGT ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JGE ->
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_JE ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_INCW ->
          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_INCQ ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_INCL ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_INCB ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_INC ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ENDBR64 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_DECW ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_DECQ ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_DECL ->
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_DECB ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_DEC ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPXCHGW ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPXCHGQ ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPXCHGL ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPXCHGB ->
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPXCHG ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPW ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPQ ->
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPL ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMPB ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMP ->
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMOVCW ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMOVCQ ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMOVCL ->
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMOVCB ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CMOVC ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_CLFLUSH _v_0 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState192
      | I_AND ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ADDW ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ADDQ ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ADDL ->
          _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ADDB ->
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | I_ADD ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XORW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState010 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_098 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState289 ->
          _menhir_run_290 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState285 ->
          _menhir_run_286 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState281 ->
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState277 ->
          _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState273 ->
          _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState251 ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState247 ->
          _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState243 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState239 ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState235 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState180 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState166 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState162 ->
          _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState158 ->
          _menhir_run_159 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState153 ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState054 ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState049 ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState036 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState317 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState315 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState313 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState309 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState305 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState301 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState297 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState291 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState287 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState279 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState275 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState271 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState267 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState265 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState263 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState257 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState255 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState249 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState231 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState229 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState225 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState223 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState220 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState218 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState216 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState214 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState212 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState184 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState176 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState174 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState170 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState168 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState151 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState149 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState145 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState134 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState121 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState114 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState098 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState070 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState024 ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState019 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState013 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_290 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState291 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_091 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_k : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState315 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState265 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState257 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState174 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState151 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState317 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState313 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState309 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState305 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState301 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState297 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState291 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState287 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState279 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState275 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState271 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState267 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState263 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState255 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState249 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState231 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState229 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState225 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState223 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState220 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState218 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState216 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState214 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState212 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState188 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState184 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState176 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState170 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState168 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState149 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState145 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState134 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState130 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState121 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState118 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState114 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState098 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState084 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState070 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState034 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState021 ->
          _menhir_run_022 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_058 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LBRK ->
          let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _1 = _v in
          let _v = _menhir_action_094 _1 in
          _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_046 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState046 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_016 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_099 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_054 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState054 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_operand : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState315 ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState265 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState257 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState174 ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState151 ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_316 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADD as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState317 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_013 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState013
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_109 _2 in
              _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | ARCH_REG _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState013
      | _ ->
          _eRR ()
  
  and _menhir_goto_rm64 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_001 _1 in
      _menhir_goto_effaddr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_effaddr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState317 ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState313 ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState309 ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState305 ->
          _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState301 ->
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState297 ->
          _menhir_run_298 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState293 ->
          _menhir_run_294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState291 ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState287 ->
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState283 ->
          _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState279 ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState275 ->
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState271 ->
          _menhir_run_272 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState267 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState263 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState259 ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState255 ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState249 ->
          _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState241 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState231 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState229 ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState227 ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState225 ->
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState223 ->
          _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState220 ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState218 ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState216 ->
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState214 ->
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState212 ->
          _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState188 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState184 ->
          _menhir_run_185 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState176 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState170 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState168 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState164 ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState160 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState156 ->
          _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState149 ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState145 ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _tok
      | MenhirState142 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState138 ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState134 ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState130 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState126 ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState118 ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState114 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState112 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState110 ->
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState108 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState104 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState102 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState100 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState098 ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState096 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState094 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState092 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState084 ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState080 ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState076 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState070 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState062 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState315 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState265 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState261 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState257 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState186 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState174 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState151 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState136 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState128 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState116 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState010 ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_318 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADD, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_014 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState007 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState328 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_321 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_086 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState007 ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState328 ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_327 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState328
          | I_XORW ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XORQ ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XORL ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XORB ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XOR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XCHGW ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XCHGQ ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XCHGL ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XCHGB ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_XCHG ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_UXCHW ->
              _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_UXCHQ ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_UXCHL ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_UXCHB ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_UXCH ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_SHL ->
              _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_SFENCE ->
              _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_SETNB ->
              _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_RET ->
              _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ORW ->
              _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ORQ ->
              _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ORL ->
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ORB ->
              _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_OR ->
              _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_NOPA ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_NOP ->
              _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVW ->
              _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVQ ->
              _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVNTIQ ->
              _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVNTIL ->
              _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVNTI ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVNTDQA ->
              _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVL ->
              _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVD ->
              _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOVB ->
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MOV ->
              _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_MFENCE ->
              _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_LOCK ->
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_LFENCE ->
              _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JS ->
              _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JNS ->
              _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JNE ->
              _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JMP ->
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JLT ->
              _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JLE ->
              _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JGT ->
              _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JGE ->
              _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_JE ->
              _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_INCW ->
              _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_INCQ ->
              _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_INCL ->
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_INCB ->
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_INC ->
              _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ENDBR64 ->
              _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_DECW ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_DECQ ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_DECL ->
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_DECB ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_DEC ->
              _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPXCHGW ->
              _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPXCHGQ ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPXCHGL ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPXCHGB ->
              _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPXCHG ->
              _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPW ->
              _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPQ ->
              _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPL ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMPB ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMP ->
              _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMOVCW ->
              _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMOVCQ ->
              _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMOVCL ->
              _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMOVCB ->
              _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CMOVC ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_CLFLUSH _v_1 ->
              _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState328
          | I_AND ->
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ADDW ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ADDQ ->
              _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ADDL ->
              _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ADDB ->
              _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | I_ADD ->
              _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState328
          | PIPE | SEMI ->
              let _v_2 = _menhir_action_084 () in
              _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState328 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_087 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_008 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState009
          | I_XORW ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XORQ ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XORL ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XORB ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XOR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHGW ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHGQ ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHGL ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHGB ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_XCHG ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_UXCHW ->
              _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_UXCHQ ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_UXCHL ->
              _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_UXCHB ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_UXCH ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_SHL ->
              _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_SFENCE ->
              _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_SETNB ->
              _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_RET ->
              _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ORW ->
              _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ORQ ->
              _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ORL ->
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ORB ->
              _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_OR ->
              _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_NOPA ->
              _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_NOP ->
              _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVW ->
              _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVQ ->
              _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVNTIQ ->
              _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVNTIL ->
              _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVNTI ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVNTDQA ->
              _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVL ->
              _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVD ->
              _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOVB ->
              _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MOV ->
              _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_MFENCE ->
              _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_LOCK ->
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_LFENCE ->
              _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JS ->
              _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JNS ->
              _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JNE ->
              _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JMP ->
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JLT ->
              _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JLE ->
              _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JGT ->
              _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JGE ->
              _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_JE ->
              _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INCW ->
              _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INCQ ->
              _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INCL ->
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INCB ->
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_INC ->
              _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ENDBR64 ->
              _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DECW ->
              _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DECQ ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DECL ->
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DECB ->
              _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_DEC ->
              _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHGW ->
              _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHGQ ->
              _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHGL ->
              _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHGB ->
              _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPXCHG ->
              _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPW ->
              _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPQ ->
              _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPL ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMPB ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMP ->
              _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVCW ->
              _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVCQ ->
              _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVCL ->
              _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVCB ->
              _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CMOVC ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_CLFLUSH _v_1 ->
              _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState009
          | I_AND ->
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADDW ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADDQ ->
              _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADDL ->
              _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADDB ->
              _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | I_ADD ->
              _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState009
          | PIPE | SEMI ->
              let _v_2 = _menhir_action_084 () in
              _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XORQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState060 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          let _menhir_stack = MenhirCell1_LBRK (_menhir_stack, _menhir_s) in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState024
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RBRK ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_110 _2 in
              _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RBRK ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _2 = _v in
              let _v = _menhir_action_108 _2 in
              _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | ARCH_REG _v ->
          let _menhir_stack = MenhirCell1_LBRK (_menhir_stack, _menhir_s) in
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState024
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_095 _1 in
      _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_064 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XORL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState064 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_068 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XORB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState068 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XOR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState072 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHGW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState076 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHGQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState080 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHGL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState084 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_088 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHGB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState088 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_092 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_XCHG (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState092 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_096 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_UXCHW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState096 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_UXCHQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState100 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_UXCHL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState104 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_108 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_UXCHB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState108 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_112 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_UXCH (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState112 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_116 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_SHL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState116 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_120 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_049 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_121 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_SETNB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState121 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_036 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_124 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ORW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState124 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ORQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState128 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ORL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState132 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_136 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ORB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState136 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState140 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_144 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_039 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_145 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_NOP (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState145 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_147 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState147 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_151 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState151 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XMM _v ->
          let _menhir_stack = MenhirCell1_XMM (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_s = MenhirState153 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_158 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVNTIQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState158 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_162 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVNTIL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState162 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_166 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVNTI (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState166 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_170 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVNTDQA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState170 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_174 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState174 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_178 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XMM _v ->
          let _menhir_stack = MenhirCell0_XMM (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_s = MenhirState180 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOVB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState182 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_186 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_MOV (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState186 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_190 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_048 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_191 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState191
      | I_ADD | I_ADDB | I_ADDL | I_ADDQ | I_ADDW | I_AND | I_CLFLUSH _ | I_CMOVC | I_CMOVCB | I_CMOVCL | I_CMOVCQ | I_CMOVCW | I_CMP | I_CMPB | I_CMPL | I_CMPQ | I_CMPW | I_CMPXCHG | I_CMPXCHGB | I_CMPXCHGL | I_CMPXCHGQ | I_CMPXCHGW | I_DEC | I_DECB | I_DECL | I_DECQ | I_DECW | I_ENDBR64 | I_INC | I_INCB | I_INCL | I_INCQ | I_INCW | I_JE | I_JGE | I_JGT | I_JLE | I_JLT | I_JMP | I_JNE | I_JNS | I_JS | I_LFENCE | I_LOCK | I_MFENCE | I_MOV | I_MOVB | I_MOVD | I_MOVL | I_MOVNTDQA | I_MOVNTI | I_MOVNTIL | I_MOVNTIQ | I_MOVQ | I_MOVW | I_NOP | I_NOPA | I_OR | I_ORB | I_ORL | I_ORQ | I_ORW | I_RET | I_SETNB | I_SFENCE | I_SHL | I_UXCH | I_UXCHB | I_UXCHL | I_UXCHQ | I_UXCHW | I_XCHG | I_XCHGB | I_XCHGL | I_XCHGQ | I_XCHGW | I_XOR | I_XORB | I_XORL | I_XORQ | I_XORW ->
          let _v = _menhir_action_111 () in
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState191 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_193 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_050 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_194 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_046 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_196 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_047 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_198 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_041 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_035 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_202 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_043 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_204 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_042 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_206 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_045 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_208 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_044 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_210 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_040 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_212 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INCW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState212 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_214 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INCQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState214 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_216 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INCL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState216 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_218 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INCB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState218 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_220 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_INC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState220 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_222 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_037 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_223 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DECW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState223 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DECQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState225 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_227 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DECL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState227 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DECB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState229 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_231 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_DEC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState231 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHGW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState233 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_237 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHGQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState237 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHGL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState241 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_245 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHGB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState245 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_249 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPXCHG (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState249 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_253 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState253 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_257 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState257 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_261 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState261 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMPB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState265 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_269 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMP (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState269 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_273 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVCW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState273 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_277 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVCQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState277 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_281 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVCL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState281 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_285 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVCB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState285 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_289 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CMOVC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState289 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_293 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_I_CLFLUSH (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState293 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_295 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_AND (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState295 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_299 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADDW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState299 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_303 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADDQ (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState303 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_307 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADDL (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState307 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_311 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADDB (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState311 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_315 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_I_ADD (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState315 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NUM _v ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRK ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEL_NUM _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_320 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_085 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState328 ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState325 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState007 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_329 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_088 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_324 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState325
      | I_XORW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XORQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XORL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XORB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XOR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XCHGW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XCHGQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XCHGL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XCHGB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_XCHG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_UXCHW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_UXCHQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_UXCHL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_UXCHB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_UXCH ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_SHL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_SFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_SETNB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_RET ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ORW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ORQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ORL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ORB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_OR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_NOPA ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_NOP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVNTIQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVNTIL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVNTI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVNTDQA ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOVB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MOV ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_MFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_LOCK ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_LFENCE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JS ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JNS ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JNE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JMP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JLT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JLE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JGT ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JGE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_JE ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_INCW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_INCQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_INCL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_INCB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_INC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ENDBR64 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_DECW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_DECQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_DECL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_DECB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_DEC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPXCHGW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPXCHGQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPXCHGL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPXCHGB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPXCHG ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMPB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMP ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMOVCW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMOVCQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMOVCL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMOVCB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CMOVC ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_CLFLUSH _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState325
      | I_AND ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ADDW ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ADDQ ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ADDL ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ADDB ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | I_ADD ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_2 = _menhir_action_084 () in
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState325 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_089 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_LOCK, _menhir_box_main) _menhir_cell1_semi_opt -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_semi_opt (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_I_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_083 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_314 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDB, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADDB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_015 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_310 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADDL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_017 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_306 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDQ, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADDQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_018 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_302 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDW, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ADDW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_016 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_298 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_AND, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_AND (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_007 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_294 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_CLFLUSH -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_CLFLUSH (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_051 _1 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_292 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVC, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_078 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_288 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCB, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVCB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_079 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_284 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCL, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVCL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_081 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_280 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCQ, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVCQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_082 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_276 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCW, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMOVCW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_080 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_272 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMP, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMP (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_030 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_268 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPB, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_031 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_264 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_033 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_260 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPQ, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_034 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_256 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPW, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_032 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_250 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHG as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState251 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_246 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState247 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState243 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_238 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState239 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_234 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState235 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DEC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DEC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_052 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_230 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DECB -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DECB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_053 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_228 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DECL -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DECL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_055 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_226 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DECQ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DECQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_056 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_224 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_DECW -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_DECW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_054 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_221 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_057 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_219 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INCB -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INCB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_058 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_217 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INCL -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INCL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_060 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_215 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INCQ -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INCQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_061 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_213 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_INCW -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_INCW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_059 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_189 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOV, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOV (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_019 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_185 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVB, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_020 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_177 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_022 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_171 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTDQA -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XMM _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_I_MOVNTDQA (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_2, _4) = (_v, _v_0) in
              let _v = _menhir_action_029 _2 _4 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_169 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTI, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVNTI (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_026 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_165 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTIL, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVNTIL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_027 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_161 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTIQ, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVNTIQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_028 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_157 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_023 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_150 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVW, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_021 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_146 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_NOP -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _tok ->
      let MenhirCell1_I_NOP (_menhir_stack, _menhir_s) = _menhir_stack in
      let _v = _menhir_action_038 () in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_143 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_OR, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_OR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_002 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_139 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORB, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ORB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_003 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_135 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ORL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_005 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_131 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORQ, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ORQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_006 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_127 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORW, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_ORW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_004 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_122 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_SETNB -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_I_SETNB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_062 _2 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_119 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_SHL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_SHL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_008 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_115 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCH, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_UXCH (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_068 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_113 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCH as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState114 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_111 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHB, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_UXCHB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_069 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_109 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState110 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_107 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHL, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_UXCHL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_071 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_105 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState106 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_103 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHQ, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_UXCHQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_072 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_101 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState102 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHW, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_UXCHW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_070 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_097 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_UXCHW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState098 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_095 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHG, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHG (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_063 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_093 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHG as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState094 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGB, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHGB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_064 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_089 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState090 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGL, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHGL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_066 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_085 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState086 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_083 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGQ, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHGQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_067 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_081 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState082 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_079 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGW, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XCHGW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_065 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_077 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XCHGW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_effaddr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState078 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_075 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XOR, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XOR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_009 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_071 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORB, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XORB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_010 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_067 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORL, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XORL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_012 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_063 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORQ, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XORQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_013 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_059 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_093 _1 in
      _menhir_goto_operand _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_057 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORW, _menhir_box_main) _menhir_cell1_operand -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_operand (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_XORW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_011 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_312 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState313 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_308 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState309 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_304 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState305 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_300 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ADDW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState301 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_296 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_AND as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState297 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_270 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMP as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState271 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_266 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState267 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_262 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState263 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_258 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState259 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_254 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState255 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_187 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOV as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState188 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_183 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState184 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_175 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState176 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_155 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState156 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_148 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState149 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_141 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_OR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState142 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_137 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState138 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState134 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState130 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_ORW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState126 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_SHL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState118 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_073 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XOR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState074 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_069 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState070 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState062 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_XORW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_operand (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState044 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_052 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_k (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_105 _1 _3 _5 _7 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_045 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LBRK ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_041 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _7) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_k (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _9 = _v in
          let _v = _menhir_action_107 _3 _5 _7 _9 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState036 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_022 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_106 _2 _4 _6 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_286 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCB as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState287 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_282 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState283 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_278 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState279 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_274 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMOVCW as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState275 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_252 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHG, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHG (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_073 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_248 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGB, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHGB (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_074 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_244 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGL, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHGL (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_076 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_240 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGQ, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHGQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_077 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_236 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_CMPXCHGW, _menhir_box_main) _menhir_cell1_effaddr -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_effaddr (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_CMPXCHGW (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_075 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_181 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVD _menhir_cell0_XMM -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_XMM (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_I_MOVD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_025 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_167 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTI as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState168 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_163 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTIL as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState164 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_159 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVNTIQ as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState160 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRK ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_154 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_I_MOVQ, _menhir_box_main) _menhir_cell1_XMM -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_XMM (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_I_MOVQ (_menhir_stack, _menhir_s) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_024 _2 _4 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_055 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRK ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_104 _1 _3 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_050 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState051 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_103 _1 _3 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState049 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_039 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState040 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_037 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState038 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_033 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState034 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | COMMA | PIPE | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_100 _1 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_LBRK -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRK ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LBRK (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_102 _2 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_020 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LPAR, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState021 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NUM _v ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_017 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_101 _2 in
          _menhir_goto_rm64 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState019 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_semi_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState002
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_096 _1 in
          _menhir_goto_proc_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState005 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_proc_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState002 ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_007 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState007
      | I_XORW ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XORQ ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XORL ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XORB ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XOR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHGW ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHGQ ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHGL ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHGB ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_XCHG ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_UXCHW ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_UXCHQ ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_UXCHL ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_UXCHB ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_UXCH ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_SHL ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_SFENCE ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_SETNB ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_RET ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ORW ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ORQ ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ORL ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ORB ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_OR ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_NOPA ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_NOP ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVW ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVQ ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVNTIQ ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVNTIL ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVNTI ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVNTDQA ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVL ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVD ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOVB ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MOV ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_MFENCE ->
          _menhir_run_190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_LOCK ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_LFENCE ->
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JS ->
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JNS ->
          _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JNE ->
          _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JMP ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JLT ->
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JLE ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JGT ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JGE ->
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_JE ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INCW ->
          _menhir_run_212 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INCQ ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INCL ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INCB ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_INC ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ENDBR64 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DECW ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DECQ ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DECL ->
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DECB ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_DEC ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHGW ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHGQ ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHGL ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHGB ->
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPXCHG ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPW ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPQ ->
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPL ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMPB ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMP ->
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVCW ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVCQ ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVCL ->
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVCB ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CMOVC ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_CLFLUSH _v_1 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState007
      | I_AND ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADDW ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADDQ ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADDL ->
          _menhir_run_307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADDB ->
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | I_ADD ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
      | PIPE | SEMI ->
          let _v_2 = _menhir_action_084 () in
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState007 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_097 _1 _3 in
      _menhir_goto_proc_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | PROC _ ->
          let _v = _menhir_action_111 () in
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
